/*
 * Licensed Materials - Use restricted, please refer to the "Sample Code" terms 
 * and conditions in the IBM International Program License Agreement (IPLA).
 * 
 *  Copyright IBM Corporation 2006, 2007. All Rights Reserved.
 */

using System;
using System.Reflection;
using System.Collections;
namespace TestFramework
{
	/// <summary>
	/// Summary description for TestUtilities.
	/// </summary>
	public class TestUtilities
	{
		public TestUtilities()
		{
			userName = System.Environment.UserName;
			if(userName == null)
			{
				userName = "test";
			}
		}
 
		private static bool TOGGLE = true;
    
		private static String userName = null;

		public static Object setByIntrospection(Object objectToSet, int index, ArrayList skipMethodList)
		{

			Console.WriteLine(skipMethodList.Count);
			// retrieve information about AccountEnumeration
			Console.WriteLine ("Names and Values of the com.icommware.AccountEnumeration are:");
			Type type = objectToSet.GetType();

			// Create an instance of AccountEnumeration in Memory
			object accountEnum = Activator.CreateInstance (type);

			// List the names and values available in the AccountEnumeration  enum
			FieldInfo[] fieldInfo = type.GetFields();
		
			TOGGLE = index%2==0;
			Console.WriteLine (type.GetField("name").ToString());
			for (int i = 0; i < fieldInfo.Length; i++)
			{
			
				FieldInfo temp = fieldInfo[i];
				if(!skipMethodList.Contains( temp.Name.ToString() ))
				{
					if (temp.FieldType.ToString().EndsWith("String"))
					{
						String field = temp.ToString();
						String value = null;
						if(field.Equals("Name"))
						{
							value = field + " " + userName + index;
						}
						else
						{
							value = field + " " + index;
						}
                    
						temp.SetValue(objectToSet, value);
					}
					else if (temp.FieldType.ToString().EndsWith("Boolean") )
					{
						Console.WriteLine (" Param: {0} {1}", temp.GetType(), temp.GetValue(objectToSet));
						Boolean valueOf = (Boolean)TOGGLE;
						TOGGLE = !TOGGLE;
                    
						temp.SetValue(objectToSet, valueOf);
					}
					else if (temp.FieldType.ToString().StartsWith("System.Int"))
					{
						temp.SetValue(objectToSet, index + i);
					}
					else if (temp.FieldType.ToString().StartsWith("System.Float"))
					{
						temp.SetValue(objectToSet, index + i * 1000 + index / 200);
					}
					else if (temp.FieldType.ToString().StartsWith("System.Double"))
					{
						temp.SetValue(objectToSet, index + i * 1000 + index / 200);
					}
						/*else if (param == Calendar)
						{
							Calendar calendar = Calendar.getInstance();
							calendar.set(2000 + index + i, i % 12, (index % 30) + 1);
							args[0] = calendar;
						}*/
					else if (temp.FieldType.ToString().StartsWith("System.DateTime"))
					{
						DateTime calendar = DateTime.Today;
						temp.SetValue(objectToSet, calendar);
					}
					else
					{
						Console.WriteLine(temp.FieldType.ToString());
					}
				}
				else
				{
					continue;
				}
			}
		
			return objectToSet;
		}
	}
}
