/*
 * Licensed Materials - Use restricted, please refer to the "Sample Code" terms 
 * and conditions in the IBM International Program License Agreement (IPLA).
 * 
 *  Copyright IBM Corporation 2006, 2007. All Rights Reserved.
 */

using System;

using NUnit.Framework;

using TestFramework.ApplicationAPI;
using TestFramework.AuthenticateAPI;
using TestFramework;

namespace Tests.wbs
{
   /// <sample-summary>
   /// Summary description for WBSBaseline.
   /// 
   /// This sample loads a project from RPM repository,
   /// creates a baseline, assigns it to the project, 
   /// queries the baseline and loads it.
   /// </sample-summary>
   [TestFixture]
   public class WBSBaseline
   {
      public WBSBaseline()
      {

      }

      public static String projectName = "IBM_GENERIC_PROJECT_ABC";
      
      //Session ID is use for all transaction and is get from the 
      //Authenticate.login function. The session ID will replace 
      // the User password while transacting
      public static String sessionid;

      [Test]
      public void sampleTest()
      {

         // initialize a session with the API
         sessionid = APISetup.SetUp();

         // create a project scope
         // this scope enables us to save 
         // information around the project
         WorkElementScope tScope = new WorkElementScope();

         // create a project object
         Project project = new Project();

         // query the project
         project = (Project)APISetup.application.loadFromXpath(
            sessionid, "/Project[name='" + projectName + "']", 
            tScope ).rpmObjectList[0];

         // initialize baselineDate
         project.baselineDate = new WbsScheduleDate();
         project.baselineDate.durationInMinutes = 1440;

         // here we should run save baseline mehod

         // close connection with API
         APISetup.CleanUp(sessionid);
      }

   }
}
