/*
 * Licensed Materials - Use restricted, please refer to the "Sample Code" terms 
 * and conditions in the IBM International Program License Agreement (IPLA).
 * 
 *  Copyright IBM Corporation 2006, 2007. All Rights Reserved.
 */

package com.ibm.rpm.resource.sample;

import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SampleTestController;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.scope.PoolScope;

public class PoolFixtureSample extends SampleTestController
{
    static String poolName = "JavaFixture";

    protected void runSample() throws Exception
    {
        PoolScope scope = new PoolScope();
        Pool pool = new Pool();
        pool.setName(poolName);

        /*
         * Save the pool then reload it from the repository
         */
        save(pool, scope, ReloadType.None);
        pool = (Pool) loadFromXpath("/Pool[@name='" + poolName + "']", scope)
            .getRpmObjectList()[0];
    }

    public static void main(String[] args)
    {
        new PoolFixtureSample();
    }
}
