/*
 * Licensed Materials - Use restricted, please refer to the "Sample Code" terms 
 * and conditions in the IBM International Program License Agreement (IPLA).
 * 
 *  Copyright IBM Corporation 2006, 2007. All Rights Reserved.
 */

package com.ibm.rpm.resource.sample;

import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SampleTestController;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;

/**
 * This sample stores the main items that should be present for the samples to
 * run successfully.
 * 
 */
public class ResourceFixtureSample extends SampleTestController
{
    /**
     * The full name of the resource we use for the samples
     */
    static String resourceName = "RESOURCE";

    /**
     * The pool to which resourceName belongs to
     */
    static String poolName = "POOL_123";

    protected void runSample() throws Exception
    {
        Pool pool = new Pool();
        Resource res = new Resource();

        pool.setName(poolName);

        SaveResult result = save(pool, null, ReloadType.ReloadResult);
        pool = (Pool) result.getRpmObject();

        res.setFullName(resourceName);
        res.setParent(pool);

        save(res, null, ReloadType.None);
    }

    public static void main(String[] args)
    {
        new ResourceFixtureSample();
    }
}
