package com.ibm.rpm.wbs.sample;

/*
 * Licensed Materials - Use restricted, please refer to the "Sample Code" terms 
 * and conditions in the IBM International Program License Agreement (IPLA).
 * 
 *  Copyright IBM Corporation 2006, 2007. All Rights Reserved.
 */

import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SampleTestController;
import com.ibm.rpm.wbs.containers.ElementDependency;
import com.ibm.rpm.wbs.containers.Milestone;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.scope.ElementDependencyScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * This sample loads a task from the repository and assigns to it a dependency.
 * 
 * @desc Assign a dependency to a task
 * 
 */
public class WBSTaskDependency extends SampleTestController
{
    static String taskName = "CHILD_TASK";

    static String depName = "DEPENDENCY";

    static String sTaskName = "MILESTONE";

    protected void runSample() throws Exception
    {
        WorkElementScope tScope = new WorkElementScope();
        tScope.setDependencies(new ElementDependencyScope());

        Task task = (Task) loadFromXpath("/Task[@name='" + taskName + "']",
            tScope).getRpmObjectList()[0];
        ElementDependency elemDep = new ElementDependency();

        Milestone sTask = (Milestone) loadFromXpath(
            "/Milestone[@name='" + sTaskName + "']", null).getRpmObjectList()[0];
        elemDep.setParent(task);
        elemDep.setPredecessor(sTask);

        task.setDependencies(new ElementDependency[]
        {
            elemDep
        });

        save(task, tScope, ReloadType.None);
    }

    public static void main(String[] args)
    {
        new WBSTaskDependency();
    }
}
