package com.ibm.rpm.applicationadministration.checkpoints;

import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;

/**
 * @author mcduffs
 */
public class AdministrationModuleCheckpoint extends AbstractCheckpoint
{

    public void validateDelete(RPMObject rpmObject,
            MessageContext messageContext)
    {
        GenericValidator.validateCannotDelete(rpmObject, messageContext);
    }

    public void validateLoad(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext messageContext)
    {
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        if (rpmObject != null)
        {
            if (rpmScope.getParent() != null)
            {
                if (rpmObject.getParent() != null)
                {
                    GenericValidator.validateReadOnly(rpmObject, "parent",
                        msgCtx);
                }
            }
        }
    }
}
