/*
 * Created on Sep 16, 2005
 */
package com.ibm.rpm.applicationadministration.checkpoints;

import com.ibm.rpm.applicationadministration.containers.ContactGroupAssignment;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.containers.Resource;

public class ContactGroupAssignmentCheckpoint extends AbstractCheckpoint
{
    private static final Class CONTACTGROUPASSIGNMENT_PARENTS = Resource.class;

    protected static ContactGroupAssignmentCheckpoint instance = new ContactGroupAssignmentCheckpoint();

    public static ContactGroupAssignmentCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, true, CONTACTGROUPASSIGNMENT_PARENTS);

        if (!GenericValidator.validateInstance(rpmObject, ContactGroupAssignment.class,
            msgCtx))
            return;

        // Initialize
        ContactGroupAssignment mainCGA = (ContactGroupAssignment) rpmObject;

        // field validation: groups
        GenericValidator.validateMandatoryID(mainCGA, "groups", mainCGA.getGroups(),
            msgCtx);
    }
    
}
