/*
 * Created on Sep 16, 2005
 */
package com.ibm.rpm.applicationadministration.checkpoints;

import com.ibm.rpm.applicationadministration.constants.ValidationConstants;
import com.ibm.rpm.applicationadministration.containers.Currency;
import com.ibm.rpm.applicationadministration.containers.CurrencyExchangeRange;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;

/**
 * @author dominiqu
 */
public class CurrencyExchangeCheckpoint extends AbstractCheckpoint
{
    private static final Class CURRENCYEXCHANGERANGE_PARENTS = Currency.class;

    protected static CurrencyExchangeCheckpoint instance = new CurrencyExchangeCheckpoint();

    public static CurrencyExchangeCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, true, CURRENCYEXCHANGERANGE_PARENTS);

        if (!GenericValidator.validateInstance(rpmObject, CurrencyExchangeRange.class,
            msgCtx))
            return;

        // Initialize
        CurrencyExchangeRange mainCurrencyExchange = (CurrencyExchangeRange) rpmObject;

        // TODO Field validation: startDate
        // startDate must be greater than the max existing start date for the
        // currency
        // SELECT MAX(START_DATE) FROM CURRENCY_EXCHANGES
        // WHERE CURRENCY_ID = mainCurrencyExchange.getParent.getID();

        // Field validation: exchangeRate
        if (mainCurrencyExchange.testExchangeRateModified())
        {
            GenericValidator.validateRange(mainCurrencyExchange,
                "exchangeRate", mainCurrencyExchange.getExchangeRate(),
                ValidationConstants.CURRENCY_EXCHANGERATE_MIN,
                ValidationConstants.CURRENCY_EXCHANGERATE_MAX, msgCtx);
        }       
    }    
    
}
