/*
 * Created on Sep 19, 2005
 */
package com.ibm.rpm.applicationadministration.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.applicationadministration.containers.GeographicalAssignment;
import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.containers.Resource;

public class GeographicalAssignmentCheckpoint extends AbstractCheckpoint
{
    private static final List GEOGRAPHICALASSIGNMENT_PARENTS = new ArrayList();

    static
    {
        GEOGRAPHICALASSIGNMENT_PARENTS.add(Asset.class);
        GEOGRAPHICALASSIGNMENT_PARENTS.add(Resource.class);
    }

    protected static GeographicalAssignmentCheckpoint instance = new GeographicalAssignmentCheckpoint();

    public static GeographicalAssignmentCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, true, GEOGRAPHICALASSIGNMENT_PARENTS);

        if (!GenericValidator.validateInstance(rpmObject, GeographicalAssignment.class,
            msgCtx))
            return;

        // Initialize
        GeographicalAssignment mainGA = (GeographicalAssignment) rpmObject;

        // Field validation: geographical
        GenericValidator.validateMandatoryID(mainGA, "geographical", mainGA
            .getGeographical(), msgCtx);
    }
    
}
