package com.ibm.rpm.applicationadministration.managers;

import java.lang.reflect.Array;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;

import com.ibm.rpm.applicationadministration.containers.ActionRTF;
import com.ibm.rpm.applicationadministration.containers.ActionState;
import com.ibm.rpm.applicationadministration.containers.AssetCategory;
import com.ibm.rpm.applicationadministration.containers.AssetFinancialCategory;
import com.ibm.rpm.applicationadministration.containers.AssetRTF;
import com.ibm.rpm.applicationadministration.containers.AssetRevisionImpact;
import com.ibm.rpm.applicationadministration.containers.AssetRevisionType;
import com.ibm.rpm.applicationadministration.containers.AssetState;
import com.ibm.rpm.applicationadministration.containers.AssignmentStatus;
import com.ibm.rpm.applicationadministration.containers.BenefitDatafield1;
import com.ibm.rpm.applicationadministration.containers.BenefitDatafield2;
import com.ibm.rpm.applicationadministration.containers.BenefitDatafieldLabelText;
import com.ibm.rpm.applicationadministration.containers.BenefitLabelText;
import com.ibm.rpm.applicationadministration.containers.CapitalDatafield1;
import com.ibm.rpm.applicationadministration.containers.CapitalDatafield2;
import com.ibm.rpm.applicationadministration.containers.CapitalDatafieldLabelText;
import com.ibm.rpm.applicationadministration.containers.CapitalLabelText;
import com.ibm.rpm.applicationadministration.containers.ChangeRequestRTF;
import com.ibm.rpm.applicationadministration.containers.ChangeRequestState;
import com.ibm.rpm.applicationadministration.containers.ChargeCodeState;
import com.ibm.rpm.applicationadministration.containers.ChargeType;
import com.ibm.rpm.applicationadministration.containers.CitizenshipCountryCode;
import com.ibm.rpm.applicationadministration.containers.Classification;
import com.ibm.rpm.applicationadministration.containers.ClientRTF;
import com.ibm.rpm.applicationadministration.containers.CommonScopeRTF;
import com.ibm.rpm.applicationadministration.containers.CommonWbsRTF;
import com.ibm.rpm.applicationadministration.containers.CompanyNameCode;
import com.ibm.rpm.applicationadministration.containers.CompanySize;
import com.ibm.rpm.applicationadministration.containers.ContractType;
import com.ibm.rpm.applicationadministration.containers.CostCenterState;
import com.ibm.rpm.applicationadministration.containers.Currency;
import com.ibm.rpm.applicationadministration.containers.CurrencyExchangeRange;
import com.ibm.rpm.applicationadministration.containers.CustomDatafield;
import com.ibm.rpm.applicationadministration.containers.CustomDatafieldCategory;
import com.ibm.rpm.applicationadministration.containers.Datafield;
import com.ibm.rpm.applicationadministration.containers.DatafieldCategory;
import com.ibm.rpm.applicationadministration.containers.DatafieldRTF;
import com.ibm.rpm.applicationadministration.containers.DatafieldState;
import com.ibm.rpm.applicationadministration.containers.DefectRTF;
import com.ibm.rpm.applicationadministration.containers.DefectState;
import com.ibm.rpm.applicationadministration.containers.DeliverableRTF;
import com.ibm.rpm.applicationadministration.containers.DeliverableState;
import com.ibm.rpm.applicationadministration.containers.DocumentRevisionType;
import com.ibm.rpm.applicationadministration.containers.DocumentState;
import com.ibm.rpm.applicationadministration.containers.EmployeeStatus;
import com.ibm.rpm.applicationadministration.containers.ExpenseCapitalCommonBenefitDatafield1;
import com.ibm.rpm.applicationadministration.containers.ExpenseCapitalCommonBenefitDatafield2;
import com.ibm.rpm.applicationadministration.containers.ExpenseCapitalCommonDatafieldLabelText;
import com.ibm.rpm.applicationadministration.containers.ExpenseDatafield1;
import com.ibm.rpm.applicationadministration.containers.ExpenseDatafield2;
import com.ibm.rpm.applicationadministration.containers.ExpenseDatafieldLabelText;
import com.ibm.rpm.applicationadministration.containers.ExpenseLabelText;
import com.ibm.rpm.applicationadministration.containers.Experience;
import com.ibm.rpm.applicationadministration.containers.GenericDatafield;
import com.ibm.rpm.applicationadministration.containers.IndustryType;
import com.ibm.rpm.applicationadministration.containers.IssueRTF;
import com.ibm.rpm.applicationadministration.containers.IssueState;
import com.ibm.rpm.applicationadministration.containers.Language;
import com.ibm.rpm.applicationadministration.containers.MilestoneRTF;
import com.ibm.rpm.applicationadministration.containers.NoteMinutesRTF;
import com.ibm.rpm.applicationadministration.containers.NoteState;
import com.ibm.rpm.applicationadministration.containers.OrganizationType;
import com.ibm.rpm.applicationadministration.containers.PaymentType;
import com.ibm.rpm.applicationadministration.containers.PreferenceRank;
import com.ibm.rpm.applicationadministration.containers.ProficiencyLevel;
import com.ibm.rpm.applicationadministration.containers.ProjectRTF;
import com.ibm.rpm.applicationadministration.containers.ReconciliationReason;
import com.ibm.rpm.applicationadministration.containers.RequirementRTF;
import com.ibm.rpm.applicationadministration.containers.RequirementRevisionType;
import com.ibm.rpm.applicationadministration.containers.RequirementState;
import com.ibm.rpm.applicationadministration.containers.ResourceCustomFields;
import com.ibm.rpm.applicationadministration.containers.ResourceRevisionType;
import com.ibm.rpm.applicationadministration.containers.RevisionImpact;
import com.ibm.rpm.applicationadministration.containers.RiskRTF;
import com.ibm.rpm.applicationadministration.containers.RiskState;
import com.ibm.rpm.applicationadministration.containers.ScheduleImpact;
import com.ibm.rpm.applicationadministration.containers.ScopeElementsRevisionType;
import com.ibm.rpm.applicationadministration.containers.ScorecardRevisionType;
import com.ibm.rpm.applicationadministration.containers.ScorecardState;
import com.ibm.rpm.applicationadministration.containers.ServiceRequestRTF;
import com.ibm.rpm.applicationadministration.containers.ServiceRequestState;
import com.ibm.rpm.applicationadministration.containers.State;
import com.ibm.rpm.applicationadministration.containers.SummaryTaskRTF;
import com.ibm.rpm.applicationadministration.containers.TaskRTF;
import com.ibm.rpm.applicationadministration.containers.TaskState;
import com.ibm.rpm.applicationadministration.containers.ValueDatafield;
import com.ibm.rpm.applicationadministration.containers.WbsRevisionType;
import com.ibm.rpm.applicationadministration.containers.WorkLocation;
import com.ibm.rpm.applicationadministration.containers.WorkProductRTF;
import com.ibm.rpm.applicationadministration.containers.WorkingStatus;
import com.ibm.rpm.contract.managers.ContractManager;
import com.ibm.rpm.framework.AbstractModuleManager;
import com.ibm.rpm.framework.AbstractRPMObjectManager;
import com.ibm.rpm.framework.ContainerMap;
import com.ibm.rpm.framework.JoinCondition;
import com.ibm.rpm.framework.ManagerUtil;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMManagerFactory;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectManager;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.constants.ErrorCodes;
import com.ibm.rpm.framework.containers.AbstractModule;
import com.ibm.rpm.framework.types.SeverityLevel;
import com.ibm.rpm.framework.util.ArrayUtil;
import com.ibm.rpm.framework.util.BitField;
import com.ibm.rpm.framework.util.CollectionUtil;
import com.ibm.rpm.framework.util.ExceptionUtil;
import com.ibm.rpm.framework.util.FieldValueMap;
import com.ibm.rpm.framework.util.SqlBuffer;
import com.ibm.rpm.framework.util.SqlUtil;
import com.ibm.rpm.framework.util.StringUtil;
import com.ibm.rpm.resource.managers.ResourceAttributeManager;
import com.ibm.rpm.resource.managers.ResourceIndustryExperienceManager;
import com.ibm.rpm.resource.managers.ResourceLanguageProficiencyManager;
import com.ibm.rpm.resource.managers.ResourceProjectHistoryManager;
import com.ibm.rpm.scopemanagement.managers.ScopeManager;
import com.ibm.rpm.wbs.managers.ResourceTaskAssignmentManager;
import com.ibm.rpm.wbs.managers.WbsManager;
import com.ibm.rpm.xpathparser.XPathContainer;

/**
 * Manager for the TMT_DATAFIELDS table and related stored procedures. This
 * manager does not use a scope. A DatafieldCategory always loads its children.
 * A Datafield never loads its parent.
 *
 * <h3>Map Object Properties To TMT_DATAFIELDS Table Fields</h3>
 * <p>
 * <table border=1 cellspacing=0>
 * <tr>
 * <th>Object property</th>
 * <th>Table field</th>
 * <th>Comment</th>
 * </tr>
 * <tr>
 * <td>RPMObject.TypeID</td>
 * <td>TYPE_ID</td>
 * <td>See containerMap</td>
 * </tr>
 * <tr>
 * <td>RPMObject.ID</td>
 * <td>ELEMENT_ID</td>
 * <td>&nbsp;</td>
 * </tr>
 * <tr>
 * <td>RPMObject.Parent</td>
 * <td>PARENT_ID</td>
 * <td>&nbsp;</td>
 * </tr>
 * <tr>
 * <td>GenericDatafield.Name</td>
 * <td>ELEMENT_NAME or DESCRIPTION</td>
 * <td>Currency: DESCRIPTION; All others: ELEMENT_NAME. Currency is logically
 * deleted when DESCRIPTION is null.</td>
 * </tr>
 * <tr>
 * <td>Currency.ExchangeRate</td>
 * <td>ELEMENT_NAME</td>
 * <td>&nbsp;</td>
 * </tr>
 * <tr>
 * <td>ValueDatafield.Value</td>
 * <td>DESCRIPTION</td>
 * <td>&nbsp;</td>
 * </tr>
 * <td>--</td>
 * <td>LEVEL_ID</td>
 * <td>0:&nbsp;DatafieldGroup; 1:&nbsp;DatafieldCategory; 2:&nbsp;Datafield
 * </td>
 * </tr>
 * </table>
 */
public class DatafieldManager extends AbstractRPMObjectManager
{
    /**
     * Minimum value for TMT_DATAFIELD.ELEMENT_ID when isCustom(datafield).
     */
    public static final int MIN_CUSTOM_ID = 10000;

    private static final String CUSTOM_GROUP_ID = "10000";

    public static final int EDITABLE_RTF_BIT_FLAG = 1;

    public static final int APPEND_FROM_TOP_BIT_FLAG = 2;

    public static final int APPEND_FROM_BOTTOM_BIT_FLAG = 4;

    public static final int CLOSED_STATE_BIT_FLAG = 8;

    public static final int PROJECT_STATE_BIT_FLAG = 16;

    public static final int PROPOSAL_STATE_BIT_FLAG = 32;

    public static final int ORGANIZATIONAL_STATE_BIT_FLAG = 64;

    public static final String TABLE_NAME = "TMT_DATAFIELDS";

    // =============
    // CONTAINER MAP
    // =============

    private static Class[] containerClasses =
    {
            // Generic classes.
            GenericDatafield.class, DatafieldCategory.class,
            CustomDatafieldCategory.class, Datafield.class,
            ValueDatafield.class, DatafieldState.class, DatafieldRTF.class,
            // Concrete classes.
            ActionRTF.class, ActionState.class, AssetCategory.class,
            AssetFinancialCategory.class, AssetRevisionImpact.class,
            AssetRevisionType.class, AssetRTF.class, AssetState.class,
            AssignmentStatus.class, BenefitDatafield1.class,
            BenefitDatafield2.class, BenefitDatafieldLabelText.class,
            BenefitLabelText.class, CapitalDatafield1.class,
            CapitalDatafield2.class, CapitalDatafieldLabelText.class,
            CapitalLabelText.class, ChangeRequestRTF.class,
            ChangeRequestState.class, ChargeCodeState.class, ChargeType.class,
            CitizenshipCountryCode.class, Classification.class,
            ClientRTF.class, CommonScopeRTF.class, CommonWbsRTF.class,
            CompanyNameCode.class, CompanySize.class, ContractType.class,
            CostCenterState.class, Currency.class, CustomDatafield.class,
            DefectRTF.class, DefectState.class, DeliverableRTF.class,
            DeliverableState.class, DocumentRevisionType.class,
            DocumentState.class, EmployeeStatus.class,
            ExpenseCapitalCommonBenefitDatafield1.class,
            ExpenseCapitalCommonBenefitDatafield2.class,
            ExpenseCapitalCommonDatafieldLabelText.class,
            ExpenseDatafield1.class, ExpenseDatafield2.class,
            ExpenseDatafieldLabelText.class, ExpenseLabelText.class,
            Experience.class, IndustryType.class, IssueRTF.class,
            IssueState.class, Language.class, MilestoneRTF.class,
            NoteMinutesRTF.class, NoteState.class, OrganizationType.class,
            PaymentType.class, PreferenceRank.class, ProficiencyLevel.class,
            ProjectRTF.class, ReconciliationReason.class,
            RequirementRevisionType.class, RequirementRTF.class,
            RequirementState.class, ResourceCustomFields.class,
            ResourceRevisionType.class, RevisionImpact.class, RiskRTF.class,
            RiskState.class, ScheduleImpact.class,
            ScopeElementsRevisionType.class, ScorecardRevisionType.class,
            ScorecardState.class, ServiceRequestRTF.class,
            ServiceRequestState.class, State.class, SummaryTaskRTF.class,
            TaskRTF.class, TaskState.class, WbsRevisionType.class,
            WorkingStatus.class, WorkLocation.class, WorkProductRTF.class
    };

    private static ContainerMap containerMap = new ContainerMap(
            DatafieldManager.class, containerClasses);

    // =========
    // FIELD MAP
    // =========

    private static final HashMap FIELDPROPERTYMAP = new HashMap();

    private static final HashMap CURRENCY_FIELD_MAP = new HashMap();

    /**
     * Column LEVEL_ID of type Types.INTEGER mapped to Integer (INTEGER 4 Not
     * Nullable).
     */
    public static final int ID_LEVEL_ID = 1;

    public static final int TYPE_LEVEL_ID = Types.INTEGER;

    public static final String NAME_LEVEL_ID = "TMT_DATAFIELDS.LEVEL_ID";

    /**
     * Column TYPE_ID of type Types.INTEGER mapped to Integer (INTEGER 4 Not
     * Nullable).
     */
    public static final int ID_TYPE_ID = 2;

    public static final int TYPE_TYPE_ID = Types.INTEGER;

    public static final String NAME_TYPE_ID = "TMT_DATAFIELDS.TYPE_ID";

    /**
     * Column MAX_RANK of type Types.INTEGER mapped to Integer (INTEGER 4 Not
     * Nullable).
     */
    public static final int ID_MAX_RANK = 3;

    public static final int TYPE_MAX_RANK = Types.INTEGER;

    public static final String NAME_MAX_RANK = "TMT_DATAFIELDS.MAX_RANK";

    /**
     * Column CHILD_COUNT of type Types.INTEGER mapped to Integer (INTEGER 4 Not
     * Nullable).
     */
    public static final int ID_CHILD_COUNT = 4;

    public static final int TYPE_CHILD_COUNT = Types.INTEGER;

    public static final String NAME_CHILD_COUNT = "TMT_DATAFIELDS.CHILD_COUNT";

    /**
     * Column DELETED_COUNT of type Types.INTEGER mapped to Integer (INTEGER 4
     * Not Nullable).
     */
    public static final int ID_DELETED_COUNT = 5;

    public static final int TYPE_DELETED_COUNT = Types.INTEGER;

    public static final String NAME_DELETED_COUNT = "TMT_DATAFIELDS.DELETED_COUNT";

    /**
     * Column "POSITION" of type Types.INTEGER mapped to Integer (INTEGER 4 Not
     * Nullable).
     */
    public static final int ID_POSITION = 6;

    public static final int TYPE_POSITION = Types.INTEGER;

    public static final String NAME_POSITION = "TMT_DATAFIELDS.\"POSITION\"";

    /**
     * Column ELEMENT_ID of type Types.INTEGER mapped to Integer (INTEGER 4 Not
     * Nullable).
     */
    public static final int ID_ELEMENT_ID = 7;

    public static final int TYPE_ELEMENT_ID = Types.INTEGER;

    public static final String NAME_ELEMENT_ID = "TMT_DATAFIELDS.ELEMENT_ID";

    public static final String PROPERTY_ELEMENT_ID = "ID";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_ELEMENT_ID, SqlUtil.castAsChar(
                NAME_ELEMENT_ID, 32));
        CURRENCY_FIELD_MAP.put(PROPERTY_ELEMENT_ID, SqlUtil.castAsChar(
                NAME_ELEMENT_ID, 32));
    }

    /**
     * Column ELEMENT_NAME of type Types.CHAR mapped to String (CHARACTER 50
     * Nullable).
     */
    public static final int ID_ELEMENT_NAME = 8;

    public static final int TYPE_ELEMENT_NAME = Types.CHAR;

    public static final String NAME_ELEMENT_NAME = "TMT_DATAFIELDS.ELEMENT_NAME";

    public static final String PROPERTY_ELEMENT_NAME = "NAME";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_ELEMENT_NAME, NAME_ELEMENT_NAME);
        CURRENCY_FIELD_MAP.put("EXCHANGERATE", SqlUtil.castAsDouble(NAME_ELEMENT_NAME));
    }

    /**
     * Column PARENT_ID of type Types.INTEGER mapped to Integer (INTEGER 4 Not
     * Nullable).
     */
    public static final int ID_PARENT_ID = 9;

    public static final int TYPE_PARENT_ID = Types.INTEGER;

    public static final String NAME_PARENT_ID = "TMT_DATAFIELDS.PARENT_ID";

    /**
     * Column REC_USER of type Types.CHAR mapped to String (CHARACTER 32
     * Nullable).
     */
    public static final int ID_REC_USER = 10;

    public static final int TYPE_REC_USER = Types.CHAR;

    public static final String NAME_REC_USER = "TMT_DATAFIELDS.REC_USER";

    /**
     * Column REC_STATUS of type Types.CHAR mapped to String (CHARACTER 1 Not
     * Nullable).
     */
    public static final int ID_REC_STATUS = 11;

    public static final int TYPE_REC_STATUS = Types.CHAR;

    public static final String NAME_REC_STATUS = "TMT_DATAFIELDS.REC_STATUS";

    /**
     * Column REC_DATETIME of type Types.TIMESTAMP mapped to java.util.Date
     * (TIMESTAMP 10 Not Nullable).
     */
    public static final int ID_REC_DATETIME = 12;

    public static final int TYPE_REC_DATETIME = Types.TIMESTAMP;

    public static final String NAME_REC_DATETIME = "TMT_DATAFIELDS.REC_DATETIME";

    /**
     * Column RANK of type Types.VARCHAR mapped to String (VARCHAR 128 Not
     * Nullable).
     */
    public static final int ID_RANK = 13;

    public static final int TYPE_RANK = Types.VARCHAR;

    public static final String NAME_RANK = "TMT_DATAFIELDS.RANK";

    /**
     * Column DESCRIPTION of type Types.VARCHAR mapped to String (VARCHAR 2048
     * Nullable).
     */
    public static final int ID_DESCRIPTION = 14;

    public static final int TYPE_DESCRIPTION = Types.VARCHAR;

    public static final String NAME_DESCRIPTION = "TMT_DATAFIELDS.DESCRIPTION";

    public static final String PROPERTY_VALUE = "VALUE";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_VALUE, NAME_DESCRIPTION);
        CURRENCY_FIELD_MAP.put(PROPERTY_ELEMENT_NAME, NAME_DESCRIPTION);
    }

    /**
     * Column CONFIG_FLAG of type Types.INTEGER mapped to Integer (INTEGER 4 Not
     * Nullable).
     */
    public static final int ID_CONFIG_FLAG = 15;

    public static final int TYPE_CONFIG_FLAG = Types.INTEGER;

    public static final String NAME_CONFIG_FLAG = "TMT_DATAFIELDS.CONFIG_FLAG";

    /**
     * Create an array of type string containing all the fields of the
     * TMT_DATAFIELDS table.
     */
    private static final String[] FIELD_NAMES =
    {
            NAME_LEVEL_ID, NAME_TYPE_ID, NAME_MAX_RANK, NAME_CHILD_COUNT,
            NAME_DELETED_COUNT, NAME_POSITION, NAME_ELEMENT_ID,
            NAME_ELEMENT_NAME, NAME_PARENT_ID, NAME_REC_USER, NAME_REC_STATUS,
            NAME_REC_DATETIME, NAME_RANK, NAME_DESCRIPTION, NAME_CONFIG_FLAG
    };

    /**
     * Create an array of type string containing all the property names of the
     * fields of the TMT_DATAFIELDS table.
     */
    public static final String[] FIELD_PROPERTY_NAMES =
    {
            "NAME_LEVEL_ID", "NAME_TYPE_ID", "NAME_MAX_RANK",
            "NAME_CHILD_COUNT", "NAME_DELETED_COUNT", "NAME_POSITION",
            "NAME_ELEMENT_ID", "NAME_ELEMENT_NAME", "NAME_PARENT_ID",
            "NAME_REC_USER", "NAME_REC_STATUS", "NAME_REC_DATETIME",
            "NAME_RANK", "NAME_DESCRIPTION", "NAME_CONFIG_FLAG"
    };

    /**
     * Comma separated field names of the TMT_ORGANIZATIONS table.
     */
    private static final String ALL_FIELDS;
    static
    {
        StringBuffer fieldcat = new StringBuffer(FIELD_NAMES[0]);
        for (int i = 1; i < FIELD_NAMES.length; i++)
        {
            fieldcat.append(",");
            fieldcat.append(FIELD_NAMES[i]);
        }
        ALL_FIELDS = fieldcat.toString();
    };

    public DatafieldManager()
    {
        super();
    }

    public String getTableName()
    {
        return TABLE_NAME;
    }

    public String getFilter()
    {
        // Ensures that we never load a logically deleted datafield.
        return NAME_REC_STATUS + "!='D'";
    }

    protected String[] getFieldsNames()
    {
        return FIELD_NAMES;
    }

    protected String getAllFields()
    {
        return ALL_FIELDS;
    }

    public String getPrimaryKey()
    {
        return NAME_ELEMENT_ID;
    }

    protected HashMap getPropertiesMap(String fieldName, String containerName)
            throws RPMException
    {
        HashMap map = FIELDPROPERTYMAP;
        if ("Currency".equalsIgnoreCase(containerName))
        {
            map = CURRENCY_FIELD_MAP;
        }
        return map;
    }

    // ==========
    // XPATH LOAD
    // ==========

    public JoinCondition getJoinCondition(RPMObjectManager callingManager,
            XPathContainer container, String contextName) throws RPMException
    {
        // Create the basic filtering condition.
        String finalCondition = getFinalCondition(container);

        JoinCondition joinCondition = new JoinCondition();
        if (callingManager == null)
        {
            joinCondition.setTableName(TABLE_NAME);
            joinCondition.appendCondition(finalCondition);
        }
        else if (callingManager instanceof DatafieldManager)
        {
            joinCondition.appendSubSelect(NAME_PARENT_ID, NAME_ELEMENT_ID,
                    TABLE_NAME, finalCondition);
        }
        else if (callingManager instanceof CurrencyExchangeManager)
        {
            joinCondition.appendSubSelect(
                    CurrencyExchangeManager.NAME_CURRENCY_ID, NAME_ELEMENT_ID,
                    TABLE_NAME, finalCondition);
        }
        else
        {
            ExceptionUtil.handleUnsupportedJoinCondition(this, callingManager,
                    ExceptionUtil.JOIN);
        }

        return joinCondition;
    }

    protected JoinCondition getForeignKeyCondition(
            RPMObjectManager callingManager, String extraCondition,
            String contextName) throws RPMException
    {
        JoinCondition joinCondition = null;

        if (callingManager instanceof DatafieldManager)
        {
            // Note: used when loading children from DatafieldCategory.
            joinCondition = new JoinCondition(TABLE_NAME);
            joinCondition.appendEqualQuestionMark(NAME_PARENT_ID);
            joinCondition.appendCondition(extraCondition);
        }
        else if (callingManager instanceof ResourceAttributeManager)
        {
            joinCondition = new JoinCondition(TABLE_NAME);
            joinCondition.appendEqualQuestionMark(NAME_DESCRIPTION);
            joinCondition.appendEqual(NAME_TYPE_ID, ProficiencyLevel.TYPE_ID);
            joinCondition.appendCondition(extraCondition);
        }
        else if (callingManager instanceof RtfAssignmentManager)
        {
            joinCondition = new JoinCondition(TABLE_NAME);
            joinCondition.appendEqualQuestionMark(NAME_ELEMENT_NAME);
            joinCondition.appendEqualQuestionMark(NAME_TYPE_ID);
            joinCondition.appendCondition(extraCondition);
        }
        else if (callingManager instanceof AbstractModuleManager)
        {
            joinCondition = new JoinCondition(TABLE_NAME);
            joinCondition.appendCondition(extraCondition);
        }
        else
        {
            ExceptionUtil.handleUnsupportedJoinCondition(this, callingManager,
                    ExceptionUtil.FOREIGN_KEY);
        }

        return joinCondition;
    }

    public JoinCondition getSubTableJoinCondition(RPMObjectManager manager,
            XPathContainer container, String contextName) throws RPMException
    {
        JoinCondition joinCondition = null;
        String finalCondition = getFinalCondition(container);

        if (manager instanceof ResourceIndustryExperienceManager)
        {
            // For XPath like: /IndustryExperience[classification[<condition>]]
            // WHERE cast(RESOURCE_INDUSTRY_EXPERIENCE.CLASSIFICATION AS
            // integer) IN
            // (SELECT TMT_DATAFIELDS.ELEMENT_ID FROM TMT_DATAFIELDS WHERE
            // TMT_DATAFIELDS.LEVEL_ID=2 AND TMT_DATAFIELDS.TYPE_ID=26 AND
            // (TMT_DATAFIELDS.ELEMENT_ID = 2723)) WITH UR

            String columnName = null;

            // TODO use the fieldName parameter instead of contextName when it
            // will be added to the getSubTableJoinCondition method.

            if (container.getShortTypeName().equalsIgnoreCase(
                    StringUtil
                            .getShortClassName(Classification.class.getName()))
                    || contextName.equalsIgnoreCase("classification"))
            {
                columnName = "cast("
                        + ResourceIndustryExperienceManager.NAME_CLASSIFICATION
                        + " AS integer)";
            }
            else if (container.getShortTypeName().equalsIgnoreCase(
                    StringUtil.getShortClassName(IndustryType.class.getName()))
                    || contextName.equalsIgnoreCase("industry"))
            {
                columnName = ResourceIndustryExperienceManager.NAME_INDUSTRY_ID;
            }
            else if (container.getShortTypeName().equalsIgnoreCase(
                    StringUtil.getShortClassName(ProficiencyLevel.class
                            .getName()))
                    || contextName.equalsIgnoreCase("proficiency"))
            {
                columnName = ResourceIndustryExperienceManager.NAME_PROF_LEVEL;
            }

            //the column name should never be null because the field name was
            // validated before this mathod was called
            if (columnName != null)
            {
                joinCondition = new JoinCondition();
                joinCondition.append(columnName);
                joinCondition.append(" IN (SELECT ");
                joinCondition.append(NAME_ELEMENT_ID);
                joinCondition.append(" FROM ");
                joinCondition.append(TABLE_NAME);
                joinCondition.append(" WHERE ");
                joinCondition.append(finalCondition);
            }
        }
        else if (manager instanceof DatafieldManager)
        {
            // For XPath queries like:
            // /DatafieldCategory[Datafield[<condition>]]
            // /DatafieldCategory[GenericDatafield[<condition>]]
            // /CustomDatafieldCategory[CustomDatafield[<condition>]]
            joinCondition = JoinCondition.createSubSelect(NAME_ELEMENT_ID,
                    NAME_PARENT_ID, TABLE_NAME, finalCondition);
        }
        else if (manager instanceof WbsManager)
        {
            // For XPath like: /Project[assetCode[<condition>]]
            Class containerType = container.getType();
            String columnName;
            if (DatafieldState.class.equals(containerType))
                columnName = WbsManager.NAME_STAGE_ID;
            else if (Currency.class.equals(containerType))
                columnName = WbsManager.NAME_CURRENCY_ID;
            else
                columnName = WbsManager.NAME_FINANCIAL_CATEGORY;
            joinCondition = new JoinCondition(TABLE_NAME);
            joinCondition.appendSubSelect(columnName, NAME_ELEMENT_ID,
                    TABLE_NAME, finalCondition);
        }
        else if (manager instanceof ResourceTaskAssignmentManager)
        {
            // For XPath queries like /ResourceTaskAssignment[workLocation[<condition>]]
            joinCondition = new JoinCondition();
            joinCondition
                    .append(ResourceTaskAssignmentManager.NAME_WORK_LOCATION);
            joinCondition.append(" IN (SELECT ");
            joinCondition.append(NAME_ELEMENT_ID);
            joinCondition.append(" FROM ");
            joinCondition.append(TABLE_NAME);
            joinCondition.append(" WHERE ");
            joinCondition.append(finalCondition);
        }
        else if (manager instanceof ResourceProjectHistoryManager)
        {
            String columnName = null;

            //Note: We can use the containerName here since there is only one
            // Classification and one IndustryType in a ProjectHistory.
            //An exception will be thrown if containerName equals Datafield

            //TODO use the fieldName parameter instead of contextName when it
            // will be added to the getSubTableJoinCondition method.

            if (container.getShortTypeName().equalsIgnoreCase(
                    StringUtil
                            .getShortClassName(Classification.class.getName()))
                    || contextName.equalsIgnoreCase("classification"))
            {
                columnName = "cast("
                        + ResourceProjectHistoryManager.NAME_CLASSIFICATION
                        + " AS integer)";
            }
            else if (container.getShortTypeName().equalsIgnoreCase(
                    StringUtil.getShortClassName(IndustryType.class.getName()))
                    || contextName.equalsIgnoreCase("industry"))
            {
                columnName = ResourceProjectHistoryManager.NAME_INDUSTRY_ID;
            }
            
            if (columnName != null)
            {
                joinCondition = new JoinCondition();
                joinCondition.append(columnName);
                joinCondition.append(" IN (SELECT ");
                joinCondition.append(NAME_ELEMENT_ID);
                joinCondition.append(" FROM ");
                joinCondition.append(TABLE_NAME);
                joinCondition.append(" WHERE ");
                joinCondition.append(finalCondition);
            }
        }
        else if (manager instanceof ResourceLanguageProficiencyManager)
        {
            joinCondition = new JoinCondition();
            joinCondition
                    .append(ResourceLanguageProficiencyManager.NAME_LANGUAGE_ID);
            joinCondition.append(" IN (SELECT ");
            joinCondition.append(NAME_ELEMENT_ID);
            joinCondition.append(" FROM ");
            joinCondition.append(TABLE_NAME);
            joinCondition.append(" WHERE ");
            joinCondition.append(finalCondition);
        }
        else if (manager instanceof ContractManager)
        {
            Class containerType = container.getType();
            String columnName;
            if (Currency.class.equals(containerType))
                columnName = ContractManager.NAME_CURRENCY_ID;
            else
                columnName = ContractManager.NAME_CONTRACT_TYPE;
            joinCondition = new JoinCondition(TABLE_NAME);
            joinCondition.appendSubSelect(columnName, NAME_ELEMENT_ID,
                    TABLE_NAME, null);
        }
        else if (manager instanceof ResourceAttributeManager)
        {
            joinCondition = JoinCondition.createSubSelect(
                ResourceAttributeManager.NAME_PROFICIENCY_LEVEL_ID,
                NAME_ELEMENT_ID, TABLE_NAME, finalCondition);
        }
        else if (manager instanceof ScopeManager)
        {
            if ("assetCode".equals(container.getPreviousFieldName()))
            {
                joinCondition = JoinCondition.createSubSelect(
                    ScopeManager.NAME_FINANCIAL_CATEGORY, NAME_ELEMENT_ID,
                    TABLE_NAME, finalCondition);
            }
            else if ("state".equals(container.getPreviousFieldName()))
            {
                joinCondition = JoinCondition.createSubSelect(
                    ScopeManager.NAME_STAGE_ID, NAME_ELEMENT_ID, TABLE_NAME,
                    null);
            } 
        }
        else
        {
            ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
                    ExceptionUtil.SUB_TABLE_JOIN);
        }

        return joinCondition;
    }

    // =======
    // FILTERS
    // =======

    private String getFinalCondition(XPathContainer container)
            throws RPMException
    {
        // Add the container filter, if required.
        SqlBuffer finalCondition = getContainerFilter(container.getType());

        return finalCondition.toString();
    }

    /**
     * Get the right filter for the container.
     */
    private SqlBuffer getContainerFilter(Class containerClass)
            throws RPMException
    {
        SqlBuffer filter = new SqlBuffer(getFilter());
        if (GenericDatafield.class.equals(containerClass))
        {
            filter.appendCondition(NAME_LEVEL_ID + ">0");
        }
        else if (CustomDatafieldCategory.class.equals(containerClass))
        {
            filter.appendEqual(NAME_TYPE_ID, CustomDatafieldCategory.TYPE_ID);
        }
        else if (DatafieldCategory.class.equals(containerClass))
        {
            filter.appendEqual(NAME_LEVEL_ID, 1);
        }
        else if (Datafield.class.equals(containerClass))
        {
            filter.appendEqual(NAME_LEVEL_ID, 2);
        }
        else if (DatafieldRTF.class.equals(containerClass))
        {
            //A generic datafieldRTF is loaded
            int[] datafieldRTFTypes = new int[] { ActionRTF.TYPE_ID,
					AssetRTF.TYPE_ID, ChangeRequestRTF.TYPE_ID,
					ClientRTF.TYPE_ID, CommonScopeRTF.TYPE_ID,
					CommonWbsRTF.TYPE_ID, DefectRTF.TYPE_ID,
					DeliverableRTF.TYPE_ID, IssueRTF.TYPE_ID,
					MilestoneRTF.TYPE_ID, NoteMinutesRTF.TYPE_ID,
					ProjectRTF.TYPE_ID, RequirementRTF.TYPE_ID,
					RiskRTF.TYPE_ID, ServiceRequestRTF.TYPE_ID,
					SummaryTaskRTF.TYPE_ID, TaskRTF.TYPE_ID,
					WorkProductRTF.TYPE_ID };
			filter.appendIn(NAME_TYPE_ID, datafieldRTFTypes);            
        }
        else
        {
            Integer typeId = containerMap.getTypeId(containerClass);
            if (typeId != null)
            {
                filter.appendEqual(NAME_LEVEL_ID, 2);
                filter.appendEqual(NAME_TYPE_ID, typeId);
                if (Currency.class.equals(containerClass))
                {
                    filter.appendIsNotNull(NAME_DESCRIPTION);
                }
            }
            else
            {
                throw new RPMException("Unsupported container "
                        + containerClass);
            }
        }

        return filter;
    }

    // ====
    // LOAD
    // ====

    public RPMObject loadByPrimaryKey(RPMObject rpmObject,
            RPMObjectScope rpmScope, MessageContext messageContext,
            boolean isDelta) throws RPMException, ParseException, SQLException
    {
        if (rpmObject == null)
        {
            return null;
        }
        
        if( ! isDelta )
        {
            RPMObject cachedContainer = getContainerInCacheWithScope( 
                rpmObject, rpmScope, messageContext);
            
            if(cachedContainer != null)
            {
                return cachedContainer;
            }
        }
        
        RPMObject outputObject = null;
        try
        {
            // Build the SQL statement with filter.
            SqlBuffer statement = new SqlBuffer();
            statement.appendSelect();
            statement.append(getAllFields());
            statement.appendFrom(getTableName(rpmObject));
            statement.appendWhere();
            statement.appendCondition(getFilter());
            Integer argument;
            String stringId = rpmObject.getID();
            if (stringId != null)
            {
                argument = Integer.valueOf(stringId);
                statement.appendEqual(NAME_ELEMENT_ID, argument);
            }
            else
            {
                argument = rpmObject.retrieveTypeID();
                if (argument == null
                        || argument.intValue() == CustomDatafieldCategory.TYPE_ID)
                {
                    throw new RPMException("Null ID and invalid Type ID.");
                }
                else if (! DatafieldCategory.class.equals(rpmObject.getClass()))
                {
                    throw new RPMException(
                            "Only DatafieldCategory can be loaded by Type ID.");
                }
                statement.appendEqual(NAME_TYPE_ID, argument);
                statement.appendEqual(NAME_LEVEL_ID, 1);
            }

            // Get the context name.
            String contextName = rpmObject.getContextName();

            // Build the object array.
            RPMObject inputObject = isDelta ? rpmObject : null;
            RPMObject[] inputObjects = new RPMObject[]
            {
                inputObject
            };
	
	        ArrayList objects = loadBySelect(null, inputObjects, rpmScope,
	            messageContext, statement.toString(), null, contextName, isDelta);
	
	        if (! CollectionUtil.isEmpty(objects))
	        {
	            outputObject = (RPMObject) objects.get(0);
	        }
	        else
	        {
	            addInvalidDatafieldIDErrorToContext(rpmObject, messageContext);
	        }
        }
        catch ( NumberFormatException ex )
        {
            addInvalidDatafieldIDErrorToContext(rpmObject, messageContext);
        }
        catch (Exception x)
        {
            messageContext.addException(x);
        }
        return outputObject;
    }

    /**
     * @param rpmObject
     * @param messageContext
     * @throws RPMException
     */
    private void addInvalidDatafieldIDErrorToContext(RPMObject rpmObject,
        MessageContext messageContext) throws RPMException
    {
        String[] errorParams =
        {
                StringUtil.getShortClassName(rpmObject.getClass()),
                rpmObject.getID()
        };
        RPMException e = new RPMException(
            ErrorCodes.AM_INVALID_RPMOBJECTID, errorParams,
            rpmObject.getClass().getName(), null, rpmObject.getID());
        SeverityLevel severity = messageContext.isRootObject(rpmObject) 
        	? SeverityLevel.SevereError : SeverityLevel.Warning;
        e.setSeverity(severity);
        messageContext.addException(e);
    }

    /**
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#decodeRow(java.sql.ResultSet,
     *      com.ibm.rpm.containers.RPMObject, int)
     */
    protected RPMObject decodeRow(ResultSet rs, RPMObject object,
            boolean isDelta) throws SQLException
    {
        // Decode the generic properties.
        GenericDatafield genDatafield = (GenericDatafield) object;
        int typeId = rs.getInt(ID_TYPE_ID);
        Integer typeIdObject = new Integer(typeId);
        String elementName = rs.getString(ID_ELEMENT_NAME);
        String description = rs.getString(ID_DESCRIPTION);
        String name;
        String value;
        if (typeId == Currency.TYPE_ID)
        {
            // Go figure why!
            name = description;
            value = elementName;
        }
        else
        {
            name = elementName;
            value = description;
        }
        //remove trailing spaces
        if(name!=null)
        {
            name = name.trim();
        }
        if (isDelta)
        {
            genDatafield.deltaTypeID(typeIdObject); // Useless???
            // Design note: name is writable only for some types.
            if (nameIsWritable(genDatafield))
            {
                genDatafield.deltaName(name);
            }
            else
            {
                genDatafield.setName(name);
            }
        }
        else
        {
            genDatafield.setID(rs.getString(ID_ELEMENT_ID));
            genDatafield.assignTypeID(typeIdObject); // Useless???
            genDatafield.setName(name);
        }

        if (genDatafield instanceof Currency)
        {
            Currency currency = (Currency) genDatafield;
            Double exchangeRate = ManagerUtil.toDouble(value);
            if (isDelta)
            {
                currency.deltaExchangeRate(exchangeRate);
            }
            else
            {
                currency.setExchangeRate(exchangeRate);
            }
        }
        else if (genDatafield instanceof ValueDatafield)
        {
            ValueDatafield valueDatafield = (ValueDatafield) genDatafield;
            if (isDelta)
            {
                valueDatafield.deltaValue(value);
            }
            else
            {
                valueDatafield.setValue(value);
            }

            if (genDatafield instanceof DatafieldRTF)
            {
                DatafieldRTF datafieldRTF = (DatafieldRTF) genDatafield;
                int configFlag = rs.getInt(ID_CONFIG_FLAG);
                if (isDelta)
                {
                    datafieldRTF.deltaAppendOnly(BitField.isSetBoolean(
                            configFlag, APPEND_FROM_TOP_BIT_FLAG));
                }
                else
                {
                    datafieldRTF.setAppendOnly(BitField.isSetBoolean(
                            configFlag, APPEND_FROM_TOP_BIT_FLAG));
                }
            }
            else if (genDatafield instanceof DatafieldState)
            {
                DatafieldState datafieldState = (DatafieldState) genDatafield;
                int configFlag = rs.getInt(ID_CONFIG_FLAG);
                if (isDelta)
                {
                    datafieldState.deltaClosedState(BitField.isSetBoolean(
                            configFlag, CLOSED_STATE_BIT_FLAG));
                }
                else
                {
                    datafieldState.setClosedState(BitField.isSetBoolean(
                            configFlag, CLOSED_STATE_BIT_FLAG));
                }
                
                if (genDatafield instanceof State)
                {
                    State state = (State) genDatafield;
                    if (isDelta)
                    {
                        state.deltaProposal(BitField.isSetBoolean(
                                configFlag, PROPOSAL_STATE_BIT_FLAG));
                    }
                    else
                    {
                        state.setProposal(BitField.isSetBoolean(
                                configFlag, PROPOSAL_STATE_BIT_FLAG));
                    }
                }
                
            }
        }

        return object;
    }

    /**
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#loadRelatedObjects(com.ibm.rpm.containers.RPMObject,
     *      com.ibm.rpm.scope.RPMObjectScope, com.ibm.rpm.MessageContext,
     *      boolean, com.ibm.rpm.FieldValueMap, int)
     */
    protected RPMObject loadRelatedObjects(RPMObject rpmObject,
            RPMObjectScope rpmScope, MessageContext messageContext,
            FieldValueMap relatedFields, int index, boolean isDelta)
            throws RPMException, SQLException, ParseException
    {
        if (rpmObject instanceof DatafieldCategory)
        {
            DatafieldCategory category = (DatafieldCategory) rpmObject;
            category.setChildren((Datafield[]) loadChildren(rpmObject, category
                    .getChildren(), Datafield.class, messageContext, isDelta));
        }
        else if (rpmObject instanceof Currency)
        {
            Currency currency = (Currency) rpmObject;
            loadCurrencyExchangeRanges(currency, messageContext, isDelta);
        }
        else if ( rpmObject instanceof Datafield )
        {
            Datafield object = (Datafield) rpmObject;
            if ( rpmScope != null )
            {
                if ( rpmScope.getParent() != null )
                {
                    String oldParentId = (String) relatedFields.get(index,
                        ID_PARENT_ID);
                    DatafieldCategory newParent = null;

                    if (isDelta)
                    {
                        newParent = (DatafieldCategory) object.getParent();
                        DatafieldCategory oldParent = null;
                        if (oldParentId != null)
                        {
                            oldParent = new DatafieldCategory();
                            oldParent.setID(oldParentId);
                            if (newParent != null && newParent.getID() != null
                                    && newParent.getID().equals(oldParentId))
                            {
                                oldParent = (DatafieldCategory) loadByPrimaryKey(
                                    newParent, rpmScope.getParent(), messageContext,
                                    true);
                            }
                            else
                            {
                                ExceptionUtil.handleParentReference(this, object);
                            }
                        }
                        else
                        {
                            if (newParent != null)
                            {
                                ExceptionUtil.handleParentReference(this, object);
                            }
                        }
                        object.deltaParent(oldParent);
                    }
                    else
                    {
                        if (oldParentId != null)
                        {
                            newParent = new DatafieldCategory();
                            newParent.setID(oldParentId);
                            newParent = (DatafieldCategory) loadByPrimaryKey(newParent,
                                rpmScope.getParent(), messageContext, false);
                            object.setParent(newParent);
                        }
                    }
                }
            }
        }
        return rpmObject;
    }

    private RPMObject[] loadChildren(RPMObject parent, RPMObject[] children,
            Class childrenClass, MessageContext messageContext, boolean isDelta)
            throws SQLException, RPMException, ParseException
    {
        // This parent ID is used as the foreign key for its children.
        Object[] arguments =
        {
            parent.getID()
        };
        ArrayList childrenList = loadByForeignKey(children, null,
                messageContext, this, arguments, null, parent.getContextName(),
                isDelta);
        if (childrenList != null)
        {
            int childrenCount = childrenList.size();
            if (childrenCount > 0)
            {
                children = (RPMObject[]) Array.newInstance(childrenClass,
                        childrenCount);
                childrenList.toArray(children);
                for (int i = 0; i < childrenCount; i++)
                {
                    children[i].setParent(parent);
                }
            }
        }
        return children;
    }

    private Currency loadCurrencyExchangeRanges(Currency currency,
            MessageContext messageContext, boolean isDelta)
            throws RPMException, ParseException, SQLException
    {
        RPMObjectManager manager = RPMManagerFactory.getInstance()
                .getRPMObjectManager(CurrencyExchangeRange.class.getName());
        ArrayList temp = manager.loadByForeignKey(currency.getExchangeRanges(),
                null, messageContext, this, new Object[]
                {
                    new Integer(currency.getID())
                }, null, null, isDelta);
        CurrencyExchangeRange[] children = null;
        if (temp != null)
        {
            children = new CurrencyExchangeRange[temp.size()];
            temp.toArray(children);
        }
        currency.setExchangeRanges(children);
        return currency;
    }

    // ========
    // DELETION
    // ========

    protected void doDelete(RPMObject rpmObject, MessageContext messageContext)
            throws RPMException, SQLException, ParseException
    {
        if (isCustom(rpmObject))
        {
            String parentId = ManagerUtil.getIntParentId(this, rpmObject,
                    messageContext, TABLE_NAME);
            SP_D_DATAFIELD(rpmObject.getID(), parentId, messageContext);
        }
        else if (rpmObject instanceof Currency)
        {
            Currency currency = (Currency) rpmObject;
            String currencyId = currency.getID();
            Integer intCurrencyId = new Integer(currencyId);
            if (intCurrencyId.intValue() >= 1000)
            {
                // Logically delete the Currency: set ELEMENT_NAME and
                // DESCRIPTION to NULL.
                SP_U_DATAFIELD(currencyId, null, null, messageContext);
                // Delete all CurrencyExchangeRange linked to any deleted
                // Currency (general cleanup).
                // DELETE FROM CURRENCY_EXCHANGES WHERE
                // CURRENCY_EXCHANGES.ELEMENT_ID IN (SELECT
                // CURRENCY_EXCHANGES.ELEMENT_ID FROM TMT_DATAFIELDS,
                // CURRENCY_EXCHANGES WHERE TMT_DATAFIELDS.TYPE_ID=37 AND
                // TMT_DATAFIELDS.ELEMENT_ID=CURRENCY_EXCHANGES.CURRENCY_ID AND
                // TMT_DATAFIELDS.DESCRIPTION IS NULL).
                SqlBuffer deleteStatement = new SqlBuffer();
                deleteStatement
                        .appendDelete(CurrencyExchangeManager.TABLE_NAME);
                deleteStatement.appendSubSelect(
                        CurrencyExchangeManager.NAME_ELEMENT_ID,
                        CurrencyExchangeManager.NAME_ELEMENT_ID,
                        CurrencyExchangeManager.TABLE_NAME, null);
                deleteStatement.appendComma();
                deleteStatement.append(TABLE_NAME);
                deleteStatement.appendWhere();
                deleteStatement.appendEqual(NAME_TYPE_ID, Currency.TYPE_ID);
                deleteStatement.appendEqualFields(NAME_ELEMENT_ID,
                        CurrencyExchangeManager.NAME_CURRENCY_ID);
                deleteStatement.appendIsNull(NAME_DESCRIPTION);
                ManagerUtil.delete(currency, "exchangeRanges", deleteStatement,
                        null, messageContext);
            }
            else
            {
                ExceptionUtil.handleNoDelete(this, rpmObject);
            }
        }
        else
        {
            ExceptionUtil.handleNoDelete(this, rpmObject);
        }
    }

    private static boolean nameIsWritable(RPMObject rpmObject)
    {
        return isCustom(rpmObject) || (rpmObject instanceof Currency);
    }

    public static boolean isCustom(RPMObject rpmObject)
    {
        return (rpmObject instanceof CustomDatafield || rpmObject instanceof CustomDatafieldCategory);
    }

    // ========
    // CREATION
    // ========

    public RPMObject createContainer(ResultSet resultSet,
            MessageContext messageContext) throws RPMException, SQLException
    {
        int typeId = resultSet.getInt(ID_TYPE_ID);
        int levelId = resultSet.getInt(ID_LEVEL_ID);
        RPMObject container;

        if (levelId == 1)
        {
            container = createDatafieldCategory(typeId);
        }
        else if (levelId == 2)
        {
            container = containerMap.createContainer(typeId);
        }
        else
        {
            throw new RPMException("Unsupported level ID: " + levelId);
        }

        return container;
    }

    private DatafieldCategory createDatafieldCategory(int typeId)
    {
        DatafieldCategory category;
        if (typeId == CustomDatafieldCategory.TYPE_ID)
        {
            category = new CustomDatafieldCategory();
        }
        else
        {
            category = new DatafieldCategory();
        }
        category.assignTypeID(new Integer(typeId));
        return category;
    }

    public void createObject(RPMObject rpmObject, MessageContext messageContext)
            throws SQLException, RPMException, ParseException
    {
        if (isCustom(rpmObject))
        {
            GenericDatafield genDatafield = (GenericDatafield) rpmObject;
            String parentId;
            if (rpmObject instanceof CustomDatafieldCategory)
            {
                // Unique, hardcoded, custom datafield group.
                parentId = CUSTOM_GROUP_ID;
            }
            else
            {
                parentId = genDatafield.getParent().getID();
            }
            String id = SP_I_DATAFIELD(genDatafield.getName(), null, parentId,
                    genDatafield.retrieveTypeID(), messageContext);
            genDatafield.setID(id);
        }
        else if (rpmObject instanceof Currency)
        {
            SqlBuffer condition = new SqlBuffer();
            condition.appendEqual(NAME_TYPE_ID, Currency.TYPE_ID);
            condition.appendEqual(NAME_LEVEL_ID, 2);
            condition.appendIsNull(NAME_DESCRIPTION);
            condition.appendOrderBy(NAME_ELEMENT_ID);
            Integer id = (Integer) ManagerUtil.selectColumnValue(Integer.class,
                    rpmObject, "ID", NAME_ELEMENT_ID, TABLE_NAME,
                    condition, messageContext);
            rpmObject.setID(id.toString());
        }
        else
        {
            ExceptionUtil.handleNoCreate(this, rpmObject);
        }
    }

    // ======
    // UPDATE
    // ======

    public RPMObject updateObject(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext messageContext) throws SQLException, RPMException,
            ParseException
    {
        GenericDatafield genDatafield = (GenericDatafield) rpmObject;

        // Update the name and value, if required.
        updateNameAndValue(genDatafield, messageContext);

        // Update the configuration flag, if required.
        updateConfigurationFlag(genDatafield, messageContext);

        // Update children, if required.
        updateChildren(genDatafield, messageContext);

        // Update exchange ranges, if required.
        if (rpmObject instanceof Currency)
        {
            Currency currency = (Currency) rpmObject;
            currency
                    .setExchangeRanges((CurrencyExchangeRange[]) updateChildren(
                            currency, currency.getExchangeRanges(), true,
                            messageContext, null));
        }

        return genDatafield;
    }

    private void updateNameAndValue(GenericDatafield genDatafield,
            MessageContext messageContext) throws SQLException, RPMException,
            ParseException
    {
        // Get the name.
        String name = genDatafield.getName();
        boolean willUpdateNameAndValue = genDatafield.testNameModified();

        // Get the value.
        String value = null;
        if (genDatafield instanceof ValueDatafield)
        {
            ValueDatafield datafield = (ValueDatafield) genDatafield;
            value = datafield.getValue();
            willUpdateNameAndValue |= datafield.testValueModified();
        }
        // Special (weird) case for Currency.
        else if (genDatafield instanceof Currency)
        {
            Currency currency = (Currency) genDatafield;
            value = name;
            name = StringUtil.toString(currency.getExchangeRate());
            willUpdateNameAndValue |= currency.testExchangeRateModified();
        }

        // Call the stored procedures, if required.
        if (willUpdateNameAndValue)
        {
            SP_U_DATAFIELD(genDatafield.getID(), name, value, messageContext);
        }
    }

    private void updateConfigurationFlag(GenericDatafield genDatafield,
            MessageContext messageContext) throws SQLException, RPMException
    {
        boolean willUpdateConfigFlag = false;
        int configFlag = 0;
        if (genDatafield instanceof DatafieldRTF)
        {
            DatafieldRTF datafieldRTF = (DatafieldRTF) genDatafield;
            
            configFlag = BitField.set(configFlag, APPEND_FROM_TOP_BIT_FLAG,
                datafieldRTF.getAppendOnly());

            if (datafieldRTF.testAppendOnlyModified())
            {
                willUpdateConfigFlag = true;
            }
        }
        else if (genDatafield instanceof DatafieldState)
        {
            DatafieldState datafieldState = (DatafieldState) genDatafield;
            if (datafieldState.testClosedStateModified())
            {
                willUpdateConfigFlag = true;
            }

            configFlag = BitField.set(configFlag, CLOSED_STATE_BIT_FLAG,
                datafieldState.getClosedState());
            
            if (genDatafield instanceof State)
            {
                State state = (State) genDatafield;
                
                configFlag = BitField.set(configFlag, PROPOSAL_STATE_BIT_FLAG,
                    state.getProposal());

                if (state.testProposalModified())
                {
                    willUpdateConfigFlag = true;
                }
            }
            
        }
        if (willUpdateConfigFlag)
        {
            SP_U_DATAFIELD_CONFIG_FLAG(genDatafield.getID(), configFlag,
                    messageContext);
        }
    }

    private void updateChildren(GenericDatafield genDatafield,
            MessageContext messageContext) throws SQLException, RPMException,
            ParseException
    {
        if (genDatafield instanceof DatafieldCategory)
        {
            DatafieldCategory category = (DatafieldCategory) genDatafield;
            category.setChildren((Datafield[]) updateChildren(category,
                    category.getChildren(), true, messageContext, null));
        }
    }

    // ======================
    // STORED PROCEDURE CALLS
    // ======================

    private String SP_I_DATAFIELD(String name, String value, String parentId,
            Integer typeId, MessageContext messageContext) throws SQLException,
            RPMException, ParseException
    {
        Object args[] = new Object[5];
        args[0] = name;
        args[1] = value;
        args[2] = parentId;
        args[3] = typeId;
        args[4] = getUser(messageContext).getID();
        return executeProcedure(messageContext, "SP_I_DATAFIELD", args);
    }

    private void SP_U_DATAFIELD_CONFIG_FLAG(String id, int configFlag,
            MessageContext messageContext) throws SQLException, RPMException
    {
        Object args[] = new Object[3];
        args[0] = id;
        args[1] = new Integer(configFlag);
        args[2] = getUser(messageContext).getID();
        executeProcedure(messageContext, "SP_U_DATAFIELD_CONFIG_FLAG", args);
    }

    private void SP_U_DATAFIELD(String id, String name, String value,
            MessageContext messageContext) throws SQLException, RPMException,
            ParseException
    {
        Object args[] = new Object[4];
        args[0] = id;
        args[1] = name;
        args[2] = value;
        args[3] = getUser(messageContext).getID();
        executeProcedure(messageContext, "SP_U_DATAFIELD", args);
    }

    /**
     * Deletes a CustomDatafieldCategroy or a CustomDatafield.
     */
    private void SP_D_DATAFIELD(String objectId, String parentId,
            MessageContext messageContext) throws SQLException, RPMException
    {
        Object args[] = new Object[4];
        args[0] = objectId;
        args[1] = parentId;
        args[2] = "X";
        args[3] = getUser(messageContext).getID();

        executeProcedure(messageContext, "SP_D_DATAFIELD", args);
    }

    // ==========
    // MODULES
    // ==========

    public Datafield[] loadDatafields(AbstractModule abstractModule,
            Datafield[] datafields, Class datafieldBaseClass, int unused,
            RPMObjectManager manager, String contextName,
            MessageContext messageContext, boolean isDelta)
            throws RPMException, SQLException, ParseException
    {
        SqlBuffer condition = new SqlBuffer();
        condition.appendEqual(NAME_TYPE_ID, 
                containerMap.getTypeId(datafieldBaseClass));
        condition.appendEqual(NAME_LEVEL_ID, 2);
        condition.appendIsNotNull(NAME_DESCRIPTION);
        condition.appendCondition(NAME_DESCRIPTION + "!=''");
        ArrayList list = loadByForeignKeyWithSpecifiedParent(abstractModule,
                datafields, null, messageContext, manager, null, 
                condition.toString(), contextName, isDelta);
        return (Datafield[]) ArrayUtil.listToArray(datafieldBaseClass, list);
    }

    public DatafieldCategory[] loadDatafieldCategories(
            AbstractModule abstractModule,
            DatafieldCategory[] datafieldCategories,
            Class datafieldCategoryBaseClass, int unused,
            RPMObjectManager manager, String contextName,
            MessageContext messageContext, boolean isDelta)
            throws RPMException, SQLException, ParseException
    {
        SqlBuffer condition = new SqlBuffer();
        condition.appendEqual(NAME_TYPE_ID, 
                containerMap.getTypeId(datafieldCategoryBaseClass));
        condition.appendEqual(NAME_LEVEL_ID, 1);
        ArrayList list = loadByForeignKeyWithSpecifiedParent(abstractModule,
                datafieldCategories, null, messageContext, manager, null, 
                condition.toString(), contextName, isDelta);
        return (DatafieldCategory[]) 
        	ArrayUtil.listToArray(datafieldCategoryBaseClass, list);
    }
    
    protected FieldValueMap decodeRelatedFields(ResultSet resultSet,
            FieldValueMap relatedFields, int index) throws SQLException
    {

        String parentId = resultSet.getString(ID_PARENT_ID);
        relatedFields.put(index, ID_PARENT_ID, parentId);

        return relatedFields;
    }

}