package com.ibm.rpm.applicationadministration.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class CalendarExceptionType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected CalendarExceptionType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _NonWorking = "NonWorking";
	public static final CalendarExceptionType NonWorking = new CalendarExceptionType(_NonWorking);
	
		
	public static final String _NonDefaultWorking = "NonDefaultWorking";
	public static final CalendarExceptionType NonDefaultWorking = new CalendarExceptionType(_NonDefaultWorking);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static CalendarExceptionType fromValue(String value) throws IllegalStateException {
		CalendarExceptionType retVal = (CalendarExceptionType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static CalendarExceptionType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof CalendarExceptionType && ordinal == ((CalendarExceptionType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((CalendarExceptionType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final CalendarExceptionType[] VALUES = {NonWorking, NonDefaultWorking};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}