package com.ibm.rpm.applicationadministration.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class CalendarWeekDayType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected CalendarWeekDayType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _UseDefault = "UseDefault";
	public static final CalendarWeekDayType UseDefault = new CalendarWeekDayType(_UseDefault);
	
		
	public static final String _NonWorking = "NonWorking";
	public static final CalendarWeekDayType NonWorking = new CalendarWeekDayType(_NonWorking);
	
		
	public static final String _NonDefaultWorking = "NonDefaultWorking";
	public static final CalendarWeekDayType NonDefaultWorking = new CalendarWeekDayType(_NonDefaultWorking);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static CalendarWeekDayType fromValue(String value) throws IllegalStateException {
		CalendarWeekDayType retVal = (CalendarWeekDayType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static CalendarWeekDayType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof CalendarWeekDayType && ordinal == ((CalendarWeekDayType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((CalendarWeekDayType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final CalendarWeekDayType[] VALUES = {UseDefault, NonWorking, NonDefaultWorking};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}