package com.ibm.rpm.applicationadministration.util;

import java.util.TreeMap;

import com.ibm.rpm.applicationadministration.types.InputType;

public class InputTypeUtil
{
    private static TreeMap indexByInputType = new TreeMap();

    private static TreeMap inputTypeByIndex = new TreeMap();

    static
    {
        indexByInputType.put(InputType.None, new Integer(0));
        indexByInputType.put(InputType.Text, new Integer(1));
        indexByInputType.put(InputType.Date, new Integer(2));
        indexByInputType.put(InputType.Numeric, new Integer(3));
        indexByInputType.put(InputType.RiskTolerance, new Integer(4));
        indexByInputType.put(InputType.RiskAppetite, new Integer(5));

        inputTypeByIndex.put("0", InputType.None);
        inputTypeByIndex.put("1", InputType.Text);
        inputTypeByIndex.put("2", InputType.Date);
        inputTypeByIndex.put("3", InputType.Numeric);
        inputTypeByIndex.put("4", InputType.RiskTolerance);
        inputTypeByIndex.put("5", InputType.RiskAppetite);
    }

    public static Integer getIndexByInputType(InputType inputType)
    {
        if (inputType == null)
        {
            return null;
        }
        return (Integer) indexByInputType.get(inputType);
    }

    public static InputType getInputTypeByIndex(String index)
    {
        if (index == null)
        {
            return null;
        }
        return (InputType) inputTypeByIndex.get(index);
    }
}
