/*
 * Created on 26/09/2005
 *
 */
package com.ibm.rpm.asset.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.asset.containers.AssetFolder;
import com.ibm.rpm.asset.containers.AssetModule;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;

/**
 * @author rosman
 */
public class AssetFolderCheckpoint extends GenericAssetCheckpoint
{
    private static final List ASSETFOLDER_PARENTS = new ArrayList();

    static
    {
        ASSETFOLDER_PARENTS.add(AssetModule.class);
        ASSETFOLDER_PARENTS.add(AssetFolder.class);
    }

    protected static AssetFolderCheckpoint instance = new AssetFolderCheckpoint();

    public static AssetFolderCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        if (!GenericValidator.validateInstance(rpmObject, AssetFolder.class, msgCtx))
            return;

         super.validateSave(rpmObject, msgCtx, false, ASSETFOLDER_PARENTS);
    }
}
