/*
 * Created on 28-Nov-2005
 */
package com.ibm.rpm.asset.checkpoints;

import java.util.List;

import com.ibm.rpm.asset.constants.ValidationConstants;
import com.ibm.rpm.asset.containers.GenericAsset;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.util.GenericValidator;

/**
 * @author dominiqu, mmatwiy
 */

public class GenericAssetCheckpoint extends AbstractCheckpoint
{
    protected void validateSave(RPMObject rpmObject, MessageContext msgCtx,
            boolean parentRequired, List validParentTypes)
    {
        super.isValidParent(rpmObject, msgCtx, parentRequired,
            validParentTypes);

        // Initialize
        GenericAsset mainAbstractAsset = (GenericAsset) rpmObject;
        
        // Field validation: name
        GenericValidator.validateMandatory(mainAbstractAsset,
            ValidationConstants.NAME_FIELD, mainAbstractAsset.getName(),
            msgCtx);
        
        if (mainAbstractAsset.testNameModified())
        {
            GenericValidator.validateMinLength(mainAbstractAsset,
                ValidationConstants.NAME_FIELD, mainAbstractAsset.getName(),
                ValidationConstants.ABSTRACTASSET_NAME_MIN, msgCtx);
            
            GenericValidator.validateMaxLength(mainAbstractAsset,
                ValidationConstants.NAME_FIELD, mainAbstractAsset.getName(),
                ValidationConstants.ABSTRACTASSET_NAME_MAX, msgCtx);
        }
    }
    
}
