/*
 * Created on 28-Nov-2005
 */
package com.ibm.rpm.asset.constants;

/**
 * @author dominiqu, mmatwiy
 */
public class ValidationConstants
{
    // field names
    public final static String PARENT = "parent";
    public final static String NAME_FIELD = "name";
    public final static String ASSETS_FIELD = "assets";
    public final static String ASSET_LIFE_FIELD = "assetLife";
    public final static String BARCODE_NUMBER_FIELD = "barcodeNumber";
    public final static String CONTACT_FIELD = "contact";
    public final static String CONTACT_EMAIL_FIELD = "contactEmail";
    public final static String CONTACT_PHONE_FIELD = "contactPhone";
    public final static String DEPRECIATION_METHOD_FIELD = "depreciationMethod";
    public final static String INITIAL_COST_FIELD = "initialCost";    
    public final static String MODEL_FIELD = "model";
    public final static String MODEL_NUMBER_FIELD = "modelNumber";
    public final static String ASSET_QUANTITY_FIELD = "quantity";
    public final static String SERIAL_NUMBER_FIELD = "serialNumber";
    public final static String AMOUNT_FIELD = "amount";
    public final static String ACTUAL_COST_FIELD = "actualCost";
    public final static String ESTIMATED_COST_FIELD = "estimatedCost";
    public final static String DESCRIPTION_FIELD = "description";
    public final static String PERFORMED_BY_FIELD = "performedBy";
    public final static String COST_FIELD = "cost";
    public final static String ESTIMATED_BUDGET_FIELD = "estimatedBudget";
    public final static String ESTIMATED_ACTUAL_FIELD = "estimatedActual";
    public final static String ESTIMATED_PAID_FIELD = "estimatedPaid";
    public final static String FINANCIALS_QUANTITY_FIELD = "quantity";
    public final static String COST_CENTER_FIELD = "costCenter";
    public final static String CHARGE_TYPE_FIELD = "chargeType";
    public final static String RESOURCE_FIELD = "resource";
    public final static String ORGANIZATIONAL_FIELD = "organizational";
    
    // Asset field names
    public final static String ASSET_ORGANIZATIONAL_ASSIGNMENT_FIELD = "assetOrganizationalAssignment";
    public final static String ASSET_RESOURCE_ASSIGNMENTS_FIELD = "assetResourceAssignments";
    public final static String ASSIGNED_SCORECARD_FIELD = "assignedScorecard";
    public final static String ATTRIBUTE_ASSIGNMENTS_FIELD = "attributeAssignments";
    public final static String CAPITAL_VALUE_FIELD = "capitalValue";
    public final static String CATEGORY_FIELD = "category";
    public final static String CROSS_CHARGE_FINANCIALS_FIELD = "crossChargeFinancials";
    public final static String CROSS_CHARGE_TODATE_FIELD = "crossChargeToDate";
    public final static String CURRENT_VALUE_FIELD = "currentValue";
    public final static String CUSTOM_FIELD_ASSIGNMENTS_FIELD = "customFieldAssignments";
    public final static String DATE_ACQUIRED_FIELD = "dateAcquired";
    public final static String DEPRECIATION_SCHEDULES_FIELD = "depreciationSchedules";
    public final static String DEPRECIATION_TODATE_FIELD = "depreciationToDate";
    public final static String DISPOSITION_DATE_FIELD = "dispositionDate";
    public final static String DOCUMENT_FOLDER_FIELD = "documentFolder";
    public final static String ESTIMATE_CROSS_CHARGE_FIELD = "estimateCrossCharge";
    public final static String ESTIMATE_MAINTENANCE_FIELD = "estimateMaintenance";
    public final static String GEOGRAPHICAL_ASSIGNMENT_FIELD = "geographicalAssignment";
    public final static String LICENSE_EXPIRY_DATE_FIELD = "licenseExpiryDate";
    public final static String MAINTENANCE_ESTIMATES_FIELD = "maintenanceEstimates";
    public final static String MAINTENANCE_TODATE_FIELD = "maintenanceToDate";
    public final static String NEXT_SCHEDULE_MAINTENANCE_FIELD = "nextScheduleMaintenance";
    public final static String RTF_ASSIGNMENTS_FIELD = "rtfAssignments";
    public final static String SALVAGE_VALUE_FIELD = "salvageValue";
    public final static String STATE_FIELD = "state";
    public final static String STATUS_UPDATES_FIELD = "statuSupdates";
    public final static String TRACKED_FIELD = "tracked";
    public final static String WARRANTY_SLAEXPIRY_DATE_FIELD = "warrantySlaexpiryDate";
    public final static String WBS_ACTIVITY_FINISH_FIELD = "wbsActivityFinish";
    public final static String WBS_ACTIVITY_START_FIELD = "wbsActivityStart";
    
    // AssetModule field names
    public final static String ASSET_CATEGORIES_FIELD = "assetCategories";
    public final static String ASSET_FOLDERS_FIELD = "assetFolders";
    public final static String ASSET_RTFS_FIELD = "assetRtfs";
    public final static String ASSET_STATES_FIELD = "assetStates";
    public final static String ATTRIBUTE_CATEGORIES_FIELD = "attributeCategories";
    public final static String CHARGE_TYPES_FIELD = "chargeTypes";
    public final static String CUSTOMFIELD_CATEGORIES_FIELD = "customfieldCategories";
    public final static String SCORECARD_FOLDERS_FIELD = "scorecardFolders";
    
    // AssetFolder field names
    public final static String FOLDERS_FIELD = "folders";
    
    // field length minimums
    public final static int ABSTRACTASSET_NAME_MIN = 1;
    public final static int ASSET_LIFE_MIN = 1;
    public final static double INITIAL_COST_MIN = 0.00;
    public final static int ASSET_QUANTITY_MIN = 0;
    public final static int DEPRECIATION_METHOD_MIN = 0;
    public final static double AMOUNT_MIN = 0.00;
    public final static double ACTUAL_COST_MIN = 0.00;
    public final static double ESTIMATED_COST_MIN = 0.00;
    public final static double COST_MIN = 0.00;
    public final static double ESTIMATED_BUDGET_MIN = 0.00;
    public final static double ESTIMATED_ACTUAL_MIN = 0.00;
    public final static double ESTIMATED_PAID_MIN = 0.00;
    public final static double FINANCIALS_QUANTITY_MIN = 0.00;
    
    // field length maximums
    public final static int ABSTRACTASSET_NAME_MAX = 50;
    public final static int ASSET_LIFE_MAX = 999;
    public final static int BARCODE_NUMBER_MAX = 30;
    public final static int CONTACT_MAX = 255;
    public final static int CONTACT_EMAIL_MAX = 255;
    public final static int CONTACT_PHONE_MAX = 50;
    public final static double INITIAL_COST_MAX = 1000000000.00;
    public final static int MODEL_MAX = 50;
    public final static int MODEL_NUMBER_MAX = 50;
    public final static int ASSET_QUANTITY_MAX = 999999999;
    public final static int SERIAL_NUMBER_MAX = 50;
    public final static int DEPRECIATION_METHOD_MAX = 1;
    public final static double AMOUNT_MAX = 9999999999999.99;
    public final static double ACTUAL_COST_MAX = 9999999999999.99;
    public final static int DESCRIPTION_MAX = 255;
    public final static double ESTIMATED_COST_MAX = 9999999999999.99;
    public final static int PERFORMED_BY_MAX = 50;
    public final static double COST_MAX = 9999999999999.99;
    public final static double ESTIMATED_BUDGET_MAX = 9999999999999.99;
    public final static double ESTIMATED_ACTUAL_MAX = 9999999999999.99;
    public final static double ESTIMATED_PAID_MAX = 9999999999999.99;
    public final static double FINANCIALS_QUANTITY_MAX = 9999999999999.99;
}
