package com.ibm.rpm.client.junit;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.util.Properties;

/**
 * @author mcduffs
 */
public class RpmTestProperties {

	public static final String OVERRIDE_PROPERTY_FILE_NAME = "local.test.properties";

	public static final String PROPERTY_FILE_NAME = "test.properties";

	private static Properties PROPERTY_MAP;

	public static String getProperty(String key) {
		loadProperties();
		return (String) PROPERTY_MAP.get(key);
	}

	private synchronized static void loadProperties()
    {
        if (PROPERTY_MAP == null)
        {
            PROPERTY_MAP = new Properties();
            try
            {
            	
                InputStream systemResourceAsStream = Thread.currentThread().
                	getContextClassLoader().getResourceAsStream
                	(OVERRIDE_PROPERTY_FILE_NAME);

                if ( systemResourceAsStream == null )
                {
	                systemResourceAsStream = Thread.currentThread().getContextClassLoader().
	                	getResourceAsStream(PROPERTY_FILE_NAME);
                }

                BufferedInputStream bis = new BufferedInputStream(
                    systemResourceAsStream);
                
                PROPERTY_MAP.load(bis);
                
                bis.close();
                systemResourceAsStream.close();
            }
            catch (Exception e)
            {
                e.printStackTrace();
            }
        }
    }
}
