	/*
 * Created on 10-May-2006
 * @author mmatwiy
 * Description
 */
package com.ibm.rpm.client.junit.applicationadministration.containers;

import junit.framework.Assert;

import com.ibm.rpm.applicationadministration.constants.ValidationConstants;
import com.ibm.rpm.applicationadministration.containers.CalendarException;
import com.ibm.rpm.applicationadministration.containers.WorkInterval;
import com.ibm.rpm.client.junit.framework.testcases.MetadataFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.metadata.MetadataException;
import com.ibm.rpm.metadata.model.Field;

public class CalendarExceptionFixture extends MetadataFixture
{
    public CalendarExceptionFixture() throws MetadataException
    {
        super(CalendarException.class);
    }

    public void fillField(RPMObject objectToFill, Field fieldInfo,
            int seed, boolean forCreation) throws Exception, ClassNotFoundException
    {
        if (fieldInfo.getName().equalsIgnoreCase(
            ValidationConstants.CALENDAR_INTERVALS_FIELD))
        {
            // Override the work i
            WorkInterval[] intervals = createWorkIntervalArray(seed);
            
            fillField(objectToFill, fieldInfo, intervals);
        }
        else
        {
            super.fillField(objectToFill, fieldInfo, seed, forCreation);
        }
    }
    
    public static WorkInterval[] createWorkIntervalArray(int seed)
    {
        int startHour = seed%8 + 1;
        
        WorkInterval[] intervals = new WorkInterval[5];
        intervals[0] = createWorkInterval(startHour+":00", (startHour+2)+":00");
        intervals[1] = createWorkInterval((startHour+2)+":15", (startHour+4)+":15");
        intervals[2] = createWorkInterval((startHour+4)+":30", (startHour+6)+":30");
        intervals[3] = createWorkInterval((startHour+6)+":45", (startHour+8)+":00");
        intervals[4] = createWorkInterval((startHour+8)+":30", (startHour+9)+":00");
        return intervals;
    }

    public static WorkInterval createWorkInterval(String from, String to)
    {

        WorkInterval workInterval = null;

        if ((from == null) || (to == null))
            Assert.fail("Work Interval values are invalid!");

        workInterval = new WorkInterval();

        workInterval.setFrom(from);
        workInterval.setTo(to);

        return workInterval;

    }

}