/*
 * Created on Feb 9, 2006
 *
 */
package com.ibm.rpm.client.junit.applicationadministration.testcases;

import java.util.ArrayList;

import junit.framework.Test;
import junit.framework.TestSuite;

import com.ibm.rpm.applicationadministration.containers.AdministrationModule;
import com.ibm.rpm.asset.containers.AssetModule;
import com.ibm.rpm.client.junit.asset.testcases.TestAssetModule;
import com.ibm.rpm.client.junit.clientcostcenters.testcases.TestClientModule;
import com.ibm.rpm.client.junit.contract.testcases.TestContractModule;
import com.ibm.rpm.client.junit.document.testcases.TestDocumentModule;
import com.ibm.rpm.client.junit.financial.testcases.TestFinancialModule;
import com.ibm.rpm.client.junit.resource.testcases.TestPoolModule;
import com.ibm.rpm.client.junit.resource.testcases.TestResourceModule;
import com.ibm.rpm.client.junit.scope.testcases.TestScopeManagementModule;
import com.ibm.rpm.client.junit.wbs.testcases.TestWbsModule;
import com.ibm.rpm.clientcostcenters.containers.ClientModule;
import com.ibm.rpm.contract.containers.ContractModule;
import com.ibm.rpm.document.containers.DocumentModule;
import com.ibm.rpm.financial.containers.FinancialModule;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.resource.containers.PoolModule;
import com.ibm.rpm.resource.containers.ResourceModule;
import com.ibm.rpm.scopemanagement.containers.ScopeManagementModule;
import com.ibm.rpm.wbs.containers.WbsModule;

/**
 * @author karim
 *
 */
public class AllModuleTests
{

    private static ArrayList TEST_PARENTS = new ArrayList();
	private static ArrayList TEST_METHODS = new ArrayList();
	
	static {
	    TEST_PARENTS.add(new AdministrationModule());	//100%
	    TEST_PARENTS.add(new AssetModule());			//100%
	    TEST_PARENTS.add(new ClientModule());			//100%
	    TEST_PARENTS.add(new DocumentModule());			//100%
	    TEST_PARENTS.add(new PoolModule());				//100%
	    TEST_PARENTS.add(new ResourceModule());			//100%
	    TEST_PARENTS.add(new ScopeManagementModule());	//100%
	    TEST_PARENTS.add(new WbsModule());				//100%
	    TEST_PARENTS.add(new FinancialModule());		//100%
	    TEST_PARENTS.add(new ContractModule());			//100%
	    
	    TEST_METHODS.add("testLoadFromXPath");
		TEST_METHODS.add("testInsertWithScopeLoadFromXPath");
		TEST_METHODS.add("testUpdateWithScopeLoadFromXPath");
	}
	
    public static Test suite(){
    	TestSuite suite = new TestSuite();
    	
    	RPMObject parent;
    	String testMethodName;
    	String testName;
    	Test test = null;
    	
    	for (int k = 0; k < TEST_PARENTS.size(); k++)
        {	
    	    parent = (RPMObject) TEST_PARENTS.get(k);
            for (int j = 0; j < TEST_METHODS.size(); j++)
            {
                testMethodName = (String) TEST_METHODS.get(j);
                testName = testMethodName;
                test = instantiateTest(testName, parent);
                if(test!=null){
                    suite.addTest(test);                    
                }
            }
        }
        return suite;
    }
        
    private static Test instantiateTest(String testName, RPMObject parent)
    {
        if(parent instanceof AdministrationModule)
        {
            return new TestAdministrationModule(testName);
        }
        else if (parent instanceof AssetModule)
        {
            return new TestAssetModule(testName);
        }
        else if (parent instanceof ClientModule)
        {
            return new TestClientModule(testName);
        }
        else if (parent instanceof DocumentModule)
        {
            return new TestDocumentModule(testName);
        }
        else if (parent instanceof PoolModule)
        {
            return new TestPoolModule(testName);
        }
        else if (parent instanceof ResourceModule)
        {
            return new TestResourceModule(testName);
        }
        else if (parent instanceof ScopeManagementModule)
        {
            return new TestScopeManagementModule(testName);
        }
        else if (parent instanceof WbsModule)
        {
            return new TestWbsModule(testName);
        }
        else if (parent instanceof FinancialModule)
        {
            return new TestFinancialModule(testName);
        }
        else if (parent instanceof ContractModule)
        {
            return new TestContractModule(testName);
        }
        return null;
    }
}
