/*
 * Created on 10-May-2007
 *
 */
package com.ibm.rpm.client.junit.applicationadministration.testcases;

import java.util.ArrayList;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.security.containers.SecurityRole;
import com.ibm.rpm.security.containers.SecurityRoleCategory;

/**
 * @author karim
 *
 */
public class TestAllBasicSecurityRolesExist extends ClientTestController
{
    public void testQueries() throws Exception
    {
        String query = "SELECT * FROM TMT_GLOBAL_SECURITY WHERE TMT_GLOBAL_SECURITY.ELEMENT_ID='SCPROJECTMANAGER                ' ";
        ArrayList rows = executeSqlQuery(query, null);
        assertNotNull(rows);
        assertEquals(1,rows.size());
        
        String query2 = "SELECT * FROM TMT_GLOBAL_SECURITY WHERE TMT_GLOBAL_SECURITY.ELEMENT_ID=? ";
        ArrayList rows2 = executeSqlQuery(query2, new Object[]{"SCPROJECTMANAGER                "});
        assertNotNull(rows2);
        assertEquals(1,rows2.size());
        
        String query3 = "SELECT * FROM TMT_GLOBAL_SECURITY WHERE TMT_GLOBAL_SECURITY.ELEMENT_ID='SCPROJECTMANAGER' ";
        ArrayList rows3 = executeSqlQuery(query3, null);
        assertNotNull(rows3);
        assertEquals(1,rows3.size());
        
        String query4 = "SELECT * FROM TMT_GLOBAL_SECURITY WHERE TMT_GLOBAL_SECURITY.ELEMENT_ID=? ";
        ArrayList rows4 = executeSqlQuery(query4, new Object[]{"SCPROJECTMANAGER"});
        assertNotNull(rows4);
        assertEquals(1,rows4.size());
    }
    
    public void testBasicSecurityRoles() throws Exception
    {
        String query = "select parent_id, element_id, element_name from TMT_GLOBAL_SECURITY where rec_status <> 'D' and level_id in (0,1)";
        ArrayList rows = executeSqlQuery(query, null);
        logger.info("FOUND "+rows.size()+" rows");
        String parentId, elementId, elementName;
        for(int i=0;i<rows.size();i++)
        {
            ArrayList columns = (ArrayList)rows.get(i);
            parentId = (String)columns.get(0);
            elementId = (String)columns.get(1);
            elementName = (String)columns.get(2);
            logger.info("ROW ["+(i+1)+"] , parent_id["+parentId+"] , elementId["+elementId+"] , elementName["+elementName+"]");
            loadAndValidate(parentId, elementId, false);
            loadAndValidate(parentId, elementId, true);
        }
    }
    
    private void loadAndValidate(String parentId, String elementId, boolean trimId) throws Exception
    {
        String localElementId = (trimId)?elementId.trim():elementId;
        
        if(parentId==null)
        {
            SecurityRoleCategory securityRoleCategory = new SecurityRoleCategory();
            securityRoleCategory.setID(localElementId);
            securityRoleCategory = (SecurityRoleCategory)loadFromID(securityRoleCategory,null);
            assertNotNull("unable to load securityRoleCategory with ID ["+localElementId+"]",securityRoleCategory);
        }
        else
        {
            SecurityRole securityRole = new SecurityRole();
            securityRole.setID(localElementId);
            securityRole = (SecurityRole)loadFromID(securityRole,null);
            assertNotNull("unable to load securityRole with ID ["+localElementId+"]",securityRole);
        }

    }
}
