package com.ibm.rpm.client.junit.applicationadministration.testcases;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.framework.RPMObject;

/**
 * @author mcduffs
 */
public class TestAttribute extends ClientTestController
{
    
    public static int INVALID_COUNT = 0;
    
    public static int VALID_COUNT = 0;
    
    /* (non-Javadoc)
     * @see com.ibm.rpm.client.junit.ClientTestController#setUp()
     */
    protected void setUp() throws Exception
    {
        VALID_COUNT = 0;
        INVALID_COUNT = 0;
        super.setUp();
    }

    public void testDeleteSystemAttributeCategory() throws Exception
    {
        RPMObject[] listToDelete = loadFromXpath(
            "/AttributeCategory[contains(@ID,'_')]", null);

        deleteObjectList(listToDelete);
    }
    
    public void testDeleteSystemAttributeClassification() throws Exception
    {
        RPMObject[] listToDelete = null;
    
        listToDelete = loadFromXpath(
            "/AttributeClassification[contains(@ID,'_')]", null);

        deleteObjectList(listToDelete);
    }
    
    public void testDeleteSystemAttribute() throws Exception
    {
        RPMObject[] listToDelete = null;
        listToDelete = loadFromXpath(
            "/Attribute[contains(@ID,'_')]", null);

        deleteObjectList(listToDelete);
    }

    /**
     * @param listToDelete
     * @throws Exception
     */
    private void deleteObjectList(RPMObject[] listToDelete) throws Exception
    {
        assertNotNull(listToDelete);
        assertTrue(listToDelete.length > 0);
        
        for (int i = 0; i < listToDelete.length; i++)
        {
            RPMObject object = listToDelete[i];
            
            if( object.getID().indexOf("_") == -1 )
            {
                INVALID_COUNT++;
            }
            else
            {
                VALID_COUNT++;
                deleteMustFail(object);
            }
        }

        logger.info("valid " + VALID_COUNT + " invalid " + INVALID_COUNT);
    }

}
