/*
 * Created on Jan 09, 2007
 */
package com.ibm.rpm.client.junit.applicationadministration.testcases.fixes;

import java.util.Calendar;

import com.ibm.rpm.applicationadministration.containers.CalendarException;
import com.ibm.rpm.applicationadministration.containers.RPMCalendar;
import com.ibm.rpm.applicationadministration.types.CalendarExceptionType;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.RPMCalendarFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.SaveResult;

/**
 * @author cobber
 */
public class Test59757 extends ClientTestController
{
    private CalendarException calendarException = null;

    private RPMCalendar parent = null;

    public void setUp() throws Exception
    {
        super.setUp();
        parent = RPMCalendarFixture.createSaveFixture(null, this);
        RPMObject[] rpmObjects = loadFromXpath("/RPMCalendar[name='"
                + parent.getName() + "']", null);

        assertNotNull(rpmObjects);
        assertTrue(rpmObjects[0] instanceof RPMCalendar);
        parent = (RPMCalendar) rpmObjects[0];
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    private void init()
    {
        calendarException = new CalendarException();
        Calendar day = Calendar.getInstance();
        calendarException.setDay(day);
        calendarException.setParent(parent);
    }

    public void testCreateCalendarExceptionWithTypeNonDefaultWorking()
            throws Exception
    {
        init();
        CalendarExceptionType type = CalendarExceptionType.NonDefaultWorking;
        calendarException.setType(type);

        saveAndTest();
    }

    public void testCreateCalendarExceptionWithTypeNonWorking()
            throws Exception
    {
        init();
        CalendarExceptionType type = CalendarExceptionType.NonWorking;
        calendarException.setType(type);

        saveAndTest();
    }

    private void saveAndTest() throws Exception
    {
        SaveResult saveResult = this.save(calendarException, null);
        assertTrue(saveResult.isSuccessful());
        assertNotNull(saveResult.getRpmObject());
        assertTrue(saveResult.getRpmObject() instanceof CalendarException);
    }
}
