/*
 * Created on 1-Nov-2005
 */
package com.ibm.rpm.client.junit.applicationadministration.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.applicationadministration.containers.Group;
import com.ibm.rpm.applicationadministration.containers.Organization;
import com.ibm.rpm.applicationadministration.scope.OrganizationalScope;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.OrganizationalFixture;
import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

/**
 * @author njarazi
 */
public class TestGroupDataXPath extends ObjectXPathTester
{
    protected RPMObject createObject() throws Exception
    {
        RPMObject o = ((Organization) OrganizationalFixture.createFixture(1,
            (OrganizationalScope) mainScope));

        //Save parent
        o = save(o, mainScope).getRpmObject();

        o = ((Organization) o).getChildren()[0].getChildren()[0];
        
        mainScope = ((OrganizationalScope)mainScope).getChildren().getChildren();
        ((OrganizationalScope)mainScope).setParent(null);

        return o;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        OrganizationalScope s = OrganizationalFixture.createScope(3);
        s.setParent(s);
        return s;
    }

    /**
     * @param dbObject
     * @throws AssertionFailedError
     * @throws Exception
     */
    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        OrganizationalFixture.compare((Group) myObject, (Group) dbObject, (OrganizationalScope)mainScope);
    }
}