/*
 * Created on Jul 18, 2005
 *
 */
package com.ibm.rpm.client.junit.asset.fixtures;

import java.util.ArrayList;

import junit.framework.Assert;
import junit.framework.AssertionFailedError;

import com.ibm.rpm.applicationadministration.containers.Geographical;
import com.ibm.rpm.applicationadministration.containers.GeographicalAssignment;
import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.GeographicalFixture;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;

/**
 * @author rosman
 *  
 */
public class AssetGeographicalAssignmentFixture extends RPMObjectFixture
{

    protected static ArrayList locationPreferenceSkipSetters,
            locationPreferenceSkipGetters;

    static
    {
        locationPreferenceSkipSetters = new ArrayList();
        locationPreferenceSkipSetters.addAll(skipSetters);
        locationPreferenceSkipSetters.add("setName");

        locationPreferenceSkipGetters = new ArrayList();
        locationPreferenceSkipGetters.addAll(skipGetters);
        locationPreferenceSkipGetters.add("getName");
    }

    public static GeographicalAssignment createFixture(Asset asset,
            ClientTestController ctc) throws Exception
    {
        Geographical geographical = GeographicalFixture.createSaveFixture(1,
                ctc);
        return createFixture(asset, geographical);
    }

    public static GeographicalAssignment createFixture(Asset asset,
            Geographical geographical) throws Exception
    {
        if (asset != null && geographical != null)
        {
            GeographicalAssignment assignment = createAssignment(asset,
                    geographical);
            return assignment;
        }
        return null;
    }

    private static GeographicalAssignment createAssignment(Asset asset,
            Geographical geographical) throws Exception
    {
        GeographicalAssignment assignment = new GeographicalAssignment();

        assignment.setParent(asset);
        assignment.setGeographical(geographical);

        return assignment;
    }

    //Compare section
    public static void compare(GeographicalAssignment[] array1,
            GeographicalAssignment[] array2) throws AssertionFailedError,
            Exception
    {

        RPMObjectFixture.compare(array1, array2);

        for (int i = 0; i < array1.length; i++)
        {
            compare(array1[i], array2[i]);
        }
    }

    public static void compare(GeographicalAssignment obj1,
            GeographicalAssignment obj2) throws AssertionFailedError, Exception
    {

        RPMObjectFixture.compareWithSkip(obj1, obj2,
                locationPreferenceSkipGetters);
        Assert.assertTrue((obj1 != null && obj2 != null)
                || (obj1 == null && obj2 == null));
        if (obj1 != null)
        {
            AssetFixture.compare((Asset) obj1.getParent(), (Asset) obj2
                    .getParent(), null);

            GeographicalFixture.compare(obj1.getGeographical(), obj2
                    .getGeographical(), null);
        }
    }

}