/*
 * Created on 22/08/2005
 *
 */
package com.ibm.rpm.client.junit.asset.testcases;

import java.util.Calendar;
import java.util.GregorianCalendar;

import com.ibm.rpm.applicationadministration.containers.AssetCategory;
import com.ibm.rpm.applicationadministration.containers.AssetRTF;
import com.ibm.rpm.applicationadministration.containers.AssetState;
import com.ibm.rpm.applicationadministration.containers.ChargeType;
import com.ibm.rpm.applicationadministration.containers.DatafieldRTF;
import com.ibm.rpm.applicationadministration.containers.RtfAssignment;
import com.ibm.rpm.asset.containers.GenericAsset;
import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.asset.containers.AssetFolder;
import com.ibm.rpm.asset.containers.CrossChargeFinancials;
import com.ibm.rpm.asset.containers.DepreciationSchedule;
import com.ibm.rpm.asset.scope.AssetScope;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.DatafieldFixture;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.clientcostcenters.containers.ClientCostCenter;
import com.ibm.rpm.framework.SingleResult;

/**
 * @author rosman
 *
 */
public class TestAsset2 extends ClientTestController
{

    /*
     * (non-Javadoc)
     *
     * @see junit.framework.TestCase#setUp()
     */
    protected void setUp() throws Exception
    {
        logger.info("setUp");
        super.setUp();


    }


    public void tearDown() throws Exception
    {

        super.tearDown();

    }

    // test 74-MRK-237-500 - true bug, the category is not updated
    public void testCreateAssetFolder237_1() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolderTC3");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");
		asset.setCategory(getAssetCategory("5153"));//Middleware Application

		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());

		SingleResult result = save(folder, mainScope);
		assertNotNull(result);
        assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof AssetFolder);
        assertNull(result.getErrors());

        AssetFolder newFolder = (AssetFolder)result.getRpmObject();
        Asset newAsset = (Asset)newFolder.getAssets()[0];
        assertEquals(asset.getCategory().getID(),newAsset.getCategory().getID());
    }

    public static AssetCategory getAssetCategory(String id) throws Exception{

		AssetCategory asset = new AssetCategory();
		asset.setID(id);

		return asset;

	}


    //74-MRK-237-500
    public void testCreateAssetFolder237_2() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolderTC3");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");
		asset.setQuantity(new Integer(25));

		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());

		SingleResult result = save(folder, mainScope);
		assertNotNull(result);
        assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof AssetFolder);
        assertNull(result.getErrors());

        AssetFolder newFolder = (AssetFolder)result.getRpmObject();
        Asset newAsset = (Asset)newFolder.getAssets()[0];
        assertEquals(asset.getQuantity(),newAsset.getQuantity());

    }


    //74-MRK-238-500
    public void testCreateAssetFolder238() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolderTC3");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");
		asset.setDispositionDate(new GregorianCalendar(2005, 11, 15));

		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());

		SingleResult result = save(folder, mainScope);
		assertNotNull(result);
        assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof AssetFolder);
        assertNull(result.getErrors());

        AssetFolder newFolder = (AssetFolder)result.getRpmObject();
        Asset newAsset = (Asset)newFolder.getAssets()[0];
        assertEquals(asset.getDispositionDate(),newAsset.getDispositionDate());

    }

    //74-MRK-239-500
    public void testCreateAssetFolder239() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolderTC3");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");
		asset.setTracked(new Boolean(true));

		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());

		SingleResult result = save(folder, mainScope);
		assertNotNull(result);
        assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof AssetFolder);
        assertNull(result.getErrors());

        AssetFolder newFolder = (AssetFolder)result.getRpmObject();
        Asset newAsset = (Asset)newFolder.getAssets()[0];
        assertEquals(asset.getTracked(),newAsset.getTracked());

    }

    //74-MRK-240-500
    public void testCreateAssetFolder240_1() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolderTC3");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");
		asset.setModel("QA-AssetModel");
		asset.setBarcodeNumber("9999999999");
		asset.setModelNumber("MN453Esw");
		asset.setDateAcquired(new GregorianCalendar(2005, 11, 01));
		asset.setSerialNumber("UIY67tr1xz");
		asset.setState(getAssetState("4972"));//In Pilot

		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());

		SingleResult result = save(folder, mainScope);
		assertNotNull(result);
        assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof AssetFolder);
        assertNull(result.getErrors());
    }

    public static AssetState getAssetState(String id) throws Exception{

		AssetState asset = new AssetState();
		asset.setID(id);

		return asset;

	}


    //74-MRK-241-500


    //74-MRK-242-500
    public void testCreateAssetFolder242() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolderTC3");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");

		//Asset Life
		asset.setAssetLife(new Integer(37));

		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());
		SingleResult result = save(folder, mainScope);
        assertEquals(37,((Asset)folder.getAssets()[0]).getAssetLife().intValue());

		folder = (AssetFolder)result.getRpmObject();
		((Asset)folder.getAssets()[0]).setAssetLife(new Integer(96));
		result = save(folder, mainScope);

		assertNotNull(result);
        assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof AssetFolder);
        assertNull(result.getErrors());
        assertEquals(96,((Asset)folder.getAssets()[0]).getAssetLife().intValue());
    }



    //74-MRK-240-500
    public void testCreateAssetFolder240_2() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolderTC3");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");

		//Asset Summary
		asset.setInitialCost(new Double("225.75"));
		asset.setWarrantySLAExpiryDate(new GregorianCalendar(2005, 05, 01));
		asset.setLicenseExpiryDate(new GregorianCalendar(2005, 04, 01));

		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());
		SingleResult result = save(folder, mainScope);
		assertNotNull(result);
        assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof AssetFolder);
        assertNull(result.getErrors());

        AssetFolder newFolder = (AssetFolder)result.getRpmObject();
        Asset newAsset = (Asset)newFolder.getAssets()[0];
        assertTrue(newAsset.getInitialCost().intValue()>newAsset.getSalvageValue().intValue());

    }

    //74-MRK-243-500

    public void testCreateAssetFolder243_1() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolderTC3");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");

		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());
		SingleResult result = save(folder, mainScope);
		folder = (AssetFolder)result.getRpmObject();

		assignRtfToAsset(this,"6041","My Description", (Asset)folder.getAssets()[0]);
    }

    public static RtfAssignment assignRtfToAsset(ClientTestController ctc,
			String id,
			String value,
			Asset asset) throws Exception{

		RtfAssignment rtfAss = new RtfAssignment();
		DatafieldRTF assetDatafield = getAssetRTF(id);

		rtfAss.setRtf(assetDatafield);
		rtfAss.setValue(value);
		rtfAss.setParent(asset);

		SingleResult result = ctc.save(rtfAss, null);
		RtfAssignment rtf = (RtfAssignment) result.getRpmObject();
		return rtf;

	}


    private static DatafieldRTF getAssetRTF(String id)
    {
		AssetRTF assetRTF = new AssetRTF();
		assetRTF.setID(id);

		return assetRTF;
    }

    //74-MRK-243-500
    public void testCreateAssetFolder243_2() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolderTC3");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");

		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());
		SingleResult result = save(folder, mainScope);
		folder = (AssetFolder)result.getRpmObject();

		assignDepreciationScheduleToAsset(this,new GregorianCalendar(2005, 11, 01),new Double(1000.0), (Asset)folder.getAssets()[0]);
    }

    public static DepreciationSchedule assignDepreciationScheduleToAsset(ClientTestController ctc,
			Calendar depreciationDate,
			Double amount,
			Asset parent) throws Exception{

		DepreciationSchedule schedule = new DepreciationSchedule();
		schedule.setDepreciationDate(depreciationDate);
		schedule.setAmount(amount);
		schedule.setParent(parent);

		SingleResult result = ctc.save(schedule, null);
		DepreciationSchedule schAss = (DepreciationSchedule) result.getRpmObject();
		return schAss;

	}

    //74-MRK-246-500

    public void testCreateAssetFolder246() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolderTC3");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");

		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());
		SingleResult result = save(folder, mainScope);
		folder = (AssetFolder)result.getRpmObject();

		ClientCostCenter costCenter = new ClientCostCenter();
		costCenter.setName(HelperTestUtilities.createName());
		costCenter = (ClientCostCenter)save(costCenter,null).getRpmObject();

		assignCrossChargeFinancialToAsset(this,
		        DatafieldFixture.ASSET_CHARGE_TYPE_NONE,
				"100",
				"10",
				"1000",
				"2000",
				"3000",
				new GregorianCalendar(2005, 01, 01),
				new GregorianCalendar(2005, 11, 01),
				(Asset)folder.getAssets()[0],
				costCenter);
    }

    public static CrossChargeFinancials assignCrossChargeFinancialToAsset(ClientTestController ctc,
			String chargeTypeID,
			String cost,
			String quantity,
			String estimatedActual,
			String estimatedBudget,
			String estimatedPaid,
			Calendar startDate,
			Calendar finishDate,
			Asset parent,
			ClientCostCenter costCenter) throws Exception{

		CrossChargeFinancials charge = new CrossChargeFinancials();
		charge.setChargeType(getChargeType(chargeTypeID));
		charge.setCost(new Double(cost));
		charge.setQuantity(new Double(quantity));
		charge.setStartDate(startDate);
		charge.setFinishDate(finishDate);
		charge.setEstimatedActual(new Double(estimatedActual));
		charge.setEstimatedBudget(new Double(estimatedBudget));
		charge.setEstimatedPaid(new Double(estimatedPaid));
		charge.setCostCenter(costCenter);
		charge.setParent(parent);

		SingleResult result = ctc.save(charge, null);
		CrossChargeFinancials chargeAss = (CrossChargeFinancials) result.getRpmObject();
		return chargeAss;

	}

    private static ChargeType getChargeType(String chargeTypeID)
    {
        return DatafieldFixture.createChargeType(chargeTypeID);
    }

    public void testCreateAssetFolder245() throws Exception
    {
    	AssetScope mainScope = new AssetScope();

		AssetFolder folder = new AssetFolder();
		folder.setName("QAAssetFolder");
		mainScope.setFolders(new AssetScope());

		Asset asset = new Asset();
		asset.setName("QAAsset");
		folder.setAssets(new GenericAsset[]{asset});
		mainScope.setAssets(new AssetScope());

		SingleResult result = save(folder, mainScope);
		assertNotNull(result);
        assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof AssetFolder);
        assertNull(result.getErrors());
    }


}