package com.ibm.rpm.client.junit.asset.testcases.fixes;

import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.asset.scope.AssetScope;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.asset.fixtures.AssetFixture;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.document.containers.Document;
import com.ibm.rpm.document.containers.DocumentFolder;
import com.ibm.rpm.document.scope.DocumentScope;

public class Test58650 extends ClientTestController {

	public void testCreateAssetDocument() throws Exception
	{
		Asset asset = AssetFixture.createSaveFixture(null, this);
		assertNotNull(asset);
		
		AssetScope assetScope = new AssetScope();
		assetScope.setDocumentFolder(new DocumentScope());
		asset = (Asset)loadFromID(asset, assetScope);
		assertNotNull(asset);
		assertNotNull(asset.getDocumentFolder());
		
		createSaveDocument(asset.getDocumentFolder());
	}
	
	private void createSaveDocument(DocumentFolder parent) throws Exception
	{
		Document document = new Document();
		document.setName(HelperTestUtilities.createName());
		parent.setChildren(new Document[]{document});
		
		DocumentScope documentScope = new DocumentScope();
		documentScope.setChildren(new DocumentScope());
		parent = (DocumentFolder)save(parent, documentScope).getRpmObject();

		assertNotNull(parent);
		assertNotNull(parent.getChildren());
		assertTrue(parent.getChildren().length ==1);
		assertNotNull(parent.getChildren()[0]);
		assertTrue(parent.getChildren()[0] instanceof Document);
		assertEquals(document.getName(), parent.getChildren()[0].getName());
	}
}
