/*
 * Created on Oct 11, 2006
 *
 */
package com.ibm.rpm.client.junit.clientcostcenters.testcases.fixes;

import com.ibm.rpm.applicationadministration.containers.CostCenterState;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.clientcostcenters.containers.ClientCostCenter;
import com.ibm.rpm.clientcostcenters.scope.ClientCostCenterScope;
import com.ibm.rpm.document.containers.DocumentFolder;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.SaveResult;

/**
 * @author karim
 *
 */
public class Test49753 extends ClientTestController{

	public void testCreateAndUpdateClientCostCenter() throws Exception
    {		
		ClientCostCenterScope mainScope = new ClientCostCenterScope();
		
		ClientCostCenter clientcostcenter = new ClientCostCenter();
		clientcostcenter.setName("Test49753_ClientCostCenterTC3");

		RPMObject[] loadResult = loadFromXpath("CostCenterState[id='6904']", null);//posting
		assertTrue(loadResult[0] instanceof CostCenterState);
		CostCenterState costCenterState = (CostCenterState)loadResult[0];
		
		clientcostcenter.setState(costCenterState);//posting
		mainScope.setState(true);
		mainScope.setDocumentFolder(new DocumentScope());
		
		SaveResult result = save(clientcostcenter, mainScope);
		assertNotNull(result);
        assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof ClientCostCenter);
        assertNull(result.getErrors());
        assertEquals(result.isSuccessful(), true);
        ClientCostCenter savedCCC = (ClientCostCenter) result.getRpmObject();
        
    	//load from XPath
    	loadResult = loadFromXpath("/ClientCostCenter[id='"+ savedCCC.getID() + "']", mainScope);
        assertNotNull(loadResult);
        assertTrue(loadResult[0] instanceof ClientCostCenter);	
		
        ClientCostCenter mainCCC = (ClientCostCenter) loadResult[0];
        assertNotNull(mainCCC);	
        
        DocumentFolder documentFolder = savedCCC.getDocumentFolder();
        assertNotNull(documentFolder);
        
        //update costCenterState
		loadResult = loadFromXpath("CostCenterState[id='6902']", null);//Locked
		assertTrue(loadResult[0] instanceof CostCenterState);
		costCenterState = (CostCenterState)loadResult[0];
        
    	mainCCC.setState(costCenterState);
    	result = save(mainCCC, mainScope);
    	assertNotNull(result);
    	assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof ClientCostCenter);
        assertNull(result.getErrors());
        assertEquals(result.isSuccessful(), true);
		savedCCC = (ClientCostCenter) result.getRpmObject();	
		assertEquals(mainCCC.getState().getID(), "6902");
    }
		
}
