/*
 * Created on 23-Nov-2006
 */
package com.ibm.rpm.client.junit.communications.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.communications.fixtures.GenericCommunicationFixture;
import com.ibm.rpm.client.junit.communications.fixtures.GenericResponseTypeFixture;
import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.communications.containers.GenericResponseType;
import com.ibm.rpm.communications.containers.WorkflowStepNotification;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.workflow.containers.RunningWorkflowProcess;

/**
 * @author dominiqu
 */
public class TestChecklistItemDataXPath extends ObjectXPathTester
{
    RunningWorkflowProcess runningProcess;

    protected RPMObject createObject() throws Exception
    {
        WorkflowStepNotification wsn = GenericCommunicationFixture.createSaveWorkflowStepNotificationFixture(
            GenericCommunicationFixture.createFullScope(true), this);

        runningProcess = wsn.getRunningWorkflowProcess();

        GenericResponseType response = null;
        if (wsn.getResponses()[0].getVisible() == Boolean.TRUE)
        {
            response = wsn.getResponses()[0].getResponse()[0];
        }
        else
        {
            response = wsn.getResponses()[1].getResponse()[0];
        }
        return response;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        return null;
    }

    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        GenericResponseTypeFixture.compare((GenericResponseType) myObject,
            (GenericResponseType) dbObject);
    }

    public void tearDown() throws Exception
    {
        if (runningProcess != null)
        {
            getApplicationInterface().cancelWorkflow(sessionid, runningProcess);
        }

        super.tearDown();
    }
}
