/*
 * Created on 19-Sep-2006
 */
package com.ibm.rpm.client.junit.communications.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.communications.fixtures.GenericCommunicationFixture;
import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.communications.containers.WorkflowStepNotification;
import com.ibm.rpm.communications.scope.GenericCommunicationScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

/**
 * @author dominiqu
 */
public class TestWorkflowStepNotificationDataXPath extends ObjectXPathTester
{
    protected RPMObject createObject() throws Exception
    {
        return GenericCommunicationFixture.createSaveWorkflowStepNotificationFixture(
            (GenericCommunicationScope) mainScope, this);
    }

    protected RPMObjectScope createScope() throws Exception
    {
        return GenericCommunicationFixture.createFullScope(true);
    }

    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        GenericCommunicationFixture.compare(
            (WorkflowStepNotification) myObject,
            (WorkflowStepNotification) dbObject,
            (GenericCommunicationScope) scope);
    }

    public void tearDown() throws Exception
    {
        if (((WorkflowStepNotification) myObject).getRunningWorkflowProcess() == null)
        {
            myObject = loadFromID(myObject, mainScope);
        }

        getApplicationInterface().cancelWorkflow(sessionid,
            ((WorkflowStepNotification) myObject).getRunningWorkflowProcess());

        super.tearDown();
    }
}
