/*
 * Created on Nov 17, 2005
 *
 */
package com.ibm.rpm.client.junit.contract.fixtures;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.contract.containers.Contract;
import com.ibm.rpm.contract.containers.ContractChargeSchedule;
import com.ibm.rpm.contract.scope.ContractScope;

/**
 * @author SandeepS
 *
 */
public class ContractChargeScheduleFixture extends RPMObjectFixture{
	
	protected static ArrayList localSkipGetters = new ArrayList();
	
	protected static ArrayList localSkipSetters = new ArrayList();
	
	static {
		localSkipGetters.addAll(skipGetters);
		localSkipGetters.add("getScheduleDate");
		//set skipSetters
		localSkipSetters.addAll(skipSetters);
	}
	public static ContractChargeSchedule createSaveFixture(ClientTestController ctc, Contract C)
	throws Exception{
		ContractScope scope = createScope();
		ContractChargeSchedule ccs = createFixture(scope,ctc);
		ccs.setParent(C);
		ccs = (ContractChargeSchedule) save(ctc, ccs, scope);
		return ccs;
	}
	
	public static ContractChargeSchedule createSaveFixture(ClientTestController ctc)
	throws Exception {
		ContractScope scope = createScope();
		return createSaveFixture(scope, ctc);
	}
	
	public static ContractChargeSchedule createSaveFixture(ContractScope scope,
			ClientTestController ctc) throws Exception {
		ContractChargeSchedule contractChargeSchedule = createFixture(scope, ctc);
		contractChargeSchedule = (ContractChargeSchedule) save(ctc, contractChargeSchedule, scope);
		return contractChargeSchedule;
	}
	
	public static ContractChargeSchedule createFixture(ContractScope scope,
			ClientTestController ctc) throws Exception {
		return createContractChargeSchedule(random(), scope, ctc);
	}
	
	private static ContractChargeSchedule createContractChargeSchedule(int index, ContractScope scope,
			ClientTestController ctc) throws Exception {
		ContractChargeSchedule contractChargeSchedule = new ContractChargeSchedule();
		HelperTestUtilities.setByIntrospection(contractChargeSchedule, index,
				localSkipSetters);
		
		return contractChargeSchedule;
	}
	
	public static void updateFixture(ContractChargeSchedule contractChargeSchedule, ContractScope scope)
	throws Exception {
		updateContractChargeSchedule(contractChargeSchedule, random(), scope);
	}
	
	private static void updateContractChargeSchedule(ContractChargeSchedule contractChargeSchedule, int index,
			ContractScope scope) throws Exception {
		//update the fields
		HelperTestUtilities.setByIntrospection(contractChargeSchedule, index,
				localSkipSetters);
	}
	
	public static void compare(ContractChargeSchedule ccb1, ContractChargeSchedule ccb2,
			ContractScope scope) throws AssertionFailedError, Exception 
			{
		RPMObjectFixture.compareWithSkip(ccb1, ccb2, localSkipGetters);
		if (scope == null)
			return;
		//validate the parents
		if (scope.getParent() != null) {
			ContractScope parentScope = (ContractScope)scope.getParent();
			if (parentScope != null) {
				parentScope.setChargeSchedules(false);
			}
				ContractFixture.compare((Contract) ccb1.getParent(), (Contract) ccb2.getParent(),
						parentScope);
		}
	}
	
	public static void compare(ContractChargeSchedule[] cArray1, ContractChargeSchedule[] cArray2,
			ContractScope scope) throws AssertionFailedError, Exception {
		sortWithComparator(cArray1, RPMObjectIDComparator.INSTANCE);
		sortWithComparator(cArray2, RPMObjectIDComparator.INSTANCE);
		RPMObjectFixture.compare(cArray1, cArray2);
		if (cArray1 == null)
			return;
		for (int i = 0; i < cArray1.length; i++) {
			ContractChargeScheduleFixture.compare(cArray1[i], cArray2[i], scope);
		}
	}
	
	public static ContractScope createScope() {
		ContractScope scope = new ContractScope();
		ContractScope parentScope = new ContractScope();

		parentScope.setChargeSchedules(true);

		scope.setParent(parentScope);
		return scope;
	}
	

}
