/*
 * Created on Feb 21, 2006
 *
 */
package com.ibm.rpm.client.junit.contract.testcases;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.applicationadministration.containers.ContractType;
import com.ibm.rpm.client.junit.contract.fixtures.ContractModuleFixture;
import com.ibm.rpm.client.junit.framework.testcases.ModuleTestController;
import com.ibm.rpm.contract.containers.ContractModule;
import com.ibm.rpm.contract.containers.GenericContract;
import com.ibm.rpm.contract.scope.ContractModuleScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.containers.AbstractModule;

/**
 * @author karim
 *
 */
public class TestContractModule extends ModuleTestController
{
    public TestContractModule(String testName)
    {
        setName(testName);
    }

    public void setUp() throws Exception
    {
        logger.info("setUp");
        super.setUp();

        mainScope = ContractModuleFixture.createFullScope();        
        moduleContaineName = "CONTRACTMODULE";
    }

    
    
    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public RPMObject load(AbstractModule aModule, RPMObjectScope aScope)
            throws Exception
    {

        ContractModule module = (ContractModule) aModule;
        ContractModuleScope scope = (ContractModuleScope) aScope;

        ContractModule loadedModule = new ContractModule();
        
        if (scope != null)
        {
            if(scope.getContracts()!=null)
            {
                GenericContract[] genericContracts = (GenericContract[]) loadElements(module.getContracts(),
            			scope.getContracts(),GenericContract.class);        
            	loadedModule.setContracts(genericContracts);
            }
            if(scope.isContractTypes())
            {
            	ContractType[] contractTypes = (ContractType[]) loadDatafields(
                        module.getContractTypes(), scope
                                .isContractTypes(), ContractType.class);
                loadedModule.setContractTypes(contractTypes);
            }
        }

        return loadedModule;
    }
    
    protected void deleteModule(AbstractModule aModule, RPMObjectScope aScope)
            throws AssertionError, Exception
    {

        ContractModule module = (ContractModule) aModule;
        ContractModuleScope scope = (ContractModuleScope) aScope;

        //delete the element
        if (module != null && scope != null)
        {
            if (module.getContracts() != null && scope.getContracts()!=null)
            {
                delete(module.getContracts());
            }
            
            //reload the deleted element
            ContractModule deletedModule = (ContractModule) loadDeletedModule(module, scope);

            //Validate the deleted element
            if (scope.getContracts() != null)
            {
                assertNull(deletedModule.getContracts());
            }
        }
    }

    protected AbstractModule createFixture(RPMObjectScope scope)
            throws Exception
    {
        return ContractModuleFixture.createFixture((ContractModuleScope) scope, this);
    }

    protected AbstractModule updateFixture(AbstractModule module,
            RPMObjectScope scope) throws Exception
    {
        return ContractModuleFixture.updateFixture((ContractModule) module, (ContractModuleScope) scope, this);
    }

    protected void compare(AbstractModule module,
            AbstractModule returnedModule, RPMObjectScope scope)
            throws AssertionFailedError, Exception
    {
        ContractModuleFixture.compare((ContractModule) module,
            (ContractModule) returnedModule, (ContractModuleScope) scope);
    }
}
