package com.ibm.rpm.client.junit.customfield.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.customfield.fixtures.CustomFieldFixture;
import com.ibm.rpm.customfield.containers.CustomField;
import com.ibm.rpm.customfield.types.FieldInputType;

public class Test58681 extends ClientTestController{

    private CustomField customField = null;
    
    protected void setUp() throws Exception
    {
        super.setUp();
        
        customField = createAndSaveCustomField("WBS",FieldInputType.Text);
    }
    
	public void testUpdateCustomFieldInputTypeWithoutDefaultValue() throws Exception
	{
		updateAndValidateCustomFieldInputType(false);
	}
	
	public void testUpdateCustomFieldInputTypeWithDefaultValue() throws Exception
	{
		updateAndValidateCustomFieldInputType(true);
	}
	
	private void updateAndValidateCustomFieldInputType(boolean assignDefaultValue) throws Exception
	{
		customField = updateAndSaveCustomField(customField, FieldInputType.Currency, assignDefaultValue);
		
		assertNotNull(customField);
		assertEquals(FieldInputType.Currency,customField.getInputType());
		if(!assignDefaultValue)
		{
			assertNull(customField.getDefaultValue());
		}
	}
	
	private CustomField createAndSaveCustomField(String contextName, FieldInputType inputType) throws Exception
	{
		return CustomFieldFixture.createSaveCustomField(contextName, inputType, this);
	}
	
	private CustomField updateAndSaveCustomField(CustomField customField, FieldInputType inputType, boolean assignDefaultValue) throws Exception
	{
		if(assignDefaultValue)
		{
		    //here we assign inputType and DefaultValue
		    CustomFieldFixture.setInputType(customField, inputType);
		}
		else
		{
		    customField.setInputType(inputType);
		}
		
		customField = (CustomField)save(customField,null).getRpmObject();
		
		return customField;
		
	}
}
