/*
 * Created on Oct 11, 2006
 *
 */
package com.ibm.rpm.client.junit.document.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.document.containers.Document;
import com.ibm.rpm.document.containers.DocumentElement;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.wbs.containers.Deliverable;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.containers.WorkProduct;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author karim
 *
 */
public class Test47122 extends ClientTestController {

	public void testSaveDocumentsInMultpleLevels() throws Exception
	{

		WorkElementScope workElementScope = new WorkElementScope();
		DocumentScope documentScope = new DocumentScope();
		documentScope.setChildren(documentScope);
		workElementScope.setDocumentFolder(documentScope);
		workElementScope.setChildren(workElementScope);
		
		Proposal proposal = new Proposal();
		proposal.setName("WS-C#-MLD-Proposal");

		Deliverable dev = new Deliverable();
		dev.setName("WS-C#-MLD-Deliverable");

		WorkProduct workPro = new WorkProduct();
		workPro.setName("WS-C#-MLD-WorkProduct");

		proposal.setChildren(new WorkElement[] {dev, workPro});

		SaveResult saveResult = save(proposal,workElementScope);
		proposal = (Proposal)saveResult.getRpmObject();
		assertNotNull(proposal.getChildren());
		assertEquals(2, proposal.getChildren().length);

		Document docProposal = new Document();
		docProposal.setName("Document-of-Proposal");
		proposal.getDocumentFolder().setChildren(new DocumentElement[] {docProposal});
		
		assertTrue(proposal.getChildren()[0] instanceof Deliverable);
		dev = (Deliverable)proposal.getChildren()[0];
		Document docDel1 = new Document();
		docDel1.setName("Document-of-Deliverable-1");
		Document docDel2 = new Document();
		docDel2.setName("Document-of-Deliverable-2");
		dev.getDocumentFolder().setChildren(new DocumentElement[] {docDel1,docDel2});
		
		assertTrue(proposal.getChildren()[1] instanceof WorkProduct);
		workPro = (WorkProduct)proposal.getChildren()[1];
		Document docWork1 = new Document();
		docWork1.setName("Document-of-WorkProduct-1");
		Document docWork2 = new Document();
		docWork2.setName("Document-of-WorkProduct-2");
		Document docWork3 = new Document();
		docWork3.setName("Document-of-WorkProduct-3");
		workPro.getDocumentFolder().setChildren(new DocumentElement[] {docWork1,docWork2,docWork3});

		saveResult = save(proposal,workElementScope);
		proposal = (Proposal)saveResult.getRpmObject();
		assertNotNull(proposal.getChildren());
		assertEquals(2, proposal.getChildren().length);
		
		assertTrue(proposal.getChildren()[0] instanceof Deliverable);
		dev = (Deliverable)proposal.getChildren()[0];
		assertTrue(proposal.getChildren()[1] instanceof WorkProduct);
		workPro = (WorkProduct)proposal.getChildren()[1];
		
		assertNotNull(proposal.getDocumentFolder().getChildren());
		assertNotNull(dev.getDocumentFolder().getChildren());
		assertNotNull(workPro.getDocumentFolder().getChildren());
		
		assertEquals(6, proposal.getDocumentFolder().getChildren().length);
		assertEquals(2, dev.getDocumentFolder().getChildren().length);
		assertEquals(3, workPro.getDocumentFolder().getChildren().length);
	}

	
}
