package com.ibm.rpm.client.junit.document.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.document.containers.Document;
import com.ibm.rpm.document.containers.DocumentFolder;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Proposal;

public class Test59999 extends ClientTestController {

	Proposal proposal = new Proposal();

	public void testloadRequirementDocumentFromXPath() throws Exception
	{
	    Proposal proposal = createProposal();
	    Requirement requirement = createRequirement(proposal);
	    Document document = createDocument(requirement);

		String xPath = "/Requirement [@id = '" + requirement.getID() + "'] /DocumentFolder";

		DocumentScope documentScope = new DocumentScope();
		documentScope.setChildren(documentScope);

		DocumentFolder docFolder = (DocumentFolder) loadOneFromXpath(xPath, documentScope);

		assertNotNull(docFolder);
		assertNotNull(docFolder.getChildren());
		assertEquals(1,docFolder.getChildren().length);
		assertNotNull(docFolder.getChildren()[0]);
		assertTrue(docFolder.getChildren()[0] instanceof Document);
	}

	private Proposal createProposal() throws Exception
	{
		proposal.setName("WS_TEST_59999");

		SaveResult result = save(proposal,null);
		proposal = (Proposal)result.getRpmObject();

		assertNotNull(proposal);

		return proposal;
	}

	private Requirement createRequirement(Proposal proposal) throws Exception
	{
		ScopeFolder rootFolder = (ScopeFolder)loadOneFromXpath("/ScopeFolder [@name = '" + proposal.getName() + "']", null);
		assertNotNull(rootFolder);

		Requirement requirement = new Requirement();
		requirement.setName(HelperTestUtilities.createName());
		requirement.setParent(rootFolder);

		ScopeElementScope requirementScope = new ScopeElementScope();
		requirementScope.setDocumentFolder(new DocumentScope());
		
		SaveResult result = save(requirement,requirementScope);
		requirement = (Requirement)result.getRpmObject();

		assertNotNull(requirement);
		assertNotNull(requirement.getDocumentFolder());
		
		return requirement;
	}
	
	private Document createDocument(Requirement requirement) throws Exception
	{
	    DocumentFolder rootDocumentFolder = requirement.getDocumentFolder();
		Document document = new Document();
		document.setName(HelperTestUtilities.createName());
		document.setParent(rootDocumentFolder);

		SaveResult result = save(document, null);
		document = (Document)result.getRpmObject();

		assertNotNull(document);
		
		return document;
	}

}
