package com.ibm.rpm.client.junit.document.testcases.validation;

import com.ibm.rpm.client.junit.framework.testcases.GenericValidation;
import com.ibm.rpm.client.junit.framework.testcases.RPMExceptionMock;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.document.constants.ErrorCodes;
import com.ibm.rpm.document.containers.Document;
import com.ibm.rpm.document.containers.DocumentFolder;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.wbs.containers.Proposal;

public class TestUnlockDocumentValidation extends GenericValidation {
	
	Document documentToUnlock;
	
	public void setUp() throws Exception
	{
		super.setUp();
		
		//	create a Proposal and save it; this will create a DocumentFolder
		Proposal proposal = (Proposal) WorkElementFixture.createSaveFixture(
            new Proposal(), null, this);
		
		RPMObject[] rpmObjects = loadFromXpath("/DocumentFolder[name='"
                + proposal.getName() + "']", null);

        assertNotNull(rpmObjects);
        assertTrue(rpmObjects[0] instanceof DocumentFolder);
        DocumentFolder docFolder = (DocumentFolder) rpmObjects[0];
        
        DocumentScope documentScope = new DocumentScope();
        documentScope.setParent(new DocumentScope());
        
		documentToUnlock = new Document();
        documentToUnlock.setParent(docFolder);
        documentToUnlock.setName(HelperTestUtilities.createName());
        documentToUnlock = (Document)save(documentToUnlock, documentScope).getRpmObject();
        
        assertNotNull(documentToUnlock);
	}
	
	public void tearDown() throws Exception
    {
        super.tearDown();
    }

	public void testErrorAlreadyUnlocked() throws Exception
	{
		
        //This should result an exception
        SingleResult result = doUnLockDocument(documentToUnlock);
        
        RPMExceptionMock[] expectedExceptions =
        {
            createRPMException(ErrorCodes.EXCEPTION_DOC_ALREADY_UNLOCKED, documentToUnlock.getClass().getName()),
        };

        verifyFailure(documentToUnlock, expectedExceptions, null, result);
        verifyExceptions(expectedExceptions, result.getErrors());
	}
	
}
