/*
 * Created on 21-Feb-2006
 * The parent class of all the test cases for document xpath
 */
package com.ibm.rpm.client.junit.document.testcases.xpath;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;
import com.ibm.rpm.client.junit.document.fixtures.DocumentElementFixture;
import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.document.containers.DocumentElement;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

/**
 * @author cobber
 */
public abstract class AbstractTestDocumentDataXPath extends ObjectXPathTester
{
    protected RPMObject parent = null;

    protected DocumentElement documentElement = null;

    protected RPMObject createObject() throws Exception
    {
        parent = DocumentElementFixture.createSaveParent(parent, this);

        RPMObject parentDocumentElement = DocumentElementFixture
            .getParentDocumentFolder(parent);
        documentElement = DocumentElementFixture.createFixture(
            parentDocumentElement, documentElement, 1,
            (DocumentScope) mainScope, this);

        return documentElement;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        initVariables();
        mainScope = DocumentElementFixture
            .createScope(documentElement, 1, 1, 1);
        return mainScope;
    }

    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        DocumentElementFixture.compare((DocumentElement) myObject,
            (DocumentElement) dbObject);
    }

    protected ArrayList generateLocalSkipList()
    {
        ArrayList localSkip = new ArrayList();
        localSkip.add("getLocked");
        localSkip.add("getDocumentCompressedSize");
        localSkip.add("getPublished");
        localSkip.add("getLinkingStatus");
        localSkip.add("getElementSecurityType");
        localSkip.add("getDocumentStatus");
        localSkip.add("getDocumentRank");
        localSkip.add("getLastUpdated");
        localSkip.add("getHasAttachment");
        return localSkip;
    }

    /**
     * The method will be implemented for different combination of document
     * test.
     */
    protected abstract void initVariables();
}