package com.ibm.rpm.client.junit.financial.testcases;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.timesheet.fixtures.SummaryTimesheetFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.framework.util.DateUtil;
import com.ibm.rpm.timesheet.containers.SummaryTimesheet;
import com.ibm.rpm.timesheet.scope.SummaryTimesheetScope;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class TestTimeCode extends ClientTestController
{
    public void setUp() throws Exception
    {
        logger.info("setUp");
        super.setUp();
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testWorkElementSearchTimeCode1() throws Exception
    {

        SummaryTimesheetScope scope = SummaryTimesheetFixture.createScope(true,
            false, true, false, true);
        scope.setParent(new RPMObjectScope());
        scope.setProject(true);

        SummaryTimesheet summaryTimesheet = insertSummaryTimesheet(scope, true);        
        WorkElement we = summaryTimesheet.getWorkElement();                
        RPMObject[] objects = searchTimeCodes(we.getID(), null, true);
                
        //The fixture only contains one TimeCode1 as a TimeCodeAssignment
        assertEquals(1, objects.length);
        return;
    }

    private SummaryTimesheet insertSummaryTimesheet(
            SummaryTimesheetScope scope, boolean loadFromId)
            throws AssertionError, Exception
    {
        SummaryTimesheet summaryTimesheet = SummaryTimesheetFixture
            .createFixture(null, null, scope, true, this);

        // Insert the element into the DB
        SingleResult result = save(summaryTimesheet, scope);

        // compare the returned element
        SummaryTimesheet returnedSummaryTimesheet = (SummaryTimesheet) result
            .getRpmObject();
        SummaryTimesheetFixture.compare(summaryTimesheet,
            returnedSummaryTimesheet, scope);

        // reload the element and compare it
        returnedSummaryTimesheet = (SummaryTimesheet) load(
            returnedSummaryTimesheet, scope, loadFromId);
        SummaryTimesheetFixture.compare(summaryTimesheet,
            returnedSummaryTimesheet, scope);

        // return the element
        return returnedSummaryTimesheet;
    }

    private RPMObject load(SummaryTimesheet summaryTimesheet,
            SummaryTimesheetScope scope, boolean loadFromId) throws Exception
    {
        RPMObject object = null;

        if (loadFromId)
        {
            // load from an id
            SummaryTimesheet obj = new SummaryTimesheet();
            obj.setTaskAssignment(summaryTimesheet.getTaskAssignment());
            obj.setWeekOf(summaryTimesheet.getWeekOf());
            object = loadFromID(obj, scope);
        }
        else
        {

            // load from an xpath
            RPMObject[] objs = loadFromXpath("/SummaryTimesheet[weekOf='"
                    + DateUtil.convertToString(summaryTimesheet.getWeekOf())
                    + "' and @taskassignment[id = '"
                    + summaryTimesheet.getTaskAssignment().getID() + "']]",
                scope);

            if (objs != null && objs.length > 0)
            {
                object = objs[0];
            }
        }

        return object;
    }
}
