/*
 * Created on Nov 27, 2006
 * @author mmatwiy
 * 
 * testLoadTimecodeAssignments below caused this error:
 * TimeCodeAssignmentManager.getJoinCondition is not implemented for the manager WbsManager.
 * The foreign key condition was calling getJoinCondition. I've removed the call to 
 * getJoinCondition from the getForeignKeyCondition and added a foreign key condition.
 * 
 * Also added tests for join and subjoin just to make sure they're fine.
 */
package com.ibm.rpm.client.junit.financial.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.financial.containers.TimeCodeAssignment;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class Test57764 extends ClientTestController
{
    Proposal proposal = null;
    WorkElementScope scope = null;
    
    public void setUp() throws Exception
    {
        super.setUp();
        
        scope = new WorkElementScope();
        scope.setTimeCodeAssignments(true);

        proposal = (Proposal) WorkElementFixture.createSaveFixture(
            new Proposal(), scope, this);
    }
    
    public void testLoadTimecodeAssignments() throws Exception
    {
        RPMObject[] objects = loadFromXpath("Proposal[name='"
                + proposal.getName() + "']", scope);
        assertNotNull(objects);
        assertNotNull(objects[0]);
        assertTrue(objects[0] instanceof Proposal);
    }

    public void testJoinCondition() throws Exception
    {
        RPMObject[] objects = loadFromXpath("/Proposal[id='"
            + proposal.getID() + "']/@timeCodeAssignments", null);
        assertNotNull(objects);
        assertNotNull(objects[0]);
        assertTrue(objects[0] instanceof TimeCodeAssignment);
    }
    
    public void testSubJoinCondition() throws Exception
    {
        RPMObject[] objects = loadFromXpath("/Proposal[@timeCodeAssignments[id='"
            + proposal.getTimeCodeAssignments()[0].getID() + "']]", scope);
        assertNotNull(objects);
        assertNotNull(objects[0]);
        assertTrue(objects[0] instanceof Proposal);
    }
}
