package com.ibm.rpm.client.junit.financial.testcases.xpath;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.financial.fixtures.ChargeCodeFixture;
import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.financial.containers.ChargeCodeCategory;
import com.ibm.rpm.financial.containers.GenericChargeCode;
import com.ibm.rpm.financial.scope.ChargeCodeScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

/**
 * @author legaults
 */
public class TestChargeCodeDataXPath extends ObjectXPathTester
{

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    protected RPMObject createObject() throws Exception
    {
        RPMObject o = ChargeCodeFixture.createSimpleChargeCode();
        
        //Save parent
        o = save(o.getParent(), ((ChargeCodeScope) mainScope).getParent()).getRpmObject();
        
        o = ((ChargeCodeCategory)o).getChildren()[0];
        
        return o;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        ChargeCodeScope scope = ChargeCodeFixture.createSimpleScope();
        return scope;
    }

    protected void objectCompare(RPMObject original, RPMObject reloaded,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        ChargeCodeFixture.assertEquals((GenericChargeCode) original,
                (GenericChargeCode) reloaded, (ChargeCodeScope) scope);
    }
    
    protected ArrayList generateLocalSkipList()
    {
        ArrayList l = new ArrayList();

        // skip the xpath /ChargeCode[billable="true"]
        // this is done in TestChargeCode and returns too many results
        l.add("getBillable");
        
        l.trimToSize();
        return l;
    }
}
