package com.ibm.rpm.client.junit.framework.testcases;

import junit.framework.TestCase;

/**
 * @author mcduffs
 */
public class PlannedTest extends TestCase
{

    public Class testClass;

    public String testName;

    public String testComment;

    public Object[] args;

    public int testIndex;

    private String overrideName;

    private RpmObjectAbstractTester testFixture;

    public PlannedTest()
    {
        super("testPlannedTest");
    }

    public String getLogString()
    {
        String logString = (testIndex) + " " + testName;
        if (testComment != null)
        {
            logString += " " + testComment;
        }
        return logString;
    }

    protected void setUp() throws Exception
    {
        testFixture = RpmTestFramework.INSTANCE.findFixture(testClass);
        testFixture.setFailOnFirstError(true);
    }

    protected void tearDown() throws Exception
    {
        testFixture.clearErrorList();
    }

    public void testPlannedTest() throws Throwable
    {
        testFixture.runPlannedTest(testIndex);
        testFixture.failAllErrors();
    }

    public String getName()
    {
        if (overrideName == null)
        {
            overrideName = (testIndex) + " : " + testName + " : " + testComment;
        }
        return overrideName;
    }
}
