package com.ibm.rpm.client.junit.framework.testcases;

import com.ibm.rpm.framework.util.StringUtil;

/**
 * @author dominiqu
 */
public class RPMExceptionMock
{
    private int errorID = 0;

    private String className;

    private String fieldName;

    private String secondaryFieldName;

    private String containerID;

    public RPMExceptionMock(int errorID, String className, String fieldName,
            String containerID)
    {
        this(errorID, className, fieldName, null, containerID);
    }

    public RPMExceptionMock(int errorID, String className, String fieldName,
            String secondaryFieldName, String containerID)
    {
        this.errorID = errorID;
        this.className = StringUtil.getShortClassName(className);
        this.fieldName = fieldName;
        this.secondaryFieldName = secondaryFieldName;
        this.containerID = containerID;
    }

    public int getErrorID()
    {
        return errorID;
    }

    public String getClassName()
    {
        return className;
    }

    public String getFieldName()
    {
        return fieldName;
    }

    public String getSecondaryFieldName()
    {
        return secondaryFieldName;
    }

    public String getContainerID()
    {
        return containerID;
    }

    public String toString()
    {
        StringBuffer msg = new StringBuffer();
        if (className != null)
        {
            msg.append(className);
        }
        if (fieldName != null)
        {
            msg.append(' ');
            msg.append(fieldName);
        }
        if (secondaryFieldName != null)
        {
            msg.append(" - Other field name: ");
            msg.append(secondaryFieldName);
        }
        if (containerID != null)
        {
            msg.append(" - Object ID: ");
            msg.append(containerID);
        }
        if (errorID != 0)
        {
            msg.append(" - Error ID: ");
            msg.append(errorID);
        }

        return msg.toString();
    }
}