/*
 * Created on 9-Aug-2006
 * @author mmatwiy
 * Create an LDAP user for use in TestLdapAuthentication. 
 */
package com.ibm.rpm.client.junit.framework.testcases;

import com.ibm.rpm.applicationadministration.scope.CalendarScope;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.RPMCalendarFixture;
import com.ibm.rpm.client.junit.resource.fixtures.PoolFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.scope.ResourceScope;

public class TestCreateAuthenticationTestUser extends ClientTestController
{
    private String PASSWORD = "123456";
    
    public void testCreateAuthenticationTestUser() throws Exception
    {
        Pool pool = null;
        Resource resource = null;

        RPMObject[] rpmObjects = loadFromXpath("/Pool[name='"
                + TestLdapAuthentication.USERNAME + "']", null);

        if (rpmObjects != null)
        {
            pool = (Pool) rpmObjects[0];
        }

        if (pool == null)
        {
            pool = PoolFixture.createFixture(false, 0, null, this);
            pool.setName(TestLdapAuthentication.USERNAME);
            saveWithoutDelete(pool, null);
        }

        ResourceScope resourceScope = new ResourceScope();
        resourceScope.setCalendar(new CalendarScope());

        rpmObjects = loadFromXpath("/Resource[userName='"
                + TestLdapAuthentication.USERNAME + "']", resourceScope);

        if (rpmObjects != null)
        {
            resource = (Resource) rpmObjects[0];
        }

        if (resource == null)
        {
            resource = new Resource();
            resource.setFullName(TestLdapAuthentication.USERNAME);
            resource.setUserName(TestLdapAuthentication.USERNAME);
            resource.setPassword(PASSWORD);
            resource.setParent(pool);
            resource.setActive(new Boolean(true));
            resource.setCalendar(RPMCalendarFixture
                .retrieveStaticFixtureForInserts(this));

            saveWithoutDelete(resource, resourceScope);

            // must change password prior to first login
            getAuthenticateInterface().changePassword(
                TestLdapAuthentication.USERNAME, PASSWORD,
                TestLdapAuthentication.PASSWORD, DSN);
        }
    }
}