package com.ibm.rpm.client.junit.framework.testcases;

/**
 * Tests LDAP Authentication with SSL connection.
 * 
 * Usage: see TestLdapAuthentication.
 * 
 * @author legaults
 */
public class TestLdapUserIDAuthentication extends TestLdapAuthentication
{
    // Tests are defined in the superclass.
    // Design note: we cannot execute the same test (same class name)
    // twice because JUnit would merge their test results (take
    // only the result of the last run).
    
    
    public static final String OVERRIDE_LDAP_CONFIG;

    static
    {
        String assignLdapConfig = "";
        
        assignLdapConfig += "java.naming.provider.url=\"ldaps://tstbluepages.mkm.can.ibm.com:636\"";
        assignLdapConfig += "java.naming.factory.initial=\"com.sun.jndi.ldap.LdapCtxFactory\"";
        assignLdapConfig += "java.naming.ldap.version=\"3\"";
        assignLdapConfig += "java.naming.security.protocol=\"simple\"";

        assignLdapConfig += "ldapsearchcontext=\"o=ibm.com\"";
        assignLdapConfig += "ldapuseridattr=\"email\"";
        // assignLdapConfig += "ldapuserauthdn=\"distinguishedName\"";
        
        OVERRIDE_LDAP_CONFIG = assignLdapConfig;
    }
    
    public String getLdapConfig()
    {
        return OVERRIDE_LDAP_CONFIG;
    }
}