package com.ibm.rpm.client.junit.framework.testcases;

import java.util.Calendar;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.framework.Property;

/**
 * @author Genevieve
 */
public class TestSystemInfo extends ClientTestController 
{
    public void testGetSystemInfo() throws Exception
    {
        Property[] properties = getSystemInfo();
        assertPropertyExist(properties, "com.ibm.rpm.ws.build.version");
        assertPropertyExist(properties, "com.ibm.rpm.ws.database.version");
    }    

    public void testDatabaseTime() throws Exception
    {
        Calendar date = getApplicationInterface().getDatabaseTimestamp(sessionid);
        assertNotNull(date);
    }
    
    private void assertPropertyExist(Property[] properties, String key)
    {
        String value = getValue(properties, key);
        assertNotNull(value);
    }
    
    private String getValue(Property[] properties, String key)
    {
        String value = null;
        for (int i = 0; i < properties.length; i ++)
        {
            Property property = properties[i];
            if (property.getKey().equals(key))
            {
                value = property.getValue();
                break;
            }
        }
        return value;
    }
}
