/*
 * Created on 14-Sep-2005
 */
package com.ibm.rpm.client.junit.framework.testcases.xpath.stats;

/**
 * @author njarazi
 */
public class StatsDetails
{
    // 10 lines of 80 chars each
    public static final int MAX_ERROR_LENGTH = 10*80;
    
    /* SINGLETON CLASS */
    private static StatsDetails instance = new StatsDetails();

    private StringBuffer errors = new StringBuffer();

    private StatsDetails()
    {
        resetErrorMessage();
    }

    public static StatsDetails getInstance()
    {
        return instance;
    }

    public void appendFieldError(String field)
    {
        if (isFull())
        {
            return;
        }
        
        errors.append("==> ").append(StatsManager.TAB).append(field).append(
                StatsManager.NEW_LINE);
    }

    public void appendFieldErrorMessage(String msg)
    {
        if (isFull())
        {
            return;
        }
        
        errors.append(StatsManager.TAB).append(StatsManager.TAB).append(
                StatsManager.TAB).append(StatsManager.TAB).append(msg).append(
                StatsManager.NEW_LINE);
    }
    
    public void appendNewLine()
    {
        if (isFull())
        {
            return;
        }
        
        errors.append(StatsManager.NEW_LINE);              
    }
    
    public void appendTab()
    {
        if (isFull())
        {
            return;
        }
        
        errors.append(StatsManager.TAB);
    }

    public String getErrorDetails()
    {
        return errors.toString();
    }

    public void resetErrorMessage()
    {
        errors.delete(0, errors.length());
        errors.append("errors found on the following fields").append(
                StatsManager.NEW_LINE).append(StatsManager.NEW_LINE);
    }
    
    public boolean isFull()
    {
        return errors.length() > MAX_ERROR_LENGTH;
    }
}
