/*
 * Created on 15-Sep-2005
 */
package com.ibm.rpm.client.junit.framework.testcases.xpath.stats;

/**
 * @author njarazi
 */
public class StatsManager
{
    public static final String TAB = "\t";
    public static final String FOUR_TABS = "\t\t\t\t";
    public static final String NEW_LINE = "\r\n";

    public static final String LEADING_STATS_STARS = "******* Stats ******"
            + NEW_LINE;

    public static final String LEADING_ERROR_STARS = "\n\n******* Errors ******"
            + NEW_LINE;

    public static final String TRAILING_STARS = "*******************"
            + NEW_LINE;

    public static final String PROPERTIES_COUNT = " properties count : ";
    public static final String SIMPLE = "Simple";
    public static final String TOTAL = "Total";
    public static final String COMPLEX = "Complex";

    /** The depth of objects to be checked */
    public static final int MAXIMUM_DEPTH_CHECK = 2;

    public StatsManager()
    {/* do nothing */
    }

    public static void incrementErrorCount()
    {
        StatsCounter.getInstance().incrementErrorCount();
    }

    public static int getErrorCount()
    {
        return StatsCounter.getInstance().getErrorCount();
    }
    
    public static void incrementSimplePropertiesCount()
    {
        StatsCounter.getInstance().incrementSimplePropertiesCount();
    }

    public static void incrementComplexPropertiesCount()
    {
        StatsCounter.getInstance().incrementComplexPropertiesCount();
    }

    public static void decrementComplexPropertiesCount()
    {
        StatsCounter.getInstance().decrementComplexPropertiesCount();
    }

    public static void appendFieldError(String error)
    {
        StatsDetails.getInstance().appendFieldError(error);
    }

    public static void appendFieldErrorMessage(String msg)
    {
        StatsDetails.getInstance().appendFieldErrorMessage(msg);
    }
    
    public static void appendNewLine()
    {
        StatsDetails.getInstance().appendNewLine();
    }
    
    public static void appendTab()
    {
        StatsDetails.getInstance().appendTab();
    }

    public static String getErrorLog()
    {
        StringBuffer s = new StringBuffer();

        s.append(LEADING_ERROR_STARS).append(
                StatsCounter.getInstance().getErrorCount()).append(" ").append(
                StatsDetails.getInstance().getErrorDetails()).append(
                TRAILING_STARS);

        return s.toString();
    }

    public static void printErrorLog()
    {
        System.out.println(getErrorLog());
    }

    public static boolean hasErrorOccured()
    {
        return (StatsCounter.getInstance().getErrorCount() > 0);
    }

    public static String getStatsLog()
    {
        StringBuffer s = new StringBuffer();

        s.append(LEADING_STATS_STARS).append(TAB).append(TOTAL).append(
                PROPERTIES_COUNT).append(
                StatsCounter.getInstance().getTotalPropertiesCount()).append(
                NEW_LINE).append(TAB).append(SIMPLE).append(PROPERTIES_COUNT)
                .append(StatsCounter.getInstance().getSimplePropertiesCount())
                .append(NEW_LINE).append(TAB).append(COMPLEX).append(
                        PROPERTIES_COUNT).append(
                        StatsCounter.getInstance().getComplexPropertiesCount())
                .append(NEW_LINE).append(TRAILING_STARS);

        return s.toString();
    }

    public static void printStats()
    {
        System.out.println(getStatsLog());
    }

    public static void clearErrorLog()
    {
        StatsCounter.getInstance().resetErrorCounter();
        StatsDetails.getInstance().resetErrorMessage();
    }

    public static void clearStats()
    {
        StatsCounter.getInstance().resetComplexPropertiesCounter();
        StatsCounter.getInstance().resetSimplePropertiesCounter();
        StatsCounter.getInstance().resetTotalPropertiesCounter();
    }

    public static void resetDepth()
    {
        StatsCounter.getInstance().resetDepth();
    }

    public static void incrementDepth()
    {
        StatsCounter.getInstance().incrementDepth();
    }

    public static void decrementDepth()
    {
        StatsCounter.getInstance().decrementDepth();
    }

    public static int getDepth()
    {
        return StatsCounter.getInstance().getCurrentDepth();
    }
}
