/*
 * Created on Jul 19, 2005
 *
 */
package com.ibm.rpm.client.junit.resource.fixtures;

import java.util.ArrayList;
import java.util.Comparator;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.clientcostcenters.fixtures.ClientCostCenterFixture;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.clientcostcenters.containers.ClientCostCenter;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.containers.ResourceCostCenterAssignment;

public class ResourceCostCentersFixture extends RPMObjectFixture
{
	protected static ArrayList localSkipGetters = new ArrayList();
	static
    {
    	//set skipGetters
    	localSkipGetters.add("getStartDate");
    	localSkipGetters.add("getFinishDate");
    }
    

	public static ResourceCostCenterAssignment createFixture(Resource resource, ClientTestController ctc)throws Exception
	{
	    return createAssignment(resource, ctc);
	}
	
    private static ResourceCostCenterAssignment createAssignment(Resource resource, ClientTestController ctc) throws Exception
    {
    	ResourceCostCenterAssignment assignment = new ResourceCostCenterAssignment();
    	
   		assignment.setParent(resource);
   		
   		ClientCostCenter ccc = ClientCostCenterFixture.createSaveFixture(ctc);
   		
  		assignment.setClientCostCenter(ccc);

    	return assignment;
    }
    
    public static void compare(ResourceCostCenterAssignment obj1, ResourceCostCenterAssignment obj2)
	throws AssertionFailedError,
            Exception
    {
        RPMObjectFixture.compareWithSkip(obj1, obj2, localSkipGetters);
        ResourceFixture.compareWithoutCanProperties((Resource)obj1.getParent(), (Resource)obj2.getParent(), null);
        ClientCostCenterFixture.compare(obj1.getClientCostCenter(), obj2.getClientCostCenter());
    }
    
    //Compare section
	public static void compare(ResourceCostCenterAssignment[] array1, ResourceCostCenterAssignment[] array2) 
	throws AssertionFailedError, Exception {
	    
    	sortWithComparator(array1, RPMObjectIDComparator.INSTANCE);
    	sortWithComparator(array2, RPMObjectIDComparator.INSTANCE);

    	//filter default ccc assignments
    	ResourceCostCenterAssignment[] filteredArray1 = filterDefaultAssignment(array1);
    	ResourceCostCenterAssignment[] filteredArray2 = filterDefaultAssignment(array2);
    	
		RPMObjectFixture.compare(filteredArray1, filteredArray2);

		for (int i = 0; i < filteredArray1.length; i++) {
			compare(filteredArray1[i], filteredArray2[i]);
		}
	}
	
	private static ResourceCostCenterAssignment[] filterDefaultAssignment(ResourceCostCenterAssignment[] assignments){
	    ResourceCostCenterAssignment[] arrayFilteredAssignments = null;
	    if(assignments!=null){
	        ArrayList filteredAssignments = new ArrayList();
	        ClientCostCenter ccc;
	        for(int i=0;i<assignments.length;i++){
	            ccc = assignments[i].getClientCostCenter();
	            if (ccc.getDefaultFlag()==null || !ccc.getDefaultFlag().booleanValue()){
	                filteredAssignments.add(assignments[i]);
	            }
	        }
	        arrayFilteredAssignments = new ResourceCostCenterAssignment[filteredAssignments.size()];
	        filteredAssignments.toArray(arrayFilteredAssignments);
	    }
	    return arrayFilteredAssignments;
	}
    
    protected static class RPMObjectComparator implements Comparator {

        private RPMObjectNameAndIDComparator clientCostCenterComparator = RPMObjectNameAndIDComparator.INSTANCE;
        
        public RPMObjectComparator() {
            super();
        }
        
        public int compare(Object o1, Object o2){ 
            
            ResourceCostCenterAssignment obj1 = (ResourceCostCenterAssignment)o1;
            ResourceCostCenterAssignment obj2 = (ResourceCostCenterAssignment)o2;
            
            ClientCostCenter key1 = null;
            ClientCostCenter key2 = null;
            
            if(obj1 != null){
                key1 = obj1.getClientCostCenter(); 
            }
            if(obj2 != null){
                key2 = obj2.getClientCostCenter();
            }
            
            return clientCostCenterComparator.compare(key1, key2);

        }
    }
	
}
