/*
 * Created on Jul 18, 2005
 *
 */
package com.ibm.rpm.client.junit.resource.fixtures;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.applicationadministration.containers.Geographical;
import com.ibm.rpm.applicationadministration.containers.GeographicalAssignment;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.GeographicalFixture;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.resource.containers.Resource;


/**
 * @author karim
 *
 */
public class ResourceGeographicalAssignmentFixture extends RPMObjectFixture {

    protected static ArrayList locationPreferenceSkipSetters, locationPreferenceSkipGetters;
    
    static
    {
        locationPreferenceSkipSetters = new ArrayList();
        locationPreferenceSkipSetters.addAll(skipSetters);
        locationPreferenceSkipSetters.add("setName");
        
        locationPreferenceSkipGetters = new ArrayList();
        locationPreferenceSkipGetters.addAll(skipGetters);
        locationPreferenceSkipGetters.add("getName");
    }  	
    public static GeographicalAssignment createFixture(Resource resource, ClientTestController ctc) throws Exception
    {
    	Geographical geographical = GeographicalFixture.createSaveFixture(1, ctc);
    	return createFixture(resource, geographical);
    }

    public static GeographicalAssignment createFixture(Resource resource, Geographical geographical) throws Exception
    {
    	if(resource!=null && geographical!=null){
        	GeographicalAssignment assignment = createAssignment(resource, geographical);
        	return assignment;    		
    	}
    	return null;
    }
    
    private static GeographicalAssignment createAssignment(Resource resource, Geographical geographical) throws Exception
    {
    	GeographicalAssignment assignment = new GeographicalAssignment();
    	
   		assignment.setParent(resource);
   		assignment.setGeographical(geographical);

    	return assignment;
    }
    
    
    //Compare section
	public static void compare(GeographicalAssignment[] array1, GeographicalAssignment[] array2) 
	throws AssertionFailedError, Exception {

		RPMObjectFixture.compare(array1, array2);

		for (int i = 0; i < array1.length; i++) {
			compare(array1[i], array2[i]);
		}
	}
	
    public static void compare(GeographicalAssignment obj1, GeographicalAssignment obj2)
	throws AssertionFailedError, Exception {
    	
    	RPMObjectFixture.compareWithSkip(obj1, obj2, locationPreferenceSkipGetters);
    	
    	ResourceFixture.compareWithoutCanProperties((Resource)obj1.getParent(), (Resource)obj2.getParent(), null);
    	
    	GeographicalFixture.compare(obj1.getGeographical(), obj2.getGeographical(), null);    	
    }
    

}
