/*
 * Created on Jul 18, 2005
 *
 */
package com.ibm.rpm.client.junit.resource.fixtures;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.applicationadministration.containers.Organizational;
import com.ibm.rpm.applicationadministration.containers.OrganizationalAssignment;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.OrganizationalFixture;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.resource.containers.Resource;


/**
 * @author karim
 *
 */
public class ResourceOrganizationalAssignmentFixture extends RPMObjectFixture {

    protected static ArrayList assignmentSkipSetters, assignmentSkipGetters;
    
    static
    {
        assignmentSkipSetters = new ArrayList();
        assignmentSkipSetters.addAll(skipSetters);
        assignmentSkipSetters.add("setName");
        
        assignmentSkipGetters = new ArrayList();
        assignmentSkipGetters.addAll(skipGetters);
        assignmentSkipGetters.add("getName");
    }  
    
    public static OrganizationalAssignment createFixture(Resource resource, ClientTestController ctc) throws Exception
    {
    	Organizational organizational = OrganizationalFixture.createSaveFixture(1, ctc);
    	return createFixture(resource, organizational);
    }

    public static OrganizationalAssignment createFixture(Resource resource, Organizational organizational) throws Exception
    {
    	if(resource!=null && organizational!=null){
        	OrganizationalAssignment assignment = createAssignment(resource, organizational);
        	return assignment;    		
    	}
    	return null;
    }
    
    private static OrganizationalAssignment createAssignment(Resource resource, Organizational organizational) throws Exception
    {
    	OrganizationalAssignment assignment = new OrganizationalAssignment();
    	
   		assignment.setParent(resource);
   		assignment.setOrganizational(organizational);

    	return assignment;
    }
    
    
    //Compare section
	public static void compare(OrganizationalAssignment[] array1, OrganizationalAssignment[] array2) 
	throws AssertionFailedError, Exception {

		RPMObjectFixture.compare(array1, array2);

		for (int i = 0; i < array1.length; i++) {
			compare(array1[i], array2[i]);
		}
	}
	
    public static void compare(OrganizationalAssignment obj1, OrganizationalAssignment obj2)
	throws AssertionFailedError, Exception {
    	
    	RPMObjectFixture.compareWithSkip(obj1, obj2, assignmentSkipGetters);
    	
    	ResourceFixture.compareWithoutCanProperties((Resource)obj1.getParent(), (Resource)obj2.getParent(), null);
    	
    	OrganizationalFixture.compare(obj1.getOrganizational(), obj2.getOrganizational(), null);    	
    }

}
