package com.ibm.rpm.client.junit.resource.testcases.fixes;

import com.ibm.rpm.applicationadministration.containers.RPMCalendar;
import com.ibm.rpm.applicationadministration.scope.CalendarScope;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.resource.fixtures.PoolFixture;
import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.scope.ResourceScope;

/**
 * @author gmeloche
 *  
 */
public class Test50198 extends ClientTestController
{

    public void testPartialSaveOfResource() throws Exception
    {
        Pool pool = PoolFixture.createSaveFixture(this);

        Resource resource = new Resource();
        resource.setFullName("TC_Test50198");
        resource.setParent(pool);

        RPMCalendar calendar = new RPMCalendar();
        calendar.setName(HelperTestUtilities.createName());
        resource.setCalendar(calendar);

        ResourceScope resScope = new ResourceScope();
        resScope.setCalendar(new CalendarScope());

        SaveResult result = getApplicationInterface().save(sessionid, resource,
            resScope, ReloadType.ReloadResult);

        assertFalse(result.isSuccessful());
        assertNull(resource.getID());

    }
}
