package com.ibm.rpm.client.junit.resource.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.resource.fixtures.PoolFixture;
import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.scope.ResourceScope;
import com.ibm.rpm.security.containers.SecurityGroup;
import com.ibm.rpm.security.scope.SecurityGroupScope;

/**
 * @author gmeloche
 *  
 */
public class Test50322 extends ClientTestController
{

    public void testPartialSaveOfResource() throws Exception
    {
        Pool pool = PoolFixture.createSaveFixture(this);

        Resource resource = new Resource();
        resource.setFullName("TC_Test50322");
        resource.setParent(pool);

        SecurityGroup securityGroup = new SecurityGroup();
        securityGroup.setName(HelperTestUtilities.createName());
        resource.setSecurityGroup(securityGroup);

        ResourceScope resScope = new ResourceScope();
        resScope.setSecurityGroup(new SecurityGroupScope());

        SaveResult result = getApplicationInterface().save(sessionid, resource,
            resScope, ReloadType.ReloadResult);

        assertFalse(result.isSuccessful());
        assertNull(resource.getID());

    }
}
