/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.resource.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.scope.ResourceScope;
import com.ibm.rpm.security.containers.SecurityGroup;
import com.ibm.rpm.security.scope.SecurityGroupScope;

/**
 * @author Yasser Lulu
 *
 */
public class Test61716 extends ClientTestController
{

    public void testLoadingResourceSecurityGroupThroughXPath() throws Exception
    {
        Resource res = new Resource();
        res.setID("PMO_SUPERVISOR");
        ResourceScope resScope = new ResourceScope();
        resScope.setSecurityGroup(new SecurityGroupScope());
        res = (Resource) loadFromID(res, resScope);
        assertNotNull(res);
        SecurityGroup originalSecurityGroup = res.getSecurityGroup();
        assertNotNull(originalSecurityGroup);

        String xpath = "/Resource[@id='" + res.getID() + "']/SecurityGroup";
        RPMObject[] result = loadFromXpath(xpath, null);

        assertNotNull(result);
        assertTrue(result.length == 1);
        assertTrue(result[0] instanceof SecurityGroup);

        SecurityGroup loadedSecurityGroup = (SecurityGroup) result[0];
        assertTrue(loadedSecurityGroup.getID().equals(
            originalSecurityGroup.getID()));
    }

}
