/*
 * Created on 11-Oct-2005
 */
package com.ibm.rpm.client.junit.resource.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.resource.fixtures.PoolFixture;
import com.ibm.rpm.client.junit.resource.fixtures.PoolReferenceFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.PoolReference;
import com.ibm.rpm.resource.scope.PoolReferenceScope;

/**
 * @author njarazi
 */
public class TestReferenceDataXPath extends ObjectXPathTester
{
    protected Pool parentPool;

    protected RPMObject createObject() throws Exception
    {
        //Parent pool is needed
        parentPool = PoolFixture.createSaveFixture(this);
        return PoolReferenceFixture.createFixture(parentPool,
                (PoolReferenceScope) mainScope);
    }

    protected RPMObjectScope createScope() throws Exception
    {
        return new PoolReferenceScope();
    }

    /**
     * @param dbObject
     * @throws AssertionFailedError
     * @throws Exception
     */
    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        PoolReferenceFixture.compare((PoolReference) myObject, (PoolReference) dbObject,
                (PoolReferenceScope) mainScope);
    }
}