/*
 * Created on 17-Oct-2005
 */
package com.ibm.rpm.client.junit.resource.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.resource.fixtures.CompetencyFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.resource.containers.ResourceAttributeCompetency;
import com.ibm.rpm.resource.containers.ResourceAttributeCompetencyCategory;
import com.ibm.rpm.resource.scope.ResourceAttributeScope;

/**
 * @author njarazi
 */
public class TestResourceAttributeCompetencyDataXPath extends ObjectXPathTester
{
    protected RPMObject createObject() throws Exception
    {
        ResourceAttributeCompetencyCategory racc = CompetencyFixture.createSaveFixture(this);
        RPMObject o = racc.getClassifications()[0]
                .getAttributes()[0];
        mainScope = getSpecificScope();
        return o;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        return CompetencyFixture.createScope(1, 1, 1);
    }
    
    private RPMObjectScope getSpecificScope()
    {
        return ((ResourceAttributeScope)mainScope).getClassifications().getAttributes();
    }

    /**
     * @param dbObject
     * @throws AssertionFailedError
     * @throws Exception
     */
    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        CompetencyFixture.compareCompetency(
                (ResourceAttributeCompetency) myObject,
                (ResourceAttributeCompetency) dbObject,
                (ResourceAttributeScope) mainScope);
    }
}