/*
 * Created on 12-Oct-2005
 */
package com.ibm.rpm.client.junit.resource.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.resource.fixtures.SkillFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.resource.containers.ResourceAttributeSkill;
import com.ibm.rpm.resource.containers.ResourceAttributeSkillCategory;
import com.ibm.rpm.resource.scope.ResourceAttributeScope;

/**
 * @author njarazi
 */
public class TestResourceAttributeSkillDataXPath extends ObjectXPathTester
{
    protected RPMObject createObject() throws Exception
    {
        ResourceAttributeSkillCategory rasc = SkillFixture.createSaveFixture(this);
        RPMObject o = rasc.getClassifications()[0]
                .getAttributes()[0];
        mainScope = getSpecificScope();
        return o;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        return SkillFixture.createScope(1, 1, 1);
    }

    private RPMObjectScope getSpecificScope()
    {
        return ((ResourceAttributeScope)mainScope).getClassifications().getAttributes();
    }
    
    /**
     * @param dbObject
     * @throws AssertionFailedError
     * @throws Exception
     */
    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        SkillFixture.compare((ResourceAttributeSkill) myObject,
                (ResourceAttributeSkill) dbObject,
                (ResourceAttributeScope) mainScope);
    }
}