/*
 * Created on 7-Oct-2005
 */
package com.ibm.rpm.client.junit.resource.testcases.xpath;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.resource.fixtures.PoolFixture;
import com.ibm.rpm.client.junit.resource.fixtures.ResourceFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.scope.ResourceScope;

/**
 * @author njarazi
 */
public class TestResourceDataXPath extends ObjectXPathTester
{
    protected Pool parentPool;

    protected RPMObject createObject() throws Exception
    {
        // Parent pool is needed
        parentPool = PoolFixture.createSaveFixture(this);
        return ResourceFixture.createFixture(parentPool,
            (ResourceScope) mainScope, this);
    }

    protected RPMObjectScope createScope() throws Exception
    {
        return new ResourceScope();
    }

    /**
     * @param dbObject
     * @throws AssertionFailedError
     * @throws Exception
     */
    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        ResourceFixture.compare((Resource) myObject, (Resource) dbObject,
            (ResourceScope) scope);
    }

    protected ArrayList generateLocalSkipList()
    {
        ArrayList local = new ArrayList();

        local.add("getResourceSecurityRights");
        local.add("getPassword");

        return local;
    }
}
