/*
 * Created on Sep 28, 2006
 *
 */
package com.ibm.rpm.client.junit.scopemanagement.fixtures;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.scopemanagement.containers.ReqProImportStatus;
import com.ibm.rpm.scopemanagement.containers.ReqProRequirement;
import com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;

/**
 * @author karim
 *
 */
public class ReqProRequirementFixture extends RPMObjectFixture
{
    protected static ArrayList localSkipGetters = new ArrayList();
    protected static ArrayList localSkipSetters = new ArrayList();
    static
    {
        //set skipGetters
        localSkipGetters.addAll(skipGetters);
        localSkipGetters.add("getClosedByName");
        localSkipGetters.add("getProposedByName");
        localSkipGetters.add("getApprovedByName");
        localSkipGetters.add("getDefaultScope");
        localSkipGetters.add("getDuplicateNumber");
        localSkipGetters.add("getEstimatedDurationInMinutes");
        localSkipGetters.add("getEstimatedFinishDate");
        localSkipGetters.add("getReferenceNumber");
        localSkipGetters.add("getTransferedUnderWbsRoot");
        localSkipGetters.add("getEstimatedStartDate");
        localSkipGetters.add("getEstimatedFinishDate");
        localSkipGetters.add("getReqProID");
        localSkipGetters.add("getWbsSortingRank");
        localSkipGetters.add("getParentSortingRank");
        localSkipGetters.add("getTemplateSortingRank");
        
        //set skipSetters
        localSkipSetters.addAll(skipSetters);
        localSkipSetters.add("setClosedByName");
        localSkipSetters.add("setProposedByName");
        localSkipSetters.add("setApprovedByName");
        localSkipSetters.add("setDefaultScope");
        localSkipSetters.add("setDuplicateNumber");
        localSkipSetters.add("setEstimatedDurationInMinutes");
        localSkipSetters.add("setEstimatedFinishDate");
        localSkipSetters.add("setReferenceNumber");
        localSkipSetters.add("setTransferedUnderWbsRoot");
        localSkipSetters.add("setEstimatedStartDate");
        localSkipSetters.add("setEstimatedFinishDate");
    }
	
    public static ReqProRequirement createFixture(ReqProScopeFolder parent,
    		ScopeElementScope scope) throws Exception
    {
        return createReqProRequirement(parent, random(), scope);
    }
	
    public static void updateFixture(ReqProRequirement reqProRequirement,
    		ScopeElementScope scope) throws Exception
    {
        updateReqProRequirement(reqProRequirement, random(), scope);
    }
    
    private static ReqProRequirement createReqProRequirement(ReqProScopeFolder parent, int index,
			ScopeElementScope scope) throws Exception
    {
    	ReqProRequirement reqProRequirement = new ReqProRequirement();

    	HelperTestUtilities.setByIntrospection(reqProRequirement, index, localSkipSetters);
    	
    	reqProRequirement.setParent(parent);

    	if(scope!=null)
    	{
    		if(scope.getReqProData()!=null)
    		{
    			ReqProImportStatus reqProImportStatus = ReqProImportStatusFixture.createFixture(reqProRequirement);
    			reqProRequirement.setReqProImportStatus(reqProImportStatus);
    		}
    	}    	
        return reqProRequirement;
    }
    
    private static void updateReqProRequirement(ReqProRequirement reqProRequirement, int index,
			ScopeElementScope scope) throws Exception
    {
    	HelperTestUtilities.setByIntrospection(reqProRequirement, index, localSkipSetters);
    	
    	if(scope!=null)
    	{
    		if(scope.getReqProData()!=null)
    		{
    			ReqProImportStatusFixture.updateFixture(reqProRequirement.getReqProImportStatus());
    		}
    	}    	
    }
    
    public static void compare(ReqProRequirement[] pArray1,
    		ReqProRequirement[] pArray2, ScopeElementScope scope)
            throws AssertionFailedError, Exception
    {
    	
    	sortWithComparator(pArray1, RPMObjectIDComparator.INSTANCE);
    	sortWithComparator(pArray2, RPMObjectIDComparator.INSTANCE); 
    	
        RPMObjectFixture.compare(pArray1, pArray2);

        if (pArray1 == null)
            return;

        for (int i = 0; i < pArray1.length; i++)
        {
            compare(pArray1[i], pArray2[i], scope);
        }
    }
    
    public static void compare(ReqProRequirement r1, ReqProRequirement r2,
    		ScopeElementScope scope) throws AssertionFailedError, Exception
    {
        RPMObjectFixture.compareWithSkip(r1, r2, localSkipGetters);
        if (scope == null)
            return;
        
        if(scope.getReqProData()!=null)
        {
            ReqProImportStatusFixture.compare(r1.getReqProImportStatus(), r2.getReqProImportStatus());
        }
        
    }
    
    public static ScopeElementScope getFullScope()
    {
        ScopeElementScope scope = new ScopeElementScope();
        scope.setReqProData(new RPMObjectScope());
        return scope;
    }
    
}
