package com.ibm.rpm.client.junit.scopemanagement.testcases;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Proposal;


/**
 * @author gmeloche
 *
 */
public class TestScopeScheduleDate extends ClientTestController
{

    public TestScopeScheduleDate()
    {
        super();
    }
    
    public void testInsertRequirementWithScheduleDate()throws Exception{
        
        ScopeElementScope scope = new ScopeElementScope();
        scope.setScheduleDates(true);
        
        ScopeFolder parent = retrieveStaticFolder();
       
        Requirement requirement = ScopeElementFixture.createRequirementFixture(scope, 0, parent, this);
        
        insertAndCompare(requirement, scope);    
        
    }
    
    private ScopeElement load(ScopeElement object, ScopeElementScope scope)
            throws Exception
    {
        object = (ScopeElement) loadFromID(object, scope);

        return object;

    }
    
    private ScopeElement insertAndCompare(ScopeElement scopeElement,
            ScopeElementScope scope) throws Exception
    {
        //Insert the ScopeElement into the DB
        SingleResult result = save(scopeElement, scope);
        scopeElement.setID(result.getRpmObject().getID());

        //compare the returned ScopeElement
        ScopeElement returnedScopeElem = (ScopeElement) result.getRpmObject();
        ScopeElementFixture.compare(scopeElement, returnedScopeElem, scope);

        //reload the ScopeElement and compare it
        returnedScopeElem = load(returnedScopeElem, scope);
        ScopeElementFixture.compare(scopeElement, returnedScopeElem, scope);

        //return the ScopeElement
        return scopeElement;
    }
    
    private ScopeFolder retrieveStaticFolder() throws Exception
    {
//        WorkElementScope scope = new WorkElementScope();
//        scope.setScopeElement(new ScopeElementScope());
//        
//        Proposal proposal = (Proposal) WorkElementFixture
//            .retrieveStaticFixture(new Proposal(), 0, 0, scope, this);
        
//        ScopeFolder folder = (ScopeFolder)proposal.getScopeElement();

        Proposal proposal = (Proposal) WorkElementFixture
        .retrieveStaticFixture(new Proposal(), this);
        
        RPMObject[] rpmObjects = loadFromXpath("/ScopeFolder[name='"
                + proposal.getName() + "']", new ScopeElementScope());
        ScopeFolder folder = (ScopeFolder) rpmObjects[0];


        return folder;
    }
    
    

    /**
     *
     */

    protected void tearDown() throws Exception
    {
        super.tearDown();
    }
}
