/*
 * Created on Sep 26, 2006
 */
package com.ibm.rpm.client.junit.scopemanagement.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.Result;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.scopemanagement.containers.AbstractScope;
import com.ibm.rpm.scopemanagement.containers.Action;
import com.ibm.rpm.scopemanagement.containers.ChangeRequest;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.containers.ScopeTask;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.containers.SummaryTask;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author dominiqu
 */
public class Test54917 extends ClientTestController
{
    ScopeElement scopeParent = null;

    ScopeElementScope scopeParentScope = null;

    Task wbsParent = null;

    WorkElementScope wbsParentScope = null;

    int NB_CHILDREN = 2;

    public void setUp() throws Exception
    {
        super.setUp();
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testLoadScopeTask() throws AssertionError, Exception
    {
        setUpScope();

        RPMObject object = loadFromID(scopeParent, scopeParentScope);

        assertNotNull(object);
        assertTrue(object instanceof ScopeTask);
        assertNotNull("ScopeTask AttributeAssignments were not loaded",
            ((ScopeTask) object).getAttributeAssignments());
        assertNotNull("ScopeTask AttributeAssignments were not loaded",
            ((ScopeTask) object).getAttributeAssignments()[0]);
        assertNotNull("ScopeTask RtfAssignments were not loaded",
            ((ScopeTask) object).getRtfAssignments());
        assertNotNull("ScopeTask RtfAssignments were not loaded",
            ((ScopeTask) object).getRtfAssignments()[0]);

        ScopeElementFixture.compare((ScopeTask) object, scopeParent,
            scopeParentScope);
    }

    public void testLoadScopeTaskAfterTransfer() throws AssertionError,
            Exception
    {
        setUpScope();

        Result result = getApplicationInterface().transferUnderWBS(
            getSessionID(), null,
            (AbstractScope) scopeParent.getParent().getParent());

        assertNull(result.getErrors());

        RPMObject object = loadFromID(scopeParent, scopeParentScope);

        assertNotNull(object);
        assertTrue(object instanceof ScopeTask);
        assertNotNull("ScopeTask AttributeAssignments were not loaded",
            ((ScopeTask) object).getAttributeAssignments());
        assertNotNull("ScopeTask AttributeAssignments were not loaded",
            ((ScopeTask) object).getAttributeAssignments()[0]);
        assertNotNull("ScopeTask RtfAssignments were not loaded",
            ((ScopeTask) object).getRtfAssignments());
        assertNotNull("ScopeTask RtfAssignments were not loaded",
            ((ScopeTask) object).getRtfAssignments()[0]);

        ScopeElementFixture.compare((ScopeTask) object, scopeParent,
            scopeParentScope);
    }

    public void testLoadScopeTaskFromXpath() throws AssertionError, Exception
    {
        setUpScope();

        RPMObject[] objects = loadFromXpath("/ScopeElement[@id='"
                + scopeParent.getID() + "']", scopeParentScope);

        assertNotNull(objects);
        assertNotNull(objects[0]);
        assertTrue(objects[0] instanceof ScopeTask);
        assertNotNull("ScopeTask AttributeAssignments were not loaded",
            ((ScopeTask) objects[0]).getAttributeAssignments());
        assertNotNull("ScopeTask AttributeAssignments were not loaded",
            ((ScopeTask) objects[0]).getAttributeAssignments()[0]);
        assertNotNull("ScopeTask RtfAssignments were not loaded",
            ((ScopeTask) objects[0]).getRtfAssignments());
        assertNotNull("ScopeTask RtfAssignments were not loaded",
            ((ScopeTask) objects[0]).getRtfAssignments()[0]);

        ScopeElementFixture.compare((ScopeTask) objects[0], scopeParent,
            scopeParentScope);
    }

    public void testLoadScopeTaskAfterTransferFromXpath()
            throws AssertionError, Exception
    {
        setUpScope();

        Result result = getApplicationInterface().transferUnderWBS(
            getSessionID(), null,
            (AbstractScope) scopeParent.getParent().getParent());

        assertNull(result.getErrors());

        RPMObject[] objects = loadFromXpath("/ScopeElement[@id='"
                + scopeParent.getID() + "']", scopeParentScope);

        assertNotNull(objects);
        assertNotNull(objects[0]);
        assertTrue(objects[0] instanceof ScopeTask);
        assertNotNull(
            "ScopeTask AttributeAssignments were not loaded after transfer under WBS",
            ((ScopeTask) objects[0]).getAttributeAssignments());
        assertNotNull(
            "ScopeTask AttributeAssignments were not loaded after transfer under WBS",
            ((ScopeTask) objects[0]).getAttributeAssignments()[0]);
        assertNotNull(
            "ScopeTask RtfAssignments were not loaded after transfer under WBS",
            ((ScopeTask) objects[0]).getRtfAssignments());
        assertNotNull(
            "ScopeTask RtfAssignments were not loaded after transfer under WBS",
            ((ScopeTask) objects[0]).getRtfAssignments()[0]);

        ScopeElementFixture.compare((ScopeTask) objects[0], scopeParent,
            scopeParentScope);
    }

    public void testLoadTask() throws AssertionError, Exception
    {
        setUpWbs();

        RPMObject[] objects = loadFromXpath("/WorkElement[@id='"
                + wbsParent.getID() + "']", wbsParentScope);

        RPMObject object = loadFromID(wbsParent, wbsParentScope);

        assertNotNull(object);
        assertTrue(object instanceof Task);
        assertNotNull("Task AttributeAssignments were not loaded",
            ((Task) object).getAttributeAssignments());
        assertNotNull("Task AttributeAssignments were not loaded",
            ((Task) object).getAttributeAssignments()[0]);
        assertNotNull("Task RtfAssignments were not loaded",
            ((Task) object).getRtfAssignments());
        assertNotNull("Task RtfAssignments were not loaded",
            ((Task) object).getRtfAssignments()[0]);

        WorkElementFixture.compare((Task) object, wbsParent, wbsParentScope);
    }

    public void testLoadTaskAfterTransfer() throws AssertionError, Exception
    {
        setUpScope();

        wbsParentScope = new WorkElementScope();
        wbsParentScope.setAttributeAssignments(true);
        wbsParentScope.setRtfAssignments(true);

        Result result = getApplicationInterface().transferUnderWBS(
            getSessionID(), null,
            (AbstractScope) scopeParent.getParent().getParent());

        assertNull(result.getErrors());

        wbsParent = new Task();
        wbsParent.setID(scopeParent.getID());
        RPMObject object = loadFromID(wbsParent, wbsParentScope);

        assertNotNull(object);
        assertTrue(object instanceof Task);
        assertNotNull("Task AttributeAssignments were not loaded",
            ((Task) object).getAttributeAssignments());
        assertNotNull("Task AttributeAssignments were not loaded",
            ((Task) object).getAttributeAssignments()[0]);
        assertNotNull("Task RtfAssignments were not loaded",
            ((Task) object).getRtfAssignments());
        assertNotNull("Task RtfAssignments were not loaded",
            ((Task) object).getRtfAssignments()[0]);
    }

    public void testLoadTaskFromXpath() throws AssertionError, Exception
    {
        setUpWbs();

        RPMObject[] objects = loadFromXpath("/WorkElement[@id='"
                + wbsParent.getID() + "']", wbsParentScope);

        assertNotNull(objects);
        assertNotNull(objects[0]);
        assertTrue(objects[0] instanceof Task);
        assertNotNull("Task AttributeAssignments were not loaded",
            ((Task) objects[0]).getAttributeAssignments());
        assertNotNull("Task AttributeAssignments were not loaded",
            ((Task) objects[0]).getAttributeAssignments()[0]);
        assertNotNull("Task RtfAssignments were not loaded",
            ((Task) objects[0]).getRtfAssignments());
        assertNotNull("Task RtfAssignments were not loaded",
            ((Task) objects[0]).getRtfAssignments()[0]);

        WorkElementFixture.compare((Task) objects[0], wbsParent, wbsParentScope);
    }

    public void testLoadTaskAfterTransferFromXpath() throws AssertionError,
            Exception
    {
        setUpScope();

        wbsParentScope = new WorkElementScope();
        wbsParentScope.setAttributeAssignments(true);
        wbsParentScope.setRtfAssignments(true);

        Result result = getApplicationInterface().transferUnderWBS(
            getSessionID(), null,
            (AbstractScope) scopeParent.getParent().getParent());

        assertNull(result.getErrors());

        RPMObject[] objects = loadFromXpath("/WorkElement[@name='"
                + scopeParent.getName() + "']", wbsParentScope);

        assertNotNull(objects);
        Task task = null;
        for (int i = 0; i != objects.length; ++i)
        {
            assertNotNull(objects[i]);
            if (objects[i] instanceof Task)
            {
                task = (Task) objects[i];
                break;
            }
        }
        assertNotNull(task);
        assertNotNull(
            "Task AttributeAssignments were not loaded after transfer under WBS",
            task.getAttributeAssignments());
        assertNotNull(
            "Task AttributeAssignments were not loaded after transfer under WBS",
            task.getAttributeAssignments()[0]);
        assertNotNull(
            "Task RtfAssignments were not loaded after transfer under WBS",
            task.getRtfAssignments());
        assertNotNull(
            "Task RtfAssignments were not loaded after transfer under WBS",
            task.getRtfAssignments()[0]);
    }

    public void testLoadAction() throws AssertionError, Exception
    {
        scopeParentScope = new ScopeElementScope();
        scopeParentScope.setAttributeAssignments(true);
        scopeParentScope.setRtfAssignments(true);

        ScopeElement scopeParentParent = ScopeElementFixture.createSaveScopeElement(this);

        scopeParent = ScopeElementFixture.createActionFixture(scopeParentScope,
            NB_CHILDREN, scopeParentParent, this);

        SingleResult result = save(scopeParent, scopeParentScope);

        // Verify that everything was saved properly
        ScopeElementFixture.compare((Action) result.getRpmObject(),
            scopeParent, scopeParentScope);

        scopeParent = (Action) result.getRpmObject();

        wbsParentScope = new WorkElementScope();
        wbsParentScope.setAttributeAssignments(true);
        wbsParentScope.setRtfAssignments(true);

        Result result2 = getApplicationInterface().transferUnderWBS(
            getSessionID(), null, (AbstractScope) scopeParentParent.getParent());

        RPMObject[] objects = loadFromXpath("/WorkElement[@id='"
                + scopeParent.getID() + "']", wbsParentScope);

        assertNotNull(objects);
        assertNotNull(objects[0]);
        assertTrue(objects[0] instanceof SummaryTask);
        // Expected behaviour: AttributeAssignments no longer loaded
        assertNull(
            "Action AttributeAssignments were loaded after transfer under WBS",
            ((SummaryTask) objects[0]).getAttributeAssignments());
        // Expected behaviour: rtfAssignments still loaded
        assertNotNull(
            "Action RtfAssignments were not loaded after transfer under WBS",
            ((SummaryTask) objects[0]).getRtfAssignments());
        assertNotNull(
            "Action RtfAssignments were not loaded after transfer under WBS",
            ((SummaryTask) objects[0]).getRtfAssignments()[0]);
    }

    public void setUpScope() throws AssertionError, Exception
    {
        scopeParentScope = new ScopeElementScope();
        scopeParentScope.setAttributeAssignments(true);
        scopeParentScope.setRtfAssignments(true);

        ScopeElement scopeParentParent = ScopeElementFixture.createSaveChangeRequest(this);

        scopeParent = ScopeElementFixture.createScopeTaskFixture(
            scopeParentScope, NB_CHILDREN, scopeParentParent, this);

        SingleResult result = save(scopeParent, scopeParentScope);

        // Verify that everything was saved properly
        ScopeElementFixture.compare((ScopeTask) result.getRpmObject(),
            scopeParent, scopeParentScope);

        scopeParent = (ScopeTask) result.getRpmObject();
        ((ChangeRequest) scopeParentParent).setChildren(new ScopeElement[]
        {
            scopeParent
        });
        scopeParentParent.setProject(scopeParent.getProject());
        scopeParent.setParent(scopeParentParent);
    }

    public void setUpWbs() throws AssertionError, Exception
    {
        wbsParentScope = new WorkElementScope();
        wbsParentScope.setAttributeAssignments(true);
        wbsParentScope.setRtfAssignments(true);

        WorkElement wbsParentParent = WorkElementFixture.createSaveFixture(
            new Proposal(), null, this);

        wbsParent = (Task) WorkElementFixture.createFixture(wbsParentParent,
            new Task(), wbsParentScope, this);

        SingleResult result = save(wbsParent, wbsParentScope);

        // Verify that everything was saved properly
        WorkElementFixture.compare((Task) result.getRpmObject(), wbsParent,
            wbsParentScope);

        wbsParent = (Task) result.getRpmObject();
    }
}
