/*
 * Created on Sep 26, 2006
 */
package com.ibm.rpm.client.junit.scopemanagement.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.scopemanagement.containers.ChangeRequest;
import com.ibm.rpm.scopemanagement.containers.ScopeDeliverable;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.containers.ScopeMilestone;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;

/**
 * @author dominiqu
 */
public class Test55437 extends ClientTestController
{
    ScopeElement scopeParent = null;

    ScopeElementScope scopeParentScope = null;

    ScopeElement scopeParentParent = null;

    int NB_CHILDREN = 2;

    public void setUp() throws Exception
    {
        super.setUp();

        scopeParentScope = new ScopeElementScope();
        scopeParentScope.setAttributeAssignments(true);
        scopeParentScope.setRtfAssignments(true);

        scopeParentParent = ScopeElementFixture.createSaveChangeRequest(this);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testSaveAndLoadScopeMilestone() throws AssertionError,
            Exception
    {
        scopeParent = ScopeElementFixture.createScopeMilestoneFixture(
            scopeParentScope, NB_CHILDREN, scopeParentParent, this);

        SingleResult result = save(scopeParent, scopeParentScope);

        // Verify that everything was saved properly
        ScopeElementFixture.compare((ScopeMilestone) result.getRpmObject(),
            scopeParent, scopeParentScope);

        scopeParent = (ScopeMilestone) result.getRpmObject();
        ((ChangeRequest) scopeParentParent).setChildren(new ScopeElement[]
        {
            scopeParent
        });
        scopeParentParent.setProject(scopeParent.getProject());
        scopeParent.setParent(scopeParentParent);

        RPMObject object = loadFromID(scopeParent, scopeParentScope);

        assertNotNull(object);
        assertTrue(object instanceof ScopeMilestone);
        assertNotNull("ScopeMilestone AttributeAssignments were not loaded",
            ((ScopeMilestone) object).getAttributeAssignments());
        assertNotNull("ScopeMilestone AttributeAssignments were not loaded",
            ((ScopeMilestone) object).getAttributeAssignments()[0]);
        assertNotNull("ScopeMilestone RtfAssignments were not loaded",
            ((ScopeMilestone) object).getRtfAssignments());
        assertNotNull("ScopeMilestone RtfAssignments were not loaded",
            ((ScopeMilestone) object).getRtfAssignments()[0]);

        ScopeElementFixture.compare((ScopeMilestone) object, scopeParent,
            scopeParentScope);
    }

    public void testSaveAndLoadScopeDeliverable() throws AssertionError,
            Exception
    {
        scopeParent = ScopeElementFixture.createScopeDeliverableFixture(
            scopeParentScope, NB_CHILDREN, scopeParentParent, this);

        SingleResult result = save(scopeParent, scopeParentScope);

        // Verify that everything was saved properly
        ScopeElementFixture.compare((ScopeDeliverable) result.getRpmObject(),
            scopeParent, scopeParentScope);

        scopeParent = (ScopeDeliverable) result.getRpmObject();
        ((ChangeRequest) scopeParentParent).setChildren(new ScopeElement[]
        {
            scopeParent
        });
        scopeParentParent.setProject(scopeParent.getProject());
        scopeParent.setParent(scopeParentParent);

        RPMObject object = loadFromID(scopeParent, scopeParentScope);

        assertNotNull(object);
        assertTrue(object instanceof ScopeDeliverable);
        assertNotNull("ScopeDeliverable AttributeAssignments were not loaded",
            ((ScopeDeliverable) object).getAttributeAssignments());
        assertNotNull("ScopeDeliverable AttributeAssignments were not loaded",
            ((ScopeDeliverable) object).getAttributeAssignments()[0]);
        assertNotNull("ScopeDeliverable RtfAssignments were not loaded",
            ((ScopeDeliverable) object).getRtfAssignments());
        assertNotNull("ScopeDeliverable RtfAssignments were not loaded",
            ((ScopeDeliverable) object).getRtfAssignments()[0]);

        ScopeElementFixture.compare((ScopeDeliverable) object, scopeParent,
            scopeParentScope);
    }
}
