/*
 * Created on Sep 26, 2006
 */
package com.ibm.rpm.client.junit.scopemanagement.testcases.fixes;

import com.ibm.rpm.applicationadministration.containers.ActionState;
import com.ibm.rpm.applicationadministration.containers.DatafieldState;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.Result;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.framework.util.StringUtil;
import com.ibm.rpm.scopemanagement.containers.AbstractScope;
import com.ibm.rpm.scopemanagement.containers.ChangeRequest;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.SummaryTask;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author dominiqu
 */
public class Test59459 extends ClientTestController
{
    ScopeElement scopeParent = null;

    ScopeElementScope scopeParentScope = null;

    WorkElementScope wbsParentScope = null;

    int NB_CHILDREN = 2;

    public void setUp() throws Exception
    {
        super.setUp();

        wbsParentScope = new WorkElementScope();
        wbsParentScope.setState(true);

        scopeParentScope = new ScopeElementScope();
        scopeParentScope.setState(true);

        ScopeElement scopeParentParent = ScopeElementFixture.createSaveChangeRequest(this);

        scopeParent = ScopeElementFixture.createActionFixture(scopeParentScope,
            NB_CHILDREN, scopeParentParent, this);

        // Verify that everything was saved properly
        SingleResult result = save(scopeParent, scopeParentScope);
        ScopeElementFixture.compare((ScopeElement) result.getRpmObject(),
            scopeParent, scopeParentScope);

        scopeParent = (ScopeElement) result.getRpmObject();
        ((ChangeRequest) scopeParentParent).setChildren(new ScopeElement[]
        {
            scopeParent
        });
        scopeParentParent.setProject(scopeParent.getProject());
        scopeParent.setParent(scopeParentParent);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testLoadTaskAfterTransferFromXpath() throws AssertionError,
            Exception
    {
        Result result = getApplicationInterface().transferUnderWBS(
            getSessionID(), null,
            (AbstractScope) scopeParent.getParent().getParent());
        assertNull(result.getErrors());

        RPMObject[] objects = loadFromXpath("/WorkElement[@name='"
                + scopeParent.getName() + "']", wbsParentScope);

        assertNotNull(objects);
        assertNotNull(objects[0]);
        assertTrue(objects[0] instanceof SummaryTask);
        assertNotNull("Task State was not loaded after transfer under WBS",
            ((SummaryTask) objects[0]).getState());
        assertTrue(((SummaryTask) objects[0]).getState() instanceof ActionState);

        // Assert that the save with this state passes after modifying it
        RPMObject[] result2 = loadFromXpath(
            "/"
                    + StringUtil.getShortClassName(((SummaryTask) objects[0]).getState().getClass())
                    + "[value='To be validated']", null);
        ((SummaryTask) objects[0]).setState((DatafieldState) result2[0]);

        SingleResult result3 = save(objects[0], wbsParentScope);
        assertNull(result3.getErrors());

        WorkElementFixture.compare(((WorkElement) objects[0]),
            (WorkElement) result3.getRpmObject(), wbsParentScope);
    }
}
