/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.scopemanagement.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.scopemanagement.containers.ScopeDeliverable;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;

/**
 * @author Yasser Lulu
 *
 */
public class Test59699 extends ClientTestController
{

    public void testCreateScopeSummaryTaskWithScopeDeliverableAsParent()
            throws AssertionError, Exception
    {
        ScopeElementScope scopeParentScope = new ScopeElementScope();
        scopeParentScope.setAttributeAssignments(true);
        scopeParentScope.setRtfAssignments(true);

        ScopeElement scopeParentParent = ScopeElementFixture
            .createSaveChangeRequest(this);
        ScopeElement scopeParent = ScopeElementFixture
            .createScopeDeliverableFixture(scopeParentScope, 2,
                scopeParentParent, this);
        SingleResult result = save(scopeParent, scopeParentScope);

        scopeParent = (ScopeDeliverable) result.getRpmObject();

        ScopeSummaryTask sst = new ScopeSummaryTask();
        sst.setName(HelperTestUtilities.createName());
        sst.setParent(scopeParent);
        ScopeElementScope sstScope = new ScopeElementScope();
        sstScope.setParent(new ScopeElementScope());
        SaveResult sr = save(sst, sstScope);
        assertTrue(sr.getRpmObject() instanceof ScopeSummaryTask);
        ScopeSummaryTask sst_x = (ScopeSummaryTask) sr.getRpmObject();
        ScopeDeliverable p = (ScopeDeliverable) sst_x.getParent();
        assertNotNull(p);
        
        ScopeElement obj = new ScopeElement();
        obj.setID(sst_x.getID());
        ScopeSummaryTask sst_y = (ScopeSummaryTask) loadFromID(obj, sstScope);
        ScopeElementFixture.compare(sst_x, sst_y, sstScope);

    }

}
