package com.ibm.rpm.client.junit.scopemanagement.testcases.fixes;

import com.ibm.rpm.applicationadministration.containers.RequirementRTF;
import com.ibm.rpm.applicationadministration.containers.RtfAssignment;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.RtfAssignmentFixture;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.SummaryTask;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class Test60167 extends ClientTestController
{
    public void testClientCrash() throws Exception
    {
        // transfer a requirement under WBS
        ScopeElementScope scope = new ScopeElementScope();
        scope.setChildren(new ScopeElementScope());
        ScopeFolder parentFolder = (ScopeFolder) ScopeElementFixture
            .createFixture(scope, this, 1);
        assertNotNull(parentFolder.getChildren());

        parentFolder = (ScopeFolder) save(parentFolder, scope).getRpmObject();
        Requirement ourRequirement = (Requirement) parentFolder.getChildren()[0];
        ourRequirement.setTask(Boolean.TRUE);

        transferUnderWBS(null, ourRequirement);

        ScopeElementScope scopeElementScope = new ScopeElementScope();
        scopeElementScope.setWorkElement(new WorkElementScope());
        Requirement req = (Requirement) loadFromID(ourRequirement, scopeElementScope);

        // assign a RTF to the transferred requirement
        SummaryTask summaryTask = (SummaryTask) req.getWorkElement();
        assertNotNull(summaryTask);
        WorkElementScope summaryTaskScope = new WorkElementScope();
        summaryTaskScope.setParent(new WorkElementScope());
        summaryTask = (SummaryTask) loadFromID(summaryTask, summaryTaskScope);
        
        RequirementRTF requirementRTF = (RequirementRTF) loadFromXpath(
            "/RequirementRTF[@value='Requirement description']", new RPMObjectScope())[0];
        RtfAssignment rtfAssignment = RtfAssignmentFixture.createAssignmentFixture(
            parentFolder, "Requirement description", requirementRTF, this);
        

        WorkElementScope newScope = new WorkElementScope();
        newScope.setRtfAssignments(true);
        
        final String before = rtfAssignment.getValue();
        
        summaryTask.setRtfAssignments(new RtfAssignment[] {rtfAssignment});
        summaryTask = (SummaryTask) save(summaryTask,
            newScope).getRpmObject();
        
        summaryTask = (SummaryTask) loadFromID(summaryTask, newScope);
        assertNotNull(summaryTask.getRtfAssignments());
        RtfAssignment assignment = summaryTask.getRtfAssignments()[0];
        final String after = (String) assignment.getValue();
        
        assertEquals(before, after);
        summaryTask.getName(); // crashes when opened in the WBS view
    }
}
