package com.ibm.rpm.client.junit.scopemanagement.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.scope.fixtures.ScopeManagementModuleFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WbsModuleFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.scopemanagement.containers.ScopeManagementModule;
import com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;
import com.ibm.rpm.scorecard.scope.ScorecardFolderScope;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WbsModuleScope;

public class Test60302 extends ClientTestController
{
    /**
     * Create a ScorecardFolder under wbs via WbsModule and another in
     * ScopeModule, both bearing the same name. The XPath framework, by design, returns
     * both objects from Wbs and Scope. This is incorrect and confusing for the user.
     * 
     * @throws Exception
     */
    public void testScorecardFolderLoadFromXPathViaScopeManagementModule()
            throws Exception
    {
        // the ScorecardFolder which exists both in ScopeManagement and WBS.
        String belongsToFolder = null;
        String wbsScorecardFolderID = null;


        WbsModuleScope wbsScope = new WbsModuleScope();
        wbsScope.setScorecardFolders(new ScorecardFolderScope());
        WbsModule wbsFixture = WbsModuleFixture.createFixture(wbsScope, this);
        wbsFixture.getScorecardFolders()[0].setName(HelperTestUtilities.createName() + "carrera911"); // TODO : removeme
        wbsFixture = (WbsModule) save(wbsFixture, wbsScope).getRpmObject();
        assertNotNull(wbsFixture.getScorecardFolders());
        belongsToFolder = wbsFixture.getScorecardFolders()[0].getName();
        wbsScorecardFolderID = wbsFixture.getScorecardFolders()[0].getID();
        assertNotNull(wbsScorecardFolderID);

        ScopeManagementModuleScope scopeScope = new ScopeManagementModuleScope();
        scopeScope.setScorecardFolders(new ScorecardFolderScope());
        ScopeManagementModule scopeModule = ScopeManagementModuleFixture.createFixture(scopeScope, this);
        scopeModule = (ScopeManagementModule) save(scopeModule, scopeScope).getRpmObject();
        assertNotNull(scopeModule.getScorecardFolders()[0]);
        ScorecardFolder scFolder = scopeModule.getScorecardFolders()[0];
        scFolder.setName(belongsToFolder);
        scFolder = (ScorecardFolder) save(scFolder, new ScorecardFolderScope()).getRpmObject();
        assertEquals(scFolder.getName(), belongsToFolder);
        
        String xPath = "/ScopeManagementModule/ScorecardFolder[@name='"
            + belongsToFolder + "']";
        
        RPMObject[] results = loadFromXpath(xPath, new ScorecardFolderScope());
        assertEquals(1, results.length);
        assertEquals(scFolder.getName(), ((ScorecardFolder)results[0]).getName());
        
        assertEquals(1, results.length); 
        ScorecardFolder result = (ScorecardFolder) results[0];
        assertTrue(result.getContextName().equalsIgnoreCase("Scope")); 
    }
}
