package com.ibm.rpm.client.junit.scopemanagement.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * According to the documentation, when a ScopeElement has been
 * transferredUnderWbs it becomes a Summary Task. However, when you transfer a
 * Task type of Scope Element (i.e. : RequirementTask, RiskTask) it's converted to
 * a Task instead of a SummaryTask.
 * 
 * @author andreit
 * 
 */
public class Test60420 extends ClientTestController
{
    public void testTransferScopeElementToWBS() throws Exception
    {
        // Create a requirement
        ScopeElementScope scopeScope = new ScopeElementScope();
        scopeScope.setChildren(new ScopeElementScope());
        ScopeFolder parentFolder = (ScopeFolder) 
            ScopeElementFixture.createFixture(scopeScope, this, 1);
        assertNotNull(parentFolder.getChildren());
        assertEquals(1, parentFolder.getChildren().length);
        
        parentFolder = (ScopeFolder) save(parentFolder, scopeScope).getRpmObject();
        
        Requirement ourRequirement = (Requirement) parentFolder.getChildren()[0];
        ourRequirement.setTask(new Boolean(true));

        ourRequirement = (Requirement) save(ourRequirement, new ScopeElementScope()).getRpmObject();
        
        transferUnderWBS(null, ourRequirement);
        
        ScopeElementScope requirementScope = new ScopeElementScope();
        requirementScope.setWorkElement(new WorkElementScope());
        
        ourRequirement = (Requirement)loadFromID(ourRequirement, requirementScope);
         
        assertTrue(ourRequirement.getWorkElement() instanceof Task);
    }
}