package com.ibm.rpm.client.junit.scopemanagement.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class Test67799 extends ClientTestController {

	public void testCreateSaveScopeElementWithRank() throws Exception
	{
		Proposal proposal = createSaveProposal();
		Requirement requirement = new Requirement();
		requirement.setName(HelperTestUtilities.createName());
		requirement.setParent(proposal.getScopeElement());
		requirement.setRank(new Integer(81));
		requirement.setPriority(new Integer(81));
		requirement = (Requirement)save(requirement, null).getRpmObject();
		assertNotNull(requirement);
		assertNotNull(requirement.getProposedByName());
		assertNotNull(requirement.getProposedByDate());
	}
	
	private Proposal createSaveProposal() throws Exception
	{
		WorkElementScope workElementScope = new WorkElementScope();
		workElementScope.setScopeElement(new ScopeElementScope());
		Proposal proposal = (Proposal)WorkElementFixture.createSaveFixture(new Proposal(), workElementScope, this);
		assertNotNull(proposal);
		assertNotNull(proposal.getScopeElement());
		assertTrue(proposal.getScopeElement() instanceof ScopeFolder);
		return proposal;
	}
}