package com.ibm.rpm.client.junit.scopemanagement.testcases.validation;

import com.ibm.rpm.client.junit.framework.testcases.GenericValidation;
import com.ibm.rpm.client.junit.framework.testcases.RPMExceptionMock;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class TestWbsParentValidation extends GenericValidation
{
    /**
     * Create a requirement with a wbsParent located in an unrelated Project.
     */
    public void testFailureInvalidWbsParent() throws Exception
    {
        Task relatedTask = (Task) WorkElementFixture.createSaveFixture(new Task(), null, this);
        
        // Create a requirement with a wbsParent located in an unrelated Project.
        Project unrelatedProject = (Project) WorkElementFixture.createSaveFixture(
            null, new Project(), null, this);
        ScopeElementScope scopeScope = new ScopeElementScope();
        scopeScope.setWbsParent(true);
        
        ScopeFolder parentScopeFolder = ScopeElementFixture.createMainParent(this);
        
        Requirement req = new Requirement();
        req.setName(HelperTestUtilities.createName());
        scopeScope = new ScopeElementScope();
        scopeScope.setProject(new WorkElementScope());
        scopeScope.setWbsParent(true);
        req.setProject(unrelatedProject);
        req.setWbsParent(relatedTask);
        req.setParent(parentScopeFolder);
        
        RPMExceptionMock[] expectedExceptions =
        {
            createRPMException(
                com.ibm.rpm.scopemanagement.constants.ErrorCodes.PROJECTID_DOES_NOT_MATCH, 
                ScopeElement.class.getName(),
                ValidationConstants.NAME_WBSPARENT , 
                req.getID()
                )
        };
        
        verifySaveMustFail(req, scopeScope, expectedExceptions);
    }
}
