package com.ibm.rpm.client.junit.scopemanagement.testcases.xpath;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProIntegrationFolderFixture;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProScopeFolderFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Proposal;

public class TestReqProScopeFolderDataXPath extends ObjectXPathTester
{
    public void testContainerInstances()
    {
    }
    
    
    protected RPMObject createObject() throws Exception
    {
        Proposal proposal = (Proposal) WorkElementFixture
            .retrieveStaticFixture(new Proposal(), this);

        RPMObject[] rpmObjects = loadFromXpath("/ScopeFolder[name='"
                + proposal.getName() + "']", new ScopeElementScope());
        ScopeFolder parent = (ScopeFolder) rpmObjects[0];

        RPMObject myParent = ReqProIntegrationFolderFixture.createFixture(
            (ScopeFolder) parent, (ScopeElementScope) mainScope);
        myParent = save(myParent, createScope()).getRpmObject();

        myParent = ReqProScopeFolderFixture.createFixture(myParent,
            (ScopeElementScope) createScope());

        return myParent;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        ScopeElementScope myScope = new ScopeElementScope();
        myScope.setReqProData(new RPMObjectScope());
        return myScope;
    }

    protected void objectCompare(RPMObject myObject, RPMObject dbObject, RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        if (myObject instanceof ReqProScopeFolder)
        {
            ReqProScopeFolderFixture.compare((ReqProScopeFolder) myObject,
                (ReqProScopeFolder) dbObject, (ScopeElementScope) scope);
        }
    }
    
    protected ArrayList generateLocalSkipList()
    {
        ArrayList skip = new ArrayList();
        skip.add("getPrivateFolder");
        skip.add("getReqProID");
        skip.add("getParentSortingRank");
        return skip;
    }
}
