/*
 * Created on Jan 17, 2006
 */
package com.ibm.rpm.client.junit.scopemanagement.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.scorecard.fixtures.PublishedScorecardFixture;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.financial.scope.FinancialScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.scope.MitigationFactorScope;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author gosselin
 */
public class TestScopeFolderDataXPath extends ObjectXPathTester
{    
    protected RPMObject createObject() throws Exception
    {
        return ScopeElementFixture.createFixture((ScopeElementScope) mainScope,
            this, 1);
    }

    protected RPMObjectScope createScope() throws Exception
    {
        ScopeElementScope scope = new ScopeElementScope();
        scope.setApprovedCostBenefits(true);
        scope.setAsset(true);
        scope.setAssetCode(true);
        scope.setAttributeAssignments(true);
        scope.setClientCostCenter(true);
        scope.setDocumentFolder(new DocumentScope());
        scope.setDuplicates(true);
        FinancialScope finScope = new FinancialScope();
        finScope.setChargeCode(true);
        scope.setWorksheetFinancials(finScope);
        scope.setWbsFinancials(finScope);
        scope.setImpact(true);
        MitigationFactorScope mitScope = new MitigationFactorScope();
        scope.setMitigationFactors(mitScope);
        mitScope.setParent(scope);
        mitScope.setMitigationTriggers(true);
        scope.setOrderOfMagnitudeCostBenefits(true);
        scope.setParent(new ScopeElementScope());
        scope.setRiskMatrix(true);
        scope.setRtfAssignments(true);
        scope.setChildren(scope);
        scope.setAssignedScorecard(PublishedScorecardFixture
            .createScorecardScope(scope));
        scope.setState(true);
        scope.setWorkElement(new WorkElementScope());
        return scope;
    }

    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        ScopeElementFixture.compare((ScopeElement) myObject,
            (ScopeElement) dbObject, (ScopeElementScope) scope);
    }
}
