/*
 * Created on Aug 12, 2005
 *
 */
package com.ibm.rpm.client.junit.scorecard.testcases;

import java.lang.reflect.Method;
import java.util.LinkedList;
import java.util.List;

import junit.framework.Test;
import junit.framework.TestSuite;

import com.ibm.rpm.client.junit.applicationadministration.fixtures.AttributeFixture;

/**
 * Run TestScorecards on all relevant contexts
 *
 * @author ragoler
 *
 */
public class AllScorecardTests
{

    public static Test suite()
    {
        List TEST_CONTEXTS = new LinkedList();

        TEST_CONTEXTS.add(AttributeFixture.WBS_CONTEXT);
        TEST_CONTEXTS.add(AttributeFixture.SCOPE_CONTEXT);

        TestSuite suite = new TestSuite();

        String testContext;

        for (int i = 0; i < TEST_CONTEXTS.size(); i++)
        {
            testContext = (String) TEST_CONTEXTS.get(i);

            Method[] dMethods = TestScorecard.class.getDeclaredMethods();
            for (int j = 0; j < dMethods.length; j++)
            {
                if (dMethods[j].getName().startsWith("test"))
                {
                    suite.addTest(new TestScorecard(dMethods[j].getName(),
                            testContext));
                }

            }

        }

        return suite;
    }

}