/*
 * Created on Dec 8, 2005
 * @author mmatwiy
 * Test validation for container AssignedScorecard for an Asset.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.asset.containers.AssetModule;
import com.ibm.rpm.scorecard.containers.AssignedScorecard;

public class TestAssetsAssignedScorecardValidation extends
        AbstractTestAssignedScorecardValidation
{
    private AssetModule module;
   
    public void setUp() throws Exception
    {
        super.setUp();
        
        ScorecardAssetsValidationUtility utility = new ScorecardAssetsValidationUtility();
        
        module = utility.createAssetModule();

        Asset assignedAsset = utility.prepareScorecardAssignment(module);

        AssignedScorecard scorecard = assignedAsset.getAssignedScorecard();
        
        initializeValues(scorecard);

    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testInsertWithoutMandatoryFields() throws Exception
    {
        insertWithoutMandatoryFields();
    }
    
    public void testFailureValidationMax() throws Exception
    {
        failureValidationMax();
    }
    
    public void testFailureValidationMin() throws Exception
    {
        failureValidationMin();
    }
    
    public void testSuccessValidationMax() throws Exception
    {
        successValidationMax();
    }
    
    public void testReadOnlyFields() throws Exception
    {
        readOnlyFields();
    }
    
    public void testDefaultValuesInsert() throws Exception
    {
        defaultValuesInsert();
    }
    
    public void testDefaultValuesUpdateToNull() throws Exception
    {
        defaultValuesUpdateToNull();
    }

}
