/*
 * Created on Dec 13, 2005
 * @author mmatwiy
 * Test validation for container AssignedScorecard for a 
 * ScopeManagement Action object.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.scopemanagement.containers.Action;
import com.ibm.rpm.scopemanagement.containers.ScopeManagementModule;

public class TestScopeActionAssignedScorecardValidation extends
        AbstractTestAssignedScorecardValidation
{
    ScopeManagementModule module;

    public void setUp() throws Exception
    {
        super.setUp();

        ScorecardScopeValidationUtility utility = new ScorecardScopeValidationUtility();

        module = utility.createModule();
        
        Action assignedAction = utility.prepareActionAssignment(module);

        initializeValues(assignedAction.getAssignedScorecard());
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testReadOnlyFields() throws Exception
    {
        readOnlyFields();
    }

    public void testFailureValidationMax() throws Exception
    {
        failureValidationMax();
    }
    
    public void testFailureValidationMin() throws Exception
    {
        failureValidationMin();
    }

    public void testSuccessValidationMax() throws Exception
    {
        successValidationMax();
    }

    public void testInsertWithoutMandatoryFields() throws Exception
    {
        insertWithoutMandatoryFields();
    }

    public void testDefaultValues() throws Exception
    {
        defaultValuesInsert();
        defaultValuesUpdateToNull();
    }
}
