/*
 * Created on Dec 6, 2005
 * @author mmatwiy
 * Validation of ScorecardFolder container with module WbsModule.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.scorecard.fixtures.ScorecardFixture;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WbsModuleScope;

public class TestWBSScorecardFolderValidation extends
        AbstractTestScorecardFolderValidation
{
    private WbsModule wbsModule;
    
    public void setUp() throws Exception
    {
        wbsModule = new WbsModule();

        ScorecardFolder folder = new ScorecardFolder();
        folder.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecard folder - folder");

        wbsModule.setScorecardFolders(new ScorecardFolder[]
        {
            folder
        });

        WbsModuleScope moduleScope = new WbsModuleScope();
        moduleScope.setScorecardFolders(ScorecardFixture.createScope());

        super.setUp(wbsModule, moduleScope, folder);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testInsertWithoutModule() throws AssertionError, Exception
    {
        super.insertWithoutModule();
    }

    public void testInsertWithoutMandatoryFields() throws AssertionError,
            Exception
    {
        super.insertWithoutMandatoryFields();
    }

    public void testInsertSuccess() throws AssertionError, Exception
    {
        super.insertSuccess();
    }

    public void testSuccessValidationMax() throws AssertionError, Exception
    {
        super.successValidationMax();
    }

    public void testFailureValidationMax() throws AssertionError, Exception
    {
        super.failureValidationMax();
    }
    
    public void testFailureValidationMin() throws AssertionError, Exception
    {
        super.failureValidationMin();
    }
}
