/*
 * Created on Dec 5, 2005
 * @author mmatwiy
 * Validation of Scorecard container with module WbsModule.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.scorecard.fixtures.ScorecardFixture;
import com.ibm.rpm.scorecard.containers.Scorecard;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WbsModuleScope;


public class TestWBSScorecardValidation extends
        AbstractTestScorecardValidation
{
    private WbsModule wbsModule;

    public void setUp() throws Exception
    {
        wbsModule = new WbsModule();

        ScorecardFolder folder = new ScorecardFolder();
        folder.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecard - folder");
        
        Scorecard scorecard = new Scorecard();

        folder.setScorecards(new Scorecard[]
        {
            scorecard
        });

        wbsModule.setScorecardFolders(new ScorecardFolder[]
        {
            folder
        });

        WbsModuleScope moduleScope = new WbsModuleScope();
        moduleScope.setScorecardFolders(ScorecardFixture.createScope());

        super.setUp(wbsModule, moduleScope, scorecard);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testInsertWithoutModule() throws AssertionError,
            Exception
    {
        insertWithoutModule();
    }

    public void testInsertWithoutMandatoryFields() throws AssertionError,
            Exception
    {
        insertWithoutMandatoryFields();
    }

    public void testInsertSuccess() throws AssertionError, Exception
    {
        insertSuccess();
    }

    public void testSuccessValidationMax() throws AssertionError,
            Exception
    {
        successValidationMax();
    }

    public void testFailureValidationMax() throws AssertionError,
            Exception
    {
        failureValidationMax();
    }

    public void testSuccessValidationMin() throws AssertionError,
            Exception
    {
        successValidationMin();
    }

    public void testFailureValidationMin() throws AssertionError,
            Exception
    {
        failureValidationMin();
    }
    
    public void testDefaultValuesInsert() throws AssertionError, Exception
    {
        defaultValuesInsert();
    }
    
    public void testDefaultUpdateToNull() throws AssertionError, Exception
    {
        defaultValuesUpdateToNull();
    }
}
