/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.containers;

import com.ibm.rpm.client.junit.framework.testcases.MetadataFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.util.StringUtil;
import com.ibm.rpm.metadata.MetadataException;

/**
 * @author Yasser Lulu
 *
 */
public abstract class SecurityMetadataFixture extends MetadataFixture
{

    protected String parentId;

    protected RPMObject parent;

    /**
     * @param containerClass
     * @throws MetadataException
     */
    public SecurityMetadataFixture(Class containerClass, String parentId)
            throws MetadataException
    {
        super(containerClass);
        this.parentId = parentId;
    }

    public RPMObject loadStaticParentFixture() throws Exception
    {
        if (parent == null)
        {
            String loadXPath = "/"
                    + StringUtil.getShortClassName(getObjectClass())
                    + "[iD = '" + parentId + "']";

            RPMObject[] loadFromXpath = getTestController().loadFromXpath(
                loadXPath, null);

            if (loadFromXpath == null || loadFromXpath.length == 0)
            {
                return null;
            }
            parent = loadFromXpath[0];
        }
        return parent;
    }

}
