/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.wbs.fixtures.DependencyFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.wbs.containers.ElementDependency;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.ElementDependencyScope;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectDependencySecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test() {}
    
//    public void testAddProjectDependency() throws Exception
//    {
//        // Sets up the test Project with a child item
//        ElementDependencyScope elementDependencyScope = DependencyFixture
//            .createScope();
//        projectScope.setDependencies(elementDependencyScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project, should succeed
//        ElementDependency[] ed =
//        {
//            DependencyFixture.createFixture(testProject,
//                elementDependencyScope, this)
//        };
//        testProject.setDependencies(ed);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Add new child, should fail
//        ElementDependency[] ed2 =
//        {
//                ed[0],
//                DependencyFixture.createFixture(testProject,
//                    elementDependencyScope, this)
//        };
//        testProject.setDependencies(ed2);
//        saveAndValidate(testProject, projectScope, false);
//    }
//
//    public void testDeleteProjectDependency() throws Exception
//    {
//        // Sets up the test Project with a child item
//        ElementDependencyScope elementDependencyScope = DependencyFixture
//            .createScope();
//        projectScope.setDependencies(elementDependencyScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project, should succeed
//        ElementDependency[] ed =
//        {
//            DependencyFixture.createFixture(testProject,
//                elementDependencyScope, this)
//        };
//        testProject.setDependencies(ed);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Delete child, should succeed
//        ed = testProject.getDependencies();
//        deleteAndValidate(ed[0], true);
//
//        // Add a child element to project, should succeed
//        ed[0] = DependencyFixture.createFixture(testProject,
//            elementDependencyScope, this);
//        testProject.setDependencies(ed);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Delete child, should fail
//        ed = testProject.getDependencies();
//        deleteAndValidate(ed[0], false);
//    }
//
//    public void testUpdateProjectDependency() throws Exception
//    {
//        // Sets up the test Project with a child item
//        ElementDependencyScope elementDependencyScope = DependencyFixture
//            .createScope();
//        projectScope.setDependencies(elementDependencyScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project, should succeed
//        ElementDependency[] ed =
//        {
//            DependencyFixture.createFixture(testProject,
//                elementDependencyScope, this)
//        };
//        testProject.setDependencies(ed);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Update child, should succeed
//        ed = testProject.getDependencies();
//        ed[0].setAmount(new Integer(ed[0].getAmount().intValue() + 1));
//        saveAndValidate(ed[0], elementDependencyScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Update child, should fail
//        ed = testProject.getDependencies();
//        ed[0].setAmount(new Integer(ed[0].getAmount().intValue() + 1));
//        saveAndValidate(ed[0], elementDependencyScope, false);
//    }

}
