/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectDocumentElementsSecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test()
    {
        // Added so test wll nto fail because empty....
    }
    
//    public void testAddProjectDocumentElements() throws Exception
//    {
//        // Sets up the test Project with a child item
//        DocumentScope documentElementScope = new DocumentScope();
//        documentElementScope.setChildren(documentElementScope);
//        projectScope.setDocumentFolder(documentElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project, should succeed
//        DocumentFolder rootDocumentFolder = testProject.getDocumentFolder();
//        DocumentElement[] de =
//        {
//            DocumentElementFixture.createFixture(rootDocumentFolder,
//                new Document(), 0, documentElementScope, this)
//        };
//        rootDocumentFolder.setChildren(de);
//        rootDocumentFolder = (DocumentFolder) saveAndValidate(
//            rootDocumentFolder, documentElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Add new child, should fail
//        DocumentElement[] de2 =
//        {
//                de[0],
//                DocumentElementFixture.createFixture(rootDocumentFolder,
//                    new DocumentFolder(), 0, documentElementScope, this)
//        };
//        rootDocumentFolder.setChildren(de2);
//        saveAndValidate(rootDocumentFolder, documentElementScope, false);
//    }
//
//    public void testDeleteProjectDocumentElements() throws Exception
//    {
//        // Sets up the test Project with a child item
//        DocumentScope documentElementScope = new DocumentScope();
//        documentElementScope.setChildren(documentElementScope);
//        projectScope.setDocumentFolder(documentElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project, should succeed
//        DocumentFolder rootDocumentFolder = testProject.getDocumentFolder();
//        DocumentElement[] de =
//        {
//            DocumentElementFixture.createFixture(rootDocumentFolder,
//                new Document(), 0, documentElementScope, this)
//        };
//        rootDocumentFolder.setChildren(de);
//        rootDocumentFolder = (DocumentFolder) saveAndValidate(
//            rootDocumentFolder, documentElementScope, true);
//
//        // Deletes the child, should succeed
//        de = rootDocumentFolder.getChildren();
//        deleteAndValidate(de[0], true);
//
//        // Add a child element to project, should succeed
//        rootDocumentFolder = testProject.getDocumentFolder();
//        de[0] = DocumentElementFixture.createFixture(rootDocumentFolder,
//            new Document(), 0, documentElementScope, this);
//        rootDocumentFolder.setChildren(de);
//        rootDocumentFolder = (DocumentFolder) saveAndValidate(
//            rootDocumentFolder, documentElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Deletes the child, should fail
//        de = rootDocumentFolder.getChildren();
//        deleteAndValidate(de[0], false);
//    }
//
//    public void testUpdateProjectDocumentElements() throws Exception
//    {
//        // Sets up the test Project with a child item
//        DocumentScope documentElementScope = new DocumentScope();
//        documentElementScope.setChildren(documentElementScope);
//        projectScope.setDocumentFolder(documentElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project, should succeed
//        DocumentFolder rootDocumentFolder = testProject.getDocumentFolder();
//        DocumentElement[] de =
//        {
//            DocumentElementFixture.createFixture(rootDocumentFolder,
//                new Document(), 0, documentElementScope, this)
//        };
//        rootDocumentFolder.setChildren(de);
//        rootDocumentFolder = (DocumentFolder) saveAndValidate(
//            rootDocumentFolder, documentElementScope, true);
//
//        // Updates the child, should succeed
//        de = rootDocumentFolder.getChildren();
//        de[0].setDocumentRank("test");
//        saveAndValidate(de[0], documentElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Updates the child, should fail
//        de = rootDocumentFolder.getChildren();
//        de[0].setDocumentRank("test updated");
//        saveAndValidate(de[0], documentElementScope, false);
//    }

}
