/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import java.util.Calendar;

import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProImportStatusFixture;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProIntegrationFolderFixture;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProScopeFolderFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.scopemanagement.containers.ReqProImportStatus;
import com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder;
import com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectReqProImportStatusSecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test() {}
    
//    public void testAddProjectReqProImportStatus() throws Exception
//    {
//        // Sets up the test Project
//        ScopeElementScope reqProIntScope = ReqProIntegrationFolderFixture
//            .getFullScope();
//        ScopeElementScope reqProScope = ReqProScopeFolderFixture.getFullScope();
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a req pro integration folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ReqProIntegrationFolder reqProIntegrationFolder = ReqProIntegrationFolderFixture
//            .createFixture(rootScopeFolder, 0, reqProIntScope);
//        reqProIntegrationFolder = (ReqProIntegrationFolder) saveAndValidate(
//            reqProIntegrationFolder, reqProIntScope, true);
//
//        // Add a req pro scope folder, should succeed
//        ReqProScopeFolder reqProScopeFolder = ReqProScopeFolderFixture
//            .createFixture(reqProIntegrationFolder, 0, 0, 0, 0, reqProScope);
//        reqProScopeFolder = (ReqProScopeFolder) saveAndValidate(
//            reqProScopeFolder, reqProScope, true);
//
//        // Add a req pro import status, should succeed
//        ReqProImportStatus reqProImportStatus = ReqProImportStatusFixture
//            .createFixture(reqProScopeFolder);
//        reqProImportStatus = (ReqProImportStatus) saveAndValidate(
//            reqProImportStatus, null, true);
//        reqProScopeFolder.setReqProImportStatus(reqProImportStatus);
//        reqProScopeFolder = (ReqProScopeFolder) saveAndValidate(
//            reqProScopeFolder, reqProScope, true);
//
//        // Add a new req pro import status, should fail
//        reqProImportStatus = ReqProImportStatusFixture
//            .createFixture(reqProScopeFolder);
//        reqProImportStatus = (ReqProImportStatus) saveAndValidate(
//            reqProImportStatus, null, true);
//        reqProScopeFolder.setReqProImportStatus(reqProImportStatus);
//
//        //      Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//        reqProScopeFolder = (ReqProScopeFolder) saveAndValidate(
//            reqProScopeFolder, reqProScope, false);
//    }
//
//    // Not valid because we cannot delete req pro import status
//    //
//    // public void testDeleteProjectReqProImportStatus() throws Exception
//    // {
//    // // Sets up the test Project
//    // ScopeElementScope reqProIntScope =
//    // ReqProIntegrationFolderFixture.getFullScope();
//    // ScopeElementScope reqProScope = ReqProScopeFolderFixture.getFullScope();
//    // ScopeElementScope scopeElementScope = new ScopeElementScope();
//    // projectScope.setScopeElement(scopeElementScope);
//    // testProject = (Project) saveAndValidate(testProject, projectScope, true);
//    //        
//    // // Add a req pro integration folder, should succeed
//    // ScopeFolder rootScopeFolder = (ScopeFolder)
//    // testProject.getScopeElement();
//    // ReqProIntegrationFolder reqProIntegrationFolder =
//    // ReqProIntegrationFolderFixture.createFixture(rootScopeFolder, 0,
//    // reqProIntScope);
//    // reqProIntegrationFolder = (ReqProIntegrationFolder)
//    // saveAndValidate(reqProIntegrationFolder, reqProIntScope, true);
//    //        
//    // // Add a req pro scope folder, should succeed
//    // ReqProScopeFolder reqProScopeFolder =
//    // ReqProScopeFolderFixture.createFixture(reqProIntegrationFolder, 0, 0, 0,
//    // 0, reqProScope);
//    // reqProScopeFolder = (ReqProScopeFolder)saveAndValidate(reqProScopeFolder,
//    // reqProScope, true);
//    //        
//    // // Add a req pro import status, should succeed
//    // ReqProImportStatus reqProImportStatus =
//    // ReqProImportStatusFixture.createFixture(reqProScopeFolder);
//    // reqProImportStatus = (ReqProImportStatus)
//    // saveAndValidate(reqProImportStatus, null, true);
//    // reqProScopeFolder.setReqProImportStatus(reqProImportStatus);
//    // reqProScopeFolder = (ReqProScopeFolder)
//    // saveAndValidate(reqProScopeFolder, reqProScope, true);
//    //        
//    // // Delete the req pro import status, should succeed
//    // deleteAndValidate(reqProImportStatus, true);
//    //        
//    // // Add a req pro import status, should succeed
//    // reqProImportStatus =
//    // ReqProImportStatusFixture.createFixture(reqProScopeFolder);
//    // reqProImportStatus = (ReqProImportStatus)
//    // saveAndValidate(reqProImportStatus, null, true);
//    // reqProScopeFolder.setReqProImportStatus(reqProImportStatus);
//    // reqProScopeFolder = (ReqProScopeFolder)
//    // saveAndValidate(reqProScopeFolder, reqProScope, true);
//    //        
//    // // Assign another resource as manager of the Project
//    // assignOtherResourceAsProjectManager(testProject);
//    //
//    // // Delete the req pro import status, should fail
//    // deleteAndValidate(reqProImportStatus, false);
//    // }
//
//    public void testUpdateProjectReqProImportStatus() throws Exception
//    {
//        // Sets up the test Project
//        ScopeElementScope reqProIntScope = ReqProIntegrationFolderFixture
//            .getFullScope();
//        ScopeElementScope reqProScope = ReqProScopeFolderFixture.getFullScope();
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a req pro integration folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ReqProIntegrationFolder reqProIntegrationFolder = ReqProIntegrationFolderFixture
//            .createFixture(rootScopeFolder, 0, reqProIntScope);
//        reqProIntegrationFolder = (ReqProIntegrationFolder) saveAndValidate(
//            reqProIntegrationFolder, reqProIntScope, true);
//
//        // Add a req pro scope folder, should succeed
//        ReqProScopeFolder reqProScopeFolder = ReqProScopeFolderFixture
//            .createFixture(reqProIntegrationFolder, 0, 0, 0, 0, reqProScope);
//        reqProScopeFolder = (ReqProScopeFolder) saveAndValidate(
//            reqProScopeFolder, reqProScope, true);
//
//        // Add a req pro import status, should succeed
//        ReqProImportStatus reqProImportStatus = ReqProImportStatusFixture
//            .createFixture(reqProScopeFolder);
//        reqProImportStatus = (ReqProImportStatus) saveAndValidate(
//            reqProImportStatus, null, true);
//        reqProScopeFolder.setReqProImportStatus(reqProImportStatus);
//        reqProScopeFolder = (ReqProScopeFolder) saveAndValidate(
//            reqProScopeFolder, reqProScope, true);
//
//        // Update the req pro import status, should suceed
//        Calendar cal = reqProImportStatus.getReqProLastImportedDateTime();
//        cal.setTimeInMillis(cal.getTimeInMillis() + 100);
//        reqProImportStatus.setReqProLastImportedDateTime(cal);
//        reqProImportStatus = (ReqProImportStatus) saveAndValidate(
//            reqProImportStatus, null, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Update the req pro import status, should suceed
//        cal = reqProImportStatus.getReqProLastImportedDateTime();
//        cal.setTimeInMillis(cal.getTimeInMillis() + 100);
//        reqProImportStatus.setReqProLastImportedDateTime(cal);
//        reqProImportStatus = (ReqProImportStatus) saveAndValidate(
//            reqProImportStatus, null, false);
//    }

}
