/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.scopemanagement.containers.Duplicate;
import com.ibm.rpm.scopemanagement.containers.Risk;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectRiskDuplicateSecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test() {}
    
//    public void testAddProjectRiskDuplicate() throws Exception
//    {
//        // Sets up the test Project
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        scopeElementScope.setChildren(scopeElementScope);
//        scopeElementScope.setDuplicates(true);
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project's folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ScopeElement[] se =
//        {
//                ScopeElementFixture.createRiskFixture(scopeElementScope, 0,
//                    rootScopeFolder, this),
//                ScopeElementFixture.createRiskFixture(scopeElementScope, 0,
//                    rootScopeFolder, this),
//                ScopeElementFixture.createRiskFixture(scopeElementScope, 0,
//                    rootScopeFolder, this)
//        };
//        rootScopeFolder.setChildren(se);
//        rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//            scopeElementScope, true);
//
//        // Add a duplicate, should succeed
//        se = rootScopeFolder.getChildren();
//        Duplicate[] dup =
//        {
//            new Duplicate()
//        };
//        dup[0].setScopeElement(se[1]);
//        dup[0].setParent(se[0]);
//        ((Risk) se[0]).setDuplicates(dup);
//        saveAndValidate(se[0], scopeElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Add new duplicate, should fail
//        se = rootScopeFolder.getChildren();
//        Duplicate[] dup2 =
//        {
//                dup[0], new Duplicate()
//        };
//        dup2[1].setScopeElement(se[2]);
//        dup2[1].setParent(se[0]);
//        ((Risk) se[0]).setDuplicates(dup2);
//        saveAndValidate(se[0], scopeElementScope, false);
//    }
//
//    // Won't work because the duplicate is not loaded correctly by the save method.  
//    //    
//    // public void testDeleteProjectRiskDuplicate() throws Exception
//    // {
//    // // Sets up the test Project with a child item
//    // ScopeElementScope scopeElementScope = new ScopeElementScope();
//    // scopeElementScope.setChildren(scopeElementScope);
//    // scopeElementScope.setDuplicates(true);
//    // projectScope.setScopeElement(scopeElementScope);
//    // testProject = (Project) saveAndValidate(testProject, projectScope, true);
//    //
//    // // Add a child element to project's folder, should succeed
//    // ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//    // .getScopeElement();
//    // ScopeElement[] se =
//    // {
//    // ScopeElementFixture.createRiskFixture(scopeElementScope, 0,
//    // rootScopeFolder, this),
//    // ScopeElementFixture.createRiskFixture(scopeElementScope, 0,
//    // rootScopeFolder, this)
//    // };
//    // rootScopeFolder.setChildren(se);
//    // rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//    // scopeElementScope, true);
//    //        
//    // // Add a duplicate, should succeed
//    // se = rootScopeFolder.getChildren();
//    // Duplicate[] dup = {new Duplicate()};
//    // dup[0].setScopeElement(se[1]);
//    // dup[0].setParent(se[0]);
//    // ((Risk)se[0]).setDuplicates(dup);
//    // se[0] = (ScopeElement) saveAndValidate(se[0], scopeElementScope, true);
//    //
//    // // Deletes the duplicate, should succeed
//    // ((Risk)se[0]).getDuplicates()[0].setDeleted(new Boolean(true));
//    // se[0] = (ScopeElement) saveAndValidate(se[0], scopeElementScope, true);
//    //
//    // // Add a duplicate, should succeed
//    // ((Risk)se[0]).setDuplicates(dup);
//    // se[0] = (ScopeElement) saveAndValidate(se[0], scopeElementScope, true);
//    //
//    // // Assign another resource as manager of the Project
//    // assignOtherResourceAsProjectManager(testProject);
//    //
//    // // Deletes the duplicate, should fail
//    // se = rootScopeFolder.getChildren();
//    // ((Risk)se[0]).getDuplicates()[0].setDeleted(new Boolean(true));
//    // saveAndValidate(se[0], scopeElementScope, false);
//    // }

}
