/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.scopemanagement.containers.MitigationFactor;
import com.ibm.rpm.scopemanagement.containers.Risk;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.MitigationFactorScope;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectRiskMitigationFactorSecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test() {}

//    public void testAddProjectRiskMitigationFactor() throws Exception
//    {
//        // Sets up the test Project
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        scopeElementScope.setChildren(scopeElementScope);
//        scopeElementScope.setMitigationFactors(new MitigationFactorScope());
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project's folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ScopeElement[] se =
//        {
//            ScopeElementFixture.createRiskFixture(scopeElementScope, 0,
//                rootScopeFolder, this)
//        };
//        rootScopeFolder.setChildren(se);
//        rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//            scopeElementScope, true);
//
//        // Add a mitigation factor, should succeed
//        se = rootScopeFolder.getChildren();
//        MitigationFactor[] mf =
//        {
//            new MitigationFactor()
//        };
//        mf[0].setParent(se[0]);
//        ((Risk) se[0]).setMitigationFactors(mf);
//        saveAndValidate(se[0], scopeElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Add new mitigation factor, should fail
//        se = rootScopeFolder.getChildren();
//        MitigationFactor[] mf2 =
//        {
//                mf[0], new MitigationFactor()
//        };
//        mf2[1].setParent(se[0]);
//        ((Risk) se[0]).setMitigationFactors(mf2);
//        saveAndValidate(se[0], scopeElementScope, false);
//    }
//
//    public void testDeleteProjectRiskMitigationFactor() throws Exception
//    {
//        // Sets up the test Project with a child item
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        scopeElementScope.setChildren(scopeElementScope);
//        scopeElementScope.setMitigationFactors(new MitigationFactorScope());
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project's folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ScopeElement[] se =
//        {
//            ScopeElementFixture.createRiskFixture(scopeElementScope, 0, rootScopeFolder, this)
//        };
//        rootScopeFolder.setChildren(se);
//        rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//            scopeElementScope, true);
//        
//        // Add a mitigation factor, should succeed
//        se = rootScopeFolder.getChildren();
//        MitigationFactor[] mf = {new MitigationFactor()};
//        mf[0].setParent(se[0]);
//        ((Risk)se[0]).setMitigationFactors(mf);
//        se[0] = (ScopeElement) saveAndValidate(se[0], scopeElementScope, true);
//
//        // Deletes the mitigation factor, should succeed
//        se = rootScopeFolder.getChildren();
//        mf = ((Risk)se[0]).getMitigationFactors();
//        deleteAndValidate(mf[0], true);
//
//        // Add a mitigation factor, should succeed
//        se = rootScopeFolder.getChildren();
//        mf[0] = new MitigationFactor();
//        mf[0].setParent(se[0]);
//        ((Risk)se[0]).setMitigationFactors(mf);
//        se[0] = (ScopeElement) saveAndValidate(se[0], scopeElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Deletes the mitigation factor, should fail
//        se = rootScopeFolder.getChildren();
//        mf = ((Risk)se[0]).getMitigationFactors();
//        deleteAndValidate(mf[0], false);
//    }
//
//    public void testUpdateProjectRiskMitigationFactor() throws Exception
//    {
//        // Sets up the test Project
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        scopeElementScope.setChildren(scopeElementScope);
//        //        scopeElementScope.setRiskMatrix(true);
//        scopeElementScope.setMitigationFactors(new MitigationFactorScope());
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project's folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ScopeElement[] se =
//        {
//            ScopeElementFixture.createRiskFixture(scopeElementScope, 0,
//                rootScopeFolder, this)
//        };
//        rootScopeFolder.setChildren(se);
//        rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//            scopeElementScope, true);
//
//        // Add a mitigation factor, should succeed
//        se = rootScopeFolder.getChildren();
//        MitigationFactor[] mf =
//        {
//            new MitigationFactor()
//        };
//        mf[0].setParent(se[0]);
//        mf[0].setMitigationCost(new Double(10));
//        mf[0].setPriority(new Integer(1));
//        ((Risk) se[0]).setMitigationFactors(mf);
//        saveAndValidate(se[0], scopeElementScope, true);
//
//        // Updates the mitigation factor, should succeed
//        MitigationFactorScope scope = new MitigationFactorScope();
//        scope.setParent(scopeElementScope);
//        mf = ((Risk) se[0]).getMitigationFactors();
//        mf[0].setDescription(mf[0].getDescription() + "_MODIFIED");
//        mf[0] = (MitigationFactor) saveAndValidate(mf[0], scope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Updates the mitigation factor, should fail
//        mf[0].setDescription(mf[0].getDescription() + "_MODIFIED_2");
//        saveAndValidate(mf[0], scope, false);
//    }

}
