/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.customfield.containers.CustomFieldAssignment;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectScopeElementsSecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test() {}
    
//    public void testAddProjectScopeElements() throws Exception
//    {
//        // Sets up the test Project
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        scopeElementScope.setChildren(scopeElementScope);
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project's folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ScopeElement[] se =
//        {
//            ScopeElementFixture.createDefectFixture(scopeElementScope, 0,
//                rootScopeFolder, this)
//        };
//        rootScopeFolder.setChildren(se);
//        rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//            scopeElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Add new child, should fail
//        ScopeElement[] se2 =
//        {
//                se[0],
//                ScopeElementFixture.createActionFixture(scopeElementScope, 0,
//                    rootScopeFolder, this)
//        };
//        rootScopeFolder.setChildren(se2);
//        saveAndValidate(rootScopeFolder, scopeElementScope, false);
//    }
//
//    public void testDeleteProjectScopeElements() throws Exception
//    {
//        // Sets up the test Project with a child item
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        scopeElementScope.setChildren(scopeElementScope);
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project's folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ScopeElement[] se =
//        {
//            ScopeElementFixture.createDefectFixture(scopeElementScope, 0,
//                rootScopeFolder, this)
//        };
//        rootScopeFolder.setChildren(se);
//        rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//            scopeElementScope, true);
//
//        // Deletes the child, should succeed
//        se = rootScopeFolder.getChildren();
//        deleteAndValidate(se[0], true);
//
//        // Add a child element to project's folder, should succeed
//        rootScopeFolder = (ScopeFolder) testProject.getScopeElement();
//        se[0] = ScopeElementFixture.createDefectFixture(scopeElementScope, 0,
//            rootScopeFolder, this);
//        rootScopeFolder.setChildren(se);
//        rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//            scopeElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Deletes the child, should fail
//        se = rootScopeFolder.getChildren();
//        deleteAndValidate(se[0], false);
//    }
//
//    public void testUpdateProjectScopeElements() throws Exception
//    {
//        // Sets up the test Project with a child item
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        scopeElementScope.setChildren(scopeElementScope);
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project's folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ScopeElement[] se =
//        {
//            ScopeElementFixture.createDefectFixture(scopeElementScope, 0,
//                rootScopeFolder, this)
//        };
//        rootScopeFolder.setChildren(se);
//        rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//            scopeElementScope, true);
//
//        // Updates the child, should succeed
//        se = rootScopeFolder.getChildren();
//        CustomFieldAssignment[] cfa =
//        {
//            new CustomFieldAssignment()
//        };
//        se[0].setCustomFieldAssignments(cfa);
//        saveAndValidate(se[0], scopeElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Updates the child, should fail
//        se = rootScopeFolder.getChildren();
//        cfa[0] = new CustomFieldAssignment();
//        se[0].setCustomFieldAssignments(cfa);
//        saveAndValidate(se[0], scopeElementScope, false);
//    }

}
