/*
 * Created on Feb 2, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.applicationadministration.containers.AttributeCategory;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.AttributeFixture;
import com.ibm.rpm.wbs.containers.WbsModule;

/**
 * @author Karim, Marc-Andre Lamothe
 *
 */
public class TestAttributeSecurityLocal extends BaseResourceSecurityTestLocal
{
    // For some reason the checkpoint is not called for Attributes so no security...

    public void testCreateAttribute() throws Exception
    {
        // Set up the test
        AttributeCategory attributeCategory = AttributeFixture.createFixture(0,
            0, 0, null);
        attributeCategory.setParent(new WbsModule());
        
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditAttributeAdmin(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create an attribute, should fail
        saveAndValidate(attributeCategory, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditAttributeAdmin(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create an attribute, should succeed
        saveAndValidate(attributeCategory, null, true);
    }

    public void testDeleteAttribute() throws Exception
    {
        // Set up the test
        AttributeCategory attributeCategory = AttributeFixture.createFixture(0,
            0, 0, null);
        attributeCategory.setParent(new WbsModule());

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditAttributeAdmin(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);
        
        // Create an attribute, should succeed
        saveAndValidate(attributeCategory, null, true);
        
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditAttributeAdmin(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the attribute, should fail
        deleteAndValidate(attributeCategory, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditAttributeAdmin(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the attribute, should succeed
        deleteAndValidate(attributeCategory, true);
    }

}