/*
 * Created on Jan 30, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.client.junit.clientcostcenters.fixtures.ClientCostCenterFixture;
import com.ibm.rpm.clientcostcenters.containers.ClientCostCenter;

/**
 * @author Karim, Marc-Andre Lamothe
 */
public class TestClientCostCenterSecurityLocal extends
        BaseResourceSecurityTestLocal
{
    public void testCreateClientCostCenter() throws Exception
    {
        // Remove the right to create
        getCurrentUser().getResourceSecurityRights()
            .setCanCreateClientCostCenterDivisionFolders(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        //Create a Client/Cost Center, should fail
        ClientCostCenter clientCostCenter = ClientCostCenterFixture
            .createFixture(null, this);
        clientCostCenter = (ClientCostCenter) saveAndValidate(clientCostCenter,
            null, false);

        // Give the right to create
        getCurrentUser().getResourceSecurityRights()
            .setCanCreateClientCostCenterDivisionFolders(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create a Client/Cost Center, should succeed
        clientCostCenter = ClientCostCenterFixture.createFixture(null, this);
        clientCostCenter = (ClientCostCenter) saveAndValidate(clientCostCenter,
            null, true);
    }

    public void testDeleteClientCostCenter() throws Exception
    {
        // Create a Client/Cost Center, should succeed
        ClientCostCenter clientCostCenter = ClientCostCenterFixture
            .createFixture(null, this);
        clientCostCenter = (ClientCostCenter) saveAndValidate(clientCostCenter,
            null, true);

        // Remove the right to delete
        getCurrentUser().getResourceSecurityRights()
            .setCanDeleteClientCostCenterDivisionFolders(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should fail
        deleteAndValidate(clientCostCenter, false);

        // Give the right to delete
        getCurrentUser().getResourceSecurityRights()
            .setCanDeleteClientCostCenterDivisionFolders(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should succeed
        deleteAndValidate(clientCostCenter, true);
    }

    public void testEditClientCostCenterNames() throws Exception
    {
        // Create a Client/Cost Center, should succeed
        ClientCostCenter clientCostCenter = ClientCostCenterFixture
            .createFixture(null, this);
        clientCostCenter = (ClientCostCenter) saveAndValidate(clientCostCenter,
            null, true);

        // Remove the right to Edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditClientCostCenterDivisionFolderNames(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        clientCostCenter.setName(clientCostCenter.getName() + "_UPDATED");
        saveAndValidate(clientCostCenter, null, false);

        // Give the right to Edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditClientCostCenterDivisionFolderNames(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should succeed
        saveAndValidate(clientCostCenter, null, true);
    }

}
