/*
 * Created on Jan 31, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.applicationadministration.containers.Currency;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.CurrencyFixture;

/**
 * @author karim
 *
 */
public class TestCurrencySecurityLocal extends BaseResourceSecurityTestLocal
{
    public void testCreateCurrency() throws Exception
    {
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCurrencyExchangeRates(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create a currency, should fail
        Currency currency = CurrencyFixture.createFixture(false, 0, this);
        currency = (Currency) saveAndValidate(currency, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCurrencyExchangeRates(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create a currency, should succeed
        currency = CurrencyFixture.createFixture(false, 0, this);
        currency = (Currency) saveAndValidate(currency, null, true);
    }

    public void testDeleteCurrency() throws Exception
    {
        // Create a currency, should succeed
        Currency currency = CurrencyFixture.createFixture(false, 0, this);
        currency = (Currency) saveAndValidate(currency, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCurrencyExchangeRates(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should fail
        deleteAndValidate(currency, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCurrencyExchangeRates(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should succeed
        deleteAndValidate(currency, true);
    }

    public void testUpdateCurrency() throws Exception
    {
        // Create a currency, should succeed
        Currency currency = CurrencyFixture.createFixture(false, 0, this);
        currency = (Currency) saveAndValidate(currency, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCurrencyExchangeRates(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        currency.setExchangeRate(new Double(currency.getExchangeRate()
            .intValue() + 20));
        saveAndValidate(currency, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCurrencyExchangeRates(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should succeed
        currency.setExchangeRate(new Double(currency.getExchangeRate()
            .intValue() + 20));
        saveAndValidate(currency, null, true);
    }

}