/*
 * Created on Jan 31, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.applicationadministration.containers.Organizational;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.OrganizationalFixture;

/**
 * @author karim
 *
 */
public class TestOrganizationalSecurityLocal extends
        BaseResourceSecurityTestLocal
{
    public void testCreateOrganizational() throws Exception
    {
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationOrganizations(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create an Organizational, should fail
        Organizational organizational = OrganizationalFixture.createFixture(0,
            null);
        organizational = (Organizational) saveAndValidate(organizational, null,
            false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationOrganizations(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create an Organizational, should succeed
        organizational = OrganizationalFixture.createFixture(0, null);
        organizational = (Organizational) saveAndValidate(organizational, null,
            true);
    }

    public void testDeleteOrganizational() throws Exception
    {
        // Create an Organizational, should succeed
        Organizational organizational = OrganizationalFixture.createFixture(0,
            null);
        organizational = (Organizational) saveAndValidate(organizational, null,
            true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationOrganizations(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should fail
        deleteAndValidate(organizational, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationOrganizations(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should succeed
        deleteAndValidate(organizational, true);
    }

    public void testUpdateOrganizational() throws Exception
    {
        // Create an Organizational, should succeed
        Organizational organizational = OrganizationalFixture.createFixture(0,
            null);
        organizational = (Organizational) saveAndValidate(organizational, null,
            true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationOrganizations(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        organizational.setDescription(organizational.getDescription()
                + "_MODIFIED");
        saveAndValidate(organizational, null, false);

        // Give the right to edit (for clean up)
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationOrganizations(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should succeed
        organizational.setDescription(organizational.getDescription()
                + "_MODIFIED");
        saveAndValidate(organizational, null, true);
    }

}
