/*
 * Created on Jan 31, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.client.junit.resource.fixtures.PoolFixture;
import com.ibm.rpm.resource.containers.Pool;

/**
 * @author karim
 *
 */
public class TestPoolSecurityLocal extends BaseResourceSecurityTestLocal
{
    public void testCreatePool() throws Exception
    {
        // Remove the right to create
        getCurrentUser().getResourceSecurityRights().setCanCreateResourcePools(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create a pool, should fail
        Pool pool = PoolFixture.createFixture(false, 0, null, this);
        pool = (Pool) saveAndValidate(pool, null, false);

        // Give the right to create
        getCurrentUser().getResourceSecurityRights().setCanCreateResourcePools(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create a pool, should succeed
        pool = PoolFixture.createFixture(false, 0, null, this);
        pool = (Pool) saveAndValidate(pool, null, true);
    }

    public void testDeletePool() throws Exception
    {
        // Create a pool, should succeed
        Pool pool = PoolFixture.createFixture(false, 0, null, this);
        pool = (Pool) saveAndValidate(pool, null, true);

        // Remove the right to delete
        getCurrentUser().getResourceSecurityRights().setCanDeleteResourcePools(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should fail
        deleteAndValidate(pool, false);

        // Give the right to delete
        getCurrentUser().getResourceSecurityRights().setCanDeleteResourcePools(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should succeed
        deleteAndValidate(pool, true);
    }

    public void testEditPoolName() throws Exception
    {
        // Create a pool, should succeed
        Pool pool = PoolFixture.createFixture(false, 0, null, this);
        pool = (Pool) saveAndValidate(pool, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditPoolNames(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        pool.setName(pool.getName() + "_UPDATED");
        saveAndValidate(pool, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditPoolNames(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should succeed
        saveAndValidate(pool, null, true);
    }

}