/*
 * Created on Jan 31, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.applicationadministration.containers.RPMCalendar;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.RPMCalendarFixture;

/**
 * @author karim
 *
 */
public class TestRPMCalendarSecurityLocal extends BaseResourceSecurityTestLocal
{
    public void testCreateRPMCalendar() throws Exception
    {
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditCalendarAdmin(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create a calendar, should fail
        RPMCalendar rpmCalendar = RPMCalendarFixture.createFixture(null);
        rpmCalendar = (RPMCalendar) saveAndValidate(rpmCalendar, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditCalendarAdmin(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create a calendar, should succeed
        rpmCalendar = RPMCalendarFixture.createFixture(null);
        rpmCalendar = (RPMCalendar) saveAndValidate(rpmCalendar, null, true);
    }

    public void testDeleteRPMCalendar() throws Exception
    {
        // Create a calendar, should succeed
        RPMCalendar rpmCalendar = RPMCalendarFixture.createFixture(null);
        rpmCalendar = (RPMCalendar) saveAndValidate(rpmCalendar, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditCalendarAdmin(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should fail
        deleteAndValidate(rpmCalendar, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditCalendarAdmin(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should succeed
        deleteAndValidate(rpmCalendar, true);
    }

    //    TODO Fix the RPMCalendar join condition bug first
    public void testUpdateRPMCalendar() throws Exception
    {
        // Create a calendar, should succeed
        RPMCalendar rpmCalendar = RPMCalendarFixture.createFixture(null);
        rpmCalendar = (RPMCalendar) saveAndValidate(rpmCalendar, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditCalendarAdmin(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        Double val = rpmCalendar.getHoursPerDay();
        if (val == null)
            val = new Double(0);
        rpmCalendar.setHoursPerDay(new Double(val.intValue() + 1));
        saveAndValidate(rpmCalendar, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditCalendarAdmin(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should succeed
        saveAndValidate(rpmCalendar, null, true);
    }

}