/*
 * Created on Feb 1, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.client.junit.financial.fixtures.TimecodeFixture;
import com.ibm.rpm.financial.containers.TimeCodeCategory;

/**
 * @author karim
 *
 */
public class TestTimeCodeSecurityLocal extends BaseResourceSecurityTestLocal
{
    public void testCreateTimeCode() throws Exception
    {
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditTimeCodes(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create a time code, should fail
        TimeCodeCategory timeCodeCategory = TimecodeFixture.createFixture(null,
            true, this);
        timeCodeCategory = (TimeCodeCategory) saveAndValidate(timeCodeCategory,
            null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditTimeCodes(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create a time code, should succeed
        timeCodeCategory = TimecodeFixture.createFixture(null, true, this);
        timeCodeCategory = (TimeCodeCategory) saveAndValidate(timeCodeCategory,
            null, true);
    }

    public void testDeleteTimeCode() throws Exception
    {
        // Create a time code, should succeed
        TimeCodeCategory timeCodeCategory = TimecodeFixture.createFixture(null,
            true, this);
        timeCodeCategory = (TimeCodeCategory) saveAndValidate(timeCodeCategory,
            null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditTimeCodes(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should fail
        deleteAndValidate(timeCodeCategory, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditTimeCodes(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should succeed
        deleteAndValidate(timeCodeCategory, true);
    }

    public void testUpdateTimeCode() throws Exception
    {
        // Create a time code, should succeed
        TimeCodeCategory timeCodeCategory = TimecodeFixture.createFixture(null,
            true, this);
        timeCodeCategory = (TimeCodeCategory) saveAndValidate(timeCodeCategory,
            null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditTimeCodes(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        timeCodeCategory.setDescription(timeCodeCategory.getDescription()
                + "_MODIFIED");
        saveAndValidate(timeCodeCategory, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditTimeCodes(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should succeed
        timeCodeCategory.setDescription(timeCodeCategory.getDescription()
                + "_MODIFIED");
        saveAndValidate(timeCodeCategory, null, true);
    }

}
