package com.ibm.rpm.client.junit.security.testcases.role;

import java.util.ArrayList;

import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public abstract class AbstractPlannedWorkElementSecurityTestLocal extends
        AbstractPlannedSecurityTestLocal
{
    public AbstractPlannedWorkElementSecurityTestLocal(Class securityRoleClass,
            RPMObject containerObject, RPMObject parentWorkElement,
            RPMObjectScope testObjectScope, String fieldToTest, String flagName)
    {
        super(securityRoleClass, containerObject, testObjectScope, fieldToTest,
            flagName);
        this.parentObject = parentWorkElement;
    }

    public AbstractPlannedWorkElementSecurityTestLocal(Class securityRoleClass,
            RPMObject containerObject, RPMObject parentWorkElement,
            RPMObjectScope testObjectScope, ArrayList fieldsToTest,
            String flagName)
    {
        super(securityRoleClass, containerObject, testObjectScope,
            fieldsToTest, flagName);
        this.parentObject = parentWorkElement;
    }

    protected void prepareParentHierarchy() throws Exception
    {
        // create and save the parent of the WorkElement
        parentObjectSecurityRole = prepareSecurityRole(parentObject.getClass(),
            true);
        parentObjectSecurityRole = updateSecurityRole(parentObjectSecurityRole);
        parentObject = (WorkElement) prepareContainer(parentObject, null,
            new WorkElementScope(), securityTestUser, parentObjectSecurityRole);

        // Set the parent scope used in the load operation
        WorkElementScope parentScope = new WorkElementScope();
        parentScope
            .setResourceTaskAssignments(new ResourceTaskAssignmentScope());

        // Load the parent
        parentObject = (WorkElement) loadFromID(parentObject, parentScope);
        assertNotNull(parentObject);
    }
}
