package com.ibm.rpm.client.junit.security.testcases.role.fixes;

import com.ibm.rpm.applicationadministration.containers.RPMCalendar;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.ProfileScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;
import com.ibm.rpm.wbs.types.AssignmentType;
import com.ibm.rpm.wbs.types.ProjectPublishedType;

public class TestRATLC00257994 extends ClientTestController {
	public void testSaveProject() throws Exception
    {
    	String projectName = "PROJECT_PARTNER_TEST";
        Project taskListProject = new Project();     
        taskListProject.setName(projectName);
                         
        RPMCalendar projectCalendar = (RPMCalendar) loadFromXpath("/RPMCalendar[@name='Standard (Default)']", null)[0];
        taskListProject.setCalendar(projectCalendar);
        
        taskListProject.setAssignmentType(AssignmentType.Work);
        taskListProject.setPublished(ProjectPublishedType.None);
        
        SaveResult saveResult = save(taskListProject, null, ReloadType.ReloadResult);
        assertNull(saveResult.getErrors());
        taskListProject = (Project) saveResult.getRpmObject();
        
        saveResult = save(taskListProject, null, ReloadType.None);
        assertNull(saveResult.getErrors());
    }
	public void testLoadProject() throws Exception
    {
    	String projectName = "PROJECT_PARTNER_TEST";
        Project taskListProject = new Project();     
        taskListProject.setName(projectName);
                         
        RPMCalendar projectCalendar = (RPMCalendar) loadFromXpath("/RPMCalendar[@name='Standard (Default)']", null)[0];
        taskListProject.setCalendar(projectCalendar);
        
        taskListProject.setAssignmentType(AssignmentType.Work);
        taskListProject.setPublished(ProjectPublishedType.None);
        
        SaveResult saveResult = save(taskListProject, null, ReloadType.ReloadResult);
        assertNull(saveResult.getErrors());
        taskListProject = (Project) saveResult.getRpmObject();
        
        taskListProject = (Project) loadFromID(taskListProject, null);
        assertNotNull(taskListProject);
    }
	public void testSaveProjectWithScope() throws Exception
    {
    	String projectName = "PROJECT_PARTNER_TEST";
        Project taskListProject = new Project();     
        taskListProject.setName(projectName);
                         
        RPMCalendar projectCalendar = (RPMCalendar) loadFromXpath("/RPMCalendar[@name='Standard (Default)']", null)[0];
        taskListProject.setCalendar(projectCalendar);
        
        taskListProject.setAssignmentType(AssignmentType.Work);
        taskListProject.setPublished(ProjectPublishedType.None);
        
        WorkElementScope wScope = new WorkElementScope();
                
        SaveResult saveResult = save(taskListProject, wScope, ReloadType.ReloadResult);
        assertNull(saveResult.getErrors());
        taskListProject = (Project) saveResult.getRpmObject();
        
        saveResult = save(taskListProject, wScope, ReloadType.None);
        assertNull(saveResult.getErrors());
    }
	public void testLoadProjectWithScope() throws Exception
    {
    	String projectName = "PROJECT_PARTNER_TEST";
        Project taskListProject = new Project();     
        taskListProject.setName(projectName);
                         
        RPMCalendar projectCalendar = (RPMCalendar) loadFromXpath("/RPMCalendar[@name='Standard (Default)']", null)[0];
        taskListProject.setCalendar(projectCalendar);
        
        taskListProject.setAssignmentType(AssignmentType.Work);
        taskListProject.setPublished(ProjectPublishedType.None);
        
        WorkElementScope wScope = new WorkElementScope();
        
        SaveResult saveResult = save(taskListProject, wScope, ReloadType.ReloadResult);
        assertNull(saveResult.getErrors());
        taskListProject = (Project) saveResult.getRpmObject();
        
        taskListProject = (Project) loadFromID(taskListProject, wScope);
        assertNotNull(taskListProject);
    }
	public void testSaveProjectWithScope1() throws Exception
    {
    	String projectName = "PROJECT_PARTNER_TEST";
        Project taskListProject = new Project();     
        taskListProject.setName(projectName);
                         
        RPMCalendar projectCalendar = (RPMCalendar) loadFromXpath("/RPMCalendar[@name='Standard (Default)']", null)[0];
        taskListProject.setCalendar(projectCalendar);
        
        taskListProject.setAssignmentType(AssignmentType.Work);
        taskListProject.setPublished(ProjectPublishedType.None);
        
        WorkElementScope wScope = new WorkElementScope();
                
        SaveResult saveResult = save(taskListProject, wScope, ReloadType.ReloadResult);
        assertNull(saveResult.getErrors());
        taskListProject = (Project) saveResult.getRpmObject();
        
        //Try saving with null scope
        saveResult = save(taskListProject, null, ReloadType.None);
        assertNull(saveResult.getErrors());
    }
	public void testLoadProjectWithScope1() throws Exception
    {
    	String projectName = "PROJECT_PARTNER_TEST";
        Project taskListProject = new Project();     
        taskListProject.setName(projectName);
                         
        RPMCalendar projectCalendar = (RPMCalendar) loadFromXpath("/RPMCalendar[@name='Standard (Default)']", null)[0];
        taskListProject.setCalendar(projectCalendar);
        
        taskListProject.setAssignmentType(AssignmentType.Work);
        taskListProject.setPublished(ProjectPublishedType.None);
        
        WorkElementScope wScope = new WorkElementScope();
        
        SaveResult saveResult = save(taskListProject, wScope, ReloadType.ReloadResult);
        assertNull(saveResult.getErrors());
        taskListProject = (Project) saveResult.getRpmObject();
        
        //Try Loading with Null Scope
        taskListProject = (Project) loadFromID(taskListProject, null);
        assertNotNull(taskListProject);
    }
}
