package com.ibm.rpm.client.junit.security.testcases.role.scopemanagement;

import java.util.Calendar;

import com.ibm.rpm.applicationadministration.containers.Attribute;
import com.ibm.rpm.applicationadministration.containers.AttributeAssignment;
import com.ibm.rpm.applicationadministration.containers.AttributeCategory;
import com.ibm.rpm.applicationadministration.containers.AttributeClassification;
import com.ibm.rpm.applicationadministration.types.InputType;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.AttributeFixture;
import com.ibm.rpm.scopemanagement.containers.AbstractAggregateScope;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;

public class AstractTestAggregateScopeSecurityTestLocal extends
		AbstractTestScopeElementSecurityTestLocal {

	protected void setUp() throws Exception
    {
        super.setUp();
    }

	protected void runViewProposedBy() throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;
		
		String proposedByName = modifyString(abstractAggregateScopeElement.getProposedByName());
		Calendar proposedByDate = modifyDate(abstractAggregateScopeElement.getProposedByDate());
		abstractAggregateScopeElement.setProposedByDate(proposedByDate);
		abstractAggregateScopeElement.setProposedByName(proposedByName);

		updateSaveScopeElement(true);

		runLoadValueFor(ABSTRACT_AGGREGATESCOPE_PROPOSEDBY);

		assertNotNull(((AbstractAggregateScope)testScopeElement).getProposedByDate());
		validateDate(proposedByDate, ((AbstractAggregateScope)testScopeElement).getProposedByDate());
		assertEquals(proposedByName, ((AbstractAggregateScope)testScopeElement).getProposedByName());
	}

	protected void runEditProposedBy() throws Exception
	{
		runEditProposedByName();

		runEditProposedByDate();
	}

	protected void runViewClosedBy() throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;
		
		String closedByName = modifyString(abstractAggregateScopeElement.getClosedByName());
		Calendar closedByDate = modifyDate(abstractAggregateScopeElement.getClosedByDate());
		abstractAggregateScopeElement.setClosedByDate(closedByDate);
		abstractAggregateScopeElement.setClosedByName(closedByName);

		updateSaveScopeElement(true);

		runLoadValueFor(ABSTRACT_AGGREGATESCOPE_CLOSEDBY);

		assertNotNull(((AbstractAggregateScope)testScopeElement).getClosedByDate());
		validateDate(closedByDate, ((AbstractAggregateScope)testScopeElement).getClosedByDate());
		assertEquals(closedByName, ((AbstractAggregateScope)testScopeElement).getClosedByName());
	}

	protected void runEditClosedBy() throws Exception
	{
		runEditClosedByName();

		runEditClosedByDate();
	}

	protected void runEditEstimatedDates() throws Exception
	{
		runEditEstimatedStartDate();

		runEditEstimatedFinishDate();
	}

	protected void runEditPriority() throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;

		int modifiedPriority = 500;
		if(abstractAggregateScopeElement.getPriority() != null)
		{
			modifiedPriority = abstractAggregateScopeElement.getPriority().intValue() + 1;
		}
		abstractAggregateScopeElement.setPriority(new Integer(modifiedPriority));

		runUpdatesFor(ABSTRACT_AGGREGATESCOPE_PRIORITY);

		assertEquals(modifiedPriority, ((AbstractAggregateScope)testScopeElement).getPriority().intValue());
	}

	protected void runEditAttributeAssignments() throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;

		String modifiedValue = (String)abstractAggregateScopeElement.getAttributeAssignments()[0].getValue();
		modifiedValue = modifiedValue + "_MOD";
		abstractAggregateScopeElement.getAttributeAssignments()[0].setValue(modifiedValue);

		runUpdatesFor(ABSTRACT_ATTRIBUTE_ASSIGNMENTS);

		AttributeAssignment attributeAssignments[] = ((AbstractAggregateScope)testScopeElement).getAttributeAssignments();
		assertNotNull(attributeAssignments);
		assertEquals(1, attributeAssignments.length);
		assertNotNull(attributeAssignments[0]);
		assertEquals(modifiedValue, attributeAssignments[0].getValue());
	}

	private void runEditProposedByName() throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;
		
		String proposedByName = modifyString(abstractAggregateScopeElement.getProposedByName());
		abstractAggregateScopeElement.setProposedByName(proposedByName);

		runUpdatesFor(ABSTRACT_AGGREGATESCOPE_PROPOSEDBY);

		assertEquals(proposedByName, ((AbstractAggregateScope)testScopeElement).getProposedByName());
	}

	private void runEditProposedByDate() throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;

		Calendar proposedByDate = modifyDate(abstractAggregateScopeElement.getProposedByDate());
		abstractAggregateScopeElement.setProposedByDate(proposedByDate);

		runUpdatesFor(ABSTRACT_AGGREGATESCOPE_PROPOSEDBY);

		assertNotNull(((AbstractAggregateScope)testScopeElement).getProposedByDate());
		validateDate(proposedByDate, ((AbstractAggregateScope)testScopeElement).getProposedByDate());
	}

	private void runEditClosedByName() throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;
		
		String closedByName = modifyString(abstractAggregateScopeElement.getClosedByName());
		abstractAggregateScopeElement.setClosedByName(closedByName);

		runUpdatesFor(ABSTRACT_AGGREGATESCOPE_CLOSEDBY);

		assertEquals(closedByName, ((AbstractAggregateScope)testScopeElement).getClosedByName());
	}

	private void runEditClosedByDate() throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;

		Calendar closedByDate = modifyDate(abstractAggregateScopeElement.getClosedByDate());
		abstractAggregateScopeElement.setClosedByDate(closedByDate);

		runUpdatesFor(ABSTRACT_AGGREGATESCOPE_CLOSEDBY);

		assertNotNull(((AbstractAggregateScope)testScopeElement).getClosedByDate());
		validateDate(closedByDate, ((AbstractAggregateScope)testScopeElement).getClosedByDate());
	}

	private void runEditEstimatedStartDate() throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;

		Calendar estimatedStartDate = modifyDate(abstractAggregateScopeElement.getEstimatedStartDate());
		abstractAggregateScopeElement.setEstimatedStartDate(estimatedStartDate);

		runUpdatesFor(ABSTRACT_AGGREGATESCOPE_ESTIMATED_DATES);

		assertNotNull(((AbstractAggregateScope)testScopeElement).getEstimatedStartDate());
		validateDate(estimatedStartDate, ((AbstractAggregateScope)testScopeElement).getEstimatedStartDate());
	}

	private void runEditEstimatedFinishDate() throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;

		Calendar estimatedFinishDate = abstractAggregateScopeElement.getEstimatedStartDate();
		if(abstractAggregateScopeElement.getEstimatedFinishDate() != null)
		{
			estimatedFinishDate = abstractAggregateScopeElement.getEstimatedFinishDate();
		}
		estimatedFinishDate.add(Calendar.DAY_OF_MONTH, 1);
		abstractAggregateScopeElement.setEstimatedFinishDate(estimatedFinishDate);

		runUpdatesFor(ABSTRACT_AGGREGATESCOPE_ESTIMATED_DATES);

		assertNotNull(((AbstractAggregateScope)testScopeElement).getEstimatedFinishDate());
		validateDate(estimatedFinishDate, ((AbstractAggregateScope)testScopeElement).getEstimatedFinishDate());
	}

	protected void createSaveScopeElementWithAttributeAssignments(AbstractAggregateScope abstractAggregateScopeElement) throws Exception
	{
		createSaveScopeElementWithSecurity(abstractAggregateScopeElement);

		Attribute attribute = createSaveAttribute();

		AttributeAssignment attributeAssignment = new AttributeAssignment();
		attributeAssignment.setAttribute(attribute);
		attributeAssignment.setValue("Test");
		((AbstractAggregateScope)testScopeElement).setAttributeAssignments(new AttributeAssignment[]{attributeAssignment});

		testScopeElement = (ScopeElement)save(testScopeElement, scopeElementScope).getRpmObject();

		abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;
		assertNotNull(abstractAggregateScopeElement);
		assertNotNull(abstractAggregateScopeElement.getAttributeAssignments());
		assertEquals(1, abstractAggregateScopeElement.getAttributeAssignments().length);
		assertNotNull(abstractAggregateScopeElement.getAttributeAssignments()[0]);
	}

	protected void loadOrUpdateField(int fieldType, boolean isSecurityFlagOn, boolean isLoad, boolean found) throws Exception
	{
		switch(fieldType)
		{
			case ABSTRACT_AGGREGATESCOPE_PROPOSEDBY:
				if(isLoad)
				{
					scopeElementSecurityRole.setCanViewProposedBy(new Boolean(isSecurityFlagOn));
					if(!isSecurityFlagOn)
						scopeElementSecurityRole.setCanEditProposedBy(new Boolean(isSecurityFlagOn));
				}
				else
				{
					scopeElementSecurityRole.setCanEditProposedBy(new Boolean(isSecurityFlagOn));
					if(isSecurityFlagOn)
						scopeElementSecurityRole.setCanViewProposedBy(new Boolean(isSecurityFlagOn));
				}
				found = true;
				break;
			case ABSTRACT_AGGREGATESCOPE_CLOSEDBY:
				if(isLoad)
				{
					scopeElementSecurityRole.setCanViewClosedBy(new Boolean(isSecurityFlagOn));
					if(!isSecurityFlagOn)
						scopeElementSecurityRole.setCanEditClosedBy(new Boolean(isSecurityFlagOn));
				}
				else
				{
					scopeElementSecurityRole.setCanEditClosedBy(new Boolean(isSecurityFlagOn));
					if(isSecurityFlagOn)
						scopeElementSecurityRole.setCanViewClosedBy(new Boolean(isSecurityFlagOn));
				}
				found = true;
				break;
			case ABSTRACT_AGGREGATESCOPE_ESTIMATED_DATES:
				if(isLoad)
				{
					scopeElementSecurityRole.setCanViewESTStartAndESTFinish(new Boolean(isSecurityFlagOn));
					if(!isSecurityFlagOn)
						scopeElementSecurityRole.setCanEditESTStartAndESTFinish(new Boolean(isSecurityFlagOn));
				}
				else
				{
					scopeElementSecurityRole.setCanEditESTStartAndESTFinish(new Boolean(isSecurityFlagOn));
					if(isSecurityFlagOn)
						scopeElementSecurityRole.setCanViewESTStartAndESTFinish(new Boolean(isSecurityFlagOn));
				}
				found = true;
				break;
			case ABSTRACT_AGGREGATESCOPE_PRIORITY:
				if(isLoad)
				{
					scopeElementSecurityRole.setCanViewPriority(new Boolean(isSecurityFlagOn));
					if(!isSecurityFlagOn)
						scopeElementSecurityRole.setCanEditPriority(new Boolean(isSecurityFlagOn));
				}
				else
				{
					scopeElementSecurityRole.setCanEditPriority(new Boolean(isSecurityFlagOn));
					if(isSecurityFlagOn)
						scopeElementSecurityRole.setCanViewPriority(new Boolean(isSecurityFlagOn));
				}
				found = true;
				break;
			case ABSTRACT_ATTRIBUTE_ASSIGNMENTS:
				if(isLoad)
				{
					scopeElementSecurityRole.setCanViewAttributes(new Boolean(isSecurityFlagOn));
					if(!isSecurityFlagOn)
						scopeElementSecurityRole.setCanEditAttributes(new Boolean(isSecurityFlagOn));
				}
				else
				{
					scopeElementSecurityRole.setCanEditAttributes(new Boolean(isSecurityFlagOn));
					if(isSecurityFlagOn)
						scopeElementSecurityRole.setCanViewAttributes(new Boolean(isSecurityFlagOn));
				}
				found = true;
				break;
		}
		super.loadOrUpdateField(fieldType,isSecurityFlagOn,isLoad,found);
	}

	protected void checkNullValueFor(int fieldType, boolean found, Object value[]) throws Exception
	{
		AbstractAggregateScope abstractAggregateScopeElement = (AbstractAggregateScope)testScopeElement;
		switch(fieldType)
		{
			case ABSTRACT_AGGREGATESCOPE_PROPOSEDBY:
				value = new Object[2];
				value[0] = abstractAggregateScopeElement.getProposedByDate();
				value[1] = abstractAggregateScopeElement.getProposedByName();
				found = true;
				break;
			case ABSTRACT_AGGREGATESCOPE_CLOSEDBY:
				value = new Object[2];
				value[0] = abstractAggregateScopeElement.getClosedByDate();
				value[1] = abstractAggregateScopeElement.getClosedByName();
				found = true;
				break;
			case ABSTRACT_AGGREGATESCOPE_ESTIMATED_DATES:
				value = new Object[2];
				value[0] = abstractAggregateScopeElement.getEstimatedStartDate();
				value[1] = abstractAggregateScopeElement.getEstimatedFinishDate();
				found = true;
				break;
			case ABSTRACT_AGGREGATESCOPE_PRIORITY:
				value = new Object[1];
				value[0] = abstractAggregateScopeElement.getPriority();
				found = true;
				break;
			case ABSTRACT_ATTRIBUTE_ASSIGNMENTS:
				value = abstractAggregateScopeElement.getAttributeAssignments();
				found = true;
				break;
		}
		super.checkNullValueFor(fieldType,found,value);
	}

	private Attribute createSaveAttribute() throws Exception
	{
		AttributeCategory attributeCategory = AttributeFixture.createSaveFixture(AttributeFixture.SCOPE_CONTEXT, this);

		assertNotNull(attributeCategory.getClassifications());
		assertEquals(1, attributeCategory.getClassifications().length);
		assertNotNull(attributeCategory.getClassifications()[0]);

		AttributeClassification attributeClassification = attributeCategory.getClassifications()[0];
		assertNotNull(attributeClassification.getAttributes());
		assertEquals(1, attributeClassification.getAttributes().length);
		assertNotNull(attributeClassification.getAttributes()[0]);

		Attribute attribute = attributeCategory.getClassifications()[0].getAttributes()[0];
		attribute.setInputType(InputType.Text);
		attribute = (Attribute)save(attribute, null).getRpmObject();
		assertNotNull(attribute);
		assertEquals(InputType.Text, attribute.getInputType());

		return attribute;
	}
}
