package com.ibm.rpm.client.junit.timesheet.testcases.fixes;

import java.util.Calendar;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.timesheet.fixtures.SummaryTimesheetFixture;
import com.ibm.rpm.client.junit.timesheet.fixtures.TimesheetTestUtil;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.timesheet.containers.Step;
import com.ibm.rpm.timesheet.containers.StepTimesheet;
import com.ibm.rpm.timesheet.containers.SummaryTimesheet;
import com.ibm.rpm.timesheet.scope.StepScope;
import com.ibm.rpm.wbs.containers.TaskAssignment;

/**
 * @author gmeloche
 *  
 */
public class Test55914 extends ClientTestController
{

    TaskAssignment taskAssignment = null;

    SummaryTimesheet summaryTimesheet = null;

    Calendar weekOf1 = null;

    protected void setUp() throws Exception
    {
        super.setUp();

        //Create a step with 2 summaryTimesheets and a StepTimesheet for the
        // first week
        taskAssignment = TaskAssignmentFixture.createSaveFixture(null, this);

        weekOf1 = TimesheetTestUtil.getValidWeekOf(taskAssignment
            .getAssignmentStartDate(), 1);

        //summary timesheet

        summaryTimesheet = SummaryTimesheetFixture.createSaveFixture(
            taskAssignment, weekOf1, null, false, this);

    }

    public void testValidateETTC_AfterStepCreation() throws Exception
    {

        //Update summaryTimesheet with an EETC of 8 hours.
        ((TaskAssignment)summaryTimesheet.getTaskAssignment()).setEETCHours(new Double(8));

        SingleResult result1 = save(summaryTimesheet, null);
        summaryTimesheet = (SummaryTimesheet) result1.getRpmObject();

        Step step = new Step();
        step.setTaskAssignment(taskAssignment);
        StepTimesheet timesheet1 = new StepTimesheet();
        timesheet1.setWeekOf(weekOf1);

        //put 1 hour of worked time
        timesheet1.setRegularMonday(new Double(1));
        step.setStepTimesheets(new StepTimesheet[]
        {
            timesheet1
        });

        StepScope stepScope = new StepScope();
        stepScope.setTimesheets(true);

        save(step, stepScope);

        //EETC must be 7 in the summaryTimesheet

        SummaryTimesheet reloadedTimesheet = (SummaryTimesheet) loadFromID(
            summaryTimesheet, null);

        assertEquals(new Double(7), ((TaskAssignment)reloadedTimesheet.getTaskAssignment()).getEETCHours());

    }
}
