/*
 * Created on Feb 2, 2006
 */
package com.ibm.rpm.client.junit.wbs.fixtures;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.client.junit.resource.fixtures.ResourceAttributeAssignmentFixture;
import com.ibm.rpm.resource.containers.ResourceAttribute;
import com.ibm.rpm.resource.containers.ResourceAttributeCompetencyCategory;
import com.ibm.rpm.resource.containers.ResourceAttributeProficiencyLevel;
import com.ibm.rpm.resource.containers.ResourceAttributeSkillCategory;
import com.ibm.rpm.wbs.containers.Profile;
import com.ibm.rpm.wbs.containers.ProfileCompetencyAssignment;
import com.ibm.rpm.wbs.containers.ProfileResourceAttributeAssignment;
import com.ibm.rpm.wbs.containers.ProfileSkillAssignment;

/**
 * @author gosselin
 */
public class ProfileResourceAttributeAssignmentFixture extends RPMObjectFixture
{

    public static ProfileResourceAttributeAssignment createFixture(
            ResourceAttribute type, Profile parent,
            ClientTestController ctc) throws Exception
    {
        if (type instanceof ResourceAttributeCompetencyCategory)
        {
            ProfileCompetencyAssignment assignment = new ProfileCompetencyAssignment();
//            ResourceAttributeProficiencyLevel proLevel = ResourceAttributeAssignmentFixture
//                .createProficiencyLevelStructure(type, ctc);
            ResourceAttributeProficiencyLevel proLevel = ResourceAttributeAssignmentFixture
                .retrieveProficiencyStructStaticFixture(type, ctc);
            assignment.setProficiencyLevel(proLevel);
            assignment.setParent(parent);
            return assignment;
        }
        else if (type instanceof ResourceAttributeSkillCategory)
        {
            ProfileSkillAssignment assignment = new ProfileSkillAssignment();
            ResourceAttributeProficiencyLevel proLevel = ResourceAttributeAssignmentFixture
                .retrieveProficiencyStructStaticFixture(type, ctc);
//            ResourceAttributeProficiencyLevel proLevel = ResourceAttributeAssignmentFixture
//                .createProficiencyLevelStructure(type, ctc);
            assignment.setProficiencyLevel(proLevel);
            assignment.setParent(parent);
            return assignment;
        }
        else
        {
            return null;
        }

    }
    
	public static void compare(ProfileResourceAttributeAssignment[] array1,
            ProfileResourceAttributeAssignment[] array2)
            throws AssertionFailedError, Exception
    {
        RPMObjectFixture.compare(array1, array2);

        for (int i = 0; i < array1.length; i++)
        {
            ProfileResourceAttributeAssignmentFixture.compare(array1[i],
                array2[i]);
        }
    }

    public static void compare(ProfileResourceAttributeAssignment assignment1,
            ProfileResourceAttributeAssignment assignment2)
            throws AssertionFailedError, Exception
    {
        RPMObjectFixture.compare(assignment1, assignment2);
        ResourceAttributeAssignmentFixture.compare(assignment1
            .getProficiencyLevel(), assignment2.getProficiencyLevel());
    }
}
