package com.ibm.rpm.client.junit.wbs.testcases;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author dominiqu
 */
public class TestDeleteScopeElement extends ClientTestController
{
    protected ScopeElementScope mainScope;

    protected ScopeFolder mainFolder = null;

    protected WorkElementScope proposalScope;

    protected Proposal proposal = null;

    protected int nbChildren = 1;

    public void setUp() throws Exception
    {
        super.setUp();
    }

    // Note: This test requires that a project with an associated scope element
    // of name STATIC_ARCHIVED_REQUIREMENT has been archived using the client.
    // This test will mistakenly pass (even if the filter does not work) if
    // the archived project and associated Requirement has been deleted.
    public void testDelete() throws AssertionError, Exception
    {
        // Ensure the archived work element's scope elements are hidden
        RPMObject[] objs = loadFromXpath(
            "/ScopeElement[name='STATIC_ARCHIVED_PROPOSAL']", null);
        assertTrue(
            "Archived Work Element's corresponding Proposal was loaded.",
            objs == null || objs.length == 0);
        objs = loadFromXpath(
            "/ScopeElement[name='STATIC_ARCHIVED_REQUIREMENT']", null);
        assertTrue("Archived Work Element's Requirement was loaded.",
            objs == null || objs.length == 0);
    }
}
