package com.ibm.rpm.client.junit.wbs.testcases;

import com.ibm.rpm.client.junit.wbs.fixtures.ResourceTaskAssignmentFixture;

/**
 * @author ikusakov
 */
public class TestProjectResourceTaskAssignmentAffect extends
        AbstractTestResourceTaskAssignment
{

    public TestProjectResourceTaskAssignmentAffect(String testName)
    {
        super(testName);
    }

    public void setUp() throws Exception
    {
        mainScope = ResourceTaskAssignmentFixture.createScope(true, false,
                false, true, true);
        useProposalParent = true;
        super.setUp();
    }

    public void testInsertWithNoScopeLoadFromID() throws AssertionError,
            Exception
    {
        insert(null, false, true);
    }

    public void testInsertWithScopeLoadFromID() throws AssertionError,
            Exception
    {
        insert(mainScope, false, true);
    }

    public void testUpdateWithNoScopeLoadFromID() throws AssertionError,
            Exception
    {
        update(null, false, true);
    }

    public void testUpdateWithScopeLoadFromID() throws AssertionError,
            Exception
    {
        update(mainScope, false, true);
    }
    
    public void testInsertUpdateFromWbsPerspective() throws AssertionError,
            Exception
    {
        insertUpdateFromWbsPerspective(false);
    }

    public void testDeleteFromWbsPerspective() throws AssertionError, Exception
    {
        deleteFromWbsPerspective(false);
    }

    public void testLoadFromWbsPerspective() throws AssertionError, Exception
    {
        loadFromWbsPerspective(false);
    }

}
