package com.ibm.rpm.client.junit.wbs.testcases;

import com.ibm.rpm.client.junit.wbs.fixtures.ResourceTaskAssignmentFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.wbs.containers.ResourceTaskAssignment;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * 
 * @author ikusakov
 */
public class TestResourceTaskAssignmentAffect extends
        AbstractTestResourceTaskAssignment
{

    public TestResourceTaskAssignmentAffect(String testName)
    {
        super(testName);
    }

    public void setUp() throws Exception
    {
        mainScope = ResourceTaskAssignmentFixture.createScope(true, true,
                false, true, true);
        super.setUp();
    }

    public void testInsertWithNoScopeLoadFromID() throws AssertionError,
            Exception
    {
        insert(mainScope, false, true);
    }

    public void testInsertWithScopeLoadFromID() throws AssertionError,
            Exception
    {
        mainScope.setTaskAssignment(TaskAssignmentFixture.createScope(false,
                true, true, true));
        insert(mainScope, false, true);
    }
    
    public void testInsertWithScopeManualCheckout()
            throws AssertionError, Exception
    {
        mainScope.setTaskAssignment(TaskAssignmentFixture.createScope(false,
            true, true, true));
        ResourceTaskAssignment assignment = insertAssignment(mainScope, false, true);
        this.disableAutomaticCheckout();
        assignment.getTaskAssignment().setBillable(Boolean.FALSE);
        this.checkOut(assignment.getParent());
        WorkElementScope weScope = new WorkElementScope();
        weScope.setResourceTaskAssignments(mainScope);
        TaskAssignmentScope  taScope = new TaskAssignmentScope();
        this.save(assignment.getTaskAssignment(), taScope);
        this.checkIn(assignment.getParent());
    }

    public void testUpdateWithNoScopeLoadFromID() throws AssertionError,
            Exception
    {
        update(mainScope, false, true);
    }

    public void testUpdateWithScopeLoadFromID() throws AssertionError,
            Exception
    {
        mainScope.setTaskAssignment(TaskAssignmentFixture.createScope(false,
                true, true, true));
        update(mainScope, false, true);
    }
    
    public void testInsertUpdateFromWbsPerspective() throws AssertionError,
            Exception
    {
        insertUpdateFromWbsPerspective(false);
    }

    public void testDeleteFromWbsPerspective() throws AssertionError, Exception
    {
        deleteFromWbsPerspective(false);
    }

    public void testLoadFromWbsPerspective() throws AssertionError, Exception
    {
        loadFromWbsPerspective(false);
    }
    
    public void testDeleteAssignedWorkUpdatePercentDC() throws AssertionError,
            Exception
    {
        deleteAssignedWorkUpdatePercentDC(mainScope, false, true);
    }

}
