package com.ibm.rpm.client.junit.wbs.testcases;

import com.ibm.rpm.client.junit.wbs.fixtures.ResourceTaskAssignmentFixture;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * 
 * @author ikusakov
 */
public class TestScopeResourceTaskAssignmentAssign extends
        AbstractTestScopeResourceTaskAssignment
{

    public TestScopeResourceTaskAssignmentAssign(String testName)
    {
        super(testName);
    }

    public void setUp() throws Exception
    {
        mainScope = ResourceTaskAssignmentFixture.createScope(true, false,
                false, true, true);
        ScopeElementScope scopeScope = new ScopeElementScope();
        scopeScope.setProject(new WorkElementScope());
        mainScope.setParent(scopeScope);
        super.setUp();
    }

    public void testInsertWithNoScopeLoadFromID() throws AssertionError,
            Exception
    {
        insert(null, false, true);
    }

    public void testInsertWithScopeLoadFromID() throws AssertionError,
            Exception
    {
        insert(mainScope, false, true);
    }

    public void testUpdateWithNoScopeLoadFromID() throws AssertionError,
            Exception
    {
        update(null, false, true);
    }

    public void testUpdateWithScopeLoadFromID() throws AssertionError,
            Exception
    {
        update(mainScope, false, true);
    }
    
    public void testDeleteFromWbsPerspective() throws AssertionError, Exception
    {
        deleteFromWbsPerspective(false);
    }
    
    public void testInsertUpdateFromCRIPerspective() throws AssertionError, Exception
    {
        insertUpdateFromCRIPerspective(false);
    }
    
    public void testInsertWithNoScopeLoadFromXPath() throws AssertionError, Exception
    {
        insertWithNoScopeLoadFromXPath();
    }
    
    public void testLoadFromCRIPerspective() throws AssertionError, Exception
    {
        loadFromCRIPerspective(false);
    }  
}
