/*
 * Created on Oct 5, 2006
 *
 */
package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.applicationadministration.containers.Organization;
import com.ibm.rpm.applicationadministration.containers.OrganizationType;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.wbs.containers.Portfolio;
import com.ibm.rpm.wbs.containers.ProjectOrganizationalAssignment;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.scope.PortfolioScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author karim
 *
 */
public class Test49819 extends ClientTestController
{

	public void testProjectAssignment() throws Exception
	{
		Portfolio portfolio = new Portfolio();
		portfolio.setName("Test49819_Portfolio");
		
		Proposal proposal = new Proposal();
		proposal.setName("Test49819_Proposal");
		
		//Link proposal to portfolio
		portfolio.setProjects(new Proposal[] {proposal});

		//Scope used to save the portfolio
		PortfolioScope portfolioScope = new PortfolioScope();
		WorkElementScope proposalScope = new WorkElementScope();
		portfolioScope.setProjects(proposalScope);
		
		SaveResult saveResult = save(portfolio,portfolioScope);

		portfolio = (Portfolio)saveResult.getRpmObject();
		proposal = (Proposal)portfolio.getProjects()[0];
		
		Organization organization = new Organization();
		organization.setName("Test49819_Organization");
		
		saveResult = save(organization,null);
		organization = (Organization)saveResult.getRpmObject();
		
		RPMObject[] loadResult = loadFromXpath("OrganizationType[id='7002']", null);
		assertTrue(loadResult[0] instanceof OrganizationType);

		OrganizationType organizationType = (OrganizationType)loadResult[0];
		
		ProjectOrganizationalAssignment assignment = new ProjectOrganizationalAssignment();
		assignment.setOrganizational(organization);
		assignment.setOrganizationType(organizationType);// 7002 Executing
		assignment.setParent(proposal);
		
		SaveResult result = save(assignment, null);
		assertTrue(result.getRpmObject() instanceof ProjectOrganizationalAssignment);
	}

}
