/*
 * Created on Nov 28, 2006
 * @author mmatwiy
 * 
 * Test methods for defect 57271. Join condition missing:
 * WbsManager.getJoinCondition is not implemented for the manager PublishedScorecardManager
 */
package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scorecard.testcases.validation.ScorecardWBSValidationUtility;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.scorecard.containers.AssignedScorecard;
import com.ibm.rpm.scorecard.scope.ScorecardScope;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class Test57271 extends ClientTestController
{
    Proposal assignedProposal = null;

    WorkElementScope scope = null;

    public void setUp() throws Exception
    {
        super.setUp();
        
        ScorecardWBSValidationUtility util = new ScorecardWBSValidationUtility();
        WbsModule module = util.createModule();

        Proposal proposal = (Proposal) WorkElementFixture.createSaveFixture(
            new Proposal(), null, this);

        scope = new WorkElementScope();
        scope.setAssignedScorecards(new ScorecardScope());

        assignedProposal = (Proposal) getApplicationInterface()
            .assignScoreCard(getSessionID(), proposal, scope,
                module.getScorecardFolders()[0].getScorecards()[0],
                ReloadType.ReloadResult).getRpmObject();

        assertNotNull(assignedProposal.getAssignedScorecards());
    }

    public void testJoinCondition() throws Exception
    {
        RPMObject[] rpmObjects = loadFromXpath("/Proposal[@id='"
                + assignedProposal.getID() + "']/AssignedScorecard", null);

        assertNotNull(rpmObjects);
        assertNotNull(rpmObjects[0]);
        assertTrue(rpmObjects[0] instanceof AssignedScorecard);
    }

    public void testSubJoinCondition() throws Exception
    {
        RPMObject[] rpmObjects = loadFromXpath("/Proposal[AssignedScorecard[@id='"
                + assignedProposal.getAssignedScorecards()[0].getID() + "']]", null);

        assertNotNull(rpmObjects);
        assertNotNull(rpmObjects[0]);
        assertTrue(rpmObjects[0] instanceof Proposal);
    }
}
