package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.wbs.containers.TaskAssignment;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class Test57671 extends ClientTestController
{

    TaskAssignment taskAssignment = null;

    public void testLoadTaskAssignmentWithGenericParent() throws Exception
    {

        RPMObjectScope scope = new RPMObjectScope();
        scope.setParent(scope);

        RPMObject object = loadFromID(taskAssignment, scope);
        
        assertNotNull(object);
        RPMObject resourceTaskAssignment = object.getParent();
        assertNotNull(resourceTaskAssignment);
        RPMObject task = resourceTaskAssignment.getParent();
        assertNotNull(task);
        assertTrue(task instanceof WorkElement);

    }
    
    public void testLoadTaskAssignmentWithWorkElementParent() throws Exception
    {

        WorkElementScope wes = new WorkElementScope();
        wes.setContainingProject(new WorkElementScope());
        
        ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
        rtas.setParent(wes);
        
        TaskAssignmentScope scope = new TaskAssignmentScope();
        scope.setParent(rtas);
  
        RPMObject object = loadFromID(taskAssignment, scope);
        
        assertNotNull(object);
        RPMObject resourceTaskAssignment = object.getParent();
        assertNotNull(resourceTaskAssignment);
        RPMObject task = resourceTaskAssignment.getParent();
        assertNotNull(task);
        assertTrue(task instanceof WorkElement);
        assertNotNull(((WorkElement)task).getContainingProject());

    }

    protected void setUp() throws Exception
    {

        super.setUp();

        taskAssignment = TaskAssignmentFixture.createSaveFixture(null, this);
    }
}
