/*
 * Created on March 2, 2007
 * Defect 61234: WS - SQL error when trying to update billable for TA
 * 
 * Description:
 * 1- create a TaskAssignment.
 * 2- set billable to false and try to save.
 * 3- notice how you get the following error: RPMException(-407): An UPDATE, INSERT, or SET value is null, but the column cannot contain null values
 */
package com.ibm.rpm.client.junit.wbs.testcases.fixes;

/**
 * @author cobber
 */

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.wbs.containers.TaskAssignment;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;

public class Test61234 extends ClientTestController
{
    public void testUpdateBillable() throws Exception
    {
        // Create a TaskAssignment
        TaskAssignmentScope taskAssignmentScope = TaskAssignmentFixture
            .createScope(true, false, false, false);
        TaskAssignment taskAssignment = TaskAssignmentFixture
            .createSaveFixture(taskAssignmentScope, this);
        assertNotNull(taskAssignment);

        taskAssignment.setBillable(new Boolean(false));
        SingleResult result = save(taskAssignment, null);
        assertTrue(result.isSuccessful());
        assertTrue(result.isWarningFree());
        assertNotNull(result.getRpmObject());
        assertTrue(result.getRpmObject() instanceof TaskAssignment);
        taskAssignment = (TaskAssignment) result.getRpmObject();
        assertNotNull(taskAssignment.getBillable());
        assertFalse(taskAssignment.getBillable().booleanValue());
    }
}
