package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.applicationadministration.containers.DefectState;
import com.ibm.rpm.applicationadministration.containers.RPMCalendar;
import com.ibm.rpm.applicationadministration.scope.CalendarScope;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.RPMCalendarFixture;
import com.ibm.rpm.client.junit.resource.fixtures.ResourceFixture;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.ResourceTaskAssignmentFixture;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.scopemanagement.containers.Defect;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.ResourceTaskAssignment;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class Test61401 extends ClientTestController
{
    public void testInvalidDefectState() throws Exception
    {
        DefectState aState = (DefectState) loadFromXpath(
            "/DefectState[@value='To be validated']", new RPMObjectScope())[0];

        assertNotNull(aState);

        ScopeElement parent = ScopeElementFixture.createFixture(
            new ScopeElementScope(), this, 1);

        parent = (ScopeElement) save(parent, new ScopeElementScope())
            .getRpmObject();

        Defect defect = ScopeElementFixture.createDefectFixture(
            new ScopeElementScope(), 1, parent, this);

        defect = (Defect) save(defect, new ScopeElementScope()).getRpmObject();

        ResourceTaskAssignment resourceAssignment = ResourceTaskAssignmentFixture
            .createFixture(new ResourceTaskAssignmentScope(), false, this);

        Resource resource = ResourceFixture.createSaveFixture(this);
        RPMCalendar resourceCalendar = RPMCalendarFixture.createSaveFixture(
            new CalendarScope(), this);
        resource.setCalendar(resourceCalendar);
        resourceAssignment.setResource(resource);

        defect.setResourceTaskAssignments(new ResourceTaskAssignment[]
        {
            resourceAssignment
        });

        defect.setTask(Boolean.TRUE);
        defect = (Defect) save(defect, new ScopeElementScope()).getRpmObject();

        transferUnderWBS(null, defect);

        ScopeElementScope defectScope = new ScopeElementScope();
        defectScope.setWorkElement(new WorkElementScope());
        defect = (Defect) loadFromID(defect, defectScope);

        Task defectTask = (Task) defect.getWorkElement();
        assertNotNull(defectTask);

        WorkElementScope weScope = new WorkElementScope();
        weScope.setState(true);

        defectTask.setState(aState);
        defectTask = (Task) save(defectTask, weScope).getRpmObject();
    }
}
