package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scorecard.fixtures.ScorecardFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;
import com.ibm.rpm.scorecard.scope.ScorecardFolderScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * Info
 * 
 * Ref No: DB2-SM-700 Date: 2007/3/23 Version: 7.1.0.0 (Build 1466) Reported by:
 * Stephane Requirement: Tomcat 5.5.17 (JVM 1.4.2_11-b06) Regression: No
 * 
 * Description I try to assign a previously created Scorecard to a proposal via
 * the ApplicationInterface.assignScorecard() function. However, the operation
 * ends up in a Server side NullPointerException.
 * 
 * @author andreit
 */
public class Test62930 extends ClientTestController
{
    public void testAssignScorecardProposal() throws Exception
    {
        ScorecardFolderScope mainScope = ScorecardFixture.createScope();
        ScorecardFolder folder = ScorecardFixture.createSaveFixture(
            new WbsModule(), mainScope, this);
        Proposal proposal = (Proposal) WorkElementFixture.createSaveFixture(
            new Proposal(), new WorkElementScope(), this);
        assertNull(folder.getScorecards()[0].getID()); // this is what is making the test fail.

        Proposal reloadedProposal = (Proposal) this.getApplicationInterface()
            .assignScoreCard(getSessionID(), proposal, new WorkElementScope(),
                folder.getScorecards()[0], ReloadType.ReloadResult)
            .getRpmObject();
        assertNull(reloadedProposal);
    }
}
