package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.wbs.fixtures.ProfileFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.ResourceTaskAssignmentFixture;
import com.ibm.rpm.wbs.containers.Profile;
import com.ibm.rpm.wbs.scope.ProfileScope;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;

public class TestContourWithProfile extends AbstractTestContour {

	public void setUp() throws Exception
	{
		super.setUp();
		mainScope = createRTAScope();
		Profile profile = createProfile();
		assignment = ResourceTaskAssignmentFixture
					.createFixture(parentWorkElement, null, profile, mainScope, false, this);
		assignment.getTaskAssignment().setProposedDurationHours(null);
		mainScope.setTaskAssignment(null);
	}

	private Profile createProfile() throws Exception
	{
		ProfileScope profileScope = new ProfileScope();
		profileScope.setProfileCompetencyAssignments(true);
		profileScope.setProfileSkillAssignments(true);
		Profile profile = ProfileFixture.createFixture(profileScope, 1, null, this);
		return profile;
	}
	
	private ResourceTaskAssignmentScope createRTAScope()
	{
		ResourceTaskAssignmentScope rtaScope = new ResourceTaskAssignmentScope();
		rtaScope.setTaskAssignment(new TaskAssignmentScope());
		ProfileScope profileScope = new ProfileScope();
		profileScope.setProfileCompetencyAssignments(true);
		profileScope.setProfileSkillAssignments(true);
		rtaScope.setProfile(profileScope);
		return rtaScope;
	}
}
