/*
 * Created on Dec 1, 2005 
 * @author mmatwiy 
 * Validation tests for container Milestone.
 */
package com.ibm.rpm.client.junit.wbs.testcases.validation;

import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.wbs.constants.ValidationConstants;
import com.ibm.rpm.wbs.containers.Milestone;
import com.ibm.rpm.wbs.containers.Project;

public class TestMilestoneValidation extends AbstractTestSimpleNodeValidation
{
    private Milestone milestone;

    public void setUp() throws Exception
    {
        super.setUp();

        milestone = new Milestone();
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testReadOnlyActualDateFields() throws AssertionError, Exception
    {
        super.testReadOnlyActualDateFields(milestone);
    }

    public void testReadOnlyForecastDateFields() throws AssertionError,
            Exception
    {
        super.testReadOnlyForecastDateFields(milestone);
    }

    public void testReadOnlyPlanDateFields() throws AssertionError, Exception
    {
        super.testReadOnlyPlanDateFields(milestone);
    }

    public void testReadOnlyProposedDateFields() throws AssertionError,
            Exception
    {
        super.testReadOnlyProposedDateFields(milestone);
    }

    public void testConditionalReadOnlyAssignedWorkExists()
            throws AssertionError, Exception
    {
        super.testConditionalReadOnlyAssignedWorkExists(milestone);
    }

    public void testSuccessConditionalReadOnlyAssignedParticipantsExist()
            throws AssertionError, Exception
    {
        super
            .testSuccessConditionalReadOnlyAssignedParticipantsExist(milestone);
    }

    public void testConditionalReadOnlyActualStart() throws AssertionError,
            Exception
    {
        super.testConditionalReadOnlyActualStart(milestone);
    }

    public void testConditionalReadOnlyActualDurationInMinutes()
            throws AssertionError, Exception
    {
        super.testConditionalReadOnlyActualDurationInMinutes(milestone);
    }

    public void testConditionalReadOnlyDurationsSame() throws AssertionError,
            Exception
    {
        super.testConditionalReadOnlyDurationsSame(milestone);
    }

    public void testConditionalReadOnlyForecastDurationInMinutes()
            throws AssertionError, Exception
    {
        super.testConditionalReadOnlyForecastDurationInMinutes(milestone);
    }

    public void testConditionalReadOnlyPlanStartAndDuration()
            throws AssertionError, Exception
    {
        super.testConditionalReadOnlyPlanStartAndDuration(milestone);
    }

    public void testConditionalReadOnlyPlanDurationInMinutes()
            throws AssertionError, Exception
    {
        super.testConditionalReadOnlyPlanDurationInMinutes(milestone);
    }

    public void testConditionalReadOnlyProposedStartAndDuration()
            throws AssertionError, Exception
    {
        super.testConditionalReadOnlyProposedStartAndDuration(milestone);
    }

    public void testInsertWithInvalidParent() throws AssertionError, Exception
    {
        super.testInsertWithInvalidParent(milestone);
    }

    public void testInsertSuccess() throws AssertionError, Exception
    {
        super.testInsertSuccess(milestone);
    }

    public void testInsertScheduleDatesSuccess() throws AssertionError,
            Exception
    {
        super.testInsertScheduleDatesSuccess(milestone);
    }

    public void testFailureClearProposedStart() throws AssertionError,
            Exception
    {
        super.testFailureClearProposedStart(milestone);
    }

    public void testFailureClearPlanStart() throws AssertionError, Exception
    {
        super.testFailureClearPlanStart(milestone);
    }

    public void testFailureCompareDurations() throws AssertionError, Exception
    {
        super.testFailureCompareDurations(milestone);
    }

    public void testFailureInvalidEstimatedFinishDate() throws AssertionError,
            Exception
    {
        super.testFailureInvalidEstimatedFinishDate(milestone);
    }

    public void testFailureValidationMax() throws AssertionError, Exception
    {
        super.testFailureValidationMax(milestone);
    }

    public void testFailureValidationMin() throws AssertionError, Exception
    {
        super.testFailureValidationMin(milestone);
    }

    public void testInsertWithoutMandatoryFields() throws AssertionError,
            Exception
    {
        super.testInsertWithoutMandatoryFields(milestone);
    }

    public void testInsertWithoutParent() throws AssertionError, Exception
    {
        super.testInsertWithoutParent(milestone);

    }

    public void testInsertWithParentWorkOrganization() throws AssertionError,
            Exception
    {
        super.testInsertWithParentWorkOrganization(milestone);
    }

    public void testInsertWithParentWorkProduct() throws AssertionError,
            Exception
    {
        super.testInsertWithParentWorkProduct(milestone);
    }

    public void testInsertWithParentSummaryTask() throws AssertionError,
            Exception
    {
        super.testInsertWithParentSummaryTask(milestone);
    }

    public void testInsertWithParentDeliverable() throws AssertionError,
            Exception
    {
        super.testInsertWithParentDeliverable(milestone);
    }

    public void testInsertWithParentProposal() throws AssertionError, Exception
    {
        super.testInsertWithParentProposal(milestone);
    }

    public void testInsertWithParentProject() throws AssertionError, Exception
    {
        super.testInsertWithParentProject(milestone);
    }

    public void testSuccessValidationMax() throws AssertionError, Exception
    {
        super.testSuccessValidationMax(milestone);
    }

    public void testSuccessValidationMin() throws AssertionError, Exception
    {
        super.testSuccessValidationMin(milestone);
    }

    public void testFailureInvalidState() throws AssertionError, Exception
    {
        super.testFailureInvalidState(milestone);
    }

    public void testSuccessValidState() throws AssertionError, Exception
    {
        super.testSuccessValidState(milestone);
    }

    public void testFailureInvalidTimeCodes() throws AssertionError, Exception
    {
        super.testFailureInvalidTimeCodes(milestone);
    }

    public void testFailureEffortDrivenWithDefaultTask() throws AssertionError,
            Exception
    {
        super.testFailureEffortDrivenWithDefaultTask(milestone);
    }
    
    public void testReadOnlyFields() throws Exception
    {
        milestone
            .setName(getTestString(ValidationConstants.PROJECT_NAME_CHARACTER_LIMIT));
        milestone.setParent(WorkElementFixture.retrieveStaticFixture(
            new Project(), this));
        
        super.testReadOnlyFields(milestone);
    }
}
