package com.ibm.rpm.client.junit.wbs.testcases.xpath;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author njarazi
 */
public class TestProjectXPath extends ObjectXPathTester
{
    protected RPMObject createObject() throws Exception
    {
        WorkElementScope scope = (WorkElementScope) mainScope;
        WorkElement work = WorkElementFixture.createFixture(new Project(), 
                scope, this);
        return work;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        return WorkElementFixture.createScope(new Project(), true,
            false, false, false, false, false, false, false, false, 
            false, false, false, false, false,false);
    }

    protected void objectCompare(RPMObject expected, RPMObject actual,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        WorkElementFixture.compare((WorkElement)expected, (WorkElement)actual, (WorkElementScope)mainScope);
    }
    
    protected ArrayList generateLocalSkipList()
    {
        ArrayList l = new ArrayList();

        l.add("getAssignmentType");
        l.add("getDefaultProject");
        l.add("getPublished");
        l.add("getEarnedValuesCalculationState");
        // cannot load from xpath on lastModifiedDate without including
        // the time portion of the date - see Test56934
        l.add("getLastModifiedDate");
        
        l.trimToSize();
        return l;
    }
}