/*
 * Created on Feb 20, 2006
 */
package com.ibm.rpm.client.junit.wbs.testcases.xpath;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.contract.fixtures.ContractFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.ResourceTaskAssignmentFixture;
import com.ibm.rpm.contract.containers.Contract;
import com.ibm.rpm.contract.scope.ContractScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.wbs.containers.ResourceTaskAssignment;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;

/**
 * @author ikusakov
 */
public class TestResourceTaskAssignmentAffectXPath  extends ClientTestController
{
    ResourceTaskAssignment assignment = null;

    public void setUp() throws Exception
    {
        logger.info("setUp");
        super.setUp();
        
        ResourceTaskAssignmentScope scope = ResourceTaskAssignmentFixture
    		.createScope(true, true, false, true, true);
        assignment = ResourceTaskAssignmentFixture.createSaveFixture(scope, false, this);        
    }
    
    public void testTaskAssignmentIntegration() throws Exception 
    {        
        // getJoinCondition
        RPMObject[] result = loadFromXpath("/ResourceTaskAssignment[ID='" 
                + assignment.getID()
                + "']/TaskAssignment", null);
        
        assertNotNull(result);
        assertEquals("Should be only one TaskAssignment", 1 , result.length);
        assertEquals("ResourceTaskAssignment not found", assignment.getTaskAssignment().getID(), result[0].getID());
        
        // getSubtableJoinCondition
        result = loadFromXpath("/ResourceTaskAssignment["         
                + "TaskAssignment[ID='" 
                + assignment.getTaskAssignment().getID()+ "']]", null);
        
        assertNotNull(result);
        assertEquals("Should be only one ResourceTaskAssignment", 1 , result.length);
        assertEquals("ResourceTaskAssignment not found", assignment.getID(), result[0].getID());        
    }
    
   
    public void testContractIntegration() throws Exception 
    {
        Contract contract = ContractFixture.createSaveFixture(this);
        assertNotNull(contract);

        // adding Contract/saving TaskAssignment
        assignment.getTaskAssignment().setContract(contract);
        TaskAssignmentScope scope = new TaskAssignmentScope();
        scope.setContract(new ContractScope());
        save(assignment.getTaskAssignment(), scope);        

        // getJoinCondition
        RPMObject[] result = loadFromXpath("/TaskAssignment[ID='" 
                + assignment.getTaskAssignment().getID()
                + "']/Contract", null);
        
        assertNotNull(result);
        assertEquals("Should be only one Contract", 1 , result.length);
        assertEquals("Contract not found", contract.getID(), result[0].getID());
        
        // getSubtableJoinCondition
        result = loadFromXpath("/TaskAssignment["         
                + "Contract[ID='" 
                + contract.getID()+ "']]", null);
        
        assertNotNull(result);
        assertEquals("Should be only one TaskAssignment", 1 , result.length);
        assertEquals("TaskAssignment not found", assignment.getTaskAssignment().getID(), result[0].getID());        
    }    
}
