/*
 * Created on Feb 20, 2006
 */
package com.ibm.rpm.client.junit.wbs.testcases.xpath;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.ResourceTaskAssignmentFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.wbs.containers.ResourceTaskAssignment;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;

/**
 * @author ikusakov
 */
public class TestResourceTaskAssignmentAssignXPath extends ClientTestController
{
    ResourceTaskAssignment assignment = null;

    public void setUp() throws Exception
    {
        logger.info("setUp");
        super.setUp();

        ResourceTaskAssignmentScope scope = ResourceTaskAssignmentFixture
                .createScope(true, false, false, true, true);
        assignment = ResourceTaskAssignmentFixture.createSaveFixture(scope,
            false, this);
    }

    public void testWbsIntegration() throws Exception
    {
        // getJoinCondition
        RPMObject[] result = loadFromXpath("/WorkElement[ID='"
                + assignment.getParent().getID() + "']/ResourceTaskAssignment",
                null);

        assertNotNull(result);
        assertTrue(result.length > 0);

        boolean found = false;
        for (int i = 0; i < result.length; i++)
        {
            if (result[i].getID().equals(assignment.getID()))
            {
                found = true;
                break;
            }
        }

        assertTrue("ResourceTaskAssignment was not found", found);

        // getSubtableJoinCondition
        result = loadFromXpath("/WorkElement[" + "ResourceTaskAssignment[ID='"
                + assignment.getID() + "']]", null);

        assertNotNull(result);
        assertTrue(result.length == 1);
        assertEquals("WorkElement not found", assignment.getParent().getID(),
                result[0].getID());
    }

    public void testResourceIntegration() throws Exception
    {

        // getJoinCondition from ResourceTaskAssignment
        RPMObject[] result = loadFromXpath("/ResourceTaskAssignment[ID='"
                + assignment.getID() + "']/Resource", null);

        assertNotNull(result);
        assertTrue(result.length > 0);

        boolean found = false;
        for (int i = 0; i < result.length; i++)
        {
            if (result[i].getID().equals(assignment.getResource().getID()))
            {
                found = true;
                break;
            }
        }

        assertTrue("Resource was not found", found);

        // getSubtableJoinCondition from ResourceTaskAssignment
        result = loadFromXpath("/ResourceTaskAssignment[" + "Resource[ID='"
                + assignment.getResource().getID() + "']]", null);

        assertNotNull(result);
        assertTrue(result.length > 0);

        found = false;
        for (int i = 0; i < result.length; i++)
        {
            if (result[i].getID().equals(assignment.getID()))
            {
                found = true;
                break;
            }
        }
        assertTrue("ResourceTaskAssignment was not found", found);
    }
}
