/*
 * Created on Feb 20, 2006
 */
package com.ibm.rpm.client.junit.wbs.testcases.xpath;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.ResourceTaskAssignmentFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.wbs.containers.ResourceTaskAssignment;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;

/**
 * @author ikusakov
 */
public class TestResourceTaskAssignmentProfileXPath extends ClientTestController
{
    ResourceTaskAssignment assignment = null;

    public void setUp() throws Exception
    {
        logger.info("setUp");
        super.setUp();

        ResourceTaskAssignmentScope scope = ResourceTaskAssignmentFixture
                .createScope(true, true, true, false, true);
        assignment = ResourceTaskAssignmentFixture.createSaveFixture(scope, false, this);
    }
    
    public void testProfileIntegration() throws Exception 
    {        
        
        // getJoinCondition from ResourceTaskAssignment
        RPMObject[] result = loadFromXpath("/ResourceTaskAssignment[ID='" 
                + assignment.getID()
                + "']/Profile", null);
        
        assertNotNull(result);
        assertTrue(result.length > 0);
        
        boolean found = false;
        for (int i = 0; i < result.length; i++) {
            if (result[i].getID().equals(assignment.getProfile().getID())) {
                found = true;
                break;
            }
        }
        
        assertTrue("Profile was not found", found);
        
        // getSubtableJoinCondition from ResourceTaskAssignment
        result = loadFromXpath("/ResourceTaskAssignment["         
                + "Profile[ID='" 
                + assignment.getProfile().getID()+ "']]", null);
        
        assertNotNull(result);
        assertTrue(result.length > 0);
        
        found = false;
        for (int i = 0; i < result.length; i++) {
            if (result[i].getID().equals(assignment.getID())) {
                found = true;
                break;
            }
        }
        assertTrue("ResourceTaskAssignment was not found", found);
    }    
}
