package com.ibm.rpm.client.junit.wbs.testcases.xpath;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.wbs.containers.TaskAssignment;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;

public class TestTaskAssignmentObjectXPath extends ObjectXPathTester
{
    protected RPMObject createObject() throws Exception
    {
        TaskAssignmentScope scope = (TaskAssignmentScope) mainScope;
        TaskAssignment assignment = TaskAssignmentFixture.createSaveFixture(
                scope, this);
        return assignment;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        return TaskAssignmentFixture.createScope(true, true, true, true);
    }

    protected void objectCompare(RPMObject expected, RPMObject actual,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        TaskAssignmentFixture.compare((TaskAssignment) expected,
                (TaskAssignment) actual, (TaskAssignmentScope) mainScope);
    }
    
    protected ArrayList generateLocalSkipList()
    {
        ArrayList l = new ArrayList();

        l.add("getBaselineWork");
        l.add("getWorkSchedule");
        l.add("getEETCHours");
        l.add("getActualWork");
        l.add("getAssignmentStartDate");
        l.add("getAssignmentFinishDate");
        l.add("getBillable");
        l.add("getCostPerHour");
        l.add("getDaysOfDelay");
        l.add("getDefaultLabor");
        l.add("getExpectedStartDate");
        l.add("getExpectedFinishDate");
        l.add("getExpectedWork");
        l.add("getLastScheduleWork");
        l.add("getPercentageComplete");
        l.add("getComplete");
        l.add("getPercentageRateAdjustment");
        l.add("getPercentageWork");
        l.add("getPlannedDurationHours");
        l.add("getProposedDurationHours");
        l.add("getRemainingHours");
        l.add("getSellingRatePerHour");
        l.add("getSpecialCostPerHour");
        l.add("getSpecialSellingRatePerHour");
        l.add("getUnitsPercentage");
        l.add("getShownInTimesheet");
        
//        l.add("getRemaining");
//        l.add("getEAC");
//        l.add("getEACVariance");
//        l.add("getETC");
//        l.add("getActual");
//        l.add("getBaselineVariance");
//        l.add("getEstimate");
//        l.add("getProbabilityAmount");
//        l.add("getRevRecType");
//        l.add("getTimePhased");        
        
        l.trimToSize();
        return l;
    }
}
