/*
 * Created on 13-Oct-2006
 * @author mmatwiy
 * Comparison methods for WorkflowRoleMapping containers.
 */
package com.ibm.rpm.client.junit.workflow.fixtures;

import junit.framework.Assert;
import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.applicationadministration.fixtures.ContactGroupFixture;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.SecurityRoleFixture;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.client.junit.resource.fixtures.ResourceFixture;
import com.ibm.rpm.workflow.containers.WorkflowRoleMapping;
import com.ibm.rpm.workflow.scope.WorkflowRoleMappingScope;

public class WorkflowRoleMappingFixture extends RPMObjectFixture
{
    public static void compare(WorkflowRoleMapping w1, WorkflowRoleMapping w2,
            WorkflowRoleMappingScope scope) throws AssertionFailedError,
            Exception
    {
        compare(w1, w2);
        compare(w1.getWorkflowRole(), w2.getWorkflowRole());

        if (scope != null)
        {
            if (scope.getParent() != null)
            {
                if ((w1.getParent() == null && w2.getParent() != null)
                        || (w1.getParent() != null && w2.getParent() == null))

                {
                    Assert
                        .fail("One of the WorkflowRoleMapping's parents is null and the other is not.");
                }

                if (w1.getParent() != null && w2.getParent() != null)
                {
                    Assert.assertEquals(w1.getParent().getClass(), w2
                        .getParent().getClass());
                    Assert.assertEquals(w1.getParent().getID(), w2.getParent()
                        .getID());
                }
            }

            if (scope.getSecurityRole() != null)
            {
                SecurityRoleFixture.compare(w1.getSecurityRole(), w2
                    .getSecurityRole());
            }

            if (scope.getContactGroup() != null)
            {
                ContactGroupFixture.compare(w1.getContactGroup(), w2
                    .getContactGroup());
            }

            if (scope.getResource() != null)
            {
                ResourceFixture.compare(w1.getResource(), w2.getResource());
            }
        }        
    }
}