/*
 * Created on 4-Oct-2006
 * @author mmatwiy
 * Xpath tests for container AvailableWorkflowProcess.
 */
package com.ibm.rpm.client.junit.workflow.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.client.junit.workflow.fixtures.WorkflowFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.wbs.containers.WorkOrganization;
import com.ibm.rpm.wbs.scope.WorkElementScope;
import com.ibm.rpm.workflow.containers.AvailableWorkflowProcess;
import com.ibm.rpm.workflow.containers.WorkflowProcess;
import com.ibm.rpm.workflow.scope.AvailableWorkflowProcessScope;
import com.ibm.rpm.workflow.scope.WorkflowScope;

public class TestAvailableWorkflowProcessXpath extends ObjectXPathTester
{
    private static final String PROCESS_NAME = "ProjectProcess1";

    protected RPMObject createObject() throws Exception
    {
        AvailableWorkflowProcessScope scope = (AvailableWorkflowProcessScope) mainScope;

        WorkElementScope workElementScope = new WorkElementScope();
        workElementScope.setWorkflowProcessesAvailable(scope);

        WorkOrganization workOrganization = (WorkOrganization) WorkElementFixture
            .createSaveFixture(new WorkOrganization(), null, this);

        //TODO: replace this load once the API is able to create a WorkflowProcess
        RPMObject[] objects = loadFromXpath("/WorkflowProcess[name='"
                + PROCESS_NAME + "']", scope.getChildren());
        assertNotNull(objects);
        assertTrue(objects[0] instanceof WorkflowProcess);

        // associate the WorkflowProcess to the WorkOrganization
        getApplicationInterface().associateWorkflow(getSessionID(),
            (WorkflowProcess) objects[0], workOrganization, true, true);

        // reload the WorkOrganization to get the list of available workflow processes
        workOrganization = (WorkOrganization) loadFromID(workOrganization,
            workElementScope);
        assertNotNull(workOrganization.getWorkflowProcessesAvailable());
        assertNotNull(workOrganization.getWorkflowProcessesAvailable()[0]);

        return workOrganization.getWorkflowProcessesAvailable()[0];
    }

    protected RPMObjectScope createScope() throws Exception
    {
        WorkflowScope workflowScope = new WorkflowScope();
        workflowScope.setChildren(new WorkflowScope());
        workflowScope.setParent(new WorkflowScope());
        
        AvailableWorkflowProcessScope availableScope = new AvailableWorkflowProcessScope();
        availableScope.setChildren(workflowScope);

        return availableScope;
    }

    protected void objectCompare(RPMObject expected, RPMObject actual,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        WorkflowFixture.compare((AvailableWorkflowProcess) expected,
            (AvailableWorkflowProcess) actual, (AvailableWorkflowProcessScope) scope);
    }

}