/*
 * Created on 3-Oct-2006
 * @author mmatwiy
 * Xpath tests for container WorkflowGroup.
 */
package com.ibm.rpm.client.junit.workflow.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.workflow.fixtures.WorkflowFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.workflow.containers.WorkflowGroup;
import com.ibm.rpm.workflow.scope.WorkflowScope;

public class TestWorkflowGroupXpath extends ObjectXPathTester
{
    private static final String GROUP_ID = "ISSUE";

    protected RPMObject createObject() throws Exception
    {
        WorkflowScope scope = (WorkflowScope) mainScope;

        RPMObject[] objects = loadFromXpath("/WorkflowGroup[id='"
                + GROUP_ID + "']", scope);
        assertNotNull(objects);
        return objects[0];
    }

    protected RPMObjectScope createScope() throws Exception
    {
        WorkflowScope scope = new WorkflowScope();
        scope.setChildren(new WorkflowScope());
        scope.setParent(new WorkflowScope());

        return scope;
    }

    protected void objectCompare(RPMObject expected, RPMObject actual,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        WorkflowFixture.compare((WorkflowGroup) expected,
            (WorkflowGroup) actual, (WorkflowScope) mainScope);
    }

}