/*
 * Created on 3-Oct-2006
 * @author mmatwiy
 * Xpath tests for container WorkflowProcess.
 */
package com.ibm.rpm.client.junit.workflow.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.workflow.fixtures.WorkflowFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.workflow.containers.WorkflowProcess;
import com.ibm.rpm.workflow.scope.WorkflowScope;

public class TestWorkflowProcessXpath extends ObjectXPathTester
{
    private static final String PROCESS_NAME = "ProjectProcess1";

    protected RPMObject createObject() throws Exception
    {
        WorkflowScope scope = (WorkflowScope) mainScope;

        //TODO: replace this load once the API is able to create a WorkflowProcess
        RPMObject[] objects = loadFromXpath("/WorkflowProcess[name='"
                + PROCESS_NAME + "']", scope);
        assertNotNull(objects);
        return objects[0];
    }

    protected RPMObjectScope createScope() throws Exception
    {
        WorkflowScope scope = new WorkflowScope();
        scope.setChildren(new WorkflowScope());
        scope.setParent(new WorkflowScope());

        return scope;
    }

    protected void objectCompare(RPMObject expected, RPMObject actual,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        WorkflowFixture.compare((WorkflowProcess) expected,
            (WorkflowProcess) actual, (WorkflowScope) mainScope);
    }

}