package com.ibm.rpm.client.junit.xpath.testcases;

import com.ibm.rpm.applicationadministration.containers.Attribute;
import com.ibm.rpm.applicationadministration.scope.AttributeScope;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.AttributeFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WbsModuleFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WbsModuleScope;

/**
 * @author Genevieve
 *  
 */
public class TestSingleOccurenceWithMultipleContext extends ClientTestController
{

    private WbsModule module = null;
    Attribute attribute = null;
    
    public void setUp() throws Exception
    {
        super.setUp();
        
        AttributeScope attrScope = AttributeFixture.createScope(1, 1, 1, 1, 1);
        WbsModuleScope scope = new WbsModuleScope();                
        scope.setAttributeCategories(attrScope);

        module = WbsModuleFixture.createFixture(scope, this);
        module = (WbsModule)save(module, scope).getRpmObject();
        attribute = module.getAttributeCategories()[0].getClassifications()[0].getAttributes()[0];

    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testLoadAttributeXpath() throws Exception
    {

        RPMObject[] objects = loadFromXpath("/Attribute[id = '"
                + attribute.getID() + "']", null);

        assertNotNull(objects);
        assertEquals(objects.length, 1);
    }
}
