package com.ibm.rpm.client.junit.xpath.testcases;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.util.DateUtil;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Genevieve
 *  
 */
public class WbsScheduleDateXPath extends ClientTestController
{

    Project project = new Project();

    WorkElementScope scope = null;

    public void setUp() throws Exception
    {
        super.setUp();
        scope = new WorkElementScope();
        scope.setScheduleDates(true);
        project = (Project) WorkElementFixture.createSaveFixture(project, scope,
            this);

    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testProjectWithExpectedDate() throws Exception
    {

        String expectedDateStart = DateUtil.convertToStringWithTime(project
            .getExpectedDate().getStartDate());

        String xpath = "/Project[name = '" + project.getName()
                + "'][expectedDate[startDate > '" + expectedDateStart + "']]";
        
        RPMObject[] objects = loadFromXpath(xpath, scope);

        assertNotNull(objects);

    }
}
