/*
 * Created on Nov 3, 2005 @author mmatwiy
 * 
 * Sets up a list of valid parents and calls the superclass. If there was
 * specific Client Folder validation, it would be done here.
 */
package com.ibm.rpm.clientcostcenters.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.clientcostcenters.containers.ClientFolder;
import com.ibm.rpm.clientcostcenters.containers.ClientModule;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

public class ClientFolderCheckpoint extends GenericClientCheckpoint
{
    private static final List CLIENTFOLDER_PARENT_LIST = new ArrayList();

    protected static ClientFolderCheckpoint instance = new ClientFolderCheckpoint();

    static
    {
        CLIENTFOLDER_PARENT_LIST.add(ClientModule.class);
        CLIENTFOLDER_PARENT_LIST.add(ClientFolder.class);
    }

    public static ClientFolderCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, msgCtx, false, CLIENTFOLDER_PARENT_LIST);
    }
}
