package com.ibm.rpm.communications.constants;

public class ErrorCodes
{

    /**
     * Validation error codes for communication containers. Error code range:
     * 411,001 - 412,000 411,001 - 411,299: validation codes 411,300 - 411,499:
     * xpath codes 411,500 + : manager codes
     * 
     * These error messages usually have the container name at the beginning.
     * The className of the RPMException will be a container. All validation
     * errors that can be thrown to an end user should be of this type.
     */

    public final static int CANNOT_MOVE_TO_FOLDER = 411001;

    public final static int NO_DUPLICATE_RECIPIENTS = 411002;

    public final static int CANNOT_DELETE_COMMUNICATION = 411003;
    
    public final static int ALL_CHECKLIST_ITEMS_MUST_BE_COMPLETE = 411004;

    public final static int ONLY_ONE_VOTE_RESPONSE_REASON_CAN_BE_SELECTED = 411005;
    
    public final static int WARNING_EFFORT_IS_READ_ONLY = 411006;
    
    public final static int NO_SEND_RESPONSE = 411500;
    
    public final static int NO_SAVE_RESPONSE = 411501;
}