package com.ibm.rpm.communications.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class WorkflowResponseState implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected WorkflowResponseState(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _NotComplete = "NotComplete";
	public static final WorkflowResponseState NotComplete = new WorkflowResponseState(_NotComplete);
	
		
	public static final String _Rejected = "Rejected";
	public static final WorkflowResponseState Rejected = new WorkflowResponseState(_Rejected);
	
		
	public static final String _Accepted = "Accepted";
	public static final WorkflowResponseState Accepted = new WorkflowResponseState(_Accepted);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static WorkflowResponseState fromValue(String value) throws IllegalStateException {
		WorkflowResponseState retVal = (WorkflowResponseState) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static WorkflowResponseState fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof WorkflowResponseState && ordinal == ((WorkflowResponseState)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((WorkflowResponseState)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final WorkflowResponseState[] VALUES = {NotComplete, Rejected, Accepted};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}