/*
 * Created on January 3, 2006
 * @author mmatwiy
 * Validation constants for Contracts
 */
package com.ibm.rpm.contract.constants;

import java.util.Calendar;

import com.ibm.rpm.framework.util.DateUtil;


public class ValidationConstants
{
    public final static String PARENT = "parent";
    
    // field names
    public final static String NAME_FIELD = "name";
    public final static String DESCRIPTION_FIELD = "description";
    public final static String EXTERNAL_REFERENCE_FIELD = "externalReference";
    public final static String MAXIMUM_AMOUNT_FIELD = "maximumAmount";
    public final static String AMOUNT_FIELD = "amount";
    public final static String SCHEDULE_DATE_FIELD = "scheduleDate";
    public final static String CONTRACT_TYPE_FIELD = "contractType";

    // maximum values
    public final static int NAME_MAX = 50;
    public final static int DESCRIPTION_MAX = 255;
    public final static int EXTERNAL_REFERENCE_MAX = 32;
    public final static double MAXIMUM_AMOUNT_MAX = 9999999999999.99;
    public final static double AMOUNT_MAX = 9999999999999.99;
    public final static Calendar SCHEDULE_DATE_MAX;
    public final static Calendar SCHEDULE_DATE_MIN;
    
    // minimum values
    public final static int NAME_MIN = 1;
    public final static double MAXIMUM_AMOUNT_MIN = 0.00;
    public final static double AMOUNT_MIN = 0.00;
    
    // contract field names
    public final static String CURRENCY_FIELD = "currency";
    public final static String CHARGE_SCHEDULES_FIELD = "chargeSchedules";
    
    // contractFolder field names
    public final static String CHILDREN_FIELD = "children";
    
    // contractModule field names
    public final static String CONTRACTS_FIELD = "contracts";
    public final static String CONTRACT_TYPES_FIELD = "contractTypes";
    
    static
    {
        SCHEDULE_DATE_MAX = DateUtil.getCalendarInstance();
	    SCHEDULE_DATE_MAX.set(9999, 11, 31, 23, 59, 59);
	    SCHEDULE_DATE_MAX.set(Calendar.MILLISECOND, 0);
	
	    SCHEDULE_DATE_MIN = DateUtil.getCalendarInstance();
	    SCHEDULE_DATE_MIN.set(1900, 0, 1, 0, 0, 0);
	    SCHEDULE_DATE_MIN.set(Calendar.MILLISECOND, 0);
    }
}
