package com.ibm.rpm.customfield.constants;

public class ErrorCodes
{

    /**
     * Error codes for custom field containers.
     * Error code range: 409,001 - 410,000
     * 409,001 - 409,299: validation codes
     * 409,300 - 409,499: xpath codes
     * 409,500 + : manager codes
     * 
     * These error messages usually have the container name at the beginning. 
     * The className of the RPMException will be a container.
     * All validation errors that can be thrown to an end user should
     * be of this type.
     */
    
    // validation errors
    public final static int NULL_CATEGORY_WITH_NON_NULL_VALUE = 409001;
    
    public final static int DATAFIELD_NOT_IN_CATEGORY = 409002;
    
    public final static int INVALID_CUSTOM_FIELD = 409003;
    
    
    // xpath errors
    
    
    // manager errors
    public final static int INVALID_CUSTOM_FIELD_VALUE_IN_DATABASE = 409501;

    public final static int INVALID_CUSTOM_FIELD_TYPE_IN_DATABASE = 409502;
}