/*
 * Created on Oct 18, 2006
 */
package com.ibm.rpm.customfield.types;

import java.util.HashMap;
import java.util.Map;

import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.constants.ErrorCodes;
import com.ibm.rpm.framework.types.SeverityLevel;

public class GroupTypeToDBMap
{
    private static Map groupTypeToDBMap;

    private static Map dbToGroupTypeMap;

    static
    {
        groupTypeToDBMap = new HashMap();
        dbToGroupTypeMap = new HashMap();

        addToMap(CustomPortletCategoryGroupType.AssetGroup, 9);
        addToMap(CustomPortletCategoryGroupType.ClientGroup, 11);
        addToMap(CustomPortletCategoryGroupType.DeliverableGroup, 2);
        addToMap(CustomPortletCategoryGroupType.DocumentGroup, 14);
        addToMap(CustomPortletCategoryGroupType.ProjectGroup, 1);
        addToMap(CustomPortletCategoryGroupType.ResourceGroup, 13);
        addToMap(CustomPortletCategoryGroupType.ScopeGroup, 4);
        addToMap(CustomPortletCategoryGroupType.TaskGroup, 3);
    }

    private static void addToMap(CustomPortletCategoryGroupType gt, int dbCode)
    {
        Integer codeObject = new Integer(dbCode);
        groupTypeToDBMap.put(gt, codeObject);
        dbToGroupTypeMap.put(codeObject, gt);
    }

    public static Integer toDBCode(CustomPortletCategoryGroupType gt)
            throws RPMException
    {
        Integer value = (Integer) groupTypeToDBMap.get(gt);
        if (value == null)
        {
            String[] errorParams =
            {
                "Unknown CustomPortletCategoryGroupType " + gt.toString()
            };
            throw new RPMException(ErrorCodes.INTERNAL_ERROR, errorParams);
        }
        return value;
    }

    public static CustomPortletCategoryGroupType toGroupType(int dbCode)
            throws RPMException
    {
        Integer key = new Integer(dbCode);
        CustomPortletCategoryGroupType value = (CustomPortletCategoryGroupType) dbToGroupTypeMap
            .get(key);
        if (value == null)
        {
            String[] errorParams =
            {
                key.toString()
            };

            RPMException rpmEx = new RPMException(
                com.ibm.rpm.customfield.constants.ErrorCodes.INVALID_CUSTOM_FIELD_TYPE_IN_DATABASE,
                errorParams);
            rpmEx.setSeverity(SeverityLevel.Error);

            throw rpmEx;
        }
        return value;
    }
}
