/*
 * Created on 16-Nov-2005
 */
package com.ibm.rpm.document.checkpoints;

import com.ibm.rpm.document.constants.ValidationConstants;
import com.ibm.rpm.document.containers.UrlDocument;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;

/**
 * @author dominiqu
 */
public class URLCheckpoint extends AbstractDocumentCheckpoint
{
    protected static URLCheckpoint URLinstance = new URLCheckpoint();

    public static AbstractDocumentCheckpoint getInstance()
    {
        return URLinstance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx);

        // Initialize
        UrlDocument mainURL = (UrlDocument) rpmObject;

        // Field validation: processLink and RUPLink
        if (mainURL.testProcessLinkModified() || mainURL.testRUPLinkModified())
        {
            GenericValidator.validateBooleanDependancy(mainURL, "processLink",
                mainURL.getProcessLink(), true, "RUPLink", mainURL.getRUPLink(), false,
                msgCtx);
            GenericValidator.validateBooleanDependancy(mainURL, "RUPLink",
                mainURL.getRUPLink(), true, "processLink", mainURL.getProcessLink(),
                false, msgCtx);
        }

        // Field validation: url
        if (mainURL.testUrlModified())
        {
            GenericValidator.validateMaxLength(mainURL, "url", mainURL
                .getUrl(), ValidationConstants.URL_MAX, msgCtx);
        }
    }
    
}
