package com.ibm.rpm.document.constants;

public class ErrorCodes
{

    /**
     * Validation error codes for document containers.
     * Error code range: 402,001 - 403,000
     * 402,001 - 402,299: validation codes
     * 402,300 - 402,499: xpath codes
     * 402,500 + : manager codes
     * 
     * These error messages usually have the container name at the beginning. 
     * The className of the RPMException will be a container.
     * All validation errors that can be thrown to an end user should
     * be of this type.
     */
    
    public final static int WRONG_DOCUMENT_ELEMENT_TYPE = 402001;
    
    public final static int EXCEPTION_LOCKING_CHECKEDOUT_DOC = 402002;
    
    public final static int EXCEPTION_DOC_ALREADY_LOCKED	= 402003;
    
    public static final int EXCEPTION_DOC_ALREADY_UNLOCKED	= 402004;

}