
package com.ibm.rpm.document.managers;

import java.util.HashMap;
import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.ibm.rpm.framework.util.ContextUtil;

public class DocumentUtil {

    private static Log logger = LogFactory.getLog(DocumentUtil.class);

    private Map tableNameByContext = new HashMap();
    private Map tableTypeByContext = new HashMap();

    private Map historyTableNameByContext = new HashMap();
    
    
    private static DocumentUtil singleton = new DocumentUtil();

    /**
     *  
     */
    private DocumentUtil()
    {
         init();     
    }
    
    synchronized public static DocumentUtil getInstance()
    {
        return singleton;
    } 
    
    private void init(){
        tableNameByContext.put(ContextUtil.NONE, "TMT_DOCUMENTS");
        
    	tableNameByContext.put(ContextUtil.ASSET_DOCUMENT_CONTEXT, "TMT_ASSET_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.ASSET_DOCUMENT_CONTEXT, new Integer(14));
    	tableNameByContext.put(ContextUtil.CLIENT_DOCUMENT_CONTEXT, "TMT_CLIENT_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.CLIENT_DOCUMENT_CONTEXT, new Integer(15));
    	tableNameByContext.put(ContextUtil.UMBRELLA_DOCUMENT_CONTEXT, "TMT_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.UMBRELLA_DOCUMENT_CONTEXT, new Integer(4));
    	tableNameByContext.put(ContextUtil.SCOPE_DOCUMENT_CONTEXT, "TMT_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.SCOPE_DOCUMENT_CONTEXT, new Integer(4));
    	tableNameByContext.put(ContextUtil.WBS_DOCUMENT_CONTEXT, "TMT_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.WBS_DOCUMENT_CONTEXT, new Integer(4));
    	tableNameByContext.put(ContextUtil.RESOURCE_DOCUMENT_CONTEXT, "TMT_RESOURCE_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.RESOURCE_DOCUMENT_CONTEXT, new Integer(13));
    	tableNameByContext.put(ContextUtil.POOL_DOCUMENT_CONTEXT, "TMT_POOL_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.POOL_DOCUMENT_CONTEXT, new Integer(12));
    	// TODO: TMT_VENDOR_DOCUMENTS
    	
    	//parent contexts
    	tableNameByContext.put(ContextUtil.ASSET_CONTEXT, "TMT_ASSET_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.ASSET_CONTEXT, new Integer(14));
    	tableNameByContext.put(ContextUtil.CLIENT_CONTEXT, "TMT_CLIENT_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.CLIENT_CONTEXT, new Integer(15));
    	tableNameByContext.put(ContextUtil.SCOPE_CONTEXT, "TMT_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.SCOPE_CONTEXT, new Integer(4));
    	tableNameByContext.put(ContextUtil.WBS_CONTEXT, "TMT_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.WBS_CONTEXT, new Integer(4));
    	tableNameByContext.put(ContextUtil.RESOURCE_CONTEXT, "TMT_RESOURCE_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.RESOURCE_CONTEXT, new Integer(13));
    	tableNameByContext.put(ContextUtil.POOL_CONTEXT, "TMT_POOL_DOCUMENTS");
    	tableTypeByContext.put(ContextUtil.POOL_CONTEXT, new Integer(12));
    	
    	// For Document History
    	historyTableNameByContext.put(ContextUtil.ASSET_DOCUMENT_CONTEXT, "HISTORY_ASSET_DOCUMENTS");
    	historyTableNameByContext.put(ContextUtil.CLIENT_DOCUMENT_CONTEXT, "HISTORY_CLIENT_DOCUMENTS");
    	historyTableNameByContext.put(ContextUtil.UMBRELLA_DOCUMENT_CONTEXT, "HISTORY_DOCUMENTS");
    	historyTableNameByContext.put(ContextUtil.SCOPE_DOCUMENT_CONTEXT, "HISTORY_DOCUMENTS");
    	historyTableNameByContext.put(ContextUtil.WBS_DOCUMENT_CONTEXT, "HISTORY_DOCUMENTS");
    	historyTableNameByContext.put(ContextUtil.RESOURCE_DOCUMENT_CONTEXT, "HISTORY_RESOURCE_DOCUMENTS");
    	// TODO: HISTORY_POOL_DOCUMENTS, HISTORY_VENDOR_DOCUMENTS
    }
    
    public String getTableName(String contextName){
    	return (String) tableNameByContext.get(contextName);
    }
    public Integer getTableType(String contextName){
    	return (Integer) tableTypeByContext.get(contextName);
    }

    public String getHistoryTableName(String contextName){
    	return (String) historyTableNameByContext.get(contextName);
    }
 
}
