package com.ibm.rpm.document.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class DocumentLinkingStatus implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected DocumentLinkingStatus(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _IsLink = "IsLink";
	public static final DocumentLinkingStatus IsLink = new DocumentLinkingStatus(_IsLink);
	
		
	public static final String _IsReferenced = "IsReferenced";
	public static final DocumentLinkingStatus IsReferenced = new DocumentLinkingStatus(_IsReferenced);
	
		
	public static final String _IsNotReferenced = "IsNotReferenced";
	public static final DocumentLinkingStatus IsNotReferenced = new DocumentLinkingStatus(_IsNotReferenced);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static DocumentLinkingStatus fromValue(String value) throws IllegalStateException {
		DocumentLinkingStatus retVal = (DocumentLinkingStatus) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static DocumentLinkingStatus fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof DocumentLinkingStatus && ordinal == ((DocumentLinkingStatus)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((DocumentLinkingStatus)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final DocumentLinkingStatus[] VALUES = {IsLink, IsReferenced, IsNotReferenced};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}