package com.ibm.rpm.financial.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class BudgetType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected BudgetType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Calendar = "Calendar";
	public static final BudgetType Calendar = new BudgetType(_Calendar);
	
		
	public static final String _Actual = "Actual";
	public static final BudgetType Actual = new BudgetType(_Actual);
	
		
	public static final String _Estimate = "Estimate";
	public static final BudgetType Estimate = new BudgetType(_Estimate);
	
		
	public static final String _Baseline = "Baseline";
	public static final BudgetType Baseline = new BudgetType(_Baseline);
	
		
	public static final String _BaselinePrevious = "BaselinePrevious";
	public static final BudgetType BaselinePrevious = new BudgetType(_BaselinePrevious);
	
		
	public static final String _BaselineInitial = "BaselineInitial";
	public static final BudgetType BaselineInitial = new BudgetType(_BaselineInitial);
	
		
	public static final String _GL = "GL";
	public static final BudgetType GL = new BudgetType(_GL);
	
		
	public static final String _Billed = "Billed";
	public static final BudgetType Billed = new BudgetType(_Billed);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static BudgetType fromValue(String value) throws IllegalStateException {
		BudgetType retVal = (BudgetType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static BudgetType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof BudgetType && ordinal == ((BudgetType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((BudgetType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final BudgetType[] VALUES = {Calendar, Actual, Estimate, Baseline, BaselinePrevious, BaselineInitial, GL, Billed};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}