package com.ibm.rpm.financial.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class TimePhasedType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected TimePhasedType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _NotTimephased = "NotTimephased";
	public static final TimePhasedType NotTimephased = new TimePhasedType(_NotTimephased);
	
		
	public static final String _ProjectAssignment = "ProjectAssignment";
	public static final TimePhasedType ProjectAssignment = new TimePhasedType(_ProjectAssignment);
	
		
	public static final String _AutoTimephased = "AutoTimephased";
	public static final TimePhasedType AutoTimephased = new TimePhasedType(_AutoTimephased);
	
		
	public static final String _ManuallyTimephased = "ManuallyTimephased";
	public static final TimePhasedType ManuallyTimephased = new TimePhasedType(_ManuallyTimephased);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static TimePhasedType fromValue(String value) throws IllegalStateException {
		TimePhasedType retVal = (TimePhasedType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static TimePhasedType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof TimePhasedType && ordinal == ((TimePhasedType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((TimePhasedType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final TimePhasedType[] VALUES = {NotTimephased, ProjectAssignment, AutoTimephased, ManuallyTimephased};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}