package com.ibm.rpm.financial.util;

import com.ibm.rpm.financial.types.RevenueRecognitionMethodType;

/**
 * Converts RevenueRecognitionMethodType <--> BUDGETS.AUTO_FLAG
 * 
 * @author ikusakov
 */
public class RevenueRecognitionToDBMap
{
    public static final Integer getIntegerRevRecType(
            RevenueRecognitionMethodType rt)
    {
        if (rt == null)
            return null;

        Integer result = null;
        if (RevenueRecognitionMethodType.NA.equals(rt))
        {
            // There is no NA code for the database, so assuming 0 as default
            result = new Integer(0);
        }
        else if (RevenueRecognitionMethodType.Manual.equals(rt))
        {
            result = new Integer(0);
        }
        else if (RevenueRecognitionMethodType.Ratio.equals(rt))
        {
            result = new Integer(1);
        }
        else if (RevenueRecognitionMethodType.FlowThru.equals(rt))
        {
            result = new Integer(2);
        }

        return result;
    }

    public static final RevenueRecognitionMethodType getRevRecTypeFromInteger(
            Integer i)
    {
        RevenueRecognitionMethodType rt = null;
        if (i != null)
        {
            if (i.intValue() == 0)
            {
                return RevenueRecognitionMethodType.Manual;
            }
            else if (i.intValue() == 1)
            {
                return RevenueRecognitionMethodType.Ratio;
            }
            else if (i.intValue() == 2)
            {
                return RevenueRecognitionMethodType.FlowThru;
            }
        }

        return rt;
    }

}
