package com.ibm.rpm.framework.security.controller.impl.resource;

import java.util.Map;

import com.ibm.rpm.customfield.containers.CustomFieldAssignment;
import com.ibm.rpm.framework.security.SecurityFlags.RESOURCE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;

class ResourceBasedCustomFieldAssignmentSecurityController extends
        ResourceBasedContainerSecurityController
{

    public Class getContainerClass()
    {
        return CustomFieldAssignment.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new ResourceBasedCustomFieldAssignmentMappingEntry("value",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {                
                RESOURCE.CanViewPersonalRecordCustomFieldsGroups1,
                RESOURCE.CanViewPersonalRecordCustomFieldsGroups2,
                RESOURCE.CanViewPersonalRecordCustomFieldsGroups3,
                RESOURCE.CanViewPersonalRecordCustomFieldsGroups4,
                RESOURCE.CanViewPersonalRecordCustomFieldsGroups5,
                RESOURCE.CanViewPersonalRecordCustomFieldsGroups6,
                RESOURCE.CanViewPersonalRecordCustomFieldsGroups7,
                RESOURCE.CanViewPersonalRecordCustomFieldsGroups8,
                RESOURCE.CanViewPersonalRecordCustomFieldsGroups9,
                RESOURCE.CanViewPersonalRecordCustomFieldsGroups10,
                
                RESOURCE.CanViewOtherResourcesRecordCustomFieldsGroups1,
                RESOURCE.CanViewOtherResourcesRecordCustomFieldsGroups2,
                RESOURCE.CanViewOtherResourcesRecordCustomFieldsGroups3,
                RESOURCE.CanViewOtherResourcesRecordCustomFieldsGroups4,
                RESOURCE.CanViewOtherResourcesRecordCustomFieldsGroups5,
                RESOURCE.CanViewOtherResourcesRecordCustomFieldsGroups6,
                RESOURCE.CanViewOtherResourcesRecordCustomFieldsGroups7,
                RESOURCE.CanViewOtherResourcesRecordCustomFieldsGroups8,
                RESOURCE.CanViewOtherResourcesRecordCustomFieldsGroups9,
                RESOURCE.CanViewOtherResourcesRecordCustomFieldsGroups10,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
                
                RESOURCE.CanEditPersonalRecordCustomFieldsGroups1,
                RESOURCE.CanEditPersonalRecordCustomFieldsGroups2,
                RESOURCE.CanEditPersonalRecordCustomFieldsGroups3,
                RESOURCE.CanEditPersonalRecordCustomFieldsGroups4,
                RESOURCE.CanEditPersonalRecordCustomFieldsGroups5,
                RESOURCE.CanEditPersonalRecordCustomFieldsGroups6,
                RESOURCE.CanEditPersonalRecordCustomFieldsGroups7,
                RESOURCE.CanEditPersonalRecordCustomFieldsGroups8,
                RESOURCE.CanEditPersonalRecordCustomFieldsGroups9,
                RESOURCE.CanEditPersonalRecordCustomFieldsGroups10,
                
                
                RESOURCE.CanEditOtherResourcesRecordCustomFieldsGroups1,
                RESOURCE.CanEditOtherResourcesRecordCustomFieldsGroups2,
                RESOURCE.CanEditOtherResourcesRecordCustomFieldsGroups3,
                RESOURCE.CanEditOtherResourcesRecordCustomFieldsGroups4,
                RESOURCE.CanEditOtherResourcesRecordCustomFieldsGroups5,
                RESOURCE.CanEditOtherResourcesRecordCustomFieldsGroups6,
                RESOURCE.CanEditOtherResourcesRecordCustomFieldsGroups7,
                RESOURCE.CanEditOtherResourcesRecordCustomFieldsGroups8,
                RESOURCE.CanEditOtherResourcesRecordCustomFieldsGroups9,
                RESOURCE.CanEditOtherResourcesRecordCustomFieldsGroups10,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new ResourceBasedCustomFieldAssignmentMappingEntry("customField",
            getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

}
