package com.ibm.rpm.framework.security.controller.impl.resource;

import java.util.Map;

import com.ibm.rpm.customfield.containers.CustomPortletCategory;
import com.ibm.rpm.customfield.containers.GenericCustomPortlet;
import com.ibm.rpm.framework.security.SecuredOperations;
import com.ibm.rpm.framework.security.SecurityFlags.RESOURCE;
import com.ibm.rpm.framework.security.controller.impl.CreationOperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;

class ResourceBasedCustomPortletCategorySecurityController extends
        ResourceBasedGenericCustomPortletSecurityController
{

    public Class getContainerClass()
    {
        return CustomPortletCategory.class;
    }

    protected void generateCreationOperationMappingEntries(Map mappingEntryMap)
    {
        super.generateCreationOperationMappingEntries(mappingEntryMap);
        CreationOperationMappingEntry creationInfo = null;

        // --------------------------------------------------------
        creationInfo = new CreationOperationMappingEntry(
            SecuredOperations.CreateGenericCustomPortlet, getContainerClass(),
            GenericCustomPortlet.class);
        creationInfo.securityFlag = RESOURCE.CanEditCustomFieldsAdmin;
        mappingEntryMap.put(creationInfo.childrenClass, creationInfo);
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("children", getContainerClass());
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
        
        //--------------------------------------------------------
        fieldInfo = new FieldMappingEntry("groupType", getContainerClass());
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

}
