package com.ibm.rpm.framework.security.controller.impl.resource;

import java.util.Map;

import com.ibm.rpm.document.containers.DocumentElement;
import com.ibm.rpm.document.containers.DocumentFolder;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.ControllerSecuredOperations;
import com.ibm.rpm.framework.security.controller.impl.CreationOperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil.ReferencedObjectInfo;

class ResourceBasedDocumentFolderSecurityController extends
        ResourceBasedDocumentElementSecurityController
{

    public Class getContainerClass()
    {
        return DocumentFolder.class;
    }

    protected void generateCreationOperationMappingEntries(Map mappingEntryMap)
    {
        super.generateCreationOperationMappingEntries(mappingEntryMap);
        CreationOperationMappingEntry creationInfo = null;

        // --------------------------------------------------------
        creationInfo = new ResourceBasedCreateDocumentElementMappingEntry(
            ControllerSecuredOperations.CreateDocumentElement,
            getContainerClass(), DocumentElement.class);
        mappingEntryMap.put(creationInfo.childrenClass, creationInfo);
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new ResourceBasedDocumentElementMappingEntry(
            "privateFolder", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }
 
    // Adds the CreationOperation descriptors of the resource's DocumentFolder 
    // to the resource's CreationOperation descriptors because the WebUI does not
    // receive the resource's DocumentFolder when it is empty but still requires security 
    protected Map buildCreationOperationSecurityDescriptors(
            ReferencedObjectInfo objectInfo,
            CombinedSecurityFlags combinedSecurityFlags,
            MessageContext messageContext)
    {
        return super.buildCreationOperationSecurityDescriptors(objectInfo,
            combinedSecurityFlags, messageContext);
    }
    
}
