package com.ibm.rpm.framework.security.controller.impl.resource;

import java.util.Map;

import com.ibm.rpm.applicationadministration.containers.GenericAttribute;
import com.ibm.rpm.framework.security.SecurityFlags.RESOURCE;
import com.ibm.rpm.framework.security.controller.impl.DeletionOperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;

public class ResourceBasedGenericAttributeSecurityController extends
        ResourceBasedContainerSecurityController
{

    protected Integer[] readSecurityFlags = null; 
//        new Integer[]
//    {
//        RESOURCE.CanEditAttributeAdmin,
//    };
    protected Integer[] writeSecurityFlags = new Integer[]
    {
        RESOURCE.CanEditAttributeAdmin,
    };
        
    public Class getContainerClass()
    {
        return GenericAttribute.class;
    }

    protected DeletionOperationMappingEntry generateDeletionOperationMappingEntry()
    {
        DeletionOperationMappingEntry deletionEntry = new DeletionOperationMappingEntry(
           getContainerClass());
        deletionEntry.securityFlag = RESOURCE.CanEditAttributeAdmin;
        return deletionEntry;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("name", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("description", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

}
