package com.ibm.rpm.framework.security.controller.impl.resource;

import java.util.Map;

import com.ibm.rpm.framework.security.SecuredOperations;
import com.ibm.rpm.framework.security.SecurityFlags.RESOURCE;
import com.ibm.rpm.framework.security.controller.impl.OperationMappingEntry;
import com.ibm.rpm.wbs.containers.Project;

class ResourceBasedProjectSecurityController extends
        ResourceBasedGenericProjectSecurityController
{

    public Class getContainerClass()
    {
        return Project.class;
    }

    protected void generateOperationMappingEntries(Map mappingEntryMap)
    {
        super.generateOperationMappingEntries(mappingEntryMap);
        OperationMappingEntry operationInfo = null;

        // --------------------------------------------------------
        operationInfo = new OperationMappingEntry(
            SecuredOperations.ConvertProjectToOrganization, getContainerClass());
        operationInfo.securityFlag = RESOURCE.CanConvertProjectToOrganization;
        mappingEntryMap.put(operationInfo.name, operationInfo);

        // --------------------------------------------------------
        operationInfo = new OperationMappingEntry(
            SecuredOperations.CreateFromWBSTemplate, getContainerClass());
        operationInfo.securityFlag = RESOURCE.CanCreateProjectsFromWBSTemplate;
        mappingEntryMap.put(operationInfo.name, operationInfo);

        // --------------------------------------------------------
        operationInfo = new OperationMappingEntry(
            SecuredOperations.CreateProjectsFromDefault, getContainerClass());
        operationInfo.securityFlag = RESOURCE.CanCreateProjectsFromDefault;
        mappingEntryMap.put(operationInfo.name, operationInfo);
    }

}
