/**
 * 
 */
package com.ibm.rpm.framework.security.controller.impl.resource;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.SecurityFlags.RESOURCE;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;
import com.ibm.rpm.resource.containers.Resource;

class ResourceBasedResourceAttributeAssignmentMappingEntry extends
        FieldMappingEntry
{
    public ResourceBasedResourceAttributeAssignmentMappingEntry(
            String fieldName, Class container)
    {
        super(fieldName, container);
    }

    public SecurityValidationResult canRead(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        RPMObject parent = SecurityControllerUtil.loadParent(
            messageContext, rpmObject);
        if (parent instanceof Resource)
        {
            if (parent.getID() != null
                && messageContext.getUser().getID().equals(parent.getID()))
            {
                return SecurityControllerUtil.calculateFlagResult(
                    RESOURCE.CanViewPersonalCompetencySkills, securityFlags,
                    getViewErrorMessage(), rpmObject.getClass());
            }
            else
            {
                return SecurityControllerUtil.calculateFlagResult(
                    RESOURCE.CanViewResourceCompetencySkills, securityFlags,
                    getViewErrorMessage(), rpmObject.getClass());
            }
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }

    public SecurityValidationResult canWrite(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        RPMObject parent = SecurityControllerUtil.loadParent(
            messageContext, rpmObject);
        if (parent instanceof Resource)
        {
            if (parent.getID() != null
                && messageContext.getUser().getID().equals(parent.getID()))
            {
                return SecurityControllerUtil.calculateFlagResult(
                    RESOURCE.CanEditPersonalCompetencySkills, securityFlags,
                    getEditErrorMessage(), rpmObject.getClass());
            }
            else
            {
                return SecurityControllerUtil.calculateFlagResult(
                    RESOURCE.CanEditResourceCompetencySkills, securityFlags,
                    getEditErrorMessage(), rpmObject.getClass());
            }
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }
}