/**
 * 
 */
package com.ibm.rpm.framework.security.controller.impl.resource;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.types.ProjectPublishedType;

class ResourceBasedWorkElementMappingEntry extends FieldMappingEntry
{
    public ResourceBasedWorkElementMappingEntry(String fieldName,
            Class container)
    {
        super(fieldName, container);
    }

    public SecurityValidationResult canRead(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        return SecurityValidationResult.TRUE_RESULT;
    }

    public SecurityValidationResult canWrite(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        if (canWriteSecurityFlags != null)
        {
            WorkElement workElement = (WorkElement) rpmObject;
            ProjectPublishedType type = SecurityControllerUtil
                .loadWorkElementPublishedType(workElement, messageContext);
            if (type != null)
            {
                if (type == ProjectPublishedType.ToTemplate
                        && workElement.getPublished() != ProjectPublishedType.ToTemplate)
                {
                    return SecurityControllerUtil.calculateFlagResult(
                        canWriteSecurityFlags[0], securityFlags,
                        getEditErrorMessage(), rpmObject.getClass());
                }
            }
            return SecurityValidationResult.TRUE_RESULT;
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }

}