package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.wbs.containers.AggregateNode;

class RoleBasedAggregateNodeSecurityController extends
        RoleBasedWorkElementSecurityController
{

    public Class getContainerClass()
    {
        return AggregateNode.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;
        
        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("children", getContainerClass());
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanBreakdown,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("worksheetFinancials",
            getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
        
        //--------------------------------------------------------
        fieldInfo = new FieldMappingEntry("proposedDate", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewScheduleInformation,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditForChildrenDatesProposed,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

    }

}
