package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.HashMap;
import java.util.Map;

import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.security.FieldSecurityDescriptor;
import com.ibm.rpm.framework.security.SecuredFields;
import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil.ReferencedObjectInfo;

class RoleBasedAssetSecurityController extends
        RoleBasedContainerSecurityController
{

    public Class getContainerClass()
    {
        return Asset.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("crossChargeFinancials", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("geographicalAssignment", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("customFieldAssignments", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("serialNumber", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("WBSActivityFinish", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("contactEmail", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("attributeAssignments", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("maintenanceEstimates", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("depreciationSchedules", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("assetOrganizationalAssignment",
            getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("dateAcquired", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("estimateMaintenance", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("maintenanceToDate", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("depreciationMethod", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("estimateCrossCharge", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("nextScheduleMaintenance",
            getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("model", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("salvageValue", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("modelNumber", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("currentValue", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("quantity", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("capitalValue", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("state", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("contactPhone", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("assetResourceAssignments",
            getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("documentFolder", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("warrantySLAExpiryDate", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("initialCost", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("contact", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("tracked", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("dispositionDate", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("WBSActivityStart", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("licenseExpiryDate", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("barcodeNumber", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("rtfAssignments", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("assignedScorecard", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("depreciationToDate", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("statusUpdates", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("crossChargeToDate", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("category", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("assetLife", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

    protected Map buildCustomFieldSecurityDescriptors(
            ReferencedObjectInfo objectInfo,
            CombinedSecurityFlags combinedSecurityFlags,
            MessageContext messageContext)
    {
        Map customFieldSecurityDescrs = new HashMap();
        FieldSecurityDescriptor customFieldSecurityDescr = null;

        // --------------------------------------------------------
        customFieldSecurityDescr = new FieldSecurityDescriptor();
        customFieldSecurityDescr.setName(SecuredFields.CustomFieldGroup1);
        customFieldSecurityDescr.setCanView(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanViewCustomFieldsGroups1,
                combinedSecurityFlags));
        customFieldSecurityDescr.setCanEdit(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanEditCustomFieldsGroups1,
                combinedSecurityFlags));
        customFieldSecurityDescrs.put(SecuredFields.INTEGERS[1],
            customFieldSecurityDescr);

        // --------------------------------------------------------
        customFieldSecurityDescr = new FieldSecurityDescriptor();
        customFieldSecurityDescr.setName(SecuredFields.CustomFieldGroup2);
        customFieldSecurityDescr.setCanView(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanViewCustomFieldsGroups2,
                combinedSecurityFlags));
        customFieldSecurityDescr.setCanEdit(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanEditCustomFieldsGroups2,
                combinedSecurityFlags));
        customFieldSecurityDescrs.put(SecuredFields.INTEGERS[2],
            customFieldSecurityDescr);

        // --------------------------------------------------------
        customFieldSecurityDescr = new FieldSecurityDescriptor();
        customFieldSecurityDescr.setName(SecuredFields.CustomFieldGroup3);
        customFieldSecurityDescr.setCanView(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanViewCustomFieldsGroups3,
                combinedSecurityFlags));
        customFieldSecurityDescr.setCanEdit(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanEditCustomFieldsGroups3,
                combinedSecurityFlags));
        customFieldSecurityDescrs.put(SecuredFields.INTEGERS[3],
            customFieldSecurityDescr);

        // --------------------------------------------------------
        customFieldSecurityDescr = new FieldSecurityDescriptor();
        customFieldSecurityDescr.setName(SecuredFields.CustomFieldGroup4);
        customFieldSecurityDescr.setCanView(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanViewCustomFieldsGroups4,
                combinedSecurityFlags));
        customFieldSecurityDescr.setCanEdit(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanEditCustomFieldsGroups4,
                combinedSecurityFlags));
        customFieldSecurityDescrs.put(SecuredFields.INTEGERS[4],
            customFieldSecurityDescr);

        // --------------------------------------------------------
        customFieldSecurityDescr = new FieldSecurityDescriptor();
        customFieldSecurityDescr.setName(SecuredFields.CustomFieldGroup5);
        customFieldSecurityDescr.setCanView(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanViewCustomFieldsGroups5,
                combinedSecurityFlags));
        customFieldSecurityDescr.setCanEdit(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanEditCustomFieldsGroups5,
                combinedSecurityFlags));
        customFieldSecurityDescrs.put(SecuredFields.INTEGERS[5],
            customFieldSecurityDescr);

        // --------------------------------------------------------
        customFieldSecurityDescr = new FieldSecurityDescriptor();
        customFieldSecurityDescr.setName(SecuredFields.CustomFieldGroup6);
        customFieldSecurityDescr.setCanView(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanViewCustomFieldsGroups6,
                combinedSecurityFlags));
        customFieldSecurityDescr.setCanEdit(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanEditCustomFieldsGroups6,
                combinedSecurityFlags));
        customFieldSecurityDescrs.put(SecuredFields.INTEGERS[6],
            customFieldSecurityDescr);

        // --------------------------------------------------------
        customFieldSecurityDescr = new FieldSecurityDescriptor();
        customFieldSecurityDescr.setName(SecuredFields.CustomFieldGroup7);
        customFieldSecurityDescr.setCanView(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanViewCustomFieldsGroups7,
                combinedSecurityFlags));
        customFieldSecurityDescr.setCanEdit(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanEditCustomFieldsGroups7,
                combinedSecurityFlags));
        customFieldSecurityDescrs.put(SecuredFields.INTEGERS[7],
            customFieldSecurityDescr);

        // --------------------------------------------------------
        customFieldSecurityDescr = new FieldSecurityDescriptor();
        customFieldSecurityDescr.setName(SecuredFields.CustomFieldGroup8);
        customFieldSecurityDescr.setCanView(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanViewCustomFieldsGroups8,
                combinedSecurityFlags));
        customFieldSecurityDescr.setCanEdit(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanEditCustomFieldsGroups8,
                combinedSecurityFlags));
        customFieldSecurityDescrs.put(SecuredFields.INTEGERS[8],
            customFieldSecurityDescr);

        // --------------------------------------------------------
        customFieldSecurityDescr = new FieldSecurityDescriptor();
        customFieldSecurityDescr.setName(SecuredFields.CustomFieldGroup9);
        customFieldSecurityDescr.setCanView(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanViewCustomFieldsGroups9,
                combinedSecurityFlags));
        customFieldSecurityDescr.setCanEdit(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanEditCustomFieldsGroups9,
                combinedSecurityFlags));
        customFieldSecurityDescrs.put(SecuredFields.INTEGERS[9],
            customFieldSecurityDescr);

        // --------------------------------------------------------
        customFieldSecurityDescr = new FieldSecurityDescriptor();
        customFieldSecurityDescr.setName(SecuredFields.CustomFieldGroup10);
        customFieldSecurityDescr.setCanView(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanViewCustomFieldsGroups10,
                combinedSecurityFlags));
        customFieldSecurityDescr.setCanEdit(SecurityControllerUtil
            .calculateFlagValue(ROLE.CanEditCustomFieldsGroups10,
                combinedSecurityFlags));
        customFieldSecurityDescrs.put(SecuredFields.INTEGERS[10],
            customFieldSecurityDescr);

        return customFieldSecurityDescrs;
    }

}
