package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.financial.containers.ChargeCodeCategory;
import com.ibm.rpm.framework.security.controller.impl.ControllerSecuredOperations;
import com.ibm.rpm.framework.security.controller.impl.CreationOperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;

class RoleBasedChargeCodeCategorySecurityController extends
        RoleBasedGenericChargeCodeSecurityController
{

    public Class getContainerClass()
    {
        return ChargeCodeCategory.class;
    }

    protected void generateCreationOperationMappingEntries(Map mappingEntryMap)
    {
        super.generateCreationOperationMappingEntries(mappingEntryMap);
        CreationOperationMappingEntry creationInfo = null;
        // --------------------------------------------------------
        creationInfo = new RoleBasedCreateChargeCodeCategoryChargeCodeMappingEntry(
            ControllerSecuredOperations.CreateChargeCode,
            getContainerClass(), getContainerClass());
        mappingEntryMap.put(creationInfo.childrenClass, creationInfo);
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("children", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

}
