/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.framework.security.controller.impl.role;

import com.ibm.rpm.financial.containers.ChargeCode;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.ContainerSecurityController;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;

/**
 * @author Yasser Lulu
 *
 */
class RoleBasedChargeCodeStateSecurityMappingEntry extends
        FieldMappingEntry
{

    public RoleBasedChargeCodeStateSecurityMappingEntry(String fieldName,
            Class container)
    {
        super(fieldName, container);
    }

    /* (non-Javadoc)
     * @see com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry#canRead(com.ibm.rpm.framework.RPMObject, com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags, com.ibm.rpm.framework.MessageContext)
     */
    public SecurityValidationResult canRead(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        //XXX TODO to be added to the util
        RPMObject parent = null;//SecurityControllerUtil.loadChargeCode(messageContext, rpmObject);
        if (parent instanceof ChargeCode)
        {
            ContainerSecurityController controller = RoleBasedSecurityControllerImpl
            .getRoleBasedContainerSecurityController(ChargeCode.class);
            return controller.canRead(parent, "state", securityFlags,
                messageContext);
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }

    /* (non-Javadoc)
     * @see com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry#canWrite(com.ibm.rpm.framework.RPMObject, com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags, com.ibm.rpm.framework.MessageContext)
     */
    public SecurityValidationResult canWrite(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        //XXX TODO to be added to the util
        RPMObject parent = null;//SecurityControllerUtil.loadChargeCode(messageContext, rpmObject);
        if (parent instanceof ChargeCode)
        {
            ContainerSecurityController controller = RoleBasedSecurityControllerImpl
            .getRoleBasedContainerSecurityController(ChargeCode.class);
            return controller.canWrite(parent, "state", securityFlags,
                messageContext);
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }

}
