package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.applicationadministration.containers.Currency;
import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.ViewOperationMappingEntry;

class RoleBasedCurrencySecurityController extends
        RoleBasedGenericDatafieldSecurityController
{

    public Class getContainerClass()
    {
        return Currency.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        // Override parent's entry
        fieldInfo = new FieldMappingEntry("name", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewCurrency,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
        
        // --------------------------------------------------------
        fieldInfo = new RoleBasedCurrencyMappingEntry("exchangeRate",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewCurrency,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedCurrencyMappingEntry("exchangeRanges",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewCurrency,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

    protected ViewOperationMappingEntry generateViewOperationMappingEntry()
    {
        ViewOperationMappingEntry viewEntry = new ViewOperationMappingEntry(
            getContainerClass());
        viewEntry.securityFlag = ROLE.CanViewCurrency;
        return viewEntry;
    }

}
