package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.customfield.containers.CustomFieldAssignment;
import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;

class RoleBasedCustomFieldAssignmentSecurityController extends
        RoleBasedContainerSecurityController
{

    public Class getContainerClass()
    {
        return CustomFieldAssignment.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        // Supposed to be read only.
        fieldInfo = new FieldMappingEntry("customField",
            getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedCustomFieldAssignmentMappingEntry("value",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewCustomFieldsGroups1,
            ROLE.CanViewCustomFieldsGroups2,
            ROLE.CanViewCustomFieldsGroups3,
            ROLE.CanViewCustomFieldsGroups4,
            ROLE.CanViewCustomFieldsGroups5,
            ROLE.CanViewCustomFieldsGroups6,
            ROLE.CanViewCustomFieldsGroups7,
            ROLE.CanViewCustomFieldsGroups8,
            ROLE.CanViewCustomFieldsGroups9,
            ROLE.CanViewCustomFieldsGroups10,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditCustomFieldsGroups1,
            ROLE.CanEditCustomFieldsGroups2,
            ROLE.CanEditCustomFieldsGroups3,
            ROLE.CanEditCustomFieldsGroups4,
            ROLE.CanEditCustomFieldsGroups5,
            ROLE.CanEditCustomFieldsGroups6,
            ROLE.CanEditCustomFieldsGroups7,
            ROLE.CanEditCustomFieldsGroups8,
            ROLE.CanEditCustomFieldsGroups9,
            ROLE.CanEditCustomFieldsGroups10,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

}
