/**
 * 
 */
package com.ibm.rpm.framework.security.controller.impl.role;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;

class RoleBasedProjectOrganizationalAssignmentMappingEntry extends
        FieldMappingEntry
{
    public RoleBasedProjectOrganizationalAssignmentMappingEntry(
            String fieldName, Class container)
    {
        super(fieldName, container);
    }

    public SecurityValidationResult canRead(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        if (canReadSecurityFlags != null)
        {
            return SecurityControllerUtil.calculateFlagResultUsingOr(
                canReadSecurityFlags, securityFlags, getViewErrorMessage(),
                rpmObject.getClass());
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }

    public SecurityValidationResult canWrite(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        if (canWriteSecurityFlags != null)
        {
            return SecurityControllerUtil.calculateFlagResultUsingOr(
                canWriteSecurityFlags, securityFlags, getEditErrorMessage(),
                rpmObject.getClass());
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }
}