package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;
import com.ibm.rpm.framework.security.controller.impl.ViewOperationMappingEntry;
import com.ibm.rpm.scorecard.containers.ScorecardCategory;

class RoleBasedScorecardCategorySecurityController extends
        RoleBasedAbstractScorecardCategorySecurityController
{

    public Class getContainerClass()
    {
        return ScorecardCategory.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;
        
        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("scorecardQuestions", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
        
        // --------------------------------------------------------
        // Override all field entries with new flag
        SecurityControllerUtil.replaceFieldMappingEntryFlags(
            new Integer[]  
            { 
                ROLE.CanViewDefaultScorecards,
            }, 
            null, mappingEntryMap);
    }

    protected ViewOperationMappingEntry generateViewOperationMappingEntry()
    {
        ViewOperationMappingEntry viewEntry = new ViewOperationMappingEntry(
            getContainerClass());
        viewEntry.securityFlag = ROLE.CanViewDefaultScorecards;
        return viewEntry;
    }

}
