package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;
import com.ibm.rpm.framework.security.controller.impl.ViewOperationMappingEntry;
import com.ibm.rpm.scorecard.containers.ScorecardQuestion;

class RoleBasedScorecardQuestionSecurityController extends
        RoleBasedAbstractScorecardQuestionSecurityController
{

    public Class getContainerClass()
    {
        return ScorecardQuestion.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);

        Integer[] canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewDefaultScorecards,
        };
        Integer[] canWriteSecurityFlags = null;

        SecurityControllerUtil.replaceFieldMappingEntryFlags(
            canReadSecurityFlags, canWriteSecurityFlags, mappingEntryMap);

        FieldMappingEntry fieldInfo = null;
        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("scorecardResponses", getContainerClass());
        fieldInfo.canReadSecurityFlags = canReadSecurityFlags;
        fieldInfo.canWriteSecurityFlags = canWriteSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);        
    }

    protected ViewOperationMappingEntry generateViewOperationMappingEntry()
    {
        ViewOperationMappingEntry viewEntry = new ViewOperationMappingEntry(
            getContainerClass());
        viewEntry.securityFlag = ROLE.CanViewDefaultScorecards;
        return viewEntry;
    }

}
