package com.ibm.rpm.framework.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class PublishedType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected PublishedType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _None = "None";
	public static final PublishedType None = new PublishedType(_None);
	
		
	public static final String _ToTemplate = "ToTemplate";
	public static final PublishedType ToTemplate = new PublishedType(_ToTemplate);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static PublishedType fromValue(String value) throws IllegalStateException {
		PublishedType retVal = (PublishedType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static PublishedType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof PublishedType && ordinal == ((PublishedType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((PublishedType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final PublishedType[] VALUES = {None, ToTemplate};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}