package com.ibm.rpm.framework.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class SeverityLevel implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected SeverityLevel(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Information = "Information";
	public static final SeverityLevel Information = new SeverityLevel(_Information);
	
		
	public static final String _Warning = "Warning";
	public static final SeverityLevel Warning = new SeverityLevel(_Warning);
	
		
	public static final String _Error = "Error";
	public static final SeverityLevel Error = new SeverityLevel(_Error);
	
		
	public static final String _SevereError = "SevereError";
	public static final SeverityLevel SevereError = new SeverityLevel(_SevereError);
	
		
	public static final String _CriticalError = "CriticalError";
	public static final SeverityLevel CriticalError = new SeverityLevel(_CriticalError);
	
		
	public static final String _FatalError = "FatalError";
	public static final SeverityLevel FatalError = new SeverityLevel(_FatalError);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static SeverityLevel fromValue(String value) throws IllegalStateException {
		SeverityLevel retVal = (SeverityLevel) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static SeverityLevel fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof SeverityLevel && ordinal == ((SeverityLevel)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((SeverityLevel)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final SeverityLevel[] VALUES = {Information, Warning, Error, SevereError, CriticalError, FatalError};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}