package com.ibm.rpm.framework.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class TimeUnitType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected TimeUnitType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Days = "Days";
	public static final TimeUnitType Days = new TimeUnitType(_Days);
	
		
	public static final String _Hours = "Hours";
	public static final TimeUnitType Hours = new TimeUnitType(_Hours);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static TimeUnitType fromValue(String value) throws IllegalStateException {
		TimeUnitType retVal = (TimeUnitType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static TimeUnitType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof TimeUnitType && ordinal == ((TimeUnitType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((TimeUnitType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final TimeUnitType[] VALUES = {Days, Hours};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}