package com.ibm.rpm.framework.util;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.ibm.rpm.framework.RPMException;

/**
 * @author legaults
 */
public class EnvironmentUtil
{
    /**
     * Reads an environment variable.
     */
    public static Object read(String variableName, Object defaultValue)
    {
        Object result;
        try
        {
            result = doRead(variableName);
        }
        catch (Exception e)
        {
            result = defaultValue;
        }
        return result;
    }

    /**
     * Reads an environment variable.
     */
    public static Object read(String variableName) throws RPMException
    {
        Object result = null;
        try
        {
            result = doRead(variableName);
        }
        catch (Exception e)
        {
            ExceptionUtil.handleException(EnvironmentUtil.class, e);
        }
        return result;
    }
    
    private static Object doRead(String variableName) throws NamingException
    {
        Context initCtx = new InitialContext();
        Context envCtx = (Context) initCtx.lookup("java:comp/env");
        Object result = envCtx.lookup(variableName);
        return result;
    }
}
