package com.ibm.rpm.interfaces;

import javax.sql.DataSource;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RpmOptions;

public interface SessionUtility
{
    public static final String RPM_DATASOURCE = new String("jdbc/RPMDATASOURCE");
    
    public DataSource getDataSource() throws RPMException;
    
    public DataSource getDataSource(String dsn) throws RPMException;

    public void fillContext(MessageContext context, String sessionID, String operationName)
            throws RPMException;
    
    public void reloadContext(MessageContext context, String sessionID, String operationName)
            throws RPMException;

    public void deleteResourceFromContext(MessageContext context,String sessionID) throws RPMException;

    public String addResourceToContext(MessageContext context,String resourceID, String dsn)
            throws RPMException;
    
    public void assignWorkflowToSession(MessageContext context,String sessionId, String workflowId)
		throws RPMException;

    public boolean isSessionRegistered(MessageContext context,long sessionID) throws RPMException;
    
    public boolean isAutomaticCheckout(MessageContext context,String sessionID) throws RPMException;

    public void setAutomaticCheckout(MessageContext context,String sessionID,
            boolean isAutomaticCheckout) throws RPMException;

    public void start();
    
    public void stop();
    
    public RpmOptions getOptions();
    
    public boolean isSessionTableFunctionnal();
    
    public void validateWebServicesEnabledAndLog(String operationName)throws RPMException;
}
