/*
 * Created on Jun 30, 2006
 */
package com.ibm.rpm.interfaces.checkpoints;

import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.constants.ValidationConstants;

/**
 * @author dominiqu
 */
public class AuthenticateCheckpoint
{
    protected static AuthenticateCheckpoint instance = new AuthenticateCheckpoint();

    public static AuthenticateCheckpoint getInstance()
    {
        return instance;
    }

    public void validateLogin(String username, String password)
            throws RPMException
    {
        GenericValidator.validateMaxLength("Login username", username,
            ValidationConstants.RESOURCE_USERNAME_MAX);

        GenericValidator.validateMinLength("Resource username", username,
            ValidationConstants.RESOURCE_USERNAME_MIN);

        GenericValidator.validateMaxLength("Login password", password,
            ValidationConstants.RESOURCE_PASSWORD_MAX);
    }
}
