/*
 * Created on 21-Apr-2006
 */
package com.ibm.rpm.resource.checkpoints;

import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.constants.ValidationConstants;
import com.ibm.rpm.resource.containers.IndustryExperience;
import com.ibm.rpm.resource.containers.Resource;

/**
 * @author cobber
 */
public class IndustryExperienceCheckpoint extends AbstractCheckpoint
{
    private static final Class INDUSTRYEXPERIENCE_PARENTS = Resource.class;

    protected static IndustryExperienceCheckpoint instance = new IndustryExperienceCheckpoint();

    public static IndustryExperienceCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super
            .isValidParent(rpmObject, msgCtx, true, INDUSTRYEXPERIENCE_PARENTS);

        IndustryExperience mainIndustryExperience = (IndustryExperience) rpmObject;
        
        // mandatory field
        GenericValidator.validateMandatory(mainIndustryExperience,
            ValidationConstants.INDUSTRYEXPERIENCE_CLASSIFICATION_FIELD,
            mainIndustryExperience.getClassification(), msgCtx);
        GenericValidator.validateMandatory(mainIndustryExperience,
            ValidationConstants.INDUSTRYEXPERIENCE_INDUSTRY_FIELD,
            mainIndustryExperience.getIndustry(), msgCtx);
        GenericValidator.validateMandatory(mainIndustryExperience,
            ValidationConstants.INDUSTRYEXPERIENCE_PROFICIENCY_FIELD,
            mainIndustryExperience.getProficiency(), msgCtx);

        if (!GenericValidator.validateInstance(rpmObject,
            IndustryExperience.class, msgCtx))
        {
            return;
        }
    }
}