/*
 * Created on Sep 15, 2005
 */
package com.ibm.rpm.resource.checkpoints;

import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.containers.ResourceCostCenterAssignment;

public class ResourceCostCenterCheckpoint extends AbstractCheckpoint
{
    private static final Class RESOURCECOSTCENTERS_PARENTS = Resource.class;

    protected static ResourceCostCenterCheckpoint instance = new ResourceCostCenterCheckpoint();

    public static ResourceCostCenterCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, true, RESOURCECOSTCENTERS_PARENTS);

        if (!GenericValidator.validateInstance(rpmObject,
            ResourceCostCenterAssignment.class, msgCtx))
            return;

        ResourceCostCenterAssignmentCheckpoint.getInstance().validateSave(
                rpmObject, rpmScope, msgCtx);
    }
}
