/*
 * Created on 11-May-2006
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import com.ibm.rpm.applicationadministration.containers.ChangeRequestState;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.ChangeRequest;

/**
 * @author cobber
 */
public class ChangeRequestCheckpoint extends AbstractRequestCheckpoint
{
    protected static ChangeRequestCheckpoint instance = new ChangeRequestCheckpoint();

    public static ChangeRequestCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx);

        // Initialize
        ChangeRequest mainChangeRequest = (ChangeRequest) rpmObject;

        // Field validation: state
        if (mainChangeRequest.testStateModified()
                && mainChangeRequest.getState() != null)
        {
            GenericValidator.validateType(mainChangeRequest,
                ChangeRequestState.class,
                ValidationConstants.ABSTRACTSCOPE_STATE_FIELD,
                mainChangeRequest.getState(), msgCtx);
        }
    }
}