/*
 * Created on 11-May-2006
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import com.ibm.rpm.applicationadministration.containers.DefectState;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.Defect;

/**
 * @author cobber
 */
public class DefectCheckpoint extends AbstractRequestCheckpoint
{
    protected static DefectCheckpoint instance = new DefectCheckpoint();

    public static DefectCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx);

        // Initialize
        Defect mainDefect = (Defect) rpmObject;

        // Field validation: state
        if (mainDefect.testStateModified() && mainDefect.getState() != null)
        {
            GenericValidator.validateType(mainDefect, DefectState.class,
                ValidationConstants.ABSTRACTSCOPE_STATE_FIELD, mainDefect
                    .getState(), msgCtx);
        }
    }
}