/*
 * Created on 7-Dec-2005
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import com.ibm.rpm.applicationadministration.containers.IssueState;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.Issue;

/**
 * @author dominiqu
 */
public class IssueCheckpoint extends AbstractScopeCheckpoint
{
    protected static IssueCheckpoint instance = new IssueCheckpoint();

    public static IssueCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx);

        // Initialize
        Issue mainIssue = (Issue) rpmObject;

        // Field validation: numberTimesReassigned
        if (mainIssue.testNumberTimesReassignedModified())
        {
            GenericValidator.validateRange(mainIssue,
                ValidationConstants.ISSUE_NUMBER_TIMES_REASSIGNED_FIELD,
                mainIssue.getNumberTimesReassigned(),
                ValidationConstants.NUMBEROFTIMESREASSIGNED_MIN,
                ValidationConstants.NUMBEROFTIMESREASSIGNED_MAX, msgCtx);
        }

        // Field validation: state
        if (mainIssue.testStateModified() && mainIssue.getState() != null)
        {
            GenericValidator.validateType(mainIssue, IssueState.class,
                ValidationConstants.ABSTRACTSCOPE_STATE_FIELD, mainIssue
                    .getState(), msgCtx);
        }
    }
}