/*
 * Created on Aug 18, 2006
 *
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder;
import com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder;

/**
 * @author karim
 *
 */
public class ReqProScopeFolderCheckpoint extends ScopeFolderCheckpoint{

    private static final List REQPROSCOPEFOLDER_PARENTS = new ArrayList();

    static
    {
        REQPROSCOPEFOLDER_PARENTS.add(ReqProIntegrationFolder.class);
        REQPROSCOPEFOLDER_PARENTS.add(ReqProScopeFolder.class);
    }

    protected static ReqProScopeFolderCheckpoint instance = new ReqProScopeFolderCheckpoint();

    public static ScopeFolderCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, msgCtx, true, REQPROSCOPEFOLDER_PARENTS);

        // Initialize
        ReqProScopeFolder reqProScopeFolder = (ReqProScopeFolder) rpmObject;

        // Field validation: name
        if (reqProScopeFolder.getID() == null)
        {
            //In creation mode, the ReqProImportStatus field is mandatory
			GenericValidator.validateMandatory(reqProScopeFolder,
					ValidationConstants.REQPRO_IMPORTSTATUS_FIELD,
					reqProScopeFolder.getReqProImportStatus(), msgCtx);
        	
            if (reqProScopeFolder.testNameModified())
            {
                GenericValidator.validateMinLength(reqProScopeFolder,
                    ValidationConstants.SCOPEELEMENT_NAME_FIELD,
                    reqProScopeFolder.getName(), ValidationConstants.NAME_MIN,
                    msgCtx);
            }
        }
    }
	
}
