/*
 * Created on 7-Dec-2005
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import com.ibm.rpm.applicationadministration.containers.RiskState;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.Risk;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;

/**
 * @author dominiqu
 */
public class RiskCheckpoint extends AbstractScopeCheckpoint
{
    protected static RiskCheckpoint instance = new RiskCheckpoint();

    public static RiskCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx);

        // Initialize
        Risk mainRisk = (Risk) rpmObject;
        ScopeElementScope scope = (ScopeElementScope) rpmScope;

        // Field validation: state
        if (mainRisk.testStateModified() && mainRisk.getState() != null)
        {
            GenericValidator.validateType(mainRisk, RiskState.class,
                ValidationConstants.ABSTRACTSCOPE_STATE_FIELD, mainRisk
                    .getState(), msgCtx);
        }
    }
}