/*
 * Created on 7-Dec-2005
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.scopemanagement.containers.Action;
import com.ibm.rpm.scopemanagement.containers.ChangeRequest;
import com.ibm.rpm.scopemanagement.containers.Defect;
import com.ibm.rpm.scopemanagement.containers.Issue;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.Risk;
import com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask;
import com.ibm.rpm.scopemanagement.containers.ServiceRequest;
import com.ibm.rpm.wbs.containers.Deliverable;

/**
 * @author dominiqu
 */
public class ScopeDeliverableCheckpoint extends AbstractAggregateScopeCheckpoint
{
    private static final List SCOPEDELIVERABLE_PARENTS = new ArrayList();

    static
    {
        SCOPEDELIVERABLE_PARENTS.add(Action.class);
        SCOPEDELIVERABLE_PARENTS.add(Issue.class);
        SCOPEDELIVERABLE_PARENTS.add(ChangeRequest.class);
        SCOPEDELIVERABLE_PARENTS.add(Defect.class);
        SCOPEDELIVERABLE_PARENTS.add(Requirement.class);
        SCOPEDELIVERABLE_PARENTS.add(Risk.class);
        SCOPEDELIVERABLE_PARENTS.add(ServiceRequest.class);
        SCOPEDELIVERABLE_PARENTS.add(ScopeSummaryTask.class);
        SCOPEDELIVERABLE_PARENTS.add(Deliverable.class);
    }
    
    protected static ScopeDeliverableCheckpoint instance = new ScopeDeliverableCheckpoint();

    public static ScopeDeliverableCheckpoint getInstance()
    {
        return instance;
    }
    
    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, msgCtx, true, SCOPEDELIVERABLE_PARENTS);
    }
}
