/*
 * Created on 7-Dec-2005
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.Action;
import com.ibm.rpm.scopemanagement.containers.ChangeRequest;
import com.ibm.rpm.scopemanagement.containers.Defect;
import com.ibm.rpm.scopemanagement.containers.Issue;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.Risk;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.containers.ServiceRequest;

/**
 * @author dominiqu
 */
public class ScopeFolderCheckpoint extends ScopeElementCheckpoint
{
    private static final List SCOPEFOLDER_PARENTS = new ArrayList();

    static
    {
        SCOPEFOLDER_PARENTS.add(ScopeFolder.class);
        SCOPEFOLDER_PARENTS.add(Action.class);
        SCOPEFOLDER_PARENTS.add(Issue.class);
        SCOPEFOLDER_PARENTS.add(ChangeRequest.class);
        SCOPEFOLDER_PARENTS.add(Defect.class);
        SCOPEFOLDER_PARENTS.add(Requirement.class);
        SCOPEFOLDER_PARENTS.add(Risk.class);
        SCOPEFOLDER_PARENTS.add(ServiceRequest.class);
    }

    protected static ScopeFolderCheckpoint instance = new ScopeFolderCheckpoint();

    public static ScopeFolderCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, msgCtx, true, SCOPEFOLDER_PARENTS);

        // Initialize
        ScopeFolder mainScopeFolder = (ScopeFolder) rpmObject;

        // Field validation: name
        if (mainScopeFolder.getID() == null)
        {
            if (mainScopeFolder.testNameModified())
            {
                GenericValidator.validateMinLength(mainScopeFolder,
                    ValidationConstants.SCOPEELEMENT_NAME_FIELD,
                    mainScopeFolder.getName(), ValidationConstants.NAME_MIN,
                    msgCtx);
            }
        }
    }
}