/*
 * Created on 7-Dec-2005
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.scopemanagement.containers.Action;
import com.ibm.rpm.scopemanagement.containers.ChangeRequest;
import com.ibm.rpm.scopemanagement.containers.Defect;
import com.ibm.rpm.scopemanagement.containers.Issue;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.Risk;
import com.ibm.rpm.scopemanagement.containers.ScopeDeliverable;
import com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask;
import com.ibm.rpm.scopemanagement.containers.ServiceRequest;

/**
 * @author dominiqu
 */
public class ScopeSummaryTaskCheckpoint extends AbstractAggregateScopeCheckpoint
{
    private static final List SCOPESUMMARYTASK_PARENTS = new ArrayList();

    static
    {
        SCOPESUMMARYTASK_PARENTS.add(Action.class);
        SCOPESUMMARYTASK_PARENTS.add(Issue.class);
        SCOPESUMMARYTASK_PARENTS.add(ChangeRequest.class);
        SCOPESUMMARYTASK_PARENTS.add(Defect.class);
        SCOPESUMMARYTASK_PARENTS.add(Requirement.class);
        SCOPESUMMARYTASK_PARENTS.add(Risk.class);
        SCOPESUMMARYTASK_PARENTS.add(ServiceRequest.class);
        SCOPESUMMARYTASK_PARENTS.add(ScopeSummaryTask.class);
        SCOPESUMMARYTASK_PARENTS.add(ScopeDeliverable.class);
    }
    
    protected static ScopeSummaryTaskCheckpoint instance = new ScopeSummaryTaskCheckpoint();

    public static ScopeSummaryTaskCheckpoint getInstance()
    {
        return instance;
    }
    
    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, msgCtx, true, SCOPESUMMARYTASK_PARENTS);
    }
}
