package com.ibm.rpm.scopemanagement.constants;

public class ErrorCodes
{

    /**
     * Error codes for scope management containers.
     * Error code range: 404,001 - 405,000
     * 404,001 - 404,299: validation codes
     * 404,300 - 404,499: xpath codes
     * 404,500 + : manager codes
     * 
     * These error messages usually have the container name at the beginning. 
     * The className of the RPMException will be a container.
     * All validation errors that can be thrown to an end user should
     * be of this type.
     */
    
    // validation constants
    public final static int DUPLICATE_CANNOT_HAVE_SAME_ID = 404001;
    
    public final static int DUPLICATE_MUST_BE_IN_SAME_PROJECT = 404002;
    
    public final static int CANNOT_CROSS_TRANSFER_WITHOUT_MOVE = 404003;
    
    public final static int CANNOT_DELETE_TRANSFERRED_ELEMENTS = 404004;
    
    public final static int INVALID_OBJECT_TEMPLATE_TYPE = 404005;    
    
    public final static int CANNOT_MOVE_FROM_PROJECT_THROUGH_PARENT = 404006;
    
    public final static int INVALID_RESOURCE_REFERENCE_PROPOSED_BY_NAME = 404007;
    
    public final static int PROJECTID_DOES_NOT_MATCH= 404008;
    
    public final static int READ_ONLY_ONCE_WORK_ASSIGNED = 404009;
    
    public final static int CANNOT_ASSIGN_UNSAVED_CLIENT_COST_CENTER = 404010;
    
    public final static int CANNOT_ASSIGN_UNSAVED_ASSET = 404011;
    // manager constants
}