/*
 * Created on 7-Dec-2005
 */
package com.ibm.rpm.scopemanagement.constants;

import java.util.ArrayList;

/**
 * @author dominiqu
 */
public class ValidationConstants
{
    public final static int SCOPEMANAGEMENT_NESTINGLEVEL_MAX = 30;
    
    // Constants for fields located in ScopeElement
    
    public final static int NAME_MIN = 1;
    public final static int NAME_MAX = 255;
    public final static String NAME_WBSPARENT = "wbsParent";
    public final static String NAME_PROJECT = "project";
    public final static String ELEMENT_SECURITY_TYPE = "elementSecurityType";
    
    // Constants for fields located in AbstractAggregateScope and AbstractScopeTask
    
    public final static int PRIORITY_MIN = 0;
    public final static int PRIORITY_MAX = 10000;
    
    // Constants for fields located in AbstractRequest and Issue
    
    public final static int NUMBEROFTIMESREASSIGNED_MIN = 0;
    public final static int NUMBEROFTIMESREASSIGNED_MAX = 9999;
    public final static String NUMBER_TIMES_REASSIGNED_FIELD = "numberTimesReassigned";
    public final static String OCCURED_DATE_TIME_FIELD = "occuredDateTime";

    
    // Constants for fields located in AbstractScope
    
    public final static int APPROVED_BY_NAME_MAX = 100;
    public final static int EXTERNALREFERENCENUMBER_MAX = 32;
    public final static int RANK_MIN = 0;
    public final static int RANK_MAX = 1000;
    public final static String TEMPLATE_INPUT_FIELD = "inputObject";
    public final static String TEMPLATE_FIELD = "scopeElementTemplate";
    
    public final static String APPROVED_COST_BENEFITS_FIELD = "approvedCostBenefits";
    public final static String RISK_MATRIX_FIELD = "riskMatrix";
    public final static String APPROVED_BY_DATE_FIELD = "approvedByDate";
    public final static String APPROVED_BY_NAME_FIELD = "approvedByName";
    public final static String APPROVED_DATE_FIELD = "approvedDate";
    public final static String ASSET_CODE_FIELD = "assetCode";
    public final static String ASSET_FIELD = "asset";
    public final static String ASSIGNED_SCORECARD_FIELD = "assignedScoreCard";
    public final static String CLIENT_COST_CENTER_FIELD = "clientCostCenter";
    public final static String DEFAULT_SCOPE_FIELD = "defaultScope";
    public final static String DOCUMENT_FOLDER_FIELD = "documentFolder";
    public final static String DUPLICATE_NUMBER_FIELD = "duplicateNumber";
    public final static String EXTERNAL_REFERENCE_NUMBER_FIELD = "externalReferenceNumber";
    public final static String IMPACT_FIELD = "impact";
    public final static String ORDER_OF_MAGNITUDE_COSTBENEFITS_FIELD = "orderOfMagnitudeCostBenefits";
    public final static String PUBLISHED_FIELD = "published";
    public final static String RANK_FIELD = "rank";
    public final static String STATE_FIELD = "state";
    public final static String TARGET_DATE_FIELD = "targetDate";


    
    // Constants for fields located in ApprovedCostBenefits
    
    public final static double ACB_BILLABLEREVENUE_MIN = 0.00;
    public final static double ACB_BILLABLEREVENUE_MAX = 999999999999.99;
    public final static double ACB_COST_MIN = 0.00;
    public final static double ACB_COST_MAX = 999999999999.99;
    public final static double ACB_NONBILLABLEBENEFITS_MIN = 0.00;
    public final static double ACB_NONBILLABLEBENEFITS_MAX = 999999999999.99;
    public final static int ACB_SCHEDULEIMPACTINDAYS_MIN = 0;
    public final static int ACB_SCHEDULEIMPACTINDAYS_MAX = 1000000000;
    public final static int ACB_WORKINHOURS_MIN = 0;
    public final static int ACB_WORKINHOURS_MAX = 1000000000;
    
    // Constants for fields located in Impact
    
    public final static int IMPACT_OOMWORKINHOURS_MIN = -1000000000;
    public final static int IMPACT_OOMWORKINHOURS_MAX = 1000000000;
    public final static int IMPACT_OOMLOWWORKINHOURS_MIN = -1000000000;
    public final static int IMPACT_OOMLOWWORKINHOURS_MAX = 1000000000;
    public final static int IMPACT_OOMHIGHWORKINHOURS_MIN = -1000000000;
    public final static int IMPACT_OOMHIGHWORKINHOURS_MAX = 1000000000;
    public final static int IMPACT_SCHEDULEIMPACTINDAYS_MIN = -1000000000;
    public final static int IMPACT_SCHEDULEIMPACTINDAYS_MAX = 1000000000;
    
    // Constants for fields located in MitigationFactor
    
    public final static int MITIGATIONFACTOR_DESCRIPTION_MAX = 255;
    public final static double MITIGATIONFACTOR_MITIGATIONCOST_MIN = 0.00;
    public final static double MITIGATIONFACTOR_MITIGATIONCOST_MAX = 999999999999.99;
    public final static int MITIGATIONFACTOR_PRIORITY_MIN = 0;
    public final static int MITIGATIONFACTOR_PRIORITY_MAX = 9999;

    // Constants for fields located in MitigationTrigger
    
    public final static int MITIGATIONTRIGGER_DESCRIPTION_MAX = 255;
    
    // Constants for fields located in OrderOfMagnitudeCostBenefits
    
    public final static double OOMCB_OOMBILLABLEREVENUE_MIN = 0.00;
    public final static double OOMCB_OOMBILLABLEREVENUE_MAX = 1000000.00;
    public final static double OOMCB_OOMCOST_MIN = 0.00;
    public final static double OOMCB_OOMCOST_MAX = 1000000.00;    
    public final static double OOMCB_OOMHIGH_MIN = 0.00;
    public final static double OOMCB_OOMHIGH_MAX = 1000000.00;    
    public final static double OOMCB_OOMLOW_MIN = 0.00;
    public final static double OOMCB_OOMLOW_MAX = 1000000.00;    
    public final static double OOMCB_OOMNONBILLABLEBENEFITS_MIN = 0.00;
    public final static double OOMCB_OOMNONBILLABLEBENEFITS_MAX = 1000000.00;

    // Constants for fields located in RiskMatrix
    
    public final static double RISKMATRIX_CONSEQUENCECOST_MIN = 0.00;
    public final static double RISKMATRIX_CONSEQUENCECOST_MAX = 9999999999999.99;
    
    public final static ArrayList RISKMATRIX_VALUES = new ArrayList();
    
    static
    {
        RISKMATRIX_VALUES.add(new Integer(20));
        RISKMATRIX_VALUES.add(new Integer(40));
        RISKMATRIX_VALUES.add(new Integer(60));
        RISKMATRIX_VALUES.add(new Integer(80));
        RISKMATRIX_VALUES.add(new Integer(100));
    }
    
    // Constants for fields located in ReqProConnection and ReqProImportStatus
    public final static int REQPRO_ID_MIN = 1;
    public final static int REQPRO_ID_MAX = 32;
    
    public final static int REQPRO_SERVER_URL_MIN = 1;
    public final static int REQPRO_SERVER_URL_MAX = 512;
    
    public final static int REQPRO_PROJECT_PATH_MIN = 1;
    public final static int REQPRO_PROJECT_PATH_MAX = 512;
    
    public final static int REQPRO_LOGON_MIN = 1;
    public final static int REQPRO_LOGON_MAX = 100;
    
    public final static int REQPRO_PASSWORD_MIN = 1;
    public final static int REQPRO_PASSWORD_MAX = 128;
    
    
    
    // field names for ScopeManagementModule
    public final static String ACTION_RTFS_FIELD = "actionRtfs";
    public final static String ACTION_STATES_FIELD = "actionStates";
    public final static String ATTRIBUTE_CATEGORIES_FIELD = "attributeCategories";
    public final static String CHANGEREQUEST_RTFS_FIELD = "changeRequestRtfs";
    public final static String CHANGEREQUEST_STATES_FIELD = "changeRequestStates";
    public final static String CUSTOMFIELD_CATEGORIES_FIELD = "customFieldCategories";
    public final static String DEFECT_RTFS_FIELD = "defectRtfs";
    public final static String DEFECT_STATES_FIELD = "defectStates";
    public final static String DELIVERABLE_RTFS_FIELD = "deliverableRtfs";
    public final static String ISSUE_RTFS_FIELD = "issueRtfs";
    public final static String ISSUE_STATES_FIELD = "issueStates";
    public final static String MILESTONE_RTFS_FIELD = "milestoneRtfs";
    public final static String REQUIREMENT_RTFS_FIELD = "requirementRtfs";
    public final static String REQUIREMENT_STATES_FIELD = "requirementStates";
    public final static String RISK_RTFS_FIELD = "riskRtfs";
    public final static String RISK_STATES_FIELD = "riskStates";
    public final static String SCOPE_FOLDERS_FIELD = "scopeFolders";
    public final static String SCORECARD_FOLDERS_FIELD = "scorecardFolders";
    public final static String SERVICEREQUEST_RTFS_FIELD = "serviceRequestRtfs";
    public final static String SERVICEREQUEST_STATES_FIELD = "serviceRequestStates";
    public final static String SUMMARYTASK_RTFS_FIELD = "summaryTaskRtfs";
    public final static String TASK_RTFS_FIELD = "taskRtfs";
    
    // common fields
    public final static String PARENT_FIELD = "parent";
    public final static String CHILDREN_FIELD = "children";
    public final static String DESCRIPTION_FIELD = "description";
    public final static String NAME_FIELD = "name";
    
    //constants for AbstractAggregateScope
    public final static int ABSTRACTAGGREGATESCOPE_CLOSED_BY_NAME_MAX = 100;
    public final static int ABSTRACTAGGREGATESCOPE_PROPOSED_BY_NAME_MAX = 100;
    
    // field name for AbstractAggregateScope
    public final static String ABSTRACTAGGREGATESCOPE_ATTRIBUTE_ASSIGNMENTS_FIELD = "attributeAssignments";
    public final static String ABSTRACTAGGREGATESCOPE_CLOSED_BY_DATE_FIELD = "closedByDate";
    public final static String ABSTRACTAGGREGATESCOPE_CLOSED_BY_NAME_FIELD = "closedByName";
    public final static String ABSTRACTAGGREGATESCOPE_ESTIMATED_DURATION_IN_MINUTES_FIELD = "estimatedDurationInMinutes";
    public final static String ABSTRACTAGGREGATESCOPE_ESTIMATED_FINISH_DATE_FIELD = "estimatedFinishDate";
    public final static String ABSTRACTAGGREGATESCOPE_ESTIMATED_START_DATE_FIELD = "estimatedStartDate";
    public final static String ABSTRACTAGGREGATESCOPE_PRIORITY_FIELD = "priority";
    public final static String ABSTRACTAGGREGATESCOPE_PROPOSED_BY_DATE_FIELD = "proposedByDate";
    public final static String ABSTRACTAGGREGATESCOPE_PROPOSED_BY_NAME_FIELD = "proposedByName";
    public final static String ABSTRACTAGGREGATESCOPE_PROPOSED_DATE_FIELD = "proposedDate";
    public final static String ABSTRACTAGGREGATESCOPE_REFERENCE_NUMBER_FIELD = "referenceNumber";
    public final static String ABSTRACTAGGREGATESCOPE_RTF_ASSIGNMENTS_FIELD = "rtfAssignments";
    public final static String ABSTRACTAGGREGATESCOPE_STATUS_UPDATES_FIELD = "statusUpdates";
    public final static String ABSTRACTAGGREGATESCOPE_TRANSFERED_UNDER_WBS_ROOT_FIELD = "transferedUnderWbsRoot";
    public final static String ABSTRACTAGGREGATESCOPE_WBS_FINANCIALS_FIELD = "wbsFinancials";
    public final static String ABSTRACTAGGREGATESCOPE_WORKSHEET_FINANCIALS_FIELD = "worksheetFinancials";
    
    // field name for AbstractRequest
    public final static String ABSTRACTREQUEST_APPROVED_COST_BENEFITS_FIELD = "approvedCostBenefits";
    public final static String ABSTRACTREQUEST_NUMBER_TIMES_REASSIGNED_FIELD = "numberTimesReassigned";
    public final static String ABSTRACTREQUEST_OCCURED_DATE_TIME_FIELD = "occuredDateTime";
    
    // field name for AbstractScope
    public final static String ABSTRACTSCOPE_APPROVED_BY_DATE_FIELD = "approvedByDate";
    public final static String ABSTRACTSCOPE_APPROVED_BY_NAME_FIELD = "approvedByName";
    public final static String ABSTRACTSCOPE_APPROVED_DATE_FIELD = "approvedDate";
    public final static String ABSTRACTSCOPE_ASSET_FIELD = "asset";
    public final static String ABSTRACTSCOPE_ASSET_CODE_FIELD = "assetCode";
    public final static String ABSTRACTSCOPE_ASSIGNED_SCORECARD_FIELD = "assignedScorecard";
    public final static String ABSTRACTSCOPE_CLIENT_COST_CENTER_FIELD = "clientCostCenter";
    public final static String ABSTRACTSCOPE_DEFAULT_SCOPE_FIELD = "defaultScope";
    public final static String ABSTRACTSCOPE_DOCUMENT_FOLDER_FIELD = "documentFolder";
    public final static String ABSTRACTSCOPE_DUPLICATE_NUMBER_FIELD = "duplicateNumber";
    public final static String ABSTRACTSCOPE_DUPLICATES_FIELD = "duplicates";
    public final static String ABSTRACTSCOPE_EXTERNAL_REFERENCE_NUMBER_FIELD = "externalReferenceNumber";
    public final static String ABSTRACTSCOPE_IMPACT_FIELD = "impact";
    public final static String ABSTRACTSCOPE_ORDER_OF_MAGNITUDE_COST_BENEFITS_FIELD = "orderOfMagnitudeCostBenefits";
    public final static String ABSTRACTSCOPE_PUBLISHED_FIELD = "published";
    public final static String ABSTRACTSCOPE_RANK_FIELD = "rank";
    public final static String ABSTRACTSCOPE_STATE_FIELD = "state";
    public final static String ABSTRACTSCOPE_TARGET_DATE_FIELD = "targetDate";
    
    // field for AbstractScopeTask
    public final static String ABSTRACTSCOPETASK_ATTRIBUTE_ASSIGNMENTS_FIELD = "attributeAssignments";
    public final static String ABSTRACTSCOPETASK_CLOSED_BY_DATE_FIELD = "closedByDate";
    public final static String ABSTRACTSCOPETASK_CLOSED_BY_NAME_FIELD = "closedByName";
    public final static String ABSTRACTSCOPETASK_MANDATORY_FIELD = "mandatory";
    public final static String ABSTRACTSCOPETASK_PRIORITY_FIELD = "priority";
    public final static String ABSTRACTSCOPETASK_PROPOSED_BY_DATE_FIELD = "proposedByDate";
    public final static String ABSTRACTSCOPETASK_PROPOSED_BY_NAME_FIELD = "proposedByName";
    public final static String ABSTRACTSCOPETASK_REFERENCE_NUMBER_FIELD = "referenceNumber";
    public final static String ABSTRACTSCOPETASK_RTF_ASSIGNMENTS_FIELD = "rtfAssignments";
    public final static String ABSTRACTSCOPETASK_STATUS_UPDATE_FIELD = "statusUpdate";
    public final static String ABSTRACTSCOPETASK_TRANSFERED_UNDER_WBS_ROOT_FIELD = "transferedUnderWbsRoot";
    public final static String ABSTRACTSCOPETASK_WBS_FINANCIALS_FIELD = "wbsFinancials";
    
    //constants for AbstractScopeTask
    public final static int ABSTRACTSCOPETASK_CLOSED_BY_NAME_MAX = 100;
    public final static int ABSTRACTSCOPETASK_PROPOSED_BY_NAME_MAX = 100;
    
    // field for Action
    public final static String ACTION_APPROVED_COST_BENEFITS_FIELD = "approvedCostBenefits";
    
    // field for ApprovedCostBenefits
    public final static String APPROVEDCOSTBENEFITS_BILLABLE_REVENUE_FIELD = "billableRevenue";
    public final static String APPROVEDCOSTBENEFITS_COST_FIELD = "cost";
    public final static String APPROVEDCOSTBENEFITS_NON_BILLABLE_BENEFITS_FIELD = "nonBillableBenefits";
    public final static String APPROVEDCOSTBENEFITS_SCHEDULE_IMPACT_IN_DAYS_FIELD = "scheduleImpactInDays";
    public final static String APPROVEDCOSTBENEFITS_WORK_IN_HOURS_FIELD = "workInHours";
    
    // field for Duplicate
    public final static String DUPLICATE_SCOPE_ELEMENT_FIELD = "scopeElement";
    
    // field for Impact
    public final static String IMPACT_ORDER_OF_MAGNITUDE_HIGH_WORK_IN_HOURS_FIELD = "orderOfMagnitudeHighWorkInHours";
    public final static String IMPACT_ORDER_OF_MAGNITUDE_LOW_WORK_IN_HOURS_FIELD = "orderOfMagnitudeLowWorkInHours";
    public final static String IMPACT_ORDER_OF_MAGNITUDE_WORK_IN_HOURS_FIELD = "orderOfMagnitudeWorkInHours";
    public final static String IMPACT_SCHEDULED_IMPACT_IN_DAYS_FIELD = "scheduleImpactInDays";
    
    // field for Issue
    public final static String ISSUE_NUMBER_TIMES_REASSIGNED_FIELD = "numberTimesReassigned";
    public final static String ISSUE_OCCURED_DATE_TIME_FIELD = "occuredDateTime";
    
    // field for MitigationFactor
    public final static String MITIGATIONFACTOR_MITIGATION_COST_FIELD = "mitigationCost";
    public final static String MITIGATIONFACTOR_MITIGATION_TRIGGERS_FIELD = "mitigationTriggers";
    public final static String MITIGATIONFACTOR_PRIORITY_FIELD = "priority";
    
    // field for OrderOfMagnitudeCostBenefits
    public final static String ORDEROFMAGNITUDECOSTBENEFITS_ORDER_OF_MAGNITUDE_BILLABLE_REVENUE_FIELD = "orderOfMagnitudeBillableRevenue";
    public final static String ORDEROFMAGNITUDECOSTBENEFITS_ORDER_OF_MAGNITUDE_COST_FIELD = "orderOfMagnitudeCost";
    public final static String ORDEROFMAGNITUDECOSTBENEFITS_ORDER_OF_MAGNITUDE_HIGH_FIELD = "orderOfMagnitudeHigh";
    public final static String ORDEROFMAGNITUDECOSTBENEFITS_ORDER_OF_MAGNITUDE_LOW_FIELD = "orderOfMagnitudeLow";
    public final static String ORDEROFMAGNITUDECOSTBENEFITS_ORDER_OF_MAGNITUDE_NON_BILLABLE_BENEFITS_FIELD = "orderOfMagnitudeNonBillableBenefits";
    
    // field for Requirement
    public final static String REQUIREMENT_APPROVED_COST_BENEFITS_FIELD = "approvedCostBenefits";
    
    // field for Risk
    public final static String RISK_MITIGATION_FACTORS_FIELD = "mitigationFactors";
    public final static String RISK_OCCURE_DATE_TIME_FIELD = "occuredDateTime";
    public final static String RISK_RISK_MATRIX_FIELD = "riskMatrix";
    
    // field for RiskMatrix
    public final static String RISKMATRIX_CONSEQUENCE_COST_FIELD = "consequenceCost";
    public final static String RISKMATRIX_EXPOSURE_PERCENT_FIELD = "exposurePercent";
    public final static String RISKMATRIX_IMPACT_FIELD = "impact";
    public final static String RISKMATRIX_MITIGATION_COST_FIELD = "mitigationCost";
    public final static String RISKMATRIX_PRECISION_FIELD = "precision";
    public final static String RISKMATRIX_PROBABILITY_FIELD = "probability";
    public final static String RISKMATRIX_PROBABILITY_COST_FIELD = "probabilityCost";
    public final static String RISKMATRIX_RISK_MATRIX_COLOR_FIELD = "riskMatrixColor";
    
    // field for ScopeElement
    public final static String SCOPEELEMENT_CUSTOM_FIELD_ASSIGNMENTS_FIELD = "customFieldAssignments";
    public final static String SCOPEELEMENT_NAME_FIELD = "name";
    public final static String SCOPEELEMENT_PROJECT_FIELD = "project";
    public final static String SCOPEELEMENT_RESOURCE_TASK_ASSIGNMENTS_FIELD = "resourceTaskAssignments";
    public final static String SCOPEELEMENT_WORK_ELEMENT_FIELD = "workElement";
    
    // field for ScopeFolder
    public final static String SCOPEFOLDER_PRIVATE_FOLDER_FIELD = "rivateFolder";
    
    // field for ScopeManagementModule
    public final static String SCOPEMANAGEMENTMODULE_ACTION_RTFS_FIELD = "actionRtfs";
    public final static String SCOPEMANAGEMENTMODULE_ACTION_STATES_FIELD = "actionStates";
    public final static String SCOPEMANAGEMENTMODULE_ATTRIBUTE_CATEGORIES_FIELD = "attributeCategories";
    public final static String SCOPEMANAGEMENTMODULE_CHANGE_REQUEST_RTFS_FIELD = "changeRequestRtfs";
    public final static String SCOPEMANAGEMENTMODULE_CHANGE_REQUEST_STATES_FIELD = "changeRequestStates";
    public final static String SCOPEMANAGEMENTMODULE_CUSTOM_FIELD_CATEGORIES_FIELD = "customFieldCategories";
    public final static String SCOPEMANAGEMENTMODULE_DEFECT_RTFS_FIELD = "defectRtfs";
    public final static String SCOPEMANAGEMENTMODULE_DEFECT_STATES_FIELD = "defectStates";
    public final static String SCOPEMANAGEMENTMODULE_DELIVERABLE_RTFS_FIELD = "deliverableRtfs";
    public final static String SCOPEMANAGEMENTMODULE_ISSUE_RTFS_FIELD = "issueRtfs";
    public final static String SCOPEMANAGEMENTMODULE_ISSUE_STATES_FIELD = "issueStates";
    public final static String SCOPEMANAGEMENTMODULE_MILESTONE_RTFS_FIELD = "milestoneRtfs";
    public final static String SCOPEMANAGEMENTMODULE_REQUIREMENT_RTFS_FIELD = "requirementRtfs";
    public final static String SCOPEMANAGEMENTMODULE_REQUIREMENT_STATES_FIELD = "requirementStates";
    public final static String SCOPEMANAGEMENTMODULE_RISK_RTFS_FIELD = "riskRtfs";
    public final static String SCOPEMANAGEMENTMODULE_RISK_STATES_FIELD = "riskStates";
    public final static String SCOPEMANAGEMENTMODULE_SCOPE_FOLDERS_FIELD = "scopeFolders";
    public final static String SCOPEMANAGEMENTMODULE_SCORECARD_FOLDERS_FIELD = "scorecardFolders";
    public final static String SCOPEMANAGEMENTMODULE_SERVICE_REQUEST_RTFS_FIELD = "serviceRequestRtfs";
    public final static String SCOPEMANAGEMENTMODULE_SERVICE_REQUEST_STATES_FIELD = "serviceRequestStates";
    public final static String SCOPEMANAGEMENTMODULE_SUMMARY_TASK_RTFS_FIELD = "summaryTaskRtfs";
    public final static String SCOPEMANAGEMENTMODULE_TASK_RTFS_FIELD = "taskRtfs";
    

    public final static String ID_FIELD = "id";
    
    // field names for ReqPro
    public final static String REQPRO_CONNECTION_FIELD = "reqProConnection";
    public final static String REQPRO_IMPORTSTATUS_FIELD = "reqProImportStatus";
    public final static String REQPRO_ID_FIELD = "reqProID";
    public final static String REQPRO_SERVER_URL_FIELD = "reqProServerURL";
    public final static String REQPRO_PROJECT_PATH_FIELD = "reqProProjectPath";
    public final static String REQPRO_LOGON_FIELD = "reqProLogon";
    public final static String REQPRO_PASSWORD_FIELD = "reqProPassword";
    public final static String REQPRO_LASTIMPORTEDDATETIME_FIELD = "reqProLastImportedDateTime";

    // Scope schedule date field names
    public final static String SCHEDULE_DATE_ACTUAL_FIELD = "actualDate";
    public final static String SCHEDULE_DATE_ACTUAL_START_FIELD = "actualDate.startDate";
    public final static String SCHEDULE_DATE_ACTUAL_FINISH_FIELD = "actualDate.finishDate";
    public final static String SCHEDULE_DATE_ACTUAL_DAYS_FIELD = "actualDate.days";
    public final static String SCHEDULE_DATE_ACTUAL_HOURS_FIELD = "actualDate.hours";
    public final static String SCHEDULE_DATE_ACTUAL_DURATION_FIELD = "actualDate.durationInMinutes";
    public final static String SCHEDULE_DATE_ACTUAL_WORK_HOURS_FIELD = "actualDate.workHours";

    public final static String SCHEDULE_DATE_PLAN_FIELD = "planDate";
    public final static String SCHEDULE_DATE_PLAN_START_FIELD = "planDate.startDate";
    public final static String SCHEDULE_DATE_PLAN_FINISH_FIELD = "planDate.finishDate";
    public final static String SCHEDULE_DATE_PLAN_DAYS_FIELD = "planDate.days";
    public final static String SCHEDULE_DATE_PLAN_HOURS_FIELD = "planDate.hours";
    public final static String SCHEDULE_DATE_PLAN_DURATION_FIELD = "planDate.durationInMinutes";
    public final static String SCHEDULE_DATE_PLAN_WORK_HOURS_FIELD = "planDate.workHours";

    public final static String SCHEDULE_DATE_PROPOSED_FIELD = "proposedDate";
    public final static String SCHEDULE_DATE_PROPOSED_START_FIELD = "proposedDate.startDate";
    public final static String SCHEDULE_DATE_PROPOSED_FINISH_FIELD = "proposedDate.finishDate";
    public final static String SCHEDULE_DATE_PROPOSED_DAYS_FIELD = "proposedDate.days";
    public final static String SCHEDULE_DATE_PROPOSED_HOURS_FIELD = "proposedDate.hours";
    public final static String SCHEDULE_DATE_PROPOSED_DURATION_FIELD = "proposedDate.durationInMinutes";
    public final static String SCHEDULE_DATE_PROPOSED_WORK_HOURS_FIELD = "proposedDate.workHours";

    public final static String SCHEDULE_DATE_FORECAST_FIELD = "forecastDate";
    public final static String SCHEDULE_DATE_FORECAST_START_FIELD = "forecastDate.startDate";
    public final static String SCHEDULE_DATE_FORECAST_FINISH_FIELD = "forecastDate.finishDate";
    public final static String SCHEDULE_DATE_FORECAST_DAYS_FIELD = "forecastDate.days";
    public final static String SCHEDULE_DATE_FORECAST_HOURS_FIELD = "forecastDate.hours";
    public final static String SCHEDULE_DATE_FORECAST_DURATION_FIELD = "forecastDate.durationInMinutes";
    public final static String SCHEDULE_DATE_FORECAST_WORK_HOURS_FIELD = "forecastDate.workHours";    
}
