package com.ibm.rpm.scopemanagement.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class PrecisionType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected PrecisionType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Low = "Low";
	public static final PrecisionType Low = new PrecisionType(_Low);
	
		
	public static final String _Medium = "Medium";
	public static final PrecisionType Medium = new PrecisionType(_Medium);
	
		
	public static final String _High = "High";
	public static final PrecisionType High = new PrecisionType(_High);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static PrecisionType fromValue(String value) throws IllegalStateException {
		PrecisionType retVal = (PrecisionType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static PrecisionType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof PrecisionType && ordinal == ((PrecisionType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((PrecisionType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final PrecisionType[] VALUES = {Low, Medium, High};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}