/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.scopemanagement.util;

import com.ibm.rpm.framework.security.ContainerSecurityDescriptor;
import com.ibm.rpm.framework.security.FieldSecurityDescriptor;
import com.ibm.rpm.framework.security.SecuredFields;
import com.ibm.rpm.framework.util.FieldSecurityDescriptorHandler;
import com.ibm.rpm.scopemanagement.containers.ReqProRequirement;

/**
 * @author Yasser Lulu
 *
 */
public class ReqProRequirementFieldSecurityDescriptorHandler extends
        FieldSecurityDescriptorHandler
{
    public ReqProRequirementFieldSecurityDescriptorHandler()
    {
        super(ReqProRequirement.class);
    }

    protected void applyReadOnlyRestrictions(ContainerSecurityDescriptor containerDescr)
    {
        super.applyReadOnlyRestrictions(containerDescr);
        FieldSecurityDescriptor rtfSecurityDescr = (FieldSecurityDescriptor) containerDescr
            .getRTFSecurityDescriptors().get(SecuredFields.INTEGERS[1]);
        //if it is null, then someone removed it, we won't create it
        if (rtfSecurityDescr != null)
        {
            rtfSecurityDescr.setCanEdit(false);
        }
        setReadOnly(getFieldSecurityDescriptors(containerDescr), "name");
    }
}