/*
 * Created on Dec 4, 2005
 * @author mmatwiy
 * Checkpoint validation of container AbstractScorecardElement. This class
 * is not called directly; it is extended by other container checkpoints.
 */
package com.ibm.rpm.scorecard.checkpoints;

import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scorecard.constants.ValidationConstants;
import com.ibm.rpm.scorecard.containers.AbstractScorecardElement;

public abstract class AbstractScorecardElementCheckpoint extends
        AbstractScorecardEntityCheckpoint
{
    protected void validateSave(RPMObject rpmObject, MessageContext msgCtx, 
            boolean parentRequired, List validParentTypes)
    {
        super.validateSave(rpmObject, msgCtx, parentRequired,
            validParentTypes);

        // Initialize
        AbstractScorecardElement scorecardElement = (AbstractScorecardElement) rpmObject;

        // On update, the weight field cannot be cleared
        GenericValidator.validateDefaultValueUpdate(scorecardElement,
            ValidationConstants.WEIGHT_FIELD, scorecardElement.getWeight(),
            msgCtx);
    }
}
