/*
 * Created on Dec 4, 2005
 * @author mmatwiy
 * Checkpoint validation of container ScorecardResponse.
 */
package com.ibm.rpm.scorecard.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scorecard.constants.ValidationConstants;
import com.ibm.rpm.scorecard.containers.ScorecardQuestion;
import com.ibm.rpm.scorecard.containers.ScorecardResponse;

public class ScorecardResponseCheckpoint extends
        AbstractScorecardElementCheckpoint
{
    private static final List SCORECARDRESPONSE_PARENT_LIST = new ArrayList();

    protected static ScorecardResponseCheckpoint instance = new ScorecardResponseCheckpoint();

    static
    {
        SCORECARDRESPONSE_PARENT_LIST.add(ScorecardQuestion.class);
    }

    public static ScorecardResponseCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, msgCtx, true,
            SCORECARDRESPONSE_PARENT_LIST);

        ScorecardResponse response = (ScorecardResponse) rpmObject;

        // On update, the defaultResponse field cannot be cleared
        GenericValidator.validateDefaultValueUpdate(response,
            ValidationConstants.DEFAULT_RESPONSE_FIELD, response
                .getDefaultResponse(), msgCtx);

        // Field validation of weight
        if (response.testWeightModified())
        {
            GenericValidator.validateRange(response,
                ValidationConstants.WEIGHT_FIELD, response.getWeight(),
                ValidationConstants.WEIGHT_RESPONSE_MIN,
                ValidationConstants.WEIGHT_MAX, msgCtx);
        }
    }

}
