package com.ibm.rpm.scorecard.constants;

public class ErrorCodes
{

    /**
     * Error codes for scorecard containers.
     * Error code range: 405,001 - 406,000
     * 405,001 - 405,299: validation codes
     * 405,300 - 405,499: xpath codes
     * 405,500 + : manager codes
     * 
     * These error messages usually have the container name at the beginning. 
     * The className of the RPMException will be a container.
     * All validation errors that can be thrown to an end user should
     * be of this type.
     */
    
    public final static int PUBLISHED_CAN_NOT_BE_SET = 405001;
    
    public final static int WRONG_NUMBER_OF_RESPONSES_FOR_QUESTION = 405002;
    
    public final static int INCORRECT_CONTEXT_FOR_SCORECARD_ASSIGNMENT = 405003;
    
    public final static int INCORRECT_NUMBER_OF_SCORECARD_ASSIGNMENTS = 405004;
    
    public final static int CANNOT_ASSIGN_SCORECARD_TO_TRANSFERRED_SCOPE_ELEMENT = 405005;
}