/*
 * Created on Dec 4, 2005 
 * @author mmatwiy 
 * Constants for use with scorecard test classes.
 */
package com.ibm.rpm.scorecard.constants;

public class ValidationConstants
{
    public final static String PARENT = "parent";
    
    // Scorecard field names for use in error messages
    public final static String NAME_FIELD = "name";
    public final static String DESCRIPTION_FIELD = "description";
    public final static String WEIGHT_FIELD = "weight";
    public final static String PROBABILITY_TYPE_FIELD = "probabilityType";
    public final static String COMMENTS_FIELD = "comments";
    public final static String RESPONSES_FIELD = "scorecardResponses";
    public final static String OBJECT_TO_ASSIGN_FIELD = "objectToAssign";
    public final static String OBJECT_TO_ASSIGN_SCOPE_FIELD = "objectToAssignScope";
    public final static String ACTIVE_FIELD = "active";
    public final static String TOREPORT_FIELD = "toReport";
    public final static String DEFAULT_RESPONSE_FIELD = "defaultResponse";
    public final static String SCORE_FIELD = "score";
    public final static String RESPONSE_DATE_FIELD = "responseDate";
    public final static String SELECTED_ANSWER_FIELD = "selectedAnswer";
    public final static String PUBLISHED_FIELD = "published";
    
    public final static String QUESTION_FIELD = "scorecardQuestions";
    public final static String CATEGORY_FIELD = "scorecardCategories";
    public final static String SCORECARD_FIELD = "scorecards";
    
    // AssignedScorecard field names
    public final static String ASSIGNED_SCORECARD_CATEGORIES_FIELD = "assignedScorecardCategories";
    public final static String SCORECARD_STATE_FIELD = "scorecardState";
    
    // AssignedScorecardCategory field names
    public final static String ASSIGNED_SCORECARD_QUESTIONS_FIELD = "assignedScorecardQuestions";
    
    // AssignedScorecardQuestion field names
    public final static String ASSIGNED_SCORECARD_RESPONSES_FIELD = "assignedScorecardResponses";
    public final static String RESPONSE_AUTHOR_FIELD = "responseAuthor";
    
    // Scorecard string length limits
    // name and description of 750 and 250 respectively can be increased
    // once Oracle SP_U_SCORECARD is fixed (defect #55281)
    public final static int NAME_CHARACTER_LIMIT = 750;
    public final static int SCORECARD_NAME_CHARACTER_LIMIT = 255;
    public final static int DESCRIPTION_CHARACTER_LIMIT = 250;
    public final static int COMMENTS_CHARACTER_LIMIT = 255;
    
    // Scorecard numeric mins and maxes
    public final static int WEIGHT_MIN = 1;
    public final static int WEIGHT_RESPONSE_MIN = 0;
    public final static int WEIGHT_MAX = 9999;
    public final static int NAME_MIN = 1;
    
}
