package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class DocumentSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected DocumentSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _DocumentGroup = "Document Group";
	public static final DocumentSecurityRoleType DocumentGroup = new DocumentSecurityRoleType(_DocumentGroup);
	
		
	public static final String _DocumentParticipant = "Document Participant";
	public static final DocumentSecurityRoleType DocumentParticipant = new DocumentSecurityRoleType(_DocumentParticipant);
	
		
	public static final String _DocumentResponsible = "Document Responsible";
	public static final DocumentSecurityRoleType DocumentResponsible = new DocumentSecurityRoleType(_DocumentResponsible);
	
		
	public static final String _DocumentVisitor = "Document Visitor";
	public static final DocumentSecurityRoleType DocumentVisitor = new DocumentSecurityRoleType(_DocumentVisitor);
	
		
	public static final String _DocumentWorkflowVisitor = "Document Workflow Visitor";
	public static final DocumentSecurityRoleType DocumentWorkflowVisitor = new DocumentSecurityRoleType(_DocumentWorkflowVisitor);
	
		
	public static final String _DocumentUnrestrictedVisitor = "Document Unrestricted Visitor";
	public static final DocumentSecurityRoleType DocumentUnrestrictedVisitor = new DocumentSecurityRoleType(_DocumentUnrestrictedVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static DocumentSecurityRoleType fromValue(String value) throws IllegalStateException {
		DocumentSecurityRoleType retVal = (DocumentSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static DocumentSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof DocumentSecurityRoleType && ordinal == ((DocumentSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((DocumentSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final DocumentSecurityRoleType[] VALUES = {DocumentGroup, DocumentParticipant, DocumentResponsible, DocumentVisitor, DocumentWorkflowVisitor, DocumentUnrestrictedVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}