package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class FolderSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected FolderSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _FolderGroup = "Folder Group";
	public static final FolderSecurityRoleType FolderGroup = new FolderSecurityRoleType(_FolderGroup);
	
		
	public static final String _FolderManager = "Folder Manager";
	public static final FolderSecurityRoleType FolderManager = new FolderSecurityRoleType(_FolderManager);
	
		
	public static final String _FolderParticipant = "Folder Participant";
	public static final FolderSecurityRoleType FolderParticipant = new FolderSecurityRoleType(_FolderParticipant);
	
		
	public static final String _FolderVisitor = "Folder Visitor";
	public static final FolderSecurityRoleType FolderVisitor = new FolderSecurityRoleType(_FolderVisitor);
	
		
	public static final String _FolderWorkflowVisitor = "Folder Workflow Visitor";
	public static final FolderSecurityRoleType FolderWorkflowVisitor = new FolderSecurityRoleType(_FolderWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static FolderSecurityRoleType fromValue(String value) throws IllegalStateException {
		FolderSecurityRoleType retVal = (FolderSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static FolderSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof FolderSecurityRoleType && ordinal == ((FolderSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((FolderSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final FolderSecurityRoleType[] VALUES = {FolderGroup, FolderManager, FolderParticipant, FolderVisitor, FolderWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}