package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class RiskSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected RiskSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _RiskGroup = "Risk Group";
	public static final RiskSecurityRoleType RiskGroup = new RiskSecurityRoleType(_RiskGroup);
	
		
	public static final String _RiskParticipant = "Risk Participant";
	public static final RiskSecurityRoleType RiskParticipant = new RiskSecurityRoleType(_RiskParticipant);
	
		
	public static final String _RiskResponsible = "Risk Responsible";
	public static final RiskSecurityRoleType RiskResponsible = new RiskSecurityRoleType(_RiskResponsible);
	
		
	public static final String _RiskTeamMember = "Risk Team Member";
	public static final RiskSecurityRoleType RiskTeamMember = new RiskSecurityRoleType(_RiskTeamMember);
	
		
	public static final String _RiskVisitor = "Risk Visitor";
	public static final RiskSecurityRoleType RiskVisitor = new RiskSecurityRoleType(_RiskVisitor);
	
		
	public static final String _RiskWorkflowVisitor = "Risk Workflow Visitor";
	public static final RiskSecurityRoleType RiskWorkflowVisitor = new RiskSecurityRoleType(_RiskWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static RiskSecurityRoleType fromValue(String value) throws IllegalStateException {
		RiskSecurityRoleType retVal = (RiskSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static RiskSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof RiskSecurityRoleType && ordinal == ((RiskSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((RiskSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final RiskSecurityRoleType[] VALUES = {RiskGroup, RiskParticipant, RiskResponsible, RiskTeamMember, RiskVisitor, RiskWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}