package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ServiceRequestSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ServiceRequestSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _ServiceRequestGroup = "Service Request Group";
	public static final ServiceRequestSecurityRoleType ServiceRequestGroup = new ServiceRequestSecurityRoleType(_ServiceRequestGroup);
	
		
	public static final String _ServiceRequestParticipant = "Service Request Participant";
	public static final ServiceRequestSecurityRoleType ServiceRequestParticipant = new ServiceRequestSecurityRoleType(_ServiceRequestParticipant);
	
		
	public static final String _ServiceRequestResponsible = "Service Request Responsible";
	public static final ServiceRequestSecurityRoleType ServiceRequestResponsible = new ServiceRequestSecurityRoleType(_ServiceRequestResponsible);
	
		
	public static final String _ServiceRequestTeamMember = "Service Request Team Member";
	public static final ServiceRequestSecurityRoleType ServiceRequestTeamMember = new ServiceRequestSecurityRoleType(_ServiceRequestTeamMember);
	
		
	public static final String _ServiceRequestVisitor = "Service Request Visitor";
	public static final ServiceRequestSecurityRoleType ServiceRequestVisitor = new ServiceRequestSecurityRoleType(_ServiceRequestVisitor);
	
		
	public static final String _ServiceRequestWorkflowVisitor = "Service Request Workflow Visitor";
	public static final ServiceRequestSecurityRoleType ServiceRequestWorkflowVisitor = new ServiceRequestSecurityRoleType(_ServiceRequestWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ServiceRequestSecurityRoleType fromValue(String value) throws IllegalStateException {
		ServiceRequestSecurityRoleType retVal = (ServiceRequestSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ServiceRequestSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ServiceRequestSecurityRoleType && ordinal == ((ServiceRequestSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ServiceRequestSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ServiceRequestSecurityRoleType[] VALUES = {ServiceRequestGroup, ServiceRequestParticipant, ServiceRequestResponsible, ServiceRequestTeamMember, ServiceRequestVisitor, ServiceRequestWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}