package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class TemplateFolderSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected TemplateFolderSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _FolderGroup = "Folder Group";
	public static final TemplateFolderSecurityRoleType FolderGroup = new TemplateFolderSecurityRoleType(_FolderGroup);
	
		
	public static final String _FolderManager = "Folder Manager";
	public static final TemplateFolderSecurityRoleType FolderManager = new TemplateFolderSecurityRoleType(_FolderManager);
	
		
	public static final String _FolderParticipant = "Folder Participant";
	public static final TemplateFolderSecurityRoleType FolderParticipant = new TemplateFolderSecurityRoleType(_FolderParticipant);
	
		
	public static final String _FolderVisitor = "Folder Visitor";
	public static final TemplateFolderSecurityRoleType FolderVisitor = new TemplateFolderSecurityRoleType(_FolderVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static TemplateFolderSecurityRoleType fromValue(String value) throws IllegalStateException {
		TemplateFolderSecurityRoleType retVal = (TemplateFolderSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static TemplateFolderSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof TemplateFolderSecurityRoleType && ordinal == ((TemplateFolderSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((TemplateFolderSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final TemplateFolderSecurityRoleType[] VALUES = {FolderGroup, FolderManager, FolderParticipant, FolderVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}