/*
 * Checkpoint validation of Timesheet container AdministrativeTaskAssignment.
 */
package com.ibm.rpm.timesheet.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.timesheet.containers.GenericTaskAssignment;


public class AdministrativeTaskAssignmentCheckpoint extends AbstractCheckpoint
{
    private static final List ADMINTASKASSIGNMENT_PARENT_LIST = new ArrayList();

    protected static AdministrativeTaskAssignmentCheckpoint instance = new AdministrativeTaskAssignmentCheckpoint();

    static
    {
        ADMINTASKASSIGNMENT_PARENT_LIST.add(Resource.class);
    }

    public static AdministrativeTaskAssignmentCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext messageContext)
    {
        if (GenericValidator.validateCannotCreate(rpmObject, messageContext))
        {
            GenericTaskAssignment ta = (GenericTaskAssignment) rpmObject;
            GenericValidator.validateMandatory(rpmObject, "shownInTimesheet",
                    ta.getShownInTimesheet(), messageContext);
        }
    }
}
