package com.ibm.rpm.timesheet.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.timesheet.constants.ValidationConstants;
import com.ibm.rpm.timesheet.containers.AdministrativeTask;
import com.ibm.rpm.timesheet.containers.PersonalProject;

public class AdministrativeTaskCheckpoint extends TimesheetElementCheckpoint
{
    private static final List ADMINISTRATIVETASK_PARENT_LIST = new ArrayList();

    protected static AdministrativeTaskCheckpoint instance = new AdministrativeTaskCheckpoint();

    static
    {
        ADMINISTRATIVETASK_PARENT_LIST.add(PersonalProject.class);
    }

    public static AdministrativeTaskCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        AdministrativeTask adminTask = (AdministrativeTask) rpmObject;

        super.isValidParent(rpmObject, msgCtx, false,
            ADMINISTRATIVETASK_PARENT_LIST);

        //cannot create
        GenericValidator.validateCannotCreate(adminTask, msgCtx);

        if (adminTask.testNameModified())
        {
            GenericValidator.validateReadOnly(adminTask,
                ValidationConstants.NAME_FIELD, msgCtx);
        }
        
        
        super.validateReadOnly(adminTask, msgCtx);

    }
}
