/**
 * Created on Dec 14, 2005
 * @author shahla
 */
package com.ibm.rpm.timesheet.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.timesheet.constants.ValidationConstants;
import com.ibm.rpm.timesheet.containers.DefaultStep;
import com.ibm.rpm.timesheet.scope.DefaultStepScope;
import com.ibm.rpm.wbs.containers.GenericProject;

public class DefaultStepCheckpoint extends AbstractCheckpoint
{
    private static final List STEP_PARENT_LIST = new ArrayList();

    protected static DefaultStepCheckpoint instance = new DefaultStepCheckpoint();

    static
    {
        STEP_PARENT_LIST.add(GenericProject.class);
    }

    public static DefaultStepCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, true, STEP_PARENT_LIST);

        if (!GenericValidator.validateInstance(rpmObject,
            DefaultStep.class, msgCtx))
            return;

        // Initialize
        DefaultStep defaultStep = (DefaultStep) rpmObject;
        DefaultStepScope scope = (DefaultStepScope) rpmScope;

        if (defaultStep.testNameModified())
        {
            GenericValidator.validateMaxLength(defaultStep,
                ValidationConstants.NAME_FIELD, defaultStep.getName(),
                ValidationConstants.STEP_NAME_CHARACTER_LIMIT, msgCtx);
        }
        // TODO after implement DefaultStep
//        TimesheetValidator.validateStepTimeCodes(defaultStep, scope, msgCtx);
    }

}