package com.ibm.rpm.timesheet.constants;

public class ErrorCodes
{

    /**
     * Error codes for timesheet containers.
     * Error code range: 406,001 - 407,000
     * 406,001 - 406,299: validation codes
     * 406,300 - 406,499: xpath codes
     * 406,500 + : manager codes
     * 
     * These error messages usually have the container name at the beginning. 
     * The className of the RPMException will be a container.
     * All validation errors that can be thrown to an end user should
     * be of this type.
     */

    // validation constants
    public final static int TIMECODE_NOT_ASSIGNED_TO_WORKELEMENT = 406001;
    
    public final static int WEIGHT_GREATER_THAN_100 = 406002;
    
    public final static int PROJECT_NOT_PUBLISHED_TO_TEAM = 406003;
    
    public final static int WORK_ELEMENT_STILL_PROPOSED = 406004;
    
    public final static int NO_SUMMARY_TIMESHEET_FOR_ID_AND_WEEKOF = 406005;
    
    public final static int NO_SUMMARY_TIMESHEET_FOR_TASK_ASSIGNMENT = 406006;
    
    public final static int NO_SUMMARY_TIMESHEET_FOR_WEEKOF = 406007;
    
    public final static int CANNOT_MODIFY_TIMESHEET = 406008;
    
    public final static int TASK_ASSIGNMENT_WITHOUT_RESOURCE = 406009;
    
    public final static int SCOPE_ELEMENT_NOT_UNDER_WBS = 406010;
    
    public final static int OBJECT_DOES_NOT_EXIST = 406011;
    
    public final static int USER_NOT_ALLOWED_TO_CHANGE_STATUS = 406012;
    
    public final static int APPROVAL_NOTES_READ_ONLY = 406013;
    
    public final static int NO_STEP_TIMESHEET_FOR_WEEK_OF = 406014;
    
    public final static int CREDIT_TIMESHEET_ALREADY_EXIST = 406015;
    
    public final static int INVALID_TIMESHEET_APPROVAL_STATUS = 406016;
    
    public final static int CANNOT_DELETE_ITEM_WITH_ACTUALS = 406017;
    
    public final static int NO_APPROVED_SUMMARY_TIMESHEET_FOR_WEEKOF = 406018;
    
    public final static int CREDIT_HOURS_CANNOT_EXCEED_ACTUAL_HOURS = 406019;
    
    public final static int CREDIT_HOURS_CANNOT_EXCEED_SUMMARY_TIMESHEET_HOURS = 406020;
    
    public final static int STEP_TIMESHEET_ALREADY_EXIST = 406021;
    
    public final static int MANDATORY_CALENDAR = 406022;
    
    public final static int TIMECODE_ASSIGNED_TO_SUMMARY_TIMESHEET = 406023;
    
    public final static int CANNOT_APPROVE_REJECT_TIMESHEET = 406024;
    
    public final static int PROJECT_MANAGER_CANNOT_APPROVE_REJECT_TIMESHEET = 406025;
    
    public final static int RESOURCE_MANAGER_CANNOT_APPROVE_REJECT_TIMESHEET = 406026;
    
    public final static int PROJECT_MANAGER_NEEDS_TO_APPROVE_FIRST = 406027;
    
    public final static int SUMMARY_TIMESHEET_IS_NOT_SUBMITTED_YET = 406028;
    
    public final static int FORECAST_FINISH_DATE_CANNOT_BEFORE_TIMESHEET_WEEKOF = 406029;
}
