/*
 * Created on Jan 16, 2006
 * @author mmatwiy
 * Constants for Timesheet validation
 */
package com.ibm.rpm.timesheet.constants;


public class ValidationConstants
{
    // Validation field names
    public final static String PARENT_FIELD = "parent";
    public final static String NAME_FIELD = "name";
    public final static String TIMECODE1_FIELD = "timeCode1";
    public final static String TIMECODE2_FIELD = "timeCode2";
    public final static String WEIGHT_FIELD = "weight";
    public final static String PERCENTAGE_COMPLETE_FIELD = "percentageComplete";
    public final static String ETC_CHANGED_FIELD = "ETCChanged";
    public final static String EETC_FIELD = "EETC";
    public final static String BILLABLE_FIELD = "billable";
    public final static String STEP_TIMESHEETS_FIELD = "stepTimesheets";
    public final static String CREDIT_TIMESHEET_FIELD = "creditTimesheet";
    public final static String APPROVAL_DATE_FIELD = "approvalDate";
    public final static String APPROVAL_NOTES_FIELD = "approvalNotes";
    public final static String APPROVAL_STATUS_FIELD = "approvalStatus";
    public final static String LAST_APPROVED_BY_FIELD = "lastApprovedRejectedBy";
    public final static String PROJECT_FIELD = "project";
    public final static String RESOURCE_FIELD = "resource";
    public final static String WEEK_OF_FIELD = "weekOf";
    public final static String CREDIT_WEEK_OF_FIELD = "creditWeekOf";
    public final static String REGULAR_MONDAY_FIELD = "regularMonday";
    public final static String REGULAR_TUESDAY_FIELD = "regularTuesday";
    public final static String REGULAR_WEDNESDAY_FIELD = "regularWednesday";
    public final static String REGULAR_THURSDAY_FIELD = "regularThursday";
    public final static String REGULAR_FRIDAY_FIELD = "regularFriday";
    public final static String REGULAR_SATURDAY_FIELD = "regularSaturday";
    public final static String REGULAR_SUNDAY_FIELD = "regularSunday";
    public final static String SPECIAL_MONDAY_FIELD = "specialMonday";
    public final static String SPECIAL_TUESDAY_FIELD = "specialTuesday";
    public final static String SPECIAL_WEDNESDAY_FIELD = "specialWednesday";
    public final static String SPECIAL_THURSDAY_FIELD = "specialThursday";
    public final static String SPECIAL_FRIDAY_FIELD = "specialFriday";
    public final static String SPECIAL_SATURDAY_FIELD = "specialSaturday";
    public final static String SPECIAL_SUNDAY_FIELD = "specialSunday";
    public final static String SUMMARY_NOTES_FIELD = "summaryNotes";
    public final static String PUBLISHED_FIELD = "published";
    public final static String TOTAL_REGULAR_FIELD = "totalRegular";
    public final static String TOTAL_SPECIAL_FIELD = "totalSpecial";
    public final static String TOTAL_WEEK_FIELD = "totalWeek";
    public final static String COMPLETE_FIELD = "complete";
    public final static String STEPS_FIELD = "steps";
    public final static String TASK_ASSIGNMENT_FIELD = "taskAssignment";
    public final static String SUMMARY_TIMESHEET_FIELD = "getParent().getParent()";
    public final static String PERSONAL_TASK_FIELD = "personalTask";
    public final static String WORK_ELEMENT_FIELD = "workElement";
    public final static String STEP_ALWAYS_AVAILABLE_FIELD = "alwaysAvailable";
    public final static String ACTUAL_FIELD = "actual";
    public final static String FINISH_DATE_FIELD = "finishDate";
    public final static String PERCENTAGE_COMPLETED_FIELD = "percentageCompleted";
    public final static String PERCENTAGE_WORK_FIELD = "percentageWork";
    public final static String START_DATE_FIELD = "startDate";
    public final static String FORECAST_START_DATE_FIELD = "forecastStartDate";
    public final static String FORECAST_FINISH_DATE_FIELD = "forecastFinishDate";
    
    // TMT_SETTINGS
    public final static String TMT_SETTINGS_TABLE_NAME = "TMT_SETTINGS";
    public final static String TMT_SETTINGS_SETTING_VALUE_FIELD = "SETTING_VALUE";
    public final static String TMT_SETTINGS_ELEMENT_ID_FIELD = "ELEMENT_ID";
    public final static String TMT_SETTINGS_APPROVAL_BY_VALUE = "TIMESHEET_AUTO_APPROVAL";
    public final static int TMT_SETTINGS_SETTING_VALUE_PMRM = 0;
    public final static int TMT_SETTINGS_SETTING_VALUE_PM = 1;
    public final static int TMT_SETTINGS_SETTING_VALUE_RM = 2;
    
    // String character limits
    public final static int STEP_NAME_CHARACTER_LIMIT = 50;
    public final static int PERSONAL_TASK_NAME_CHARACTER_LIMIT = 240;
    public final static int ADMIN_TASK_NAME_CHARACTER_LIMIT = 50;
    
    //  Minimum field values
    public final static double MIN_WORKING_HOURS_PER_DAY = 0;
    public final static double PERCENTAGE_MIN = 0;
    public final static double EETC_MIN = 0;
    public final static int NAME_MIN = 1;
    
    //  Maximum field values
    public final static double MAX_WORKING_HOURS_PER_DAY = 255;
    public final static double PERCENTAGE_MAX = 100;
    public final static int APPROVAL_NOTES_MAX = 1024;
    public final static int SUMMARY_NOTES_MAX = 255;
}
