/*
 * Created on Nov 16, 2005 
 * @author mmatwiy 
 * Checkpoint validation for WBS Proposal container.
 */
package com.ibm.rpm.wbs.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.applicationadministration.containers.State;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.wbs.constants.ValidationConstants;
import com.ibm.rpm.wbs.containers.Portfolio;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.containers.WorkOrganization;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class ProposalCheckpoint extends GenericProjectCheckpoint
{
    private static final List PROPOSAL_PARENT_LIST = new ArrayList();

    protected static ProposalCheckpoint instance = new ProposalCheckpoint();

    static
    {
        PROPOSAL_PARENT_LIST.add(WbsModule.class);
        PROPOSAL_PARENT_LIST.add(Proposal.class);
        PROPOSAL_PARENT_LIST.add(Project.class);
        PROPOSAL_PARENT_LIST.add(WorkOrganization.class);
        PROPOSAL_PARENT_LIST.add(Portfolio.class);
    }

    public static ProposalCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx, false, PROPOSAL_PARENT_LIST);

        Proposal proposal = (Proposal) rpmObject;
        WorkElementScope scope = (WorkElementScope)rpmScope;

        if (scope != null && scope.isState() && proposal.testStateModified())
        {
            // proposal.state must be of type State
            GenericValidator.validateType(rpmObject,
                State.class, ValidationConstants.STATE_FIELD,
                proposal.getState(), msgCtx);
        }
        
    }

}