/*
 * Created on Nov 16, 2005 
 * @author mmatwiy 
 * Checkpoint validation for WBS WorkOrganization container.
 */
package com.ibm.rpm.wbs.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.applicationadministration.containers.State;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.wbs.constants.ValidationConstants;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.containers.WorkOrganization;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class WorkOrganizationCheckpoint extends GenericProjectCheckpoint
{
    private static final List WORKORGANIZATION_PARENT_LIST = new ArrayList();

    protected static WorkOrganizationCheckpoint instance = new WorkOrganizationCheckpoint();

    static
    {
        WORKORGANIZATION_PARENT_LIST.add(Proposal.class);
        WORKORGANIZATION_PARENT_LIST.add(Project.class);
        WORKORGANIZATION_PARENT_LIST.add(WorkOrganization.class);
    }

    public static WorkOrganizationCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx, false,
            WORKORGANIZATION_PARENT_LIST);

        WorkOrganization workOrganization = (WorkOrganization) rpmObject;
        WorkElementScope scope = (WorkElementScope) rpmScope;

        if (scope != null && scope.isState()
                && workOrganization.testStateModified())
        {
            // workOrganization.state must be of type State
            GenericValidator.validateType(rpmObject, State.class,
                ValidationConstants.STATE_FIELD, workOrganization.getState(),
                msgCtx);
        }
    }

}