/*
 * Created on Nov 15, 2005
 * @author mmatwiy
 * Constants for WBS validation
 */
package com.ibm.rpm.wbs.constants;

public class ValidationConstants
{
    public final static int WBS_NESTINGLEVEL_MAX = 28;
    
    // Test field names
    public final static String PARENT = "parent";
    
    // SimpleNode field names for use in error messages
    public final static String MANDATORy_FIELD = "mandatory";
    public final static String EFFORT_DRIVEN_FIELD = "effortDriven";
    public final static String TASK_TYPE_FIELD = "taskType";

    // WorkElement field names for use in error messages
    public final static String NAME_FIELD = "name";
    public final static String STATE_FIELD = "state";
    public final static String PERCENT_DURATION_COMPLETED_FIELD = "percentageDurationCompleted";
    public final static String ESTIMATED_FINISH_DATE_FIELD = "estimatedFinishDate";
    public final static String ESTIMATED_START_DATE_FIELD = "estimatedStartDate";
    public final static String PRIORITY_FIELD = "priority";
    public final static String EXTERNAL_ID_FIELD = "externalID";
    public final static String REFERENCE_NUMBER_FIELD = "referenceNumber";
    public final static String RESOURCE_TASK_ASSIGNMENTS_FIELD = "resourceTaskAssignments";
    public final static String ASSET_CODE_FIELD = "assetCode";
    public final static String PUBLISHED_FIELD = "published";
    public final static String TIME_CODE1_FIELD = "timeCode1";
    public final static String TIME_CODE2_FIELD = "timeCode2";
    public final static String REFERENCE_ID_FIELD = "referenceID";
    public final static String CLOSED_BY_DATE_FIELD = "closedByDate";
    public final static String CLOSED_BY_NAME_FIELD = "closedByName";
    
    public final static String ACCEPT_TASK_ASSIGNMENT = "accept";
    public final static String REJECT_TASK_ASSIGNMENT = "reject";
    public final static String ACCEPT_TASK_ASSIGNMENT_METHOD = "acceptTaskAssignmentChanges";
    public final static String REJECT_TASK_ASSIGNMENT_METHOD = "rejectTaskAssignmentChanges";
    public final static String ACCEPT_EETC_ARG = "acceptEETC";
    public final static String REJECT_EETC_ARG = "rejectEETC";
    public final static String ACCEPT_FORECAST_DATES_ARG = "acceptForecastDates";
    public final static String REJECT_FORECAST_DATES_ARG = "rejectForecastDates";
    public final static String FORECAST_DATE_ARG = "forecastDate";

    public final static String SCHEDULE_DATE_ACTUAL_FIELD = "actualDate";
    public final static String SCHEDULE_DATE_ACTUAL_START_FIELD = "actualDate.startDate";
    public final static String SCHEDULE_DATE_ACTUAL_FINISH_FIELD = "actualDate.finishDate";
    public final static String SCHEDULE_DATE_ACTUAL_DAYS_FIELD = "actualDate.days";
    public final static String SCHEDULE_DATE_ACTUAL_HOURS_FIELD = "actualDate.hours";
    public final static String SCHEDULE_DATE_ACTUAL_DURATION_FIELD = "actualDate.durationInMinutes";
    public final static String SCHEDULE_DATE_ACTUAL_WORK_HOURS_FIELD = "actualDate.workHours";

    public final static String SCHEDULE_DATE_PLAN_FIELD = "planDate";
    public final static String SCHEDULE_DATE_PLAN_START_FIELD = "planDate.startDate";
    public final static String SCHEDULE_DATE_PLAN_FINISH_FIELD = "planDate.finishDate";
    public final static String SCHEDULE_DATE_PLAN_DAYS_FIELD = "planDate.days";
    public final static String SCHEDULE_DATE_PLAN_HOURS_FIELD = "planDate.hours";
    public final static String SCHEDULE_DATE_PLAN_DURATION_FIELD = "planDate.durationInMinutes";
    public final static String SCHEDULE_DATE_PLAN_WORK_HOURS_FIELD = "planDate.workHours";

    public final static String SCHEDULE_DATE_PROPOSED_FIELD = "proposedDate";
    public final static String SCHEDULE_DATE_PROPOSED_START_FIELD = "proposedDate.startDate";
    public final static String SCHEDULE_DATE_PROPOSED_FINISH_FIELD = "proposedDate.finishDate";
    public final static String SCHEDULE_DATE_PROPOSED_DAYS_FIELD = "proposedDate.days";
    public final static String SCHEDULE_DATE_PROPOSED_HOURS_FIELD = "proposedDate.hours";
    public final static String SCHEDULE_DATE_PROPOSED_DURATION_FIELD = "proposedDate.durationInMinutes";
    public final static String SCHEDULE_DATE_PROPOSED_WORK_HOURS_FIELD = "proposedDate.workHours";

    public final static String SCHEDULE_DATE_FORECAST_FIELD = "forecastDate";
    public final static String SCHEDULE_DATE_FORECAST_START_FIELD = "forecastDate.startDate";
    public final static String SCHEDULE_DATE_FORECAST_FINISH_FIELD = "forecastDate.finishDate";
    public final static String SCHEDULE_DATE_FORECAST_DAYS_FIELD = "forecastDate.days";
    public final static String SCHEDULE_DATE_FORECAST_HOURS_FIELD = "forecastDate.hours";
    public final static String SCHEDULE_DATE_FORECAST_DURATION_FIELD = "forecastDate.durationInMinutes";
    public final static String SCHEDULE_DATE_FORECAST_WORK_HOURS_FIELD = "forecastDate.workHours";
    
    public final static String EARNED_VALUE_FIELD="earnedValue";
    public final static String EV_CALCULATION_ACTIVATION_STATE = "earnedValuesActivationState";

    // WorkElement field length values
    public final static double PERCENT_DURATION_COMPLETED_MIN = 0.0;
    public final static double PERCENT_DURATION_COMPLETED_MAX = 100.0;

    public final static int PROJECT_REFERENCE_NUMBER_CHARACTER_LIMIT = 19;
    public final static int PROJECT_ACTIVITY_REFERENCE_NUMBER_CHARACTER_LIMIT = 50;

    public final static int PROJECT_NAME_CHARACTER_LIMIT = 240;
    public final static int PORTFOLIO_NAME_CHARACTER_LIMIT = 240;
    public final static int PORTFOLIO_NAME_MIN = 1;
    public final static int PROJECT_ACTIVITY_NAME_CHARACTER_LIMIT = 255;

    public final static int EXTERNAL_ID_CHARACTER_LIMIT = 50;
    public final static int PRIORITY_MIN = 0;
    public final static int PRIORITY_MAX = 1000;
    public final static int WORK_ELEMENT_NAME_MIN = 1;
    
    public final static  int EV_DELAY_DAYS_MIN = 0;    
    public final static  int EV_DELAY_DAYS_MAX = 8;
    
   
    // Project field names for use in error messages
    public final static String PROJECT_ASSIGNMENT_TYPE_FIELD = "assignmentType";
    public final static String PROJECT_CALENDAR_FIELD = "calendar";
    public final static String PROJECT_CURRENCY_FIELD = "currency";
    public final static String DEFAULT_PROJECT_FIELD = "defaultProject";


    // Attribute Assignment field names for use in error messages
    public final static String ACTION_ATTR_ASGN_FIELD = "actionAttributeAssignments";
    public final static String CHANGE_REQUEST_ATTR_ASGN_FIELD = "changeRequestAttributeAssignments";
    public final static String DEFECT_ATTR_ASSGN_FIELD = "defectAttributeAssignments";
    public final static String DELIVERABLE_ATTR_ASGN_FIELD = "deliverableAttributeAssignments";
    public final static String DOCUMENT_ATTR_ASGN_FIELD = "documentAttributeAssignments";
    public final static String ISSUE_ATTR_ASGN_FIELD = "issueAttributeAssignments";
    public final static String REQUIREMENT_ATTR_ASGN_FIELD = "requirementAttributeAssignments";
    public final static String RISK_ATTR_ASGN_FIELD = "riskAttributeAssignments";
    public final static String SERVICE_REQUEST_ATTR_ASGN_FIELD = "serviceRequestAttributeAssignments";
    public final static String TASK_ATTR_ASGN_FIELD = "taskAttributeAssignments";


    // ElementDependency field names for use in error messages
    public final static String ELEMENT_DEPENDENCY_AMOUNT_FIELD = "amount";
    public final static String ELEMENT_DEPENDENCY_TYPE_FIELD = "dependencyType";
    public final static String ELEMENT_DEPENDENCY_LEAD_LAG_FIELD = "leadlagType";
    public final static String ELEMENT_DEPENDENCY_UNIT_TYPE_FIELD = "unitType";
    public final static String ELEMENT_DEPENDENCY_PREDECESSOR_FIELD = "predecessor";
    public final static String ELEMENT_DEPENDENCY_CREATED_BY_FIELD = "createdBy";

    // ElementDependency field length values
    public final static int ELEMENT_DEPENDENCY_AMOUNT_MIN = 0;
    public final static int ELEMENT_DEPENDENCY_AMOUNT_MAX = 999;


    // Opportunity field names for use in error messages
    public final static String BENEFIT_BEGINS_MONTHS_FIELD = "benefitBeginsMonths";
    public final static String BENEFIT_DURATION_MONTHS_FIELD = "benefitDurationMonths";
    public final static String CONTACT_NUMBER_FIELD = "contactNumber";
    public final static String CONTACT_TYPE_FIELD = "contactType";
    public final static String CUSTOMER_NUMBER_FIELD = "customerNumber";
    public final static String EXTERNAL_CLIENT_FIELD = "externalClient";
    public final static String OPPORTUNITY_OWNER_FIELD = "opportunityOwner";
    public final static String OPPORTUNITY_TRACKING_NUMBER_FIELD = "opportunityTrackingNumber";
    public final static String ORDER_OF_MAGNITUDE_COST_FIELD = "orderOfMagnitudeCost";
    public final static String ORDER_OF_MAGNITUDE_REVENUE_BENEFITS_FIELD = "orderOfMagnitudeRevenueBenefits";
    public final static String ORDER_OF_MAGNITUDE_GP_SAVINGS_PERCENT = "orderOfMagnitudeGPSavingsPercent";
    public final static String PROBABILITY_PERCENT_FIELD = "probabilityPercent";
    public final static String FORECAST_CLOSED_FIELD = "forecastClosed";
    public final static String PURSUIT_FINISH_FIELD = "pursuitFinish";
    public final static String PURSUIT_START_FIELD = "pursuitStart";

    // Opportunity field length values
    public final static int BENEFIT_BEGINS_MONTHS_MIN = 0;
    public final static int BENEFIT_BEGINS_MONTHS_MAX = 200;
    public final static int BENEFIT_DURATION_MONTHS_MIN = 0;
    public final static int BENEFIT_DURATION_MONTHS_MAX = 200;
    public final static int CONTACT_NUMBER_CHARACTER_LIMIT = 100;
    public final static int CONTACT_TYPE_CHARACTER_LIMIT = 100;
    public final static int CUSTOMER_NUMBER_CHARACTER_LIMIT = 100;
    public final static int EXTERNAL_CLIENT_CHARACTER_LIMIT = 50;
    public final static int OPPORTUNITY_OWNER_CHARACTER_LIMIT = 255;
    public final static int OPPORTUNITY_TRACKING_NUMBER_CHARACTER_LIMIT = 255;
    public final static double ORDER_OF_MAGNITUDE_COST_MIN = 0.00;
    public final static double ORDER_OF_MAGNITUDE_COST_MAX = 9999999999999.99;
    public final static double ORDER_OF_MAGNITUDE_REVENUE_BENEFITS_MIN = 0.00;
    public final static double ORDER_OF_MAGNITUDE_REVENUE_BENEFITS_MAX = 9999999999999.99;
    public final static int PROBABILITY_PERCENT_MIN = 0;
    public final static int PROBABILITY_PERCENT_MAX = 100;


    // TaskAssignment field names for use in error messages
    public final static String ACTIVITIES_FIELD = "activities";
    public final static String ACTUAL_WORK_FIELD = "actualWork";
    public final static String BASELINE_FINISH_DATE_FIELD = "baselineFinishDate";
    public final static String BASELINE_START_DATE_FIELD = "baselineStartDate";
    public final static String BASELINE_WORK_FIELD = "baselineWork";
    public final static String BASELINE_DATE_FIELD = "baselineDate";
    public final static String INITIAL_BASELINE_DATE_FIELD="initialbaselineDate";
    public final static String CALCULATED_LEVELED_FINISH_DATE_FIELD = "calculatedLeveledFinishDate";
    public final static String CALCULATED_LEVELED_START_DATE_FIELD = "calculatedLeveledStartDate";
    public final static String CALCULATED_LEVELED_WORK_FIELD = "calculatedLeveledWork";
    public final static String COST_PER_HOUR_FIELD = "costPerHour";
    public final static String DAYS_OF_DELAY_FIELD = "daysOfDelay";
    public final static String DEFAULT_LABOR_FIELD = "defaultLabor";
    public final static String EXPECTED_DATE_FIELD="expectedDate";
    public final static String EXPECTED_FINISH_DATE_FIELD = "expectedFinishDate";
    public final static String EXPECTED_START_DATE_FIELD = "expectedStartDate";
    public final static String EXPECTED_WORK_FIELD = "expectedWork";
    public final static String FORECAST_FINISH_DATE_FIELD = "forecastFinishDate";
    public final static String FORECAST_START_DATE_FIELD = "forecastStartDate";
    public final static String FORECAST_DATE_FIELD="forecastDate";
    public final static String ACTUAL_FINISH_DATE_FIELD = "actualFinishDate";
    public final static String ACTUAL_START_DATE_FIELD = "actualStartDate";
    public final static String ASSIGNMENT_FINISH_DATE_FIELD = "assignmentFinishDate";
    public final static String ASSIGNMENT_START_DATE_FIELD = "assignmentStartDate";
    public final static String ASSIGNMENT_FINISH_DATE_TYPE_FIELD = "assignmentFinishDateType";
    public final static String ASSIGNMENT_START_DATE_TYPE_FIELD = "assignmentStartDateType";
    public final static String EETC_HOURS_FIELD = "EETCHours";
    public final static String PERCENTAGE_COMPLETE_FIELD = "percentageComplete";
    public final static String PERCENTAGE_DURATION_COMPLETE_FIELD = "percentageDurationComplete";
    public final static String PERCENTAGE_RATE_ADJUSTMENT_FIELD = "percentageRateAdjustment";
    public final static String PERCENTAGE_WORK_FIELD = "percentageWork";
    public final static String SELLING_RATE_PER_HOUR_FIELD = "sellingRatePerHour";
    public final static String SPECIAL_COST_PER_HOUR_FIELD = "specialCostPerHour";
    public final static String SPECIAL_SELLING_RATE_PER_HOUR_FIELD = "specialSellingRatePerHour";
    public final static String UNITS_PERCENTAGE_FIELD = "unitsPercentage";
    public final static String BILLABLE_FIELD = "billable";
    public final static String COST_LABOR_CODE_FIELD = "costLaborCode";
    public final static String RESOURCE_AVAILABLE_HOURS = "the number of hours for which the resource is available";
    public final static String PLANNED_DURATION_HOURS_FIELD = "plannedDurationHours";
    public final static String CONTRACT_FIELD = "contract";
    public final static String COST_TYPE_FIELD = "costType";
    public final static String INVOICES_FIELD = "invoices";
    public final static String PROPOSED_DURATION_HOURS_FIELD = "proposedDurationHours";
    public final static String REMAINING_HOURS_FIELD = "remainingHours";
    public final static String LAST_SCHEDULE_WORK_FIELD = "lastScheduleWork";
    public final static String REVENUE_LABOR_CODE_FIELD = "revenueLaborCode";
    public final static String SUMMARY_TIMESHEETS_FIELD = "summaryTimsheets";
    public final static String SCHEDULE_START_FIELD = "schedStart";
    public final static String COMPLETE_FIELD = "complete";

    // TaskAssignment field length values
    public final static double ACTUAL_WORK_MIN = 0.00;
    public final static double ACTUAL_WORK_MAX = 9000.00;
    public final static double COST_PER_HOUR_MIN = 0.00;
    public final static double COST_PER_HOUR_MAX = 9999999999999.99;
    public final static double PERCENTAGE_COMPLETE_MIN = 0.00;
    public final static double PERCENTAGE_COMPLETE_MAX = 100.00;
    public final static int PERCENTAGE_RATE_ADJUSTMENT_MIN = 0;
    public final static int PERCENTAGE_RATE_ADJUSTMENT_MAX = 100;
    public final static double PERCENTAGE_WORK_MIN = 0.00;
    public final static double PERCENTAGE_WORK_MAX = 100.00;
    public final static double SELLING_RATE_PER_HOUR_MIN = 0.00;
    public final static double SELLING_RATE_PER_HOUR_MAX = 9999999999999.99;
    public final static double SPECIAL_COST_PER_HOUR_MIN = 0.00;
    public final static double SPECIAL_COST_PER_HOUR_MAX = 9999999999999.99;
    public final static double SPECIAL_SELLING_RATE_PER_HOUR_MIN = 0.00;
    public final static double SPECIAL_SELLING_RATE_PER_HOUR_MAX = 9999999999999.99;
    public final static double UNITS_PERCENTAGE_MIN = 0.00;
    public final static double UNITS_PERCENTAGE_MAX = 999999.99;
    public final static double EETC_HOURS_MIN = 0;

    public final static int DAYS_OF_DELAY_MIN = 0;
    public final static int DAYS_OF_DELAY_MAX = 2000;

    public final static int EETC_HOURS_INVALID_CONDITIONAL = 0;


    // Constraint field names for use in error messages
    public final static String CONSTRAINT_DATE_FIELD = "constraintDate";
    public final static String CONSTRAINT_TYPE_FIELD = "constraintType";

    // ProjectOrganizationalAssignment field names for use in error messages
    public final static String ORGANIZATIONAL_FIELD = "organizational";
    public final static String ORGANIZATION_TYPE_FIELD = "organizationType";

    // ResourceTaskAssignment field names for use in error messages
    public final static String RESOURCE_FIELD = "resource";
    public final static String PROFILE_FIELD = "profile";
    public final static String SECURITY_ROLE_FIELD = "securityRole";
    public final static String TASK_ASSIGNMENT_FIELD = "taskAssignment";
    public final static String RESOURCE_TYPE_FIELD = "resourceType";
    public final static String RESOURCE_CALENDAR_FIELD = "Resource calendar";
    public final static String PARENT_CONTAINING_PROJECT_FIELD = "parent WorkElement's containingProject";
    public final static String WORK_LOCATION_FIELD = "workLocation";

    // Profile field names for use in error messages
    public final static String PROFILE_COMPETENCY_ASSIGNMENTS_FIELD = "profileCompetencyAssignments";
    public final static String PROFILE_GRANDPARENT_PROJECT = "- the project associated with the ResourceTaskAssignment's WorkElement or ScopeElement parent";
    public final static String PROFILE_GRANDPARENT = "- the WorkElement parent of the ResourceTaskAssignment";
    public final static String PROFILE_NAME_FIELD = "profileName";
    public final static String PROFILE_GEOGRAPHICAL_FIELD = "geographical";
    public final static String PROFILE_ORGANIZATIONAL_FIELD = "organizational";
    public final static String PROFILE_POOL_FIELD = "pool";
    public final static String PROFILE_SKILL_ASSIGNMENTS_FIELD = "profileSkillAssignments";
    public final static String PROFILE_PROFICIENCY_LEVEL_FIELD = "proficiencyLevel";

    // WbsModule field names
    public final static String ASSET_FINANCIAL_CATEGORIES_FIELD = "assetFinancialCategories";
    public final static String ASSIGNMENT_STATUS_FIELD = "assignmentStatus";
    public final static String ATTRIBUTE_CATEGORIES_FIELD = "attributeCategories";
    public final static String CUSTOMFIELD_CATEGORIES_FIELD = "customFieldCategories";
    public final static String DELIVERABLE_RTFS_FIELD = "deliverableRtfs";
    public final static String DELIVERABLE_STATES_FIELD = "deliverableStates";
    public final static String GENERIC_PROJECTS_FIELD = "genericProjects";
    public final static String MILESTONE_RTFS_FIELD = "milestoneRtfs";
    public final static String PORTFOLIOS_FIELD = "portfolios";
    public final static String PROJECT_RTFS_FIELD = "projectRtfs";
    public final static String SCORECARD_FOLDERS_FIELD = "scorecardFolders";
    public final static String STATES_FIELD = "states";
    public final static String SUMMARY_TASK_RTFS_FIELD = "summaryTaskRtfs";
    public final static String TASK_RTFS_FIELD = "taskRtfs";
    public final static String TASK_STATES_FIELD = "taskStates";
    public final static String WORK_LOCATIONS_FIELD = "workLocations";
    public final static String WORK_PRODUCT_RTFS_FIELD = "workProductRtfs";
    public final static String PROJECTS_FIELD = "projects";
    public final static String ACTION_SCORECARD_FIELD = "actionScorecard";
    public final static String ACTION_ATTRIBUTE_ASSIGNMENTS_FIELD = "actionAttributeAssignments";
    public final static String ASSIGNED_SCORECARDS_FIELD = "assignedScorecards";
    public final static String CHANGE_REQUEST_SCORECARD_FIELD = "changeRequestScorecard";
    public final static String CHANGE_REQUEST_ATTRIBUTE_ASSIGNMENTS_FIELD = "changeRequestAttributeAssignments";
    public final static String DEFECT_SCORECARD_FIELD = "defectScorecard";
    public final static String DEFECT_ATTRIBUTE_ASSIGNMENTS_FIELD = "defectAttributeAssignments";
    public final static String DELIVERABLE_ATTRIBUTE_ASSIGNMENTS_FIELD = "deliverableAttributeAssignments";
    public final static String DOCUMENT_ATTRIBUTE_ASSIGNMENTS_FIELD = "documentAttributeAssignments";
    public final static String FAVORITE_ACTIVITIES_FIELD = "favoriteActivities";
    public final static String ISSUE_SCORECARD_FIELD = "issueScorecard";
    public final static String ISSUE_ATTRIBUTE_ASSIGNMENTS_FIELD = "issueAttributeAssignments";
    public final static String OPPORTUNITY_FIELD = "opportunity";
    public final static String ORGANIZATIONAL_ASSIGNMENTS_FIELD = "organizationalAssignments";
    public final static String PORTFOLIO_FIELD = "portfolio";
    public final static String PROJECT_COST_CENTER_FIELD = "projectCostCenter";
    public final static String PROJECT_IDENTIFIER_FIELD = "projectIdentifier";
    public final static String REQUIREMENT_SCORECARD_FIELD = "requirementScorecard";
    public final static String REQUIREMENT_ATTRIBUTE_ASSIGNMENTS_FIELD = "requirementAttributeAssignments";
    public final static String RISK_SCORECARD_FIELD = "riskScorecard";
    public final static String RISK_ATTRIBUTE_ASSIGNMENTS = "riskAttributeAssignments";
    public final static String SERVICE_REQUEST_SCORECARD_FIELD = "serviceRequestScorecard";
    public final static String SERVICE_REQUEST_ATTRIBUTE_ASSIGNMENTS_FIELD = "serviceRequestAttributeAssignments";
    public final static String TASK_ATTRIBUTE_ASSIGNMENTS_FIELD = "taskAttributeAssignments";
    public final static String WORKSHEET_FINANCIALS_FIELD = "worksheetFinancials";
    public final static String CHILDREN_FIELD = "children";
    public final static String ACTUAL_DATE_FIELD = "actualDate";
    public final static String ASSET_FIELD = "asset";
    public final static String ATTRIBUTE_ASSIGNMENTS_FIELD = "attributeAssignments";
    public final static String CONTAINING_PROJECT_FIELD = "containingProject";
    public final static String CUSTOM_FIELD_ASSIGNMENTS_FIELD = "customFieldAssignments";
    public final static String DEPENDENCIES_FIELD = "dependencies";
    public final static String DOCUMENT_FOLDER_FIELD = "documentFolder";
    public final static String LAST_MODIFIED_DATE_FIELD = "lastModifiedDate";
    public final static String MINUTES_PER_DAY_FIELD = "minutesPerDay";
    public final static String PLAN_DATE_FIELD = "planDate";
    public final static String PREVIOUS_BASELINE_DATE_FIELD = "previousBaselineDate";
    public final static String PROPOSED_DATE_FIELD = "proposedDate";
    public final static String RTF_ASSIGNMENTS_FIELD = "rtfAssignments";
    public final static String SCOPE_ELEMENT_FIELD = "scopeElement";
    public final static String STATUS_UPDATES_FIELD = "statusUpdates";
    public final static String TIME_CODE_ASSIGNMENTS_FIELD = "timeCodeAssignments";
    public final static String WBS_FINANCIALS_FIELD = "wbsFinancials";
    public final static String TEMPLATE_FIELD = "template";
    public final static String ASSIGNMENT_TYPE_FIELD = "assignmentType";
    public final static String CALENDAR_FIELD = "calendar";
    public final static String CONTEXT_NAME_FIELD="contextName";
    public final static String CURRENCY_FIELD = "currency";
    public final static String PROJECT_COSTCENTER_FIELD = "projectCostcenter";
    public final static String ID_FIELD="id";
    public final static String TEMPLATE_INPUT_FIELD="inputObject";
    
    
    // GenericProject field names
    public final static String GENERICPROJECT_PROJECT_RECONDILIATIONS_FIELD = "projectReconciliations";
    public final static String GENERICPROJECT_PROJECT_RECONCILIATION_STATUS_FIELD = "projectReconciliationStatus";
    
    public final static int WORKSHEETFINANCIAL_MIN_CHARGECODE = 4;
    
    // ProfileResourceAttributeAssignment field names
    public final static String PROFICIENCY_LEVEL_FIELD = "proficiencyLevel";
    
    // ScheduleDate field names
    public final static String SCHEDULE_DATE_DAYS_FIELD = "days";
    public final static String SCHEDULE_DATE_DURATION_IN_MINUTES_FIELD = "durationInMinutes";
    public final static String SCHEDULE_DATE_FINISH_DATE_FIELD = "finishDate";
    public final static String SCHEDULE_DATE_HOURS_FIELD = "hours";
    public final static String SCHEDULE_DATE_START_DATE_FIELD = "startDate";
    public final static String SCHEDULE_DATE_WORK_HOURS_FIELD = "workHours";

	public static final String CONTOUR_FIELD = "contour";
        
}