package com.ibm.rpm.wbs.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class AssignmentType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected AssignmentType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Work = "Work";
	public static final AssignmentType Work = new AssignmentType(_Work);
	
		
	public static final String _Duration = "Duration";
	public static final AssignmentType Duration = new AssignmentType(_Duration);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static AssignmentType fromValue(String value) throws IllegalStateException {
		AssignmentType retVal = (AssignmentType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static AssignmentType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof AssignmentType && ordinal == ((AssignmentType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((AssignmentType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final AssignmentType[] VALUES = {Work, Duration};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}