package com.ibm.rpm.wbs.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ConstraintType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ConstraintType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _AsLateAsPossible = "AsLateAsPossible";
	public static final ConstraintType AsLateAsPossible = new ConstraintType(_AsLateAsPossible);
	
		
	public static final String _AsSoonAsPossible = "AsSoonAsPossible";
	public static final ConstraintType AsSoonAsPossible = new ConstraintType(_AsSoonAsPossible);
	
		
	public static final String _FinishNoEarlierThan = "FinishNoEarlierThan";
	public static final ConstraintType FinishNoEarlierThan = new ConstraintType(_FinishNoEarlierThan);
	
		
	public static final String _FinishNoLaterThan = "FinishNoLaterThan";
	public static final ConstraintType FinishNoLaterThan = new ConstraintType(_FinishNoLaterThan);
	
		
	public static final String _MustFinishOn = "MustFinishOn";
	public static final ConstraintType MustFinishOn = new ConstraintType(_MustFinishOn);
	
		
	public static final String _MustStartOn = "MustStartOn";
	public static final ConstraintType MustStartOn = new ConstraintType(_MustStartOn);
	
		
	public static final String _StartNoEarlierThan = "StartNoEarlierThan";
	public static final ConstraintType StartNoEarlierThan = new ConstraintType(_StartNoEarlierThan);
	
		
	public static final String _StartNoLaterThan = "StartNoLaterThan";
	public static final ConstraintType StartNoLaterThan = new ConstraintType(_StartNoLaterThan);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ConstraintType fromValue(String value) throws IllegalStateException {
		ConstraintType retVal = (ConstraintType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ConstraintType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ConstraintType && ordinal == ((ConstraintType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ConstraintType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ConstraintType[] VALUES = {AsLateAsPossible, AsSoonAsPossible, FinishNoEarlierThan, FinishNoLaterThan, MustFinishOn, MustStartOn, StartNoEarlierThan, StartNoLaterThan};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}