package com.ibm.rpm.wbs.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ContourType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ContourType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _ASAP = "ASAP";
	public static final ContourType ASAP = new ContourType(_ASAP);
	
		
	public static final String _FixedDuration = "FixedDuration";
	public static final ContourType FixedDuration = new ContourType(_FixedDuration);
	
		
	public static final String _PercentilePerDay = "PercentilePerDay";
	public static final ContourType PercentilePerDay = new ContourType(_PercentilePerDay);
	
		
	public static final String _HoursPerDay = "HoursPerDay";
	public static final ContourType HoursPerDay = new ContourType(_HoursPerDay);
	
		
	public static final String _HoursPerWeek = "HoursPerWeek";
	public static final ContourType HoursPerWeek = new ContourType(_HoursPerWeek);
	
		
	public static final String _HoursPerMonth = "HoursPerMonth";
	public static final ContourType HoursPerMonth = new ContourType(_HoursPerMonth);
	
		
	public static final String _DaysPerWeek = "DaysPerWeek";
	public static final ContourType DaysPerWeek = new ContourType(_DaysPerWeek);
	
		
	public static final String _DaysPerMonth = "DaysPerMonth";
	public static final ContourType DaysPerMonth = new ContourType(_DaysPerMonth);
	
		
	public static final String _WeeksPerMonth = "WeeksPerMonth";
	public static final ContourType WeeksPerMonth = new ContourType(_WeeksPerMonth);
	
		
	public static final String _Custom = "Custom";
	public static final ContourType Custom = new ContourType(_Custom);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ContourType fromValue(String value) throws IllegalStateException {
		ContourType retVal = (ContourType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ContourType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ContourType && ordinal == ((ContourType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ContourType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ContourType[] VALUES = {ASAP, FixedDuration, PercentilePerDay, HoursPerDay, HoursPerWeek, HoursPerMonth, DaysPerWeek, DaysPerMonth, WeeksPerMonth, Custom};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}