package com.ibm.rpm.wbs.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class TaskType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected TaskType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _DefaultTask = "DefaultTask";
	public static final TaskType DefaultTask = new TaskType(_DefaultTask);
	
		
	public static final String _FixedDuration = "FixedDuration";
	public static final TaskType FixedDuration = new TaskType(_FixedDuration);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static TaskType fromValue(String value) throws IllegalStateException {
		TaskType retVal = (TaskType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static TaskType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof TaskType && ordinal == ((TaskType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((TaskType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final TaskType[] VALUES = {DefaultTask, FixedDuration};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}