package com.ibm.rpm.xpathparser;

import java.util.Stack;

/**
 * @author gmeloche
 *
 */
public class ContainerCondition extends Condition
{

    private Stack subTables = new Stack();

    /**
     * @return Returns the subTable.
     */
    public Stack getSubTables()
    {
        return subTables;
    }

    /**
     * @param subTable The subTable to set.
     */
    public void setSubTable(Stack subTable)
    {
        this.subTables = subTable;
    }
    public String toString()
    {
        StringBuffer buffer = new StringBuffer("\nContainerCondition: ");
        buffer.append("\nOperator ");
        buffer.append(getOperator());
        buffer.append("\nSubTables:");
        if (subTables != null)
            buffer.append(subTables.toString());
        buffer.append("\n");
        return buffer.toString();
    }

    public Object clone()
    {

        ContainerCondition c = null;

        try
        {
            c = (ContainerCondition) super.clone();
            subTables = Table.cloneTableStack(subTables);
        }
        catch (CloneNotSupportedException e)
        {
            //Do nothing
        }

        return c;
    }
    

}
