package com.ibm.rpm.xpathparser;

public class FieldCondition extends Condition
{

    private String property;

    private int operation;

    private Object value;

    public FieldCondition(String property, int operation, Object value)
    {
        this.property = property;
        this.operation = operation;
        this.value = value;
    }

    /**
     * @param operation2
     */
    public FieldCondition(int operation)
    {
        this(null, operation, null);
    }

    public String toString()
    {
        StringBuffer buffer = new StringBuffer("FieldCondition: ");
        buffer.append("Operator ");
        buffer.append(getOperator());
        buffer.append(" ,Property ");
        buffer.append(property);
        buffer.append(" ,Operation ");
        buffer.append(getStringOperator());
        buffer.append(" ,Value ");
        if (value != null)
            buffer.append(value.toString());
        return buffer.toString();
    }

    /**
     * @return Returns the operation.
     */
    public int getOperation()
    {
        return operation;
    }

    /**
     * @param operation
     *            The operation to set.
     */
    public void setOperation(int operation)
    {
        this.operation = operation;
    }

    /**
     * @return Returns the property.
     */
    public String getProperty()
    {
        return property;
    }

    /**
     * @param property
     *            The property to set.
     */
    public void setProperty(String property)
    {
        this.property = property;
    }

    /**
     * @return Returns the value.
     */
    public Object getValue()
    {
        return value;
    }

    /**
     * @param value
     *            The value to set.
     */
    public void setValue(Object value)
    {
        this.value = value;
    }

    public String getStringOperator()
    {

        String operator = null;

        if (operation == ReflectOpCodes.OP_EQUALS)
        {
            operator = " = ";
        }
        else if (operation == ReflectOpCodes.OP_NOTEQUALS)
        {
            operator = " <> ";
        }
        else if (operation == ReflectOpCodes.OP_LT)
        {
            operator = " < ";
        }
        else if (operation == ReflectOpCodes.OP_LTE)
        {
            operator = " <= ";
        }
        else if (operation == ReflectOpCodes.OP_GT)
        {
            operator = " > ";
        }
        else if (operation == ReflectOpCodes.OP_GTE)
        {
            operator = " >= ";
        }
        else if (operation == ReflectFunctionTable.FUNC_CONTAINS)
        {
            operator = " LIKE ";
        }
        else if (operation == ReflectFunctionTable.FUNC_STARTS_WITH)
        {
            operator = " LIKE ";
        }
        else if (operation == XPathToStack.FUNC_ISNULL)
        {
            operator = " IS ";
        }
        else if (operation == XPathToStack.FUNC_ISNOTNULL)
        {
            operator = " IS NOT ";
        }
        else
        {
            operator = " Invalid operator value. ";
        }
        return operator;
    }
    
    public Object clone()
    {

        FieldCondition c = null;

        try
        {
            c = (FieldCondition) super.clone();
            c.setProperty(this.getProperty());
            c.setOperation(this.getOperation());
            c.setValue(this.getValue());
        }
        catch (CloneNotSupportedException e)
        {
            //Do nothing
        }

        return c;
    }
}