
package com.ibm.rpm.xpathparser.steps;

import org.apache.xml.utils.ObjectVector;
import org.apache.xpath.compiler.OpMapVector;
import org.apache.xpath.objects.XString;

import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.xpathparser.ReflectOpCodes;

/**
 * @author kuschel
 *
 * [OP_LITERAL]
 * [3]
 * [index to token]
 *
 * returns:
 *  XString
 * @xsl.usage advanced
 */
public class Literal extends TokenedXPathStep 
{

	/**
	 * @param op_xpath
	 * @param opMap
	 * @param tokenQueue
	 * @param step
	 */
	protected Literal(OpMapVector opMap, ObjectVector tokenQueue, XPathStep step) 
	{
		super(ReflectOpCodes.OP_LITERAL,opMap, tokenQueue,step);
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see com.ibm.rpm.xpathparser.steps.XPathStep#notifyPostBuild(com.ibm.rpm.xpathparser.steps.Predicate)
	 */
	protected void notifyPreBuild(XPathStep predicate) 
	{
		
		XPathStep parent = getParent();
		if(parent.getOperation() == ReflectOpCodes.OP_ARGUMENT)
			((Function) parent.getParent()).addArgument(getToken());
		else
			((Comparator)parent).getCondition().setValue(getToken());
	}

	/* (non-Javadoc)
	 * @see com.ibm.rpm.xpathparser.steps.XPathStep#notifyPreBuild(com.ibm.rpm.xpathparser.steps.Predicate)
	 */
	protected void notifyPostBuild(XPathStep predicate) {
		// TODO Auto-generated method stub

	}
	
	public int build (int position) throws RPMException
	{
		setLength(opMap.elementAt(++position) -2);
		String tok = ((XString)tokenQueue.elementAt(opMap.elementAt(++position))).str();
		tok = tok.replaceAll("'","''");
		tok = "'" + tok + "'";
		setToken(tok);
		notifyPreBuild(this);
		notifyPostBuild(this);
		return ++position;
	}
}
