
package com.ibm.rpm.xpathparser.steps;

import org.apache.xml.utils.ObjectVector;
import org.apache.xpath.compiler.OpMapVector;
import org.apache.xpath.objects.XNumber;

import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.xpathparser.ReflectOpCodes;

/**
 * @author kuschel
 * 
 * [OP_NUMBERLIT] (Number literal.) [3] [index to token]
 * 
 * returns: XString
 * @xsl.usage advanced
 */
public class NumberLiteral extends TokenedXPathStep
{

    /**
     * @param op_xpath
     * @param opMap
     * @param tokenQueue
     * @param parent
     */
    public NumberLiteral(OpMapVector opMap, ObjectVector tokenQueue,
            XPathStep parent)
    {
        super(ReflectOpCodes.OP_NUMBERLIT, opMap, tokenQueue, parent);
        // TODO Auto-generated constructor stub
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.xpathparser.steps.XPathStep#notifyPostBuild(com.ibm.rpm.xpathparser.steps.Predicate)
     */
    protected void notifyPreBuild(XPathStep predicate)
    {
        XPathStep parent = getParent();
        
        if (parent instanceof Comparator)
        {
            ((Comparator) parent).getCondition().setValue(getToken());
        }
        else if (parent instanceof Argument)
        {
            Argument arg = (Argument) parent;
            Function function = (Function)arg.getParent();
            function.addArgument(getToken());
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.xpathparser.steps.XPathStep#notifyPreBuild(com.ibm.rpm.xpathparser.steps.Predicate)
     */
    protected void notifyPostBuild(XPathStep predicate)
    {
        // TODO Auto-generated method stub

    }

    public int build(int position) throws RPMException
    {
        setLength(opMap.elementAt(++position) - 2);
        setToken(((XNumber) tokenQueue.elementAt(opMap.elementAt(++position)))
                .str());
        notifyPreBuild(this);
        notifyPostBuild(this);
        return ++position;
    }

}
