package com.ibm.rpm.init;

import java.lang.reflect.Method;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.ibm.rpm.framework.util.ContainerFieldInfoMap;
import com.ibm.rpm.framework.util.StringUtil;

/**
 * @author gmeloche
 *
 */
public class PredefinedFieldsBizMetaInfo
{
    /**
    //WARNING: Please keep this class synchronized with the content generated by FieldsBizMetaInfoInitializer (see Genevieve)

    private static ContainerFieldInfoMap map = ContainerFieldInfoMap.getInstance();

    private static Log logger = LogFactory
        .getLog(PredefinedFieldsBizMetaInfo.class);

    public static void init()
    {       	
            initPart1();
            initPart2();
            initPart3();
            initPart4();
            
            logger.debug(StringUtil
            .getShortClassName(PredefinedFieldsBizMetaInfo.class)
                + ": Number of predefined fields mapped: "
                + map.getNumberOfFieldsMapped());

    }

    private static Method getMethod(Class aClass, String aMethod){

        Method method = null;

        try{
            method = aClass.getMethod(aMethod, null);
        }
        catch(Exception e){

            logger.error("ERROR OCCUR WHILE MAPPING THE FIELDS. Method does not exist: " + aClass.getName() + "." + aMethod);
        }

        return method;

    }


    private static void initPart1()
    {
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "WorksheetFinancials", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "Children", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getChildren"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Deliverable.class, "State", getMethod(com.ibm.rpm.wbs.containers.Deliverable.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ElementDependency.class, "Predecessor", getMethod(com.ibm.rpm.wbs.containers.ElementDependency.class,"getPredecessor"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ChangeRequestScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getChangeRequestScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "TaskAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getTaskAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ActionAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getActionAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ServiceRequestAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getServiceRequestAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        //map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ProjectReconciliationStatus", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getProjectReconciliationStatus"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isProjectReconciliationStatus"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "Portfolio", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getPortfolio"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getPortfolio"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "AssignedScorecards", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getAssignedScorecards"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getAssignedScorecards"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "RequirementScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRequirementScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "Calendar", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getCalendar"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "DeliverableAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getDeliverableAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "DocumentAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getDocumentAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ProjectCostCenter", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getProjectCostCenter"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "IssueScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getIssueScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "Currency", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getCurrency"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "RequirementAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRequirementAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "DefectAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getDefectAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "State", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "RiskAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRiskAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "WorksheetFinancials", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "OrganizationalAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getOrganizationalAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isOrganizationalAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "Children", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getChildren"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ServiceRequestScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getServiceRequestScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ChangeRequestAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getChangeRequestAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        //map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ProjectReconciliations", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getProjectReconciliations"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isProjectReconciliations"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "IssueAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getIssueAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "DefectScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getDefectScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "Opportunity", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getOpportunity"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isOpportunity"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "DefaultSteps", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getDefaultSteps"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDefaultSteps"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "ActionScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getActionScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "RiskScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRiskScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.GenericProject.class, "WorkflowRoleMappings", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getWorkflowRoleMappings"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWorkflowRoleMappings"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "State", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Milestone.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.Milestone.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Portfolio.class, "Projects", getMethod(com.ibm.rpm.wbs.containers.Portfolio.class,"getProjects"), getMethod(com.ibm.rpm.wbs.scope.PortfolioScope.class,"getProjects"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Portfolio.class, "Portfolios", getMethod(com.ibm.rpm.wbs.containers.Portfolio.class,"getPortfolios"), getMethod(com.ibm.rpm.wbs.scope.PortfolioScope.class,"getPortfolios"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Profile.class, "ProfileSkillAssignments", getMethod(com.ibm.rpm.wbs.containers.Profile.class,"getProfileSkillAssignments"), getMethod(com.ibm.rpm.wbs.scope.ProfileScope.class,"isProfileSkillAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Profile.class, "ProfileCompetencyAssignments", getMethod(com.ibm.rpm.wbs.containers.Profile.class,"getProfileCompetencyAssignments"), getMethod(com.ibm.rpm.wbs.scope.ProfileScope.class,"isProfileCompetencyAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Profile.class, "Organizational", getMethod(com.ibm.rpm.wbs.containers.Profile.class,"getOrganizational"), getMethod(com.ibm.rpm.wbs.scope.ProfileScope.class,"getOrganizational"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Profile.class, "Geographical", getMethod(com.ibm.rpm.wbs.containers.Profile.class,"getGeographical"), getMethod(com.ibm.rpm.wbs.scope.ProfileScope.class,"getGeographical"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Profile.class, "Pool", getMethod(com.ibm.rpm.wbs.containers.Profile.class,"getPool"), getMethod(com.ibm.rpm.wbs.scope.ProfileScope.class,"getPool"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ProfileCompetencyAssignment.class, "ProficiencyLevel", getMethod(com.ibm.rpm.wbs.containers.ProfileCompetencyAssignment.class,"getProficiencyLevel"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ProfileResourceAttributeAssignment.class, "ProficiencyLevel", getMethod(com.ibm.rpm.wbs.containers.ProfileResourceAttributeAssignment.class,"getProficiencyLevel"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ProfileSkillAssignment.class, "ProficiencyLevel", getMethod(com.ibm.rpm.wbs.containers.ProfileSkillAssignment.class,"getProficiencyLevel"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ChangeRequestScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getChangeRequestScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "TaskAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getTaskAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ActionAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getActionAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ServiceRequestAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getServiceRequestAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        //map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ProjectReconciliationStatus", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getProjectReconciliationStatus"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isProjectReconciliationStatus"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "Portfolio", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getPortfolio"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getPortfolio"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "AssignedScorecards", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getAssignedScorecards"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getAssignedScorecards"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "RequirementScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRequirementScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "Calendar", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getCalendar"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "DeliverableAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getDeliverableAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "DocumentAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getDocumentAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ProjectCostCenter", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getProjectCostCenter"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "Currency", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getCurrency"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "RequirementAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getRequirementAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "DefectAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getDefectAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "State", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "RiskAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getRiskAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "WorksheetFinancials", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "OrganizationalAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getOrganizationalAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isOrganizationalAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "Children", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getChildren"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ChangeRequestAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getChangeRequestAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        //map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ProjectReconciliations", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getProjectReconciliations"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isProjectReconciliations"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "IssueAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getIssueAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "Opportunity", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getOpportunity"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isOpportunity"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "DefaultSteps", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getDefaultSteps"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDefaultSteps"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.Project.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "IssueScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getIssueScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ServiceRequestScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getServiceRequestScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "DefectScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getDefectScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "ActionScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getActionScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Project.class, "RiskScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRiskScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ProjectOrganizationalAssignment.class, "Organizational", getMethod(com.ibm.rpm.wbs.containers.ProjectOrganizationalAssignment.class,"getOrganizational"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ProjectOrganizationalAssignment.class, "OrganizationType", getMethod(com.ibm.rpm.wbs.containers.ProjectOrganizationalAssignment.class,"getOrganizationType"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ChangeRequestScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getChangeRequestScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "TaskAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getTaskAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ActionAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getActionAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ServiceRequestAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getServiceRequestAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        //map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ProjectReconciliationStatus", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getProjectReconciliationStatus"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isProjectReconciliationStatus"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "Portfolio", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getPortfolio"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getPortfolio"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "AssignedScorecards", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getAssignedScorecards"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getAssignedScorecards"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "RequirementScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRequirementScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "Calendar", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getCalendar"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "DeliverableAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getDeliverableAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "DocumentAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getDocumentAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ProjectCostCenter", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getProjectCostCenter"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "Currency", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getCurrency"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "RequirementAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getRequirementAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "DefectAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getDefectAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "State", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "RiskAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getRiskAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "WorksheetFinancials", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "OrganizationalAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getOrganizationalAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isOrganizationalAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "Children", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getChildren"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ChangeRequestAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getChangeRequestAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        //map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ProjectReconciliations", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getProjectReconciliations"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isProjectReconciliations"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "IssueAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getIssueAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "Opportunity", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getOpportunity"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isOpportunity"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "DefaultSteps", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getDefaultSteps"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDefaultSteps"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.Proposal.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "IssueScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getIssueScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ServiceRequestScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getServiceRequestScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "DefectScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getDefectScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "ActionScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getActionScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Proposal.class, "RiskScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRiskScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ResourceTaskAssignment.class, "Profile", getMethod(com.ibm.rpm.wbs.containers.ResourceTaskAssignment.class,"getProfile"), getMethod(com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope.class,"getProfile"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ResourceTaskAssignment.class, "Resource", getMethod(com.ibm.rpm.wbs.containers.ResourceTaskAssignment.class,"getResource"), getMethod(com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope.class,"getResource"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ResourceTaskAssignment.class, "AssignmentStatus", getMethod(com.ibm.rpm.wbs.containers.ResourceTaskAssignment.class,"getAssignmentStatus"), getMethod(com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope.class,"isAssignmentStatus"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ResourceTaskAssignment.class, "SecurityRole", getMethod(com.ibm.rpm.wbs.containers.ResourceTaskAssignment.class,"getSecurityRole"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.ResourceTaskAssignment.class, "TaskAssignment", getMethod(com.ibm.rpm.wbs.containers.ResourceTaskAssignment.class,"getTaskAssignment"), getMethod(com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope.class,"getTaskAssignment"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "State", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SimpleNode.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.SimpleNode.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "WorksheetFinancials", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "Children", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getChildren"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.SummaryTask.class, "State", getMethod(com.ibm.rpm.wbs.containers.SummaryTask.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "State", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.Task.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.Task.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.TaskAssignment.class, "RevenueLaborCode", getMethod(com.ibm.rpm.wbs.containers.TaskAssignment.class,"getRevenueLaborCode"), getMethod(com.ibm.rpm.wbs.scope.TaskAssignmentScope.class,"getRevenueLaborCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.TaskAssignment.class, "Contract", getMethod(com.ibm.rpm.wbs.containers.TaskAssignment.class,"getContract"), getMethod(com.ibm.rpm.wbs.scope.TaskAssignmentScope.class,"getContract"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.TaskAssignment.class, "CostLaborCode", getMethod(com.ibm.rpm.wbs.containers.TaskAssignment.class,"getCostLaborCode"), getMethod(com.ibm.rpm.wbs.scope.TaskAssignmentScope.class,"getCostLaborCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "WorkLocations", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getWorkLocations"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isWorkLocations"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "MilestoneRtfs", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getMilestoneRtfs"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isMilestoneRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "AttributeCategories", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getAttributeCategories"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"getAttributeCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "DeliverableRtfs", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getDeliverableRtfs"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isDeliverableRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "SummaryTaskRtfs", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getSummaryTaskRtfs"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isSummaryTaskRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "AssetFinancialCategories", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getAssetFinancialCategories"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isAssetFinancialCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "AssignmentStatus", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getAssignmentStatus"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isAssignmentStatus"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "TaskStates", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getTaskStates"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isTaskStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "TaskRtfs", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getTaskRtfs"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isTaskRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "Portfolios", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getPortfolios"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"getPortfolios"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "States", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getStates"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "CustomFieldCategories", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getCustomFieldCategories"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"getCustomFieldCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "GenericProjects", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getGenericProjects"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"getGenericProjects"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "DeliverableStates", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getDeliverableStates"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isDeliverableStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "ProjectRtfs", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getProjectRtfs"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isProjectRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "WorkProductRtfs", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getWorkProductRtfs"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"isWorkProductRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WbsModule.class, "ScorecardFolders", getMethod(com.ibm.rpm.wbs.containers.WbsModule.class,"getScorecardFolders"), getMethod(com.ibm.rpm.wbs.scope.WbsModuleScope.class,"getScorecardFolders"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "State", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "WorkflowProcessesRunning", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getWorkflowProcessesRunning"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWorkflowProcesses"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkElement.class, "WorkflowProcessesAvailable", getMethod(com.ibm.rpm.wbs.containers.WorkElement.class,"getWorkflowProcessesAvailable"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWorkflowProcesses"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ChangeRequestScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getChangeRequestScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "TaskAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getTaskAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ActionAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getActionAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ServiceRequestAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getServiceRequestAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        //map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ProjectReconciliationStatus", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getProjectReconciliationStatus"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isProjectReconciliationStatus"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "Portfolio", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getPortfolio"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getPortfolio"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "AssignedScorecards", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getAssignedScorecards"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getAssignedScorecards"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "RequirementScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRequirementScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "Calendar", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getCalendar"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "DeliverableAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getDeliverableAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "DocumentAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getDocumentAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ProjectCostCenter", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getProjectCostCenter"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "Currency", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getCurrency"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "RequirementAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getRequirementAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "DefectAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getDefectAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "State", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "RiskAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getRiskAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "WorksheetFinancials", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "OrganizationalAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getOrganizationalAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isOrganizationalAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "Children", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getChildren"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ChangeRequestAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getChangeRequestAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        //map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ProjectReconciliations", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getProjectReconciliations"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isProjectReconciliations"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "IssueAttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getIssueAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRelatedAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "Opportunity", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getOpportunity"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isOpportunity"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "DefaultSteps", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getDefaultSteps"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDefaultSteps"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "IssueScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getIssueScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ServiceRequestScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getServiceRequestScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "DefectScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getDefectScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
    }

    private static void initPart2()
    {
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.WorkOrganization.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "ActionScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getActionScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkOrganization.class, "RiskScorecard", getMethod(com.ibm.rpm.wbs.containers.GenericProject.class,"getRiskScorecard"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeScorecards"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "WorksheetFinancials", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "PlanDate", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getPlanDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "ActualDate", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getActualDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "PreviousBaselineDate", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getPreviousBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "Children", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getChildren"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "RtfAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getRtfAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "WbsFinancials", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getWbsFinancials"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "ForecastDate", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getForecastDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "TimeCode2", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getTimeCode2"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "ProposedDate", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getProposedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "AssetCode", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getAssetCode"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "BaselineDate", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "TimeCode1", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getTimeCode1"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "Dependencies", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getDependencies"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isDependencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "ExpectedDate", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getExpectedDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "DocumentFolder", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getDocumentFolder"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "Asset", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getAsset"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "InitialBaselineDate", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getInitialBaselineDate"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "ScopeElement", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getScopeElement"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getScopeElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "ContainingProject", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getContainingProject"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"getContainingProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "TimeCodeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getTimeCodeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isTimeCodeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "StatusUpdates", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "AttributeAssignments", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.wbs.containers.WorkProduct.class, "State", getMethod(com.ibm.rpm.wbs.containers.WorkProduct.class,"getState"), getMethod(com.ibm.rpm.wbs.scope.WorkElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.workflow.containers.WorkflowCategory.class, "Children", getMethod(com.ibm.rpm.workflow.containers.WorkflowCategory.class,"getChildren"), getMethod(com.ibm.rpm.workflow.scope.WorkflowScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.workflow.containers.WorkflowGroup.class, "Children", getMethod(com.ibm.rpm.workflow.containers.WorkflowGroup.class,"getChildren"), getMethod(com.ibm.rpm.workflow.scope.WorkflowScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.ActionItemSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.ActionItemSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.ChangeRequestSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.ChangeRequestSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.DefectSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.DefectSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.DeliverableSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.DeliverableSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.DocumentSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.DocumentSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.FolderSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.FolderSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.GenericSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.GenericSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.IssueSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.IssueSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.NotesMinutesSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.NotesMinutesSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.PoolSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.PoolSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.ProjectSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.ProjectSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.RequirementSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.RequirementSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.RiskSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.RiskSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.SecurityGroup.class, "SecurityGroups", getMethod(com.ibm.rpm.security.containers.SecurityGroup.class,"getSecurityGroups"), getMethod(com.ibm.rpm.security.scope.SecurityGroupScope.class,"getSecurityGroups"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.SecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.SecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.SecurityRoleAssignment.class, "SecurityRole", getMethod(com.ibm.rpm.security.containers.SecurityRoleAssignment.class,"getSecurityRole"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.security.containers.SecurityRoleCategory.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.SecurityRoleCategory.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.ServiceRequestSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.ServiceRequestSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.TaskSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.TaskSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.security.containers.TemplateFolderSecurityRole.class, "SecurityRoles", getMethod(com.ibm.rpm.security.containers.TemplateFolderSecurityRole.class,"getSecurityRoles"), getMethod(com.ibm.rpm.security.scope.SecurityRoleScope.class,"getSecurityRoles"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientCostCenterScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class, "DocumentFolder", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class,"getDocumentFolder"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientCostCenterScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class, "State", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class,"getState"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientCostCenterScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class, "RtfAssignments", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class,"getRtfAssignments"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientCostCenterScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class, "StatusUpdates", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class, "AttributeAssignments", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientCostCenter.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientCostCenterScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientCostCenterAssignment.class, "ClientCostCenter", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientCostCenterAssignment.class,"getClientCostCenter"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientFolder.class, "Divisions", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientFolder.class,"getDivisions"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientCostCenterScope.class,"getDivisions"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientFolder.class, "ClientCostCenters", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientFolder.class,"getClientCostCenters"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientCostCenterScope.class,"getClientCostCenters"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientFolder.class, "Folders", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientFolder.class,"getFolders"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientCostCenterScope.class,"getFolders"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientModule.class, "Clients", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientModule.class,"getClients"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientModuleScope.class,"getClients"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientModule.class, "CustomFieldCategories", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientModule.class,"getCustomFieldCategories"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientModuleScope.class,"getCustomFieldCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientModule.class, "ClientRtfs", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientModule.class,"getClientRtfs"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientModuleScope.class,"isClientRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientModule.class, "CostCenterStages", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientModule.class,"getCostCenterStages"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientModuleScope.class,"isCostCenterStages"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.ClientModule.class, "AttributeCategories", getMethod(com.ibm.rpm.clientcostcenters.containers.ClientModule.class,"getAttributeCategories"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientModuleScope.class,"getAttributeCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.clientcostcenters.containers.Division.class, "ClientCostCenters", getMethod(com.ibm.rpm.clientcostcenters.containers.Division.class,"getClientCostCenters"), getMethod(com.ibm.rpm.clientcostcenters.scope.ClientCostCenterScope.class,"getClientCostCenters"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.ChargeCode.class, "State", getMethod(com.ibm.rpm.financial.containers.ChargeCode.class,"getState"), getMethod(com.ibm.rpm.financial.scope.ChargeCodeScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.financial.containers.ChargeCode.class, "AssociatedChargeCode", getMethod(com.ibm.rpm.financial.containers.ChargeCode.class,"getAssociatedChargeCode"), getMethod(com.ibm.rpm.financial.scope.ChargeCodeScope.class,"getAssociatedChargeCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.financial.containers.ChargeCodeCategory.class, "Children", getMethod(com.ibm.rpm.financial.containers.ChargeCodeCategory.class,"getChildren"), getMethod(com.ibm.rpm.financial.scope.ChargeCodeScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.FinancialModule.class, "ChargeCodeStates", getMethod(com.ibm.rpm.financial.containers.FinancialModule.class,"getChargeCodeStates"), getMethod(com.ibm.rpm.financial.scope.FinancialModuleScope.class,"isChargeCodeStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.FinancialModule.class, "ChargeCodeCategories", getMethod(com.ibm.rpm.financial.containers.FinancialModule.class,"getChargeCodeCategories"), getMethod(com.ibm.rpm.financial.scope.FinancialModuleScope.class,"getChargeCodeCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.FinancialModule.class, "TimeCodeGroups", getMethod(com.ibm.rpm.financial.containers.FinancialModule.class,"getTimeCodeGroups"), getMethod(com.ibm.rpm.financial.scope.FinancialModuleScope.class,"getTimeCodeGroups"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.TimeCodeAssignment.class, "TimeCode", getMethod(com.ibm.rpm.financial.containers.TimeCodeAssignment.class,"getTimeCode"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.financial.containers.TimeCodeCategory.class, "Children", getMethod(com.ibm.rpm.financial.containers.TimeCodeCategory.class,"getChildren"), getMethod(com.ibm.rpm.financial.scope.TimeCodeScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.TimeCodeGroup.class, "Children", getMethod(com.ibm.rpm.financial.containers.TimeCodeGroup.class,"getChildren"), getMethod(com.ibm.rpm.financial.scope.TimeCodeScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WbsFinancial.class, "ChargeCode", getMethod(com.ibm.rpm.financial.containers.WbsFinancial.class,"getChargeCode"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isChargeCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WbsFinancial.class, "BaselinePreviousTimePhased", getMethod(com.ibm.rpm.financial.containers.WbsFinancial.class,"getBaselinePreviousTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isBaselinePreviousTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WbsFinancial.class, "ActualTimePhased", getMethod(com.ibm.rpm.financial.containers.WbsFinancial.class,"getActualTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isActualTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WbsFinancial.class, "EstimateTimePhased", getMethod(com.ibm.rpm.financial.containers.WbsFinancial.class,"getEstimateTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isEstimateTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WbsFinancial.class, "BilledTimePhased", getMethod(com.ibm.rpm.financial.containers.WbsFinancial.class,"getBilledTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isBilledTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WbsFinancial.class, "GLTimePhased", getMethod(com.ibm.rpm.financial.containers.WbsFinancial.class,"getGLTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isGLTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WbsFinancial.class, "BaselineInitialTimePhased", getMethod(com.ibm.rpm.financial.containers.WbsFinancial.class,"getBaselineInitialTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isBaselineInitialTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WbsFinancial.class, "BaselineTimePhased", getMethod(com.ibm.rpm.financial.containers.WbsFinancial.class,"getBaselineTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isBaselineTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WorksheetFinancial.class, "ChargeCode", getMethod(com.ibm.rpm.financial.containers.WorksheetFinancial.class,"getChargeCode"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isChargeCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WorksheetFinancial.class, "BaselinePreviousTimePhased", getMethod(com.ibm.rpm.financial.containers.WorksheetFinancial.class,"getBaselinePreviousTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isBaselinePreviousTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WorksheetFinancial.class, "ActualTimePhased", getMethod(com.ibm.rpm.financial.containers.WorksheetFinancial.class,"getActualTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isActualTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WorksheetFinancial.class, "EstimateTimePhased", getMethod(com.ibm.rpm.financial.containers.WorksheetFinancial.class,"getEstimateTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isEstimateTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WorksheetFinancial.class, "BilledTimePhased", getMethod(com.ibm.rpm.financial.containers.WorksheetFinancial.class,"getBilledTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isEstimateTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WorksheetFinancial.class, "GLTimePhased", getMethod(com.ibm.rpm.financial.containers.WorksheetFinancial.class,"getGLTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isBilledTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WorksheetFinancial.class, "BaselineInitialTimePhased", getMethod(com.ibm.rpm.financial.containers.WorksheetFinancial.class,"getBaselineInitialTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isGLTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.financial.containers.WorksheetFinancial.class, "BaselineTimePhased", getMethod(com.ibm.rpm.financial.containers.WorksheetFinancial.class,"getBaselineTimePhased"), getMethod(com.ibm.rpm.financial.scope.FinancialScope.class,"isBaselineTimePhased"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "AssetResourceAssignments", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getAssetResourceAssignments"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"isAssetResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "MaintenanceEstimates", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getMaintenanceEstimates"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"getMaintenanceEstimates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "DepreciationSchedules", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getDepreciationSchedules"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"getDepreciationSchedules"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "Category", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getCategory"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "Assets", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getAssets"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"getAssets"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "AttributeAssignments", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "DocumentFolder", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getDocumentFolder"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "RtfAssignments", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getRtfAssignments"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "CrossChargeFinancials", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getCrossChargeFinancials"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"getCrossChargeFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "StatusUpdates", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "GeographicalAssignment", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getGeographicalAssignment"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"isGeographicalAssignment"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "State", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getState"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "AssignedScorecard", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getAssignedScorecard"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"getAssignedScorecard"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.Asset.class, "AssetOrganizationalAssignment", getMethod(com.ibm.rpm.asset.containers.Asset.class,"getAssetOrganizationalAssignment"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"isAssetOrganizationalAssignment"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetFolder.class, "Folders", getMethod(com.ibm.rpm.asset.containers.AssetFolder.class,"getFolders"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"getFolders"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetFolder.class, "Assets", getMethod(com.ibm.rpm.asset.containers.AssetFolder.class,"getAssets"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"getAssets"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetModule.class, "ChargeTypes", getMethod(com.ibm.rpm.asset.containers.AssetModule.class,"getChargeTypes"), getMethod(com.ibm.rpm.asset.scope.AssetModuleScope.class,"isChargeTypes"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetModule.class, "AssetRtfs", getMethod(com.ibm.rpm.asset.containers.AssetModule.class,"getAssetRtfs"), getMethod(com.ibm.rpm.asset.scope.AssetModuleScope.class,"isAssetRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetModule.class, "AssetCategories", getMethod(com.ibm.rpm.asset.containers.AssetModule.class,"getAssetCategories"), getMethod(com.ibm.rpm.asset.scope.AssetModuleScope.class,"isAssetCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetModule.class, "AssetFolders", getMethod(com.ibm.rpm.asset.containers.AssetModule.class,"getAssetFolders"), getMethod(com.ibm.rpm.asset.scope.AssetModuleScope.class,"getAssetFolders"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetModule.class, "AttributeCategories", getMethod(com.ibm.rpm.asset.containers.AssetModule.class,"getAttributeCategories"), getMethod(com.ibm.rpm.asset.scope.AssetModuleScope.class,"getAttributeCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetModule.class, "ScorecardFolders", getMethod(com.ibm.rpm.asset.containers.AssetModule.class,"getScorecardFolders"), getMethod(com.ibm.rpm.asset.scope.AssetModuleScope.class,"getScorecardFolders"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetModule.class, "AssetStates", getMethod(com.ibm.rpm.asset.containers.AssetModule.class,"getAssetStates"), getMethod(com.ibm.rpm.asset.scope.AssetModuleScope.class,"isAssetStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetModule.class, "CustomFieldCategories", getMethod(com.ibm.rpm.asset.containers.AssetModule.class,"getCustomFieldCategories"), getMethod(com.ibm.rpm.asset.scope.AssetModuleScope.class,"getCustomFieldCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetOrganizationalAssignment.class, "Organizational", getMethod(com.ibm.rpm.asset.containers.AssetOrganizationalAssignment.class,"getOrganizational"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.asset.containers.AssetResourceAssignment.class, "Resource", getMethod(com.ibm.rpm.asset.containers.AssetResourceAssignment.class,"getResource"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.asset.containers.CrossChargeFinancials.class, "CostCenter", getMethod(com.ibm.rpm.asset.containers.CrossChargeFinancials.class,"getCostCenter"), getMethod(com.ibm.rpm.asset.scope.CrossChargeFinancialsScope.class,"getCostCenter"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.asset.containers.CrossChargeFinancials.class, "ChargeType", getMethod(com.ibm.rpm.asset.containers.CrossChargeFinancials.class,"getChargeType"), getMethod(com.ibm.rpm.asset.scope.CrossChargeFinancialsScope.class,"isChargeType"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.asset.containers.GenericAsset.class, "Assets", getMethod(com.ibm.rpm.asset.containers.GenericAsset.class,"getAssets"), getMethod(com.ibm.rpm.asset.scope.AssetScope.class,"getAssets"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scorecard.containers.AssignedScorecard.class, "ScorecardState", getMethod(com.ibm.rpm.scorecard.containers.AssignedScorecard.class,"getScorecardState"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.scorecard.containers.AssignedScorecard.class, "AssignedScorecardCategories", getMethod(com.ibm.rpm.scorecard.containers.AssignedScorecard.class,"getAssignedScorecardCategories"), getMethod(com.ibm.rpm.scorecard.scope.ScorecardScope.class,"getScorecardCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scorecard.containers.AssignedScorecardCategory.class, "AssignedScorecardQuestions", getMethod(com.ibm.rpm.scorecard.containers.AssignedScorecardCategory.class,"getAssignedScorecardQuestions"), getMethod(com.ibm.rpm.scorecard.scope.ScorecardCategoryScope.class,"getScorecardQuestions"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scorecard.containers.AssignedScorecardQuestion.class, "AssignedScorecardResponses", getMethod(com.ibm.rpm.scorecard.containers.AssignedScorecardQuestion.class,"getAssignedScorecardResponses"), getMethod(com.ibm.rpm.scorecard.scope.ScorecardQuestionScope.class,"getScorecardResponses"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scorecard.containers.Scorecard.class, "ScorecardCategories", getMethod(com.ibm.rpm.scorecard.containers.Scorecard.class,"getScorecardCategories"), getMethod(com.ibm.rpm.scorecard.scope.ScorecardScope.class,"getScorecardCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scorecard.containers.ScorecardCategory.class, "ScorecardQuestions", getMethod(com.ibm.rpm.scorecard.containers.ScorecardCategory.class,"getScorecardQuestions"), getMethod(com.ibm.rpm.scorecard.scope.ScorecardCategoryScope.class,"getScorecardQuestions"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scorecard.containers.ScorecardFolder.class, "Scorecards", getMethod(com.ibm.rpm.scorecard.containers.ScorecardFolder.class,"getScorecards"), getMethod(com.ibm.rpm.scorecard.scope.ScorecardFolderScope.class,"getScorecards"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scorecard.containers.ScorecardQuestion.class, "ScorecardResponses", getMethod(com.ibm.rpm.scorecard.containers.ScorecardQuestion.class,"getScorecardResponses"), getMethod(com.ibm.rpm.scorecard.scope.ScorecardQuestionScope.class,"getScorecardResponses"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.customfield.containers.CustomField.class, "DatafieldCategory", getMethod(com.ibm.rpm.customfield.containers.CustomField.class,"getDatafieldCategory"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.customfield.containers.CustomFieldAssignment.class, "CustomField", getMethod(com.ibm.rpm.customfield.containers.CustomFieldAssignment.class,"getCustomField"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.customfield.containers.CustomFieldCategory.class, "Children", getMethod(com.ibm.rpm.customfield.containers.CustomFieldCategory.class,"getChildren"), getMethod(com.ibm.rpm.customfield.scope.CustomFieldScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.customfield.containers.CustomPortletCategory.class, "Children", getMethod(com.ibm.rpm.customfield.containers.CustomPortletCategory.class,"getChildren"), getMethod(com.ibm.rpm.customfield.scope.CustomPortletScope.class,"isChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "OrderOfMagnitudeCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getOrderOfMagnitudeCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isOrderOfMagnitudeCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "Impact", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getImpact"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isImpact"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "State", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getState"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "ClientCostCenter", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getClientCostCenter"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isClientCostCenter"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "AssetCode", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getAssetCode"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "ApprovedDate", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getApprovedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "WorksheetFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "ApprovedCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getApprovedCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isApprovedCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "Duplicates", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getDuplicates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isDuplicates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "ProposedDate", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getProposedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "Asset", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getAsset"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "AssignedScorecard", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getAssignedScorecard"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getAssignedScorecard"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "DocumentFolder", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getDocumentFolder"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Action.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.Action.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "ApprovedCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getApprovedCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isApprovedCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "OrderOfMagnitudeCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getOrderOfMagnitudeCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isOrderOfMagnitudeCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "Impact", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getImpact"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isImpact"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "State", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getState"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "ClientCostCenter", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getClientCostCenter"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isClientCostCenter"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "AssetCode", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getAssetCode"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "ApprovedDate", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getApprovedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "WorksheetFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "Duplicates", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getDuplicates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isDuplicates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "ProposedDate", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getProposedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "Asset", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getAsset"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "AssignedScorecard", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getAssignedScorecard"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getAssignedScorecard"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "DocumentFolder", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getDocumentFolder"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.ChangeRequest.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "ApprovedCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getApprovedCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isApprovedCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "OrderOfMagnitudeCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getOrderOfMagnitudeCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isOrderOfMagnitudeCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "Impact", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getImpact"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isImpact"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "State", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getState"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "ClientCostCenter", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getClientCostCenter"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isClientCostCenter"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "AssetCode", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getAssetCode"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "ApprovedDate", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getApprovedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "WorksheetFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "Duplicates", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getDuplicates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isDuplicates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "ProposedDate", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getProposedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "Asset", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getAsset"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "AssignedScorecard", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getAssignedScorecard"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getAssignedScorecard"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "DocumentFolder", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getDocumentFolder"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Defect.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.Defect.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Duplicate.class, "ScopeElement", getMethod(com.ibm.rpm.scopemanagement.containers.Duplicate.class,"getScopeElement"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "OrderOfMagnitudeCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getOrderOfMagnitudeCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isOrderOfMagnitudeCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "Impact", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getImpact"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isImpact"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "State", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getState"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "ClientCostCenter", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getClientCostCenter"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isClientCostCenter"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "AssetCode", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getAssetCode"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "ApprovedDate", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getApprovedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "WorksheetFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "Duplicates", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getDuplicates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isDuplicates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "ProposedDate", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getProposedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "Asset", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getAsset"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "AssignedScorecard", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getAssignedScorecard"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getAssignedScorecard"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "DocumentFolder", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getDocumentFolder"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Issue.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.Issue.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.MitigationFactor.class, "MitigationTriggers", getMethod(com.ibm.rpm.scopemanagement.containers.MitigationFactor.class,"getMitigationTriggers"), getMethod(com.ibm.rpm.scopemanagement.scope.MitigationFactorScope.class,"isMitigationTriggers"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "ApprovedCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getApprovedCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isApprovedCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "OrderOfMagnitudeCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getOrderOfMagnitudeCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isOrderOfMagnitudeCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "Impact", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getImpact"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isImpact"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "State", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getState"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "ClientCostCenter", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getClientCostCenter"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isClientCostCenter"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "AssetCode", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getAssetCode"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "ApprovedDate", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getApprovedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "WorksheetFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "Duplicates", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getDuplicates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isDuplicates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "ProposedDate", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getProposedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "Asset", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getAsset"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "AssignedScorecard", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getAssignedScorecard"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getAssignedScorecard"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "DocumentFolder", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getDocumentFolder"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Requirement.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.Requirement.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "RiskMatrix", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getRiskMatrix"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRiskMatrix"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "OrderOfMagnitudeCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getOrderOfMagnitudeCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isOrderOfMagnitudeCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "Impact", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getImpact"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isImpact"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "State", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getState"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "ClientCostCenter", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getClientCostCenter"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isClientCostCenter"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "AssetCode", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getAssetCode"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "ApprovedDate", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getApprovedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "WorksheetFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "Duplicates", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getDuplicates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isDuplicates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "ProposedDate", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getProposedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "Asset", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getAsset"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "AssignedScorecard", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getAssignedScorecard"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getAssignedScorecard"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "DocumentFolder", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getDocumentFolder"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "MitigationFactors", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getMitigationFactors"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getMitigationFactors"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.Risk.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.Risk.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "WorksheetFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "ProposedDate", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getProposedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeDeliverable.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeElement.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeElement.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeElement.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeElement.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeElement.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeElement.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeElement.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeElement.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeFolder.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeFolder.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeFolder.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeFolder.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeFolder.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeFolder.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeFolder.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeFolder.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeFolder.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeFolder.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "ChangeRequestRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getChangeRequestRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isChangeRequestRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "RequirementRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getRequirementRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isRequirementRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "IssueRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getIssueRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isIssueRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "DefectStates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getDefectStates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isDefectStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "MilestoneRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getMilestoneRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isMilestoneRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "ChangeRequestStates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getChangeRequestStates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isChangeRequestStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "ActionRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getActionRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isActionRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "ScorecardFolders", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getScorecardFolders"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"getScorecardFolders"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "DeliverableRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getDeliverableRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isDeliverableRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "SummaryTaskRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getSummaryTaskRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isSummaryTaskRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "IssueStates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getIssueStates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isIssueStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "ServiceRequestStates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getServiceRequestStates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isServiceRequestStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "CustomFieldCategories", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getCustomFieldCategories"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"getCustomFieldCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "AttributeCategories", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getAttributeCategories"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"getAttributeCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "ActionStates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getActionStates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isActionStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "DefectRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getDefectRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isDefectRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "ScopeFolders", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getScopeFolders"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"getScopeFolders"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "RiskRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getRiskRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isRiskRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "RiskStates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getRiskStates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isRiskStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "TaskRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getTaskRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isTaskRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "ServiceRequestRtfs", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getServiceRequestRtfs"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isServiceRequestRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class, "RequirementStates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeManagementModule.class,"getRequirementStates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope.class,"isRequirementStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeMilestone.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "WorksheetFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "ProposedDate", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getProposedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeSummaryTask.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeTask.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeTask.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeTask.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeTask.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeTask.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeTask.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeTask.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeTask.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeTask.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeTask.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeTask.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeTask.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeTask.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeTask.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeTask.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeTask.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "WorksheetFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "ProposedDate", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getProposedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.ScopeWorkProduct.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "ApprovedCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getApprovedCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isApprovedCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "WorkElement", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getWorkElement"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "AttributeAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "RtfAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getRtfAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isRtfAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "OrderOfMagnitudeCostBenefits", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getOrderOfMagnitudeCostBenefits"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isOrderOfMagnitudeCostBenefits"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "Impact", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getImpact"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isImpact"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "State", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getState"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "ClientCostCenter", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getClientCostCenter"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isClientCostCenter"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "AssetCode", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getAssetCode"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAssetCode"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "ApprovedDate", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getApprovedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "WorksheetFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getWorksheetFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWorksheetFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "Duplicates", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getDuplicates"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isDuplicates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "ProposedDate", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getProposedDate"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isScheduleDates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "Asset", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getAsset"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"isAsset"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "AssignedScorecard", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getAssignedScorecard"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getAssignedScorecard"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "DocumentFolder", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getDocumentFolder"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "WbsFinancials", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getWbsFinancials"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getWbsFinancials"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "Project", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getProject"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "ResourceTaskAssignments", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getResourceTaskAssignments"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getResourceTaskAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class, "StatusUpdates", getMethod(com.ibm.rpm.scopemanagement.containers.ServiceRequest.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.contract.containers.Contract.class, "ContractType", getMethod(com.ibm.rpm.contract.containers.Contract.class,"getContractType"), getMethod(com.ibm.rpm.contract.scope.ContractScope.class,"isContractType"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.contract.containers.Contract.class, "Currency", getMethod(com.ibm.rpm.contract.containers.Contract.class,"getCurrency"), getMethod(com.ibm.rpm.contract.scope.ContractScope.class,"isCurrency"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.contract.containers.Contract.class, "ChargeSchedules", getMethod(com.ibm.rpm.contract.containers.Contract.class,"getChargeSchedules"), getMethod(com.ibm.rpm.contract.scope.ContractScope.class,"isChargeSchedules"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.contract.containers.ContractFolder.class, "Children", getMethod(com.ibm.rpm.contract.containers.ContractFolder.class,"getChildren"), getMethod(com.ibm.rpm.contract.scope.ContractScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.contract.containers.ContractModule.class, "Contracts", getMethod(com.ibm.rpm.contract.containers.ContractModule.class,"getContracts"), getMethod(com.ibm.rpm.contract.scope.ContractModuleScope.class,"getContracts"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.contract.containers.ContractModule.class, "ContractTypes", getMethod(com.ibm.rpm.contract.containers.ContractModule.class,"getContractTypes"), getMethod(com.ibm.rpm.contract.scope.ContractModuleScope.class,"isContractTypes"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.expense.containers.ExpenseItem.class, "ChargeCode", getMethod(com.ibm.rpm.expense.containers.ExpenseItem.class,"getChargeCode"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.expense.containers.Invoice.class, "ExpenseItems", getMethod(com.ibm.rpm.expense.containers.Invoice.class,"getExpenseItems"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.expense.containers.Invoice.class, "Currency", getMethod(com.ibm.rpm.expense.containers.Invoice.class,"getCurrency"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.expense.containers.Invoice.class, "PaymentType", getMethod(com.ibm.rpm.expense.containers.Invoice.class,"getPaymentType"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.expense.containers.Invoice.class, "TaskAssignment", getMethod(com.ibm.rpm.expense.containers.Invoice.class,"getTaskAssignment"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.IndustryExperience.class, "Proficiency", getMethod(com.ibm.rpm.resource.containers.IndustryExperience.class,"getProficiency"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.IndustryExperience.class, "Industry", getMethod(com.ibm.rpm.resource.containers.IndustryExperience.class,"getIndustry"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.IndustryExperience.class, "Classification", getMethod(com.ibm.rpm.resource.containers.IndustryExperience.class,"getClassification"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.LanguageProficiency.class, "Language", getMethod(com.ibm.rpm.resource.containers.LanguageProficiency.class,"getLanguage"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.LocationPreferences.class, "TravelLocations", getMethod(com.ibm.rpm.resource.containers.LocationPreferences.class,"getTravelLocations"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.LocationPreferences.class, "RelocateLocations", getMethod(com.ibm.rpm.resource.containers.LocationPreferences.class,"getRelocateLocations"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Passport.class, "Country", getMethod(com.ibm.rpm.resource.containers.Passport.class,"getCountry"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Passport.class, "Visas", getMethod(com.ibm.rpm.resource.containers.Passport.class,"getVisas"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Pool.class, "Resources", getMethod(com.ibm.rpm.resource.containers.Pool.class,"getResources"), getMethod(com.ibm.rpm.resource.scope.PoolScope.class,"getResources"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Pool.class, "ClientCostCenter", getMethod(com.ibm.rpm.resource.containers.Pool.class,"getClientCostCenter"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Pool.class, "DocumentFolder", getMethod(com.ibm.rpm.resource.containers.Pool.class,"getDocumentFolder"), getMethod(com.ibm.rpm.resource.scope.PoolScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Pool.class, "ResourceAssignments", getMethod(com.ibm.rpm.resource.containers.Pool.class,"getResourceAssignments"), getMethod(com.ibm.rpm.resource.scope.PoolScope.class,"isResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Pool.class, "AttributeAssignments", getMethod(com.ibm.rpm.resource.containers.Pool.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.resource.scope.PoolScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Pool.class, "Domain", getMethod(com.ibm.rpm.resource.containers.Pool.class,"getDomain"), getMethod(com.ibm.rpm.resource.scope.PoolScope.class,"getDomain"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Pool.class, "PoolReferences", getMethod(com.ibm.rpm.resource.containers.Pool.class,"getPoolReferences"), getMethod(com.ibm.rpm.resource.scope.PoolScope.class,"getPoolReferences"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Pool.class, "AdministrativeTasks", getMethod(com.ibm.rpm.resource.containers.Pool.class,"getAdministrativeTasks"), getMethod(com.ibm.rpm.resource.scope.PoolScope.class,"isAdministrativeTasks"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Pool.class, "Pools", getMethod(com.ibm.rpm.resource.containers.Pool.class,"getPools"), getMethod(com.ibm.rpm.resource.scope.PoolScope.class,"getPools"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Pool.class, "SecurityGroup", getMethod(com.ibm.rpm.resource.containers.Pool.class,"getSecurityGroup"), getMethod(com.ibm.rpm.resource.scope.PoolScope.class,"getSecurityGroup"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.PoolModule.class, "AttributeCategories", getMethod(com.ibm.rpm.resource.containers.PoolModule.class,"getAttributeCategories"), getMethod(com.ibm.rpm.resource.scope.PoolModuleScope.class,"getAttributeCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.PoolModule.class, "CompanySizes", getMethod(com.ibm.rpm.resource.containers.PoolModule.class,"getCompanySizes"), getMethod(com.ibm.rpm.resource.scope.PoolModuleScope.class,"isCompanySizes"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.PoolModule.class, "Pools", getMethod(com.ibm.rpm.resource.containers.PoolModule.class,"getPools"), getMethod(com.ibm.rpm.resource.scope.PoolModuleScope.class,"getPools"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.PoolModule.class, "PoolDomains", getMethod(com.ibm.rpm.resource.containers.PoolModule.class,"getPoolDomains"), getMethod(com.ibm.rpm.resource.scope.PoolModuleScope.class,"getPoolDomains"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.PoolReference.class, "CompanySize", getMethod(com.ibm.rpm.resource.containers.PoolReference.class,"getCompanySize"), getMethod(com.ibm.rpm.resource.scope.PoolReferenceScope.class,"isCompanySize"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ProjectHistory.class, "Classification", getMethod(com.ibm.rpm.resource.containers.ProjectHistory.class,"getClassification"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ProjectHistory.class, "Industry", getMethod(com.ibm.rpm.resource.containers.ProjectHistory.class,"getIndustry"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "WorkingStatus", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getWorkingStatus"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isWorkingStatus"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "ExecutiveAttributes", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getExecutiveAttributes"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isExecutiveAttributes"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "PersonalTasks", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getPersonalTasks"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isPersonalTasks"), true, false, true);
    }

    private static void initPart3()
    {
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "LocationPreferences", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getLocationPreferences"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isLocationPreferences"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "Passport", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getPassport"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isPassport"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "ContactGroupAssignments", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getContactGroupAssignments"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isContactGroupAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "Currency", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getCurrency"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isCurrency"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "ProjectHistories", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getProjectHistories"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isProjectHistories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "GeographicalAssignment", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getGeographicalAssignment"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isGeographicalAssignment"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "ExecutiveAttributeClassifications", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getExecutiveAttributeClassifications"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isExecutiveAttributeClassifications"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "Educations", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getEducations"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isEducations"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "Calendar", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getCalendar"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"getCalendar"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "CompetencyAttributeAssignments", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getCompetencyAttributeAssignments"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isCompetencyAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "VerifiedBy", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getVerifiedBy"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "WorkPackages", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getWorkPackages"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "EmploymentHistories", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getEmploymentHistories"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isEmploymentHistories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "ResourceSecurityRights", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getResourceSecurityRights"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "SkillAttributeAssignments", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getSkillAttributeAssignments"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isSkillAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "AdministrativeTaskAssignments", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getAdministrativeTaskAssignments"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isAdministrativeTaskAssignments"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "PersonalTaskAssignments", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getPersonalTaskAssignments"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isPersonalTaskAssignments"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "Experience", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getExperience"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isExperience"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "WorkLocation", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getWorkLocation"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isWorkLocation"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "IndustryExperiences", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getIndustryExperiences"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isIndustryExperiences"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "ReVerifiedBy", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getReVerifiedBy"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "OrganizationalAssignment", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getOrganizationalAssignment"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isOrganizationalAssignment"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "EmployeeStatus", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getEmployeeStatus"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isEmployeeStatus"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "ExecutiveSecurityRole", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getExecutiveSecurityRole"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"getExecutiveSecurityRole"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "ResourceCostCenterAssignments", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getResourceCostCenterAssignments"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isResourceCostCenterAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "Rates", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getRates"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isRates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "DocumentFolder", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getDocumentFolder"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"getDocumentFolder"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "SecurityGroup", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getSecurityGroup"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"getSecurityGroup"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Resource.class, "LanguageProficiencies", getMethod(com.ibm.rpm.resource.containers.Resource.class,"getLanguageProficiencies"), getMethod(com.ibm.rpm.resource.scope.ResourceScope.class,"isLanguageProficiencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeAssignment.class, "PreferenceRank", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeAssignment.class,"getPreferenceRank"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeAssignment.class, "Experience", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeAssignment.class,"getExperience"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeAssignment.class, "Rates", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeAssignment.class,"getRates"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeAssignment.class, "ProficiencyLevel", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeAssignment.class,"getProficiencyLevel"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeCompetency.class, "ProficiencyLevels", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeCompetency.class,"getProficiencyLevels"), getMethod(com.ibm.rpm.resource.scope.ResourceAttributeScope.class,"isProficiencyLevels"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeCompetencyCategory.class, "Classifications", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeCompetencyCategory.class,"getClassifications"), getMethod(com.ibm.rpm.resource.scope.ResourceAttributeScope.class,"getClassifications"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeCompetencyClassification.class, "Attributes", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeCompetencyClassification.class,"getAttributes"), getMethod(com.ibm.rpm.resource.scope.ResourceAttributeScope.class,"getAttributes"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeCompetencyProficiencyLevel.class, "ProficiencyLevel", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeCompetencyProficiencyLevel.class,"getProficiencyLevel"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeCompetencyProficiencyLevel.class, "Rates", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeCompetencyProficiencyLevel.class,"getRates"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeProficiencyLevel.class, "Rates", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeProficiencyLevel.class,"getRates"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeSkill.class, "ProficiencyLevels", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeSkill.class,"getProficiencyLevels"), getMethod(com.ibm.rpm.resource.scope.ResourceAttributeScope.class,"isProficiencyLevels"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeSkillCategory.class, "Classifications", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeSkillCategory.class,"getClassifications"), getMethod(com.ibm.rpm.resource.scope.ResourceAttributeScope.class,"getClassifications"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeSkillClassification.class, "Attributes", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeSkillClassification.class,"getAttributes"), getMethod(com.ibm.rpm.resource.scope.ResourceAttributeScope.class,"getAttributes"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeSkillProficiencyLevel.class, "ProficiencyLevel", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeSkillProficiencyLevel.class,"getProficiencyLevel"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceAttributeSkillProficiencyLevel.class, "Rates", getMethod(com.ibm.rpm.resource.containers.ResourceAttributeSkillProficiencyLevel.class,"getRates"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceCostCenterAssignment.class, "ClientCostCenter", getMethod(com.ibm.rpm.resource.containers.ResourceCostCenterAssignment.class,"getClientCostCenter"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "ResourceAttributeSkillCategories", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getResourceAttributeSkillCategories"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"getResourceAttributeSkillCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "Languages", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getLanguages"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"isLanguages"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "IndustryTypes", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getIndustryTypes"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"isIndustryTypes"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "EmployeeStatus", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getEmployeeStatus"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"isEmployeeStatus"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "ProficiencyLevels", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getProficiencyLevels"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"isProficiencyLevels"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "PreferenceRanks", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getPreferenceRanks"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"isPreferenceRanks"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "ResourceAttributeCompetencyCategories", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getResourceAttributeCompetencyCategories"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"getResourceAttributeCompetencyCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "WorkingStatus", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getWorkingStatus"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"isWorkingStatus"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "Experiences", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getExperiences"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"isExperiences"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "WorkLocations", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getWorkLocations"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"isWorkLocations"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "Classifications", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getClassifications"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"isClassifications"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "ContactGroups", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getContactGroups"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"getContactGroups"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "CustomFieldCategories", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getCustomFieldCategories"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"getCustomFieldCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceModule.class, "CitizenshipCountryCodes", getMethod(com.ibm.rpm.resource.containers.ResourceModule.class,"getCitizenshipCountryCodes"), getMethod(com.ibm.rpm.resource.scope.ResourceModuleScope.class,"isCitizenshipCountryCodes"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceRoleAssignment.class, "Resource", getMethod(com.ibm.rpm.resource.containers.ResourceRoleAssignment.class,"getResource"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.ResourceRoleAssignment.class, "SecurityRole", getMethod(com.ibm.rpm.resource.containers.ResourceRoleAssignment.class,"getSecurityRole"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.resource.containers.Visa.class, "Country", getMethod(com.ibm.rpm.resource.containers.Visa.class,"getCountry"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.document.containers.DelDoc.class, "State", getMethod(com.ibm.rpm.document.containers.DelDoc.class,"getState"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.document.containers.DelDoc.class, "Children", getMethod(com.ibm.rpm.document.containers.DelDoc.class,"getChildren"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DelDoc.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.document.containers.DelDoc.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DelDoc.class, "AttributeAssignments", getMethod(com.ibm.rpm.document.containers.DelDoc.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DelDoc.class, "ResourceAssignments", getMethod(com.ibm.rpm.document.containers.DelDoc.class,"getResourceAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DelDoc.class, "StatusUpdates", getMethod(com.ibm.rpm.document.containers.DelDoc.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.Document.class, "State", getMethod(com.ibm.rpm.document.containers.Document.class,"getState"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.document.containers.Document.class, "Children", getMethod(com.ibm.rpm.document.containers.Document.class,"getChildren"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.Document.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.document.containers.Document.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.Document.class, "AttributeAssignments", getMethod(com.ibm.rpm.document.containers.Document.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.Document.class, "ResourceAssignments", getMethod(com.ibm.rpm.document.containers.Document.class,"getResourceAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.Document.class, "StatusUpdates", getMethod(com.ibm.rpm.document.containers.Document.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DocumentElement.class, "Children", getMethod(com.ibm.rpm.document.containers.DocumentElement.class,"getChildren"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DocumentElement.class, "ResourceAssignments", getMethod(com.ibm.rpm.document.containers.DocumentElement.class,"getResourceAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DocumentFolder.class, "Children", getMethod(com.ibm.rpm.document.containers.DocumentFolder.class,"getChildren"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DocumentFolder.class, "ResourceAssignments", getMethod(com.ibm.rpm.document.containers.DocumentFolder.class,"getResourceAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DocumentModule.class, "NoteStates", getMethod(com.ibm.rpm.document.containers.DocumentModule.class,"getNoteStates"), getMethod(com.ibm.rpm.document.scope.DocumentModuleScope.class,"isNoteStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DocumentModule.class, "CustomFieldCategories", getMethod(com.ibm.rpm.document.containers.DocumentModule.class,"getCustomFieldCategories"), getMethod(com.ibm.rpm.document.scope.DocumentModuleScope.class,"getCustomFieldCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DocumentModule.class, "DocumentStates", getMethod(com.ibm.rpm.document.containers.DocumentModule.class,"getDocumentStates"), getMethod(com.ibm.rpm.document.scope.DocumentModuleScope.class,"isDocumentStates"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DocumentModule.class, "AttributeCategories", getMethod(com.ibm.rpm.document.containers.DocumentModule.class,"getAttributeCategories"), getMethod(com.ibm.rpm.document.scope.DocumentModuleScope.class,"getAttributeCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.DocumentModule.class, "NoteMinutesRtfs", getMethod(com.ibm.rpm.document.containers.DocumentModule.class,"getNoteMinutesRtfs"), getMethod(com.ibm.rpm.document.scope.DocumentModuleScope.class,"isNoteMinutesRtfs"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.GenericDocument.class, "Children", getMethod(com.ibm.rpm.document.containers.GenericDocument.class,"getChildren"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.GenericDocument.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.document.containers.GenericDocument.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.GenericDocument.class, "AttributeAssignments", getMethod(com.ibm.rpm.document.containers.GenericDocument.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.GenericDocument.class, "ResourceAssignments", getMethod(com.ibm.rpm.document.containers.GenericDocument.class,"getResourceAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.GenericDocument.class, "StatusUpdates", getMethod(com.ibm.rpm.document.containers.GenericDocument.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.NoteMinutes.class, "Children", getMethod(com.ibm.rpm.document.containers.NoteMinutes.class,"getChildren"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.NoteMinutes.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.document.containers.NoteMinutes.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.NoteMinutes.class, "RtfAssignment", getMethod(com.ibm.rpm.document.containers.NoteMinutes.class,"getRtfAssignment"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isRtfAssignment"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.NoteMinutes.class, "State", getMethod(com.ibm.rpm.document.containers.NoteMinutes.class,"getState"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.document.containers.NoteMinutes.class, "AttributeAssignments", getMethod(com.ibm.rpm.document.containers.NoteMinutes.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.NoteMinutes.class, "ResourceAssignments", getMethod(com.ibm.rpm.document.containers.NoteMinutes.class,"getResourceAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.NoteMinutes.class, "StatusUpdates", getMethod(com.ibm.rpm.document.containers.NoteMinutes.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.Software.class, "State", getMethod(com.ibm.rpm.document.containers.Software.class,"getState"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.document.containers.Software.class, "Children", getMethod(com.ibm.rpm.document.containers.Software.class,"getChildren"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.Software.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.document.containers.Software.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.Software.class, "AttributeAssignments", getMethod(com.ibm.rpm.document.containers.Software.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.Software.class, "ResourceAssignments", getMethod(com.ibm.rpm.document.containers.Software.class,"getResourceAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.Software.class, "StatusUpdates", getMethod(com.ibm.rpm.document.containers.Software.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.UrlDocument.class, "State", getMethod(com.ibm.rpm.document.containers.UrlDocument.class,"getState"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.document.containers.UrlDocument.class, "Children", getMethod(com.ibm.rpm.document.containers.UrlDocument.class,"getChildren"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.UrlDocument.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.document.containers.UrlDocument.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.UrlDocument.class, "AttributeAssignments", getMethod(com.ibm.rpm.document.containers.UrlDocument.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.UrlDocument.class, "ResourceAssignments", getMethod(com.ibm.rpm.document.containers.UrlDocument.class,"getResourceAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.UrlDocument.class, "StatusUpdates", getMethod(com.ibm.rpm.document.containers.UrlDocument.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.WPDoc.class, "State", getMethod(com.ibm.rpm.document.containers.WPDoc.class,"getState"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isState"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.document.containers.WPDoc.class, "Children", getMethod(com.ibm.rpm.document.containers.WPDoc.class,"getChildren"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.WPDoc.class, "CustomFieldAssignments", getMethod(com.ibm.rpm.document.containers.WPDoc.class,"getCustomFieldAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isCustomFieldAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.WPDoc.class, "AttributeAssignments", getMethod(com.ibm.rpm.document.containers.WPDoc.class,"getAttributeAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isAttributeAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.WPDoc.class, "ResourceAssignments", getMethod(com.ibm.rpm.document.containers.WPDoc.class,"getResourceAssignments"), getMethod(com.ibm.rpm.document.scope.DocumentScope.class,"isResourceAssignments"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.document.containers.WPDoc.class, "StatusUpdates", getMethod(com.ibm.rpm.document.containers.WPDoc.class,"getStatusUpdates"), null, true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.AdministrationModule.class, "Geographicals", getMethod(com.ibm.rpm.applicationadministration.containers.AdministrationModule.class,"getGeographicals"), getMethod(com.ibm.rpm.applicationadministration.scope.AdministrationModuleScope.class,"getGeographicals"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.AdministrationModule.class, "RpmCalendars", getMethod(com.ibm.rpm.applicationadministration.containers.AdministrationModule.class,"getRpmCalendars"), getMethod(com.ibm.rpm.applicationadministration.scope.AdministrationModuleScope.class,"getRpmCalendars"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.AdministrationModule.class, "Organizationals", getMethod(com.ibm.rpm.applicationadministration.containers.AdministrationModule.class,"getOrganizationals"), getMethod(com.ibm.rpm.applicationadministration.scope.AdministrationModuleScope.class,"getOrganizationals"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.AdministrationModule.class, "Currencies", getMethod(com.ibm.rpm.applicationadministration.containers.AdministrationModule.class,"getCurrencies"), getMethod(com.ibm.rpm.applicationadministration.scope.AdministrationModuleScope.class,"isCurrencies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.AdministrationModule.class, "DatafieldCategories", getMethod(com.ibm.rpm.applicationadministration.containers.AdministrationModule.class,"getDatafieldCategories"), getMethod(com.ibm.rpm.applicationadministration.scope.AdministrationModuleScope.class,"isDatafieldCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.AttributeAssignment.class, "Attribute", getMethod(com.ibm.rpm.applicationadministration.containers.AttributeAssignment.class,"getAttribute"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.AttributeCategory.class, "Categories", getMethod(com.ibm.rpm.applicationadministration.containers.AttributeCategory.class,"getCategories"), getMethod(com.ibm.rpm.applicationadministration.scope.AttributeScope.class,"getCategories"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.AttributeCategory.class, "Classifications", getMethod(com.ibm.rpm.applicationadministration.containers.AttributeCategory.class,"getClassifications"), getMethod(com.ibm.rpm.applicationadministration.scope.AttributeScope.class,"getClassifications"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.AttributeClassification.class, "Attributes", getMethod(com.ibm.rpm.applicationadministration.containers.AttributeClassification.class,"getAttributes"), getMethod(com.ibm.rpm.applicationadministration.scope.AttributeScope.class,"getAttributes"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.City.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.City.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.GeographicalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.ContactGroup.class, "ContactGroups", getMethod(com.ibm.rpm.applicationadministration.containers.ContactGroup.class,"getContactGroups"), getMethod(com.ibm.rpm.applicationadministration.scope.ContactGroupScope.class,"getContactGroups"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.ContactGroupAssignment.class, "Groups", getMethod(com.ibm.rpm.applicationadministration.containers.ContactGroupAssignment.class,"getGroups"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.Country.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.Country.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.GeographicalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.CountryState.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.CountryState.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.GeographicalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.Currency.class, "ExchangeRanges", getMethod(com.ibm.rpm.applicationadministration.containers.Currency.class,"getExchangeRanges"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.CustomDatafieldCategory.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.CustomDatafieldCategory.class,"getChildren"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.DatafieldCategory.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.DatafieldCategory.class,"getChildren"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.Department.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.Department.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.OrganizationalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.Geographical.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.Geographical.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.GeographicalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.GeographicalAssignment.class, "Geographical", getMethod(com.ibm.rpm.applicationadministration.containers.GeographicalAssignment.class,"getGeographical"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.Group.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.Group.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.OrganizationalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.Location.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.Location.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.GeographicalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.Office.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.Office.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.OrganizationalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.Organization.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.Organization.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.OrganizationalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.Organizational.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.Organizational.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.OrganizationalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.OrganizationalAssignment.class, "Organizational", getMethod(com.ibm.rpm.applicationadministration.containers.OrganizationalAssignment.class,"getOrganizational"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.PoolDomain.class, "PoolDomains", getMethod(com.ibm.rpm.applicationadministration.containers.PoolDomain.class,"getPoolDomains"), getMethod(com.ibm.rpm.applicationadministration.scope.PoolDomainScope.class,"getPoolDomains"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.Region.class, "Children", getMethod(com.ibm.rpm.applicationadministration.containers.Region.class,"getChildren"), getMethod(com.ibm.rpm.applicationadministration.scope.GeographicalScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class, "StandardMonday", getMethod(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class,"getStandardMonday"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class, "StandardFriday", getMethod(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class,"getStandardFriday"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class, "Exceptions", getMethod(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class,"getExceptions"), getMethod(com.ibm.rpm.applicationadministration.scope.CalendarScope.class,"isExceptions"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class, "Calendars", getMethod(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class,"getCalendars"), getMethod(com.ibm.rpm.applicationadministration.scope.CalendarScope.class,"getCalendars"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class, "StandardSaturday", getMethod(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class,"getStandardSaturday"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class, "StandardSunday", getMethod(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class,"getStandardSunday"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class, "StandardThursday", getMethod(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class,"getStandardThursday"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class, "StandardTuesday", getMethod(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class,"getStandardTuesday"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class, "StandardWednesday", getMethod(com.ibm.rpm.applicationadministration.containers.RPMCalendar.class,"getStandardWednesday"), null, true, true, true);
        map.addFieldInfo(com.ibm.rpm.applicationadministration.containers.RtfAssignment.class, "Rtf", getMethod(com.ibm.rpm.applicationadministration.containers.RtfAssignment.class,"getRtf"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.GenericStep.class, "TimeCode1", getMethod(com.ibm.rpm.timesheet.containers.GenericStep.class,"getTimeCode1"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.GenericStep.class, "TimeCode2", getMethod(com.ibm.rpm.timesheet.containers.GenericStep.class,"getTimeCode2"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.GenericStep.class, "WorkElement", getMethod(com.ibm.rpm.timesheet.containers.GenericStep.class,"getWorkElement"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.GenericStep.class, "Project", getMethod(com.ibm.rpm.timesheet.containers.GenericStep.class,"getProject"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.GenericStep.class, "Resource", getMethod(com.ibm.rpm.timesheet.containers.GenericStep.class,"getResource"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isResource"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.GenericStep.class, "TaskAssignment", getMethod(com.ibm.rpm.timesheet.containers.GenericStep.class,"getTaskAssignment"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTaskAssignment"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Step.class, "TimeCode1", getMethod(com.ibm.rpm.timesheet.containers.Step.class,"getTimeCode1"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Step.class, "TimeCode2", getMethod(com.ibm.rpm.timesheet.containers.Step.class,"getTimeCode2"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Step.class, "WorkElement", getMethod(com.ibm.rpm.timesheet.containers.Step.class,"getWorkElement"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Step.class, "Project", getMethod(com.ibm.rpm.timesheet.containers.Step.class,"getProject"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Step.class, "Resource", getMethod(com.ibm.rpm.timesheet.containers.Step.class,"getResource"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isResource"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Step.class, "TaskAssignment", getMethod(com.ibm.rpm.timesheet.containers.Step.class,"getTaskAssignment"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTaskAssignment"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Step.class, "StepTimesheets", getMethod(com.ibm.rpm.timesheet.containers.Step.class,"getStepTimesheets"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTimesheets"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Credit.class, "TimeCode1", getMethod(com.ibm.rpm.timesheet.containers.Credit.class,"getTimeCode1"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Credit.class, "TimeCode2", getMethod(com.ibm.rpm.timesheet.containers.Credit.class,"getTimeCode2"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Credit.class, "WorkElement", getMethod(com.ibm.rpm.timesheet.containers.Credit.class,"getWorkElement"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Credit.class, "Project", getMethod(com.ibm.rpm.timesheet.containers.Credit.class,"getProject"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Credit.class, "Resource", getMethod(com.ibm.rpm.timesheet.containers.Credit.class,"getResource"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isResource"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Credit.class, "TaskAssignment", getMethod(com.ibm.rpm.timesheet.containers.Credit.class,"getTaskAssignment"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTaskAssignment"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.Credit.class, "CreditTimesheet", getMethod(com.ibm.rpm.timesheet.containers.Credit.class,"getCreditTimesheet"), getMethod(com.ibm.rpm.timesheet.scope.StepScope.class,"isTimesheets"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.AdministrativeTaskAssignment.class, "AdministrativeTask", getMethod(com.ibm.rpm.timesheet.containers.AdministrativeTaskAssignment.class,"getAdministrativeTask"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.DefaultStep.class, "TimeCode1", getMethod(com.ibm.rpm.timesheet.containers.DefaultStep.class,"getTimeCode1"), getMethod(com.ibm.rpm.timesheet.scope.DefaultStepScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.DefaultStep.class, "TimeCode2", getMethod(com.ibm.rpm.timesheet.containers.DefaultStep.class,"getTimeCode2"), getMethod(com.ibm.rpm.timesheet.scope.DefaultStepScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.PersonalTaskAssignment.class, "personalTask", getMethod(com.ibm.rpm.timesheet.containers.PersonalTaskAssignment.class,"getPersonalTask"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class, "TimeCode2", getMethod(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class,"getTimeCode2"), getMethod(com.ibm.rpm.timesheet.scope.SummaryTimesheetScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class, "ApprovalStatus", getMethod(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class,"getApprovalStatus"), getMethod(com.ibm.rpm.timesheet.scope.SummaryTimesheetScope.class,"getApprovalStatus"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class, "TimeCode1", getMethod(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class,"getTimeCode1"), getMethod(com.ibm.rpm.timesheet.scope.SummaryTimesheetScope.class,"isTimeCodes"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class, "TaskAssignment", getMethod(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class,"getTaskAssignment"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class, "Project", getMethod(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class,"getProject"), getMethod(com.ibm.rpm.timesheet.scope.SummaryTimesheetScope.class,"isProject"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class, "Resource", getMethod(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class,"getResource"), getMethod(com.ibm.rpm.timesheet.scope.SummaryTimesheetScope.class,"isResource"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class, "WorkElement", getMethod(com.ibm.rpm.timesheet.containers.SummaryTimesheet.class,"getWorkElement"), getMethod(com.ibm.rpm.timesheet.scope.SummaryTimesheetScope.class,"getWorkElement"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.TimesheetApprovalStatus.class, "Resource", getMethod(com.ibm.rpm.timesheet.containers.TimesheetApprovalStatus.class,"getResource"), getMethod(com.ibm.rpm.timesheet.scope.TimesheetApprovalStatusScope.class,"getResource"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.TimesheetApprovalStatus.class, "LastApprovedRejectedBy", getMethod(com.ibm.rpm.timesheet.containers.TimesheetApprovalStatus.class,"getLastApprovedRejectedBy"), getMethod(com.ibm.rpm.timesheet.scope.TimesheetApprovalStatusScope.class,"getLastApprovedRejectedBy"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.timesheet.containers.TimesheetApprovalStatus.class, "Project", getMethod(com.ibm.rpm.timesheet.containers.TimesheetApprovalStatus.class,"getProject"), getMethod(com.ibm.rpm.timesheet.scope.TimesheetApprovalStatusScope.class,"getProject"), false, false, false);
	}
    
    private static void initPart4()
    {
        map.addFieldInfo(com.ibm.rpm.communications.containers.GenericCommunication.class, "Responses", getMethod(com.ibm.rpm.communications.containers.GenericCommunication.class,"getResponses"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"getResponses"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.communications.containers.GenericCommunication.class, "WorkflowAttachment", getMethod(com.ibm.rpm.communications.containers.GenericCommunication.class,"getWorkflowAttachment"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"isWorkflowAttachment"), true, false, false);
        map.addFieldInfo(com.ibm.rpm.communications.containers.GenericCommunication.class, "Author", getMethod(com.ibm.rpm.communications.containers.GenericCommunication.class,"getAuthor"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"isAuthor"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.communications.containers.Notification.class, "Responses", getMethod(com.ibm.rpm.communications.containers.Notification.class,"getReplies"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"getReplies"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.communications.containers.Notification.class, "WorkflowAttachment", getMethod(com.ibm.rpm.communications.containers.Notification.class,"getWorkflowAttachment"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"isWorkflowAttachment"), true, false, false);
        map.addFieldInfo(com.ibm.rpm.communications.containers.Notification.class, "Author", getMethod(com.ibm.rpm.communications.containers.Notification.class,"getAuthor"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"isAuthor"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.communications.containers.StaffingRequest.class, "Replies", getMethod(com.ibm.rpm.communications.containers.StaffingRequest.class,"getResponses"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"getResponses"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.communications.containers.StaffingRequest.class, "WorkflowAttachment", getMethod(com.ibm.rpm.communications.containers.StaffingRequest.class,"getWorkflowAttachment"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"isWorkflowAttachment"), true, false, false);
        map.addFieldInfo(com.ibm.rpm.communications.containers.StaffingRequest.class, "Author", getMethod(com.ibm.rpm.communications.containers.StaffingRequest.class,"getAuthor"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"isAuthor"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.communications.containers.WorkflowResponse.class, "Resource", getMethod(com.ibm.rpm.communications.containers.WorkflowResponse.class,"getResource"), getMethod(com.ibm.rpm.communications.scope.WorkflowResponseScope.class,"isResource"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.communications.containers.WorkflowStepNotification.class, "Responses", getMethod(com.ibm.rpm.communications.containers.WorkflowStepNotification.class,"getResponses"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"getResponses"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.communications.containers.WorkflowStepNotification.class, "WorkflowAttachment", getMethod(com.ibm.rpm.communications.containers.WorkflowStepNotification.class,"getWorkflowAttachment"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"isWorkflowAttachment"), true, false, false);
        map.addFieldInfo(com.ibm.rpm.communications.containers.WorkflowStepNotification.class, "Author", getMethod(com.ibm.rpm.communications.containers.WorkflowStepNotification.class,"getAuthor"), getMethod(com.ibm.rpm.communications.scope.GenericCommunicationScope.class,"isAuthor"), false, false, false);
        map.addFieldInfo(com.ibm.rpm.communications.containers.WorkflowAttachment.class, "Attachment", getMethod(com.ibm.rpm.communications.containers.WorkflowAttachment.class,"getAttachment"), null, false, true, false);
        map.addFieldInfo(com.ibm.rpm.workflow.containers.RunningWorkflowProcess.class, "WorkflowProcess", getMethod(com.ibm.rpm.workflow.containers.RunningWorkflowProcess.class,"getWorkflowProcess"), null, false, false, false);
        map.addFieldInfo(com.ibm.rpm.workflow.containers.AvailableWorkflowProcess.class, "WorkflowProcess", getMethod(com.ibm.rpm.workflow.containers.AvailableWorkflowProcess.class,"getWorkflowProcess"), null, false, false, false);
        
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder.class, "ReqProConnection", getMethod(com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder.class,"getReqProConnection"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getReqProData"), true, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder.class, "ReqProImportStatus", getMethod(com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder.class,"getReqProImportStatus"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getReqProData"), true, false, false);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder.class, "Children", getMethod(com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder.class,"getChildren"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getChildren"), true, false, true);
        map.addFieldInfo(com.ibm.rpm.scopemanagement.containers.ReqProRequirement.class, "ReqProImportStatus", getMethod(com.ibm.rpm.scopemanagement.containers.ReqProRequirement.class,"getReqProImportStatus"), getMethod(com.ibm.rpm.scopemanagement.scope.ScopeElementScope.class,"getReqProData"), true, false, false);

    }
    */
}
