package com.ibm.rpm.security.managers;

import java.util.Iterator;
import java.util.TreeMap;

public class SecurityRulesMaps {
	private static TreeMap securityGroupRules = new TreeMap();
	private static TreeMap securityRoleRules = new TreeMap();
	private static final int SECURITY_GROUP_CLEARANCE_LEVEL_TYPE = 0;
	private static final int SECURITY_ROLE_CLEARANCE_LEVEL_TYPE = 1;
	
    static {       
    	generateGroupRules();
    	generateRoleRules();
    }
   
    /*
     * attribute index = (level-1)*32 + bit
     */
    
    private static void generateGroupRules() {
    	SecurityRule securityGroupRule;
//    	 rule for RowCanDesignReport
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(139); // Level=5 Bit=11
    	securityGroupRules.put(new Integer(139),securityGroupRule);

//    	 rule for RowCanViewDoc
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(146); // Level=5 Bit=18
    	securityGroupRules.put(new Integer(146),securityGroupRule);

//    	 rule for RowCanViewExpenses
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(142); // Level=5 Bit=14
    	securityGroupRules.put(new Integer(142),securityGroupRule);

//    	 rule for RowCanViewMyPortal
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(145); // Level=5 Bit=17
    	securityGroupRules.put(new Integer(145),securityGroupRule);

//    	 rule for RowCanViewPersCal
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(143); // Level=5 Bit=15
    	securityGroupRules.put(new Integer(143),securityGroupRule);

//    	 rule for RowCanViewScope
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(140); // Level=5 Bit=12
    	securityGroupRules.put(new Integer(140),securityGroupRule);

//    	 rule for RowCanViewTimesheets
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(141); // Level=5 Bit=13
    	securityGroupRules.put(new Integer(141),securityGroupRule);

//    	 rule for RowCanViewWorkflow
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(144); // Level=5 Bit=16
    	securityGroupRules.put(new Integer(144),securityGroupRule);

//    	 rule for RowCanViewWorkflowDesign
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(154); // Level=5 Bit=26
    	securityGroupRules.put(new Integer(154),securityGroupRule);

//    	 rule for rowAccessAssetPortfolio
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(137); // Level=5 Bit=9
    	securityGroupRules.put(new Integer(137),securityGroupRule);

//    	 rule for rowAdoptWhatIfAnalysis
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(149); // Level=5 Bit=21
    	securityGroupRules.put(new Integer(149),securityGroupRule);

//    	 rule for rowArchivedProjects
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(90); // Level=3 Bit=26
    	securityGroupRules.put(new Integer(90),securityGroupRule);

//    	 rule for rowAttributes
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(76); // Level=3 Bit=12
    	securityGroupRules.put(new Integer(76),securityGroupRule);

//    	 rule for rowBackgroundEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(51); // Level=2 Bit=19
    	securityGroupRule.addSetAttributeIndexes(50); // Level=2 Bit=18
    	securityGroupRules.put(new Integer(51),securityGroupRule);

//    	 rule for rowBackgroundElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(53); // Level=2 Bit=21
    	securityGroupRule.addSetAttributeIndexes(52); // Level=2 Bit=20
    	securityGroupRules.put(new Integer(53),securityGroupRule);

//    	 rule for rowBackgroundElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(52); // Level=2 Bit=20
    	securityGroupRule.addResetAttributeIndexes(53); // Level=2 Bit=21
    	securityGroupRules.put(new Integer(52),securityGroupRule);

//    	 rule for rowBackgroundView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(50); // Level=2 Bit=18
    	securityGroupRule.addResetAttributeIndexes(51); // Level=2 Bit=19
    	securityGroupRules.put(new Integer(50),securityGroupRule);

//    	 rule for rowCRICanViewTemp
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(135); // Level=5 Bit=7
    	securityGroupRule.addResetAttributeIndexes(134); // Level=5 Bit=6
    	securityGroupRules.put(new Integer(135),securityGroupRule);

//    	 rule for rowCalendarEditElse
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(92); // Level=3 Bit=28
    	securityGroupRules.put(new Integer(92),securityGroupRule);

//    	 rule for rowCalendarEditSelf
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(89); // Level=3 Bit=25
    	securityGroupRules.put(new Integer(89),securityGroupRule);

//    	 rule for rowCalendars
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(69); // Level=3 Bit=5
    	securityGroupRules.put(new Integer(69),securityGroupRule);

//    	 rule for rowCanAdministerFinSys
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(12); // Level=1 Bit=12
    	securityGroupRules.put(new Integer(12),securityGroupRule);

//    	 rule for rowCanConvertPrjToOrg
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(147); // Level=5 Bit=19
    	securityGroupRules.put(new Integer(147),securityGroupRule);

//    	 rule for rowCanDeletePools
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(7); // Level=1 Bit=7
    	securityGroupRule.addSetAttributeIndexes(9); // Level=1 Bit=9
    	securityGroupRules.put(new Integer(7),securityGroupRule);

//    	 rule for rowCanEditExternalIdentifier
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(153); // Level=5 Bit=25
    	securityGroupRules.put(new Integer(153),securityGroupRule);

//    	 rule for rowCanSeePersonalProject
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(122); // Level=4 Bit=26
    	securityGroupRules.put(new Integer(122),securityGroupRule);

//    	 rule for rowCanViewPortfolio
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(133); // Level=5 Bit=5
    	securityGroupRules.put(new Integer(133),securityGroupRule);

//    	 rule for rowChargecodes
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(75); // Level=3 Bit=11
    	securityGroupRules.put(new Integer(75),securityGroupRule);

//    	 rule for rowCompRatesEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(98); // Level=4 Bit=2
    	securityGroupRule.addSetAttributeIndexes(97); // Level=4 Bit=1
    	securityGroupRules.put(new Integer(98),securityGroupRule);

//    	 rule for rowCompRatesElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(100); // Level=4 Bit=4
    	securityGroupRule.addSetAttributeIndexes(99); // Level=4 Bit=3
    	securityGroupRules.put(new Integer(100),securityGroupRule);

//    	 rule for rowCompRatesElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(99); // Level=4 Bit=3
    	securityGroupRule.addResetAttributeIndexes(100); // Level=4 Bit=4
    	securityGroupRules.put(new Integer(99),securityGroupRule);

//    	 rule for rowCompRatesView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(97); // Level=4 Bit=1
    	securityGroupRule.addResetAttributeIndexes(98); // Level=4 Bit=2
    	securityGroupRules.put(new Integer(97),securityGroupRule);

//    	 rule for rowCompetencySkillsEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(43); // Level=2 Bit=11
    	securityGroupRule.addSetAttributeIndexes(42); // Level=2 Bit=10
    	securityGroupRules.put(new Integer(43),securityGroupRule);

//    	 rule for rowCompetencySkillsElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(45); // Level=2 Bit=13
    	securityGroupRule.addSetAttributeIndexes(44); // Level=2 Bit=12
    	securityGroupRules.put(new Integer(45),securityGroupRule);

//    	 rule for rowCompetencySkillsElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(44); // Level=2 Bit=12
    	securityGroupRule.addResetAttributeIndexes(45); // Level=2 Bit=13
    	securityGroupRules.put(new Integer(44),securityGroupRule);

//    	 rule for rowCompetencySkillsView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(42); // Level=2 Bit=10
    	securityGroupRule.addResetAttributeIndexes(43); // Level=2 Bit=11
    	securityGroupRules.put(new Integer(42),securityGroupRule);

//    	 rule for rowCreateAsset
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(130); // Level=5 Bit=2
    	securityGroupRules.put(new Integer(130),securityGroupRule);

//    	 rule for rowCreateClient
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(101); // Level=4 Bit=5
    	securityGroupRules.put(new Integer(101),securityGroupRule);

//    	 rule for rowCreateContract
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(150); // Level=5 Bit=22
    	securityGroupRules.put(new Integer(150),securityGroupRule);

//    	 rule for rowCreateProjectTemplates
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(26); // Level=1 Bit=26
    	securityGroupRules.put(new Integer(26),securityGroupRule);

//    	 rule for rowCreateProjects
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(1); // Level=1 Bit=1
    	securityGroupRules.put(new Integer(1),securityGroupRule);

//    	 rule for rowCreateProjectsFromDefault
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(121); // Level=4 Bit=25
    	securityGroupRules.put(new Integer(121),securityGroupRule);

//    	 rule for rowCreateResources
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(8); // Level=1 Bit=8
    	securityGroupRules.put(new Integer(8),securityGroupRule);

//    	 rule for rowCreateTemplates
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(3); // Level=1 Bit=3
    	securityGroupRules.put(new Integer(3),securityGroupRule);

//    	 rule for rowCurrency
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(80); // Level=3 Bit=16
    	securityGroupRules.put(new Integer(80),securityGroupRule);

//    	 rule for rowDOCCanViewTemp
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(138); // Level=5 Bit=10
    	securityGroupRule.addResetAttributeIndexes(136); // Level=5 Bit=8
    	securityGroupRules.put(new Integer(138),securityGroupRule);

//    	 rule for rowDatafields
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(79); // Level=3 Bit=15
    	securityGroupRules.put(new Integer(79),securityGroupRule);

//    	 rule for rowDefaultResSec
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(83); // Level=3 Bit=19
    	securityGroupRules.put(new Integer(83),securityGroupRule);

//    	 rule for rowDeleteAsset
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(131); // Level=5 Bit=3
    	securityGroupRules.put(new Integer(131),securityGroupRule);

//    	 rule for rowDeleteClient
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(102); // Level=4 Bit=6
    	securityGroupRules.put(new Integer(102),securityGroupRule);

//    	 rule for rowDeleteClntract
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(151); // Level=5 Bit=23
    	securityGroupRules.put(new Integer(151),securityGroupRule);

//    	 rule for rowDeleteProjects
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(2); // Level=1 Bit=2
    	securityGroupRules.put(new Integer(2),securityGroupRule);

//    	 rule for rowDeleteResource
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(9); // Level=1 Bit=9
    	securityGroupRules.put(new Integer(9),securityGroupRule);

//    	 rule for rowDocumentEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(59); // Level=2 Bit=27
    	securityGroupRule.addSetAttributeIndexes(58); // Level=2 Bit=26
    	securityGroupRules.put(new Integer(59),securityGroupRule);

//    	 rule for rowDocumentElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(61); // Level=2 Bit=29
    	securityGroupRule.addSetAttributeIndexes(60); // Level=2 Bit=28
    	securityGroupRules.put(new Integer(61),securityGroupRule);

//    	 rule for rowDocumentElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(60); // Level=2 Bit=28
    	securityGroupRule.addResetAttributeIndexes(61); // Level=2 Bit=29
    	securityGroupRules.put(new Integer(60),securityGroupRule);

//    	 rule for rowDocumentView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(58); // Level=2 Bit=26
    	securityGroupRule.addResetAttributeIndexes(59); // Level=2 Bit=27
    	securityGroupRules.put(new Integer(58),securityGroupRule);

//    	 rule for rowEditFinancials
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(120); // Level=4 Bit=24
    	securityGroupRules.put(new Integer(120),securityGroupRule);

//    	 rule for rowEmpSpecEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(35); // Level=2 Bit=3
    	securityGroupRule.addSetAttributeIndexes(34); // Level=2 Bit=2
    	securityGroupRules.put(new Integer(35),securityGroupRule);

//    	 rule for rowEmpSpecElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(37); // Level=2 Bit=5
    	securityGroupRule.addSetAttributeIndexes(36); // Level=2 Bit=4
    	securityGroupRules.put(new Integer(37),securityGroupRule);

//    	 rule for rowEmpSpecElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(36); // Level=2 Bit=4
    	securityGroupRule.addResetAttributeIndexes(37); // Level=2 Bit=5
    	securityGroupRules.put(new Integer(36),securityGroupRule);

//    	 rule for rowEmpSpecView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(34); // Level=2 Bit=2
    	securityGroupRule.addResetAttributeIndexes(35); // Level=2 Bit=3
    	securityGroupRules.put(new Integer(34),securityGroupRule);

//    	 rule for rowExpertGroups
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(72); // Level=3 Bit=8
    	securityGroupRules.put(new Integer(72),securityGroupRule);

//    	 rule for rowGeography
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(70); // Level=3 Bit=6
    	securityGroupRules.put(new Integer(70),securityGroupRule);

//    	 rule for rowLocationEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(47); // Level=2 Bit=15
    	securityGroupRule.addSetAttributeIndexes(46); // Level=2 Bit=14
    	securityGroupRules.put(new Integer(47),securityGroupRule);

//    	 rule for rowLocationElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(49); // Level=2 Bit=17
    	securityGroupRule.addSetAttributeIndexes(48); // Level=2 Bit=16
    	securityGroupRules.put(new Integer(49),securityGroupRule);

//    	 rule for rowLocationElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(48); // Level=2 Bit=16
    	securityGroupRule.addResetAttributeIndexes(49); // Level=2 Bit=17
    	securityGroupRules.put(new Integer(48),securityGroupRule);

//    	 rule for rowLocationView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(46); // Level=2 Bit=14
    	securityGroupRule.addResetAttributeIndexes(47); // Level=2 Bit=15
    	securityGroupRules.put(new Integer(46),securityGroupRule);

//    	 rule for rowLogonEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(19); // Level=1 Bit=19
    	securityGroupRules.put(new Integer(19),securityGroupRule);

//    	 rule for rowLogonElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(21); // Level=1 Bit=21
    	securityGroupRule.addSetAttributeIndexes(20); // Level=1 Bit=20
    	securityGroupRules.put(new Integer(21),securityGroupRule);

//    	 rule for rowLogonElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(20); // Level=1 Bit=20
    	securityGroupRule.addResetAttributeIndexes(21); // Level=1 Bit=21
    	securityGroupRule.addResetAttributeIndexes(93); // Level=3 Bit=29
    	securityGroupRules.put(new Integer(20),securityGroupRule);

//    	 rule for rowModifyAlertMsg
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(124); // Level=4 Bit=28
    	securityGroupRules.put(new Integer(124),securityGroupRule);

//    	 rule for rowNameEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(15); // Level=1 Bit=15
    	securityGroupRules.put(new Integer(15),securityGroupRule);

//    	 rule for rowNameElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(17); // Level=1 Bit=17
    	securityGroupRule.addSetAttributeIndexes(16); // Level=1 Bit=16
    	securityGroupRules.put(new Integer(17),securityGroupRule);

//    	 rule for rowNameElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(16); // Level=1 Bit=16
    	securityGroupRule.addResetAttributeIndexes(17); // Level=1 Bit=17
    	securityGroupRules.put(new Integer(16),securityGroupRule);

//    	 rule for rowNickNameEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(106); // Level=4 Bit=10
    	securityGroupRule.addSetAttributeIndexes(105); // Level=4 Bit=9
    	securityGroupRules.put(new Integer(106),securityGroupRule);

//    	 rule for rowNickNameElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(108); // Level=4 Bit=12
    	securityGroupRule.addSetAttributeIndexes(107); // Level=4 Bit=11
    	securityGroupRules.put(new Integer(108),securityGroupRule);

//    	 rule for rowNickNameElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(107); // Level=4 Bit=11
    	securityGroupRule.addResetAttributeIndexes(108); // Level=4 Bit=12
    	securityGroupRules.put(new Integer(107),securityGroupRule);

//    	 rule for rowNickNameView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(105); // Level=4 Bit=9
    	securityGroupRule.addResetAttributeIndexes(106); // Level=4 Bit=10
    	securityGroupRules.put(new Integer(105),securityGroupRule);

//    	 rule for rowOrganization
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(84); // Level=3 Bit=20
    	securityGroupRules.put(new Integer(84),securityGroupRule);

//    	 rule for rowOtherDatesActiveEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(115); // Level=4 Bit=19
    	securityGroupRule.addSetAttributeIndexes(114); // Level=4 Bit=18
    	securityGroupRules.put(new Integer(115),securityGroupRule);

//    	 rule for rowOtherDatesActiveView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(114); // Level=4 Bit=18
    	securityGroupRule.addResetAttributeIndexes(115); // Level=4 Bit=19
    	securityGroupRules.put(new Integer(114),securityGroupRule);

//    	 rule for rowOtherExecAccessLevelEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(129); // Level=5 Bit=1
    	securityGroupRule.addSetAttributeIndexes(128); // Level=5 Bit=0
    	securityGroupRules.put(new Integer(129),securityGroupRule);

//    	 rule for rowOtherExecAccessLevelView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(128); // Level=5 Bit=0
    	securityGroupRule.addResetAttributeIndexes(129); // Level=5 Bit=1
    	securityGroupRules.put(new Integer(128),securityGroupRule);

//    	 rule for rowOtherExecutiveAttrEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(126); // Level=4 Bit=30
    	securityGroupRule.addSetAttributeIndexes(125); // Level=4 Bit=29
    	securityGroupRules.put(new Integer(126),securityGroupRule);

//    	 rule for rowOtherExecutiveAttrView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(125); // Level=4 Bit=29
    	securityGroupRule.addResetAttributeIndexes(126); // Level=4 Bit=30
    	securityGroupRules.put(new Integer(125),securityGroupRule);

//    	 rule for rowOtherPortalUrlEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(119); // Level=4 Bit=23
    	securityGroupRule.addSetAttributeIndexes(118); // Level=4 Bit=22
    	securityGroupRules.put(new Integer(119),securityGroupRule);

//    	 rule for rowOtherPortalUrlView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(118); // Level=4 Bit=22
    	securityGroupRule.addResetAttributeIndexes(119); // Level=4 Bit=23
    	securityGroupRules.put(new Integer(118),securityGroupRule);

//    	 rule for rowOtherResScorcardPivotView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(18); // Level=1 Bit=18
    	securityGroupRules.put(new Integer(18),securityGroupRule);

//    	 rule for rowPasswordEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(96); // Level=4 Bit=0
    	securityGroupRules.put(new Integer(96),securityGroupRule);

//    	 rule for rowPasswordElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(93); // Level=3 Bit=29
    	securityGroupRule.addSetAttributeIndexes(20); // Level=1 Bit=20
    	securityGroupRules.put(new Integer(93),securityGroupRule);

//    	 rule for rowPjCAccess
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(111); // Level=4 Bit=15
    	securityGroupRules.put(new Integer(111),securityGroupRule);

//    	 rule for rowPools
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(71); // Level=3 Bit=7
    	securityGroupRules.put(new Integer(71),securityGroupRule);

//    	 rule for rowPublishToLocalTemplates
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(4); // Level=1 Bit=4
    	securityGroupRules.put(new Integer(4),securityGroupRule);

//    	 rule for rowPublishToMethodTemplates
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(5); // Level=1 Bit=5
    	securityGroupRules.put(new Integer(5),securityGroupRule);

//    	 rule for rowRenameAsset
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(132); // Level=5 Bit=4
    	securityGroupRules.put(new Integer(132),securityGroupRule);

//    	 rule for rowRenameCRITemplates
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(134); // Level=5 Bit=6
    	securityGroupRule.addSetAttributeIndexes(135); // Level=5 Bit=7
    	securityGroupRules.put(new Integer(134),securityGroupRule);

//    	 rule for rowRenameClient
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(103); // Level=4 Bit=7
    	securityGroupRules.put(new Integer(103),securityGroupRule);

//    	 rule for rowRenameContract
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(152); // Level=5 Bit=24
    	securityGroupRules.put(new Integer(152),securityGroupRule);

//    	 rule for rowRenameDocTemplates
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(136); // Level=5 Bit=8
    	securityGroupRule.addSetAttributeIndexes(138); // Level=5 Bit=10
    	securityGroupRules.put(new Integer(136),securityGroupRule);

//    	 rule for rowRenamePool
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(86); // Level=3 Bit=22
    	securityGroupRules.put(new Integer(86),securityGroupRule);

//    	 rule for rowRenameResource
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(87); // Level=3 Bit=23
    	securityGroupRules.put(new Integer(87),securityGroupRule);

//    	 rule for rowRenameTemplate
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(85); // Level=3 Bit=21
    	securityGroupRules.put(new Integer(85),securityGroupRule);

//    	 rule for rowResRatesEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(39); // Level=2 Bit=7
    	securityGroupRule.addSetAttributeIndexes(38); // Level=2 Bit=6
    	securityGroupRules.put(new Integer(39),securityGroupRule);

//    	 rule for rowResRatesElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(41); // Level=2 Bit=9
    	securityGroupRule.addSetAttributeIndexes(40); // Level=2 Bit=8
    	securityGroupRules.put(new Integer(41),securityGroupRule);

//    	 rule for rowResRatesElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(40); // Level=2 Bit=8
    	securityGroupRule.addResetAttributeIndexes(41); // Level=2 Bit=9
    	securityGroupRules.put(new Integer(40),securityGroupRule);

//    	 rule for rowResRatesView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(38); // Level=2 Bit=6
    	securityGroupRule.addResetAttributeIndexes(39); // Level=2 Bit=7
    	securityGroupRules.put(new Integer(38),securityGroupRule);

//    	 rule for rowResourceAttributes
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(77); // Level=3 Bit=13
    	securityGroupRules.put(new Integer(77),securityGroupRule);

//    	 rule for rowResourcePools
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(6); // Level=1 Bit=6
    	securityGroupRules.put(new Integer(6),securityGroupRule);

//    	 rule for rowScorecards
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(78); // Level=3 Bit=14
    	securityGroupRules.put(new Integer(78),securityGroupRule);

//    	 rule for rowSecurityEditElse
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(65); // Level=3 Bit=1
    	securityGroupRule.addSetAttributeIndexes(64); // Level=3 Bit=0
    	securityGroupRules.put(new Integer(65),securityGroupRule);

//    	 rule for rowSecurityElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(64); // Level=3 Bit=0
    	securityGroupRule.addResetAttributeIndexes(65); // Level=3 Bit=1
    	securityGroupRules.put(new Integer(64),securityGroupRule);

//    	 rule for rowSelfDatesActiveEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(113); // Level=4 Bit=17
    	securityGroupRule.addSetAttributeIndexes(112); // Level=4 Bit=16
    	securityGroupRules.put(new Integer(113),securityGroupRule);

//    	 rule for rowSelfDatesActiveView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(112); // Level=4 Bit=16
    	securityGroupRule.addResetAttributeIndexes(113); // Level=4 Bit=17
    	securityGroupRules.put(new Integer(112),securityGroupRule);

//    	 rule for rowSelfExecutiveAttrEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(123); // Level=4 Bit=27
    	securityGroupRule.addSetAttributeIndexes(91); // Level=3 Bit=27
    	securityGroupRules.put(new Integer(123),securityGroupRule);

//    	 rule for rowSelfExecutiveAttrView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(91); // Level=3 Bit=27
    	securityGroupRule.addResetAttributeIndexes(123); // Level=4 Bit=27
    	securityGroupRules.put(new Integer(91),securityGroupRule);

//    	 rule for rowSelfPortalUrlEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(117); // Level=4 Bit=21
    	securityGroupRule.addSetAttributeIndexes(116); // Level=4 Bit=20
    	securityGroupRules.put(new Integer(117),securityGroupRule);

//    	 rule for rowSelfPortalUrlView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(116); // Level=4 Bit=20
    	securityGroupRule.addResetAttributeIndexes(117); // Level=4 Bit=21
    	securityGroupRules.put(new Integer(116),securityGroupRule);

//    	 rule for rowSelfResScorcardPivotView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(14); // Level=1 Bit=14
    	securityGroupRules.put(new Integer(14),securityGroupRule);

//    	 rule for rowShowWBS
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(110); // Level=4 Bit=14
    	securityGroupRules.put(new Integer(110),securityGroupRule);

//    	 rule for rowSysGeneral
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(68); // Level=3 Bit=4
    	securityGroupRules.put(new Integer(68),securityGroupRule);

//    	 rule for rowTimecodes
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(74); // Level=3 Bit=10
    	securityGroupRules.put(new Integer(74),securityGroupRule);

//    	 rule for rowVWorkElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(56); // Level=2 Bit=24
    	securityGroupRules.put(new Integer(56),securityGroupRule);

//    	 rule for rowViewWhatIfAnalysis
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(148); // Level=5 Bit=20
    	securityGroupRules.put(new Integer(148),securityGroupRule);

//    	 rule for rowWBSCanSetTaskAsMandatory
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(30); // Level=1 Bit=30
    	securityGroupRules.put(new Integer(30),securityGroupRule);

//    	 rule for rowWBSSecurity
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(81); // Level=3 Bit=17
    	securityGroupRules.put(new Integer(81),securityGroupRule);

//    	 rule for rowWorkSpecEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(27); // Level=1 Bit=27
    	securityGroupRules.put(new Integer(27),securityGroupRule);

//    	 rule for rowWorkSpecElseEdit
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(29); // Level=1 Bit=29
    	securityGroupRule.addSetAttributeIndexes(28); // Level=1 Bit=28
    	securityGroupRules.put(new Integer(29),securityGroupRule);

//    	 rule for rowWorkSpecElseView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(28); // Level=1 Bit=28
    	securityGroupRule.addResetAttributeIndexes(29); // Level=1 Bit=29
    	securityGroupRules.put(new Integer(28),securityGroupRule);

//    	 rule for rowWorkView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(54); // Level=2 Bit=22
    	securityGroupRules.put(new Integer(54),securityGroupRule);

//    	 rule for rowWorkflow
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(73); // Level=3 Bit=9
    	securityGroupRules.put(new Integer(73),securityGroupRule);

//    	 rule for rowsecurityView
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(62); // Level=2 Bit=30
    	securityGroupRules.put(new Integer(62),securityGroupRule);
    	
//   	 rule for canEditOtherResourcesRecordCustomFieldsGroup1
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(193); // Level=7 Bit=1
    	securityGroupRule.addSetAttributeIndexes(192);
    	securityGroupRules.put(new Integer(193),securityGroupRule);
    	
//  	 rule for canEditOtherResourcesRecordCustomFieldsGroup2
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(195); // Level=7 Bit=3
    	securityGroupRule.addSetAttributeIndexes(194);
    	securityGroupRules.put(new Integer(195),securityGroupRule);
    	
//  	 rule for canEditOtherResourcesRecordCustomFieldsGroup3
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(197); // Level=7 Bit=5
    	securityGroupRule.addSetAttributeIndexes(196);
    	securityGroupRules.put(new Integer(197),securityGroupRule);
    	
//  	 rule for canEditOtherResourcesRecordCustomFieldsGroup4
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(199); // Level=7 Bit=7
    	securityGroupRule.addSetAttributeIndexes(198);
    	securityGroupRules.put(new Integer(199),securityGroupRule);
    	
//  	 rule for canEditOtherResourcesRecordCustomFieldsGroup5
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(201); // Level=7 Bit=9
    	securityGroupRule.addSetAttributeIndexes(200);
    	securityGroupRules.put(new Integer(201),securityGroupRule);
    	
//  	 rule for canEditOtherResourcesRecordCustomFieldsGroup6
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(203); // Level=7 Bit=11
    	securityGroupRule.addSetAttributeIndexes(202);
    	securityGroupRules.put(new Integer(203),securityGroupRule);
    	
//  	 rule for canEditOtherResourcesRecordCustomFieldsGroup7
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(205); // Level=7 Bit=13
    	securityGroupRule.addSetAttributeIndexes(204);
    	securityGroupRules.put(new Integer(205),securityGroupRule);
    	
//  	 rule for canEditOtherResourcesRecordCustomFieldsGroup8
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(207); // Level=7 Bit=15
    	securityGroupRule.addSetAttributeIndexes(206);
    	securityGroupRules.put(new Integer(207),securityGroupRule);
    	
//  	 rule for canEditOtherResourcesRecordCustomFieldsGroup9
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(209); // Level=7 Bit=17
    	securityGroupRule.addSetAttributeIndexes(208);
    	securityGroupRules.put(new Integer(209),securityGroupRule);
    	
// 	 rule for canEditOtherResourcesRecordCustomFieldsGroup10
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(211); // Level=7 Bit=19
    	securityGroupRule.addSetAttributeIndexes(210);
    	securityGroupRules.put(new Integer(211),securityGroupRule);
    	
//    	 rule for canEditPersonalRecordCustomFieldsGroup1
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(161); // Level=6 Bit=1
    	securityGroupRule.addSetAttributeIndexes(160);
    	securityGroupRules.put(new Integer(161),securityGroupRule);
    	
//   	 rule for canEditPersonalRecordCustomFieldsGroup2
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(163); // Level=6 Bit=3
    	securityGroupRule.addSetAttributeIndexes(162);
    	securityGroupRules.put(new Integer(163),securityGroupRule);
    	
//   	 rule for canEditPersonalRecordCustomFieldsGroup3
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(165); // Level=6 Bit=5
    	securityGroupRule.addSetAttributeIndexes(164);
    	securityGroupRules.put(new Integer(165),securityGroupRule);
    	
//   	 rule for canEditPersonalRecordCustomFieldsGroup4
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(167); // Level=6 Bit=7
    	securityGroupRule.addSetAttributeIndexes(166);
    	securityGroupRules.put(new Integer(167),securityGroupRule);
    	
//   	 rule for canEditPersonalRecordCustomFieldsGroup5
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(169); // Level=6 Bit=9
    	securityGroupRule.addSetAttributeIndexes(168);
    	securityGroupRules.put(new Integer(169),securityGroupRule);
    	
//   	 rule for canEditPersonalRecordCustomFieldsGroup6
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(171); // Level=6 Bit=11
    	securityGroupRule.addSetAttributeIndexes(170);
    	securityGroupRules.put(new Integer(171),securityGroupRule);
    	
//   	 rule for canEditPersonalRecordCustomFieldsGroup7
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(173); // Level=6 Bit=13
    	securityGroupRule.addSetAttributeIndexes(172);
    	securityGroupRules.put(new Integer(173),securityGroupRule);
    	
//   	 rule for canEditPersonalRecordCustomFieldsGroup8
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(175); // Level=6 Bit=15
    	securityGroupRule.addSetAttributeIndexes(174);
    	securityGroupRules.put(new Integer(175),securityGroupRule);
    	
//   	 rule for canEditPersonalRecordCustomFieldsGroup9
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(177); // Level=6 Bit=17
    	securityGroupRule.addSetAttributeIndexes(176);
    	securityGroupRules.put(new Integer(177),securityGroupRule);
    	
//   	 rule for canEditPersonalRecordCustomFieldsGroup10
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(179); // Level=6 Bit=19
    	securityGroupRule.addSetAttributeIndexes(178);
    	securityGroupRules.put(new Integer(179),securityGroupRule);
    	
//  	 rule for canViewOtherResourcesRecordCustomFieldsGroup1
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(192); // Level=7 Bit=0
    	securityGroupRule.addResetAttributeIndexes(193);
    	securityGroupRules.put(new Integer(192),securityGroupRule);
    	
// 	 rule for canViewOtherResourcesRecordCustomFieldsGroup2
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(194); // Level=7 Bit=2
    	securityGroupRule.addResetAttributeIndexes(195);
    	securityGroupRules.put(new Integer(194),securityGroupRule);
    	
// 	 rule for canViewOtherResourcesRecordCustomFieldsGroup3
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(196); // Level=7 Bit=4
    	securityGroupRule.addResetAttributeIndexes(197);
    	securityGroupRules.put(new Integer(196),securityGroupRule);
    	
// 	 rule for canViewOtherResourcesRecordCustomFieldsGroup4
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(198); // Level=7 Bit=6
    	securityGroupRule.addResetAttributeIndexes(199);
    	securityGroupRules.put(new Integer(198),securityGroupRule);
    	
// 	 rule for canViewOtherResourcesRecordCustomFieldsGroup5
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(200); // Level=7 Bit=8
    	securityGroupRule.addResetAttributeIndexes(201);
    	securityGroupRules.put(new Integer(200),securityGroupRule);
    	
// 	 rule for canViewOtherResourcesRecordCustomFieldsGroup6
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(202); // Level=7 Bit=10
    	securityGroupRule.addResetAttributeIndexes(203);
    	securityGroupRules.put(new Integer(202),securityGroupRule);
    	
// 	 rule for canViewOtherResourcesRecordCustomFieldsGroup7
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(204); // Level=7 Bit=12
    	securityGroupRule.addResetAttributeIndexes(205);
    	securityGroupRules.put(new Integer(204),securityGroupRule);
    	
// 	 rule for canViewOtherResourcesRecordCustomFieldsGroup8
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(206); // Level=7 Bit=14
    	securityGroupRule.addResetAttributeIndexes(207);
    	securityGroupRules.put(new Integer(206),securityGroupRule);
    	
// 	 rule for canViewOtherResourcesRecordCustomFieldsGroup9
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(208); // Level=7 Bit=16
    	securityGroupRule.addResetAttributeIndexes(209);
    	securityGroupRules.put(new Integer(208),securityGroupRule);
    	
// 	 rule for canViewOtherResourcesRecordCustomFieldsGroup10
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(210); // Level=7 Bit=18
    	securityGroupRule.addResetAttributeIndexes(211);
    	securityGroupRules.put(new Integer(210),securityGroupRule);
    	
//    	 rule for canViewPersonalRecordCustomFieldsGroup1
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(160); // Level=6 Bit=0
    	securityGroupRule.addResetAttributeIndexes(161);
    	securityGroupRules.put(new Integer(160),securityGroupRule);
    	
//   	 rule for canViewPersonalRecordCustomFieldsGroup2
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(162); // Level=6 Bit=2
    	securityGroupRule.addResetAttributeIndexes(163);
    	securityGroupRules.put(new Integer(162),securityGroupRule);
    	
//   	 rule for canViewPersonalRecordCustomFieldsGroup3
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(164); // Level=6 Bit=4
    	securityGroupRule.addResetAttributeIndexes(165);
    	securityGroupRules.put(new Integer(164),securityGroupRule);
    	
//   	 rule for canViewPersonalRecordCustomFieldsGroup4
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(166); // Level=6 Bit=6
    	securityGroupRule.addResetAttributeIndexes(167);
    	securityGroupRules.put(new Integer(166),securityGroupRule);
    	
//   	 rule for canViewPersonalRecordCustomFieldsGroup5
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(168); // Level=6 Bit=8
    	securityGroupRule.addResetAttributeIndexes(169);
    	securityGroupRules.put(new Integer(168),securityGroupRule);
    	
//  	 rule for canViewPersonalRecordCustomFieldsGroup6
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(170); // Level=6 Bit=10
    	securityGroupRule.addResetAttributeIndexes(171);
    	securityGroupRules.put(new Integer(170),securityGroupRule);
    	
// 	 rule for canViewPersonalRecordCustomFieldsGroup7
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(172); // Level=6 Bit=12
    	securityGroupRule.addResetAttributeIndexes(173);
    	securityGroupRules.put(new Integer(172),securityGroupRule);
    	
// 	 rule for canViewPersonalRecordCustomFieldsGroup8
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(174); // Level=6 Bit=14
    	securityGroupRule.addResetAttributeIndexes(175);
    	securityGroupRules.put(new Integer(174),securityGroupRule);
    	
// 	 rule for canViewPersonalRecordCustomFieldsGroup9
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(176); // Level=6 Bit=16
    	securityGroupRule.addResetAttributeIndexes(177);
    	securityGroupRules.put(new Integer(176),securityGroupRule);
    	
// 	 rule for canViewPersonalRecordCustomFieldsGroup10
    	securityGroupRule = new SecurityRule();
    	securityGroupRule.setAttributeIndex(178); // Level=6 Bit=18
    	securityGroupRule.addResetAttributeIndexes(179);
    	securityGroupRules.put(new Integer(178),securityGroupRule);
    }
    
    private static void generateRoleRules() {
    	SecurityRule securityRoleRule;
//    	 rule for colTransfer
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(110); // Level=4 Bit=14
    	securityRoleRules.put(new Integer(110),securityRoleRule);

//    	 rule for rowAcceptRejectETCBudget
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(220); // Level=7 Bit=28
    	securityRoleRules.put(new Integer(220),securityRoleRule);

//    	 rule for rowAcceptRejectForecastDates
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(212); // Level=7 Bit=20
    	securityRoleRules.put(new Integer(212),securityRoleRule);

//    	 rule for rowActionRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(553); // Level=18 Bit=9
    	securityRoleRule.addSetAttributeIndexes(393); // Level=13 Bit=9
    	securityRoleRules.put(new Integer(553),securityRoleRule);

//    	 rule for rowActionRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(393); // Level=13 Bit=9
    	securityRoleRule.addResetAttributeIndexes(553); // Level=18 Bit=9
    	securityRoleRules.put(new Integer(393),securityRoleRule);

//    	 rule for rowActionRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(544); // Level=18 Bit=0
    	securityRoleRule.addSetAttributeIndexes(384); // Level=13 Bit=0
    	securityRoleRules.put(new Integer(544),securityRoleRule);

//    	 rule for rowActionRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(384); // Level=13 Bit=0
    	securityRoleRule.addResetAttributeIndexes(544); // Level=18 Bit=0
    	securityRoleRules.put(new Integer(384),securityRoleRule);

//    	 rule for rowActionRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(545); // Level=18 Bit=1
    	securityRoleRule.addSetAttributeIndexes(385); // Level=13 Bit=1
    	securityRoleRules.put(new Integer(545),securityRoleRule);

//    	 rule for rowActionRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(385); // Level=13 Bit=1
    	securityRoleRule.addResetAttributeIndexes(545); // Level=18 Bit=1
    	securityRoleRules.put(new Integer(385),securityRoleRule);

//    	 rule for rowActionRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(546); // Level=18 Bit=2
    	securityRoleRule.addSetAttributeIndexes(386); // Level=13 Bit=2
    	securityRoleRules.put(new Integer(546),securityRoleRule);

//    	 rule for rowActionRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(386); // Level=13 Bit=2
    	securityRoleRule.addResetAttributeIndexes(546); // Level=18 Bit=2
    	securityRoleRules.put(new Integer(386),securityRoleRule);

//    	 rule for rowActionRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(547); // Level=18 Bit=3
    	securityRoleRule.addSetAttributeIndexes(387); // Level=13 Bit=3
    	securityRoleRules.put(new Integer(547),securityRoleRule);

//    	 rule for rowActionRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(387); // Level=13 Bit=3
    	securityRoleRule.addResetAttributeIndexes(547); // Level=18 Bit=3
    	securityRoleRules.put(new Integer(387),securityRoleRule);

//    	 rule for rowActionRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(548); // Level=18 Bit=4
    	securityRoleRule.addSetAttributeIndexes(388); // Level=13 Bit=4
    	securityRoleRules.put(new Integer(548),securityRoleRule);

//    	 rule for rowActionRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(388); // Level=13 Bit=4
    	securityRoleRule.addResetAttributeIndexes(548); // Level=18 Bit=4
    	securityRoleRules.put(new Integer(388),securityRoleRule);

//    	 rule for rowActionRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(549); // Level=18 Bit=5
    	securityRoleRule.addSetAttributeIndexes(389); // Level=13 Bit=5
    	securityRoleRules.put(new Integer(549),securityRoleRule);

//    	 rule for rowActionRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(389); // Level=13 Bit=5
    	securityRoleRule.addResetAttributeIndexes(549); // Level=18 Bit=5
    	securityRoleRules.put(new Integer(389),securityRoleRule);

//    	 rule for rowActionRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(550); // Level=18 Bit=6
    	securityRoleRule.addSetAttributeIndexes(390); // Level=13 Bit=6
    	securityRoleRules.put(new Integer(550),securityRoleRule);

//    	 rule for rowActionRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(390); // Level=13 Bit=6
    	securityRoleRule.addResetAttributeIndexes(550); // Level=18 Bit=6
    	securityRoleRules.put(new Integer(390),securityRoleRule);

//    	 rule for rowActionRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(551); // Level=18 Bit=7
    	securityRoleRule.addSetAttributeIndexes(391); // Level=13 Bit=7
    	securityRoleRules.put(new Integer(551),securityRoleRule);

//    	 rule for rowActionRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(391); // Level=13 Bit=7
    	securityRoleRule.addResetAttributeIndexes(551); // Level=18 Bit=7
    	securityRoleRules.put(new Integer(391),securityRoleRule);

//    	 rule for rowActionRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(552); // Level=18 Bit=8
    	securityRoleRule.addSetAttributeIndexes(392); // Level=13 Bit=8
    	securityRoleRules.put(new Integer(552),securityRoleRule);

//    	 rule for rowActionRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(392); // Level=13 Bit=8
    	securityRoleRule.addResetAttributeIndexes(552); // Level=18 Bit=8
    	securityRoleRules.put(new Integer(392),securityRoleRule);

//    	 rule for rowAssignEffortResource
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(214); // Level=7 Bit=22
    	securityRoleRules.put(new Integer(214),securityRoleRule);

//    	 rule for rowAsssignEffortProfile
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(213); // Level=7 Bit=21
    	securityRoleRules.put(new Integer(213),securityRoleRule);

//    	 rule for rowBaselineCrossCharge
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(128); // Level=5 Bit=0
    	securityRoleRules.put(new Integer(128),securityRoleRule);

//    	 rule for rowBenefitAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(225); // Level=8 Bit=1
    	securityRoleRule.addSetAttributeIndexes(150); // Level=5 Bit=22
    	securityRoleRule.addSetAttributeIndexes(182); // Level=6 Bit=22
    	securityRoleRules.put(new Integer(225),securityRoleRule);

//    	 rule for rowBenefitEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(182); // Level=6 Bit=22
    	securityRoleRule.addResetAttributeIndexes(225); // Level=8 Bit=1
    	securityRoleRule.addSetAttributeIndexes(150); // Level=5 Bit=22
    	securityRoleRules.put(new Integer(182),securityRoleRule);

//    	 rule for rowBenefitView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(150); // Level=5 Bit=22
    	securityRoleRule.addResetAttributeIndexes(182); // Level=6 Bit=22
    	securityRoleRule.addResetAttributeIndexes(225); // Level=8 Bit=1
    	securityRoleRules.put(new Integer(150),securityRoleRule);

//    	 rule for rowBreackdownDoc
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(211); // Level=7 Bit=19
    	securityRoleRules.put(new Integer(211),securityRoleRule);

//    	 rule for rowBreackdownNotMin
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(211); // Level=7 Bit=19
    	securityRoleRules.put(new Integer(211),securityRoleRule);

//    	 rule for rowBreakdownExceptions
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(211); // Level=7 Bit=19
    	securityRoleRules.put(new Integer(211),securityRoleRule);

//    	 rule for rowCPChangeEETC
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(221); // Level=7 Bit=29
    	securityRoleRules.put(new Integer(221),securityRoleRule);

//    	 rule for rowCRIApprovalEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(83); // Level=3 Bit=19
    	securityRoleRule.addSetAttributeIndexes(19); // Level=1 Bit=19
    	securityRoleRules.put(new Integer(83),securityRoleRule);

//    	 rule for rowCRIApprovalView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(19); // Level=1 Bit=19
    	securityRoleRule.addResetAttributeIndexes(83); // Level=3 Bit=19
    	securityRoleRules.put(new Integer(19),securityRoleRule);

//    	 rule for rowCRIApprovedByEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(82); // Level=3 Bit=18
    	securityRoleRule.addSetAttributeIndexes(18); // Level=1 Bit=18
    	securityRoleRules.put(new Integer(82),securityRoleRule);

//    	 rule for rowCRIApprovedByView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(18); // Level=1 Bit=18
    	securityRoleRule.addResetAttributeIndexes(82); // Level=3 Bit=18
    	securityRoleRules.put(new Integer(18),securityRoleRule);

//    	 rule for rowCRIApprovedEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(177); // Level=6 Bit=17
    	securityRoleRule.addSetAttributeIndexes(145); // Level=5 Bit=17
    	securityRoleRules.put(new Integer(177),securityRoleRule);

//    	 rule for rowCRIApprovedView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(145); // Level=5 Bit=17
    	securityRoleRule.addResetAttributeIndexes(177); // Level=6 Bit=17
    	securityRoleRules.put(new Integer(145),securityRoleRule);

//    	 rule for rowCRIAttrAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRule.addSetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRules.put(new Integer(224),securityRoleRule);

//    	 rule for rowCRIAttrEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRules.put(new Integer(178),securityRoleRule);

//    	 rule for rowCRIAttrView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(146); // Level=5 Bit=18
    	securityRoleRule.addResetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRules.put(new Integer(146),securityRoleRule);

//    	 rule for rowCRIBallparkCostEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(164); // Level=6 Bit=4
    	securityRoleRule.addSetAttributeIndexes(132); // Level=5 Bit=4
    	securityRoleRules.put(new Integer(164),securityRoleRule);

//    	 rule for rowCRIBallparkCostView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(132); // Level=5 Bit=4
    	securityRoleRule.addResetAttributeIndexes(164); // Level=6 Bit=4
    	securityRoleRules.put(new Integer(132),securityRoleRule);

//    	 rule for rowCRICanChangeTo
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(210); // Level=7 Bit=18
    	securityRoleRules.put(new Integer(210),securityRoleRule);

//    	 rule for rowCRICheckInAll
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(189); // Level=6 Bit=29
    	securityRoleRules.put(new Integer(189),securityRoleRule);

//    	 rule for rowCRIClientNameEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(77); // Level=3 Bit=13
    	securityRoleRule.addSetAttributeIndexes(13); // Level=1 Bit=13
    	securityRoleRules.put(new Integer(77),securityRoleRule);

//    	 rule for rowCRIClientNameView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(13); // Level=1 Bit=13
    	securityRoleRule.addResetAttributeIndexes(77); // Level=3 Bit=13
    	securityRoleRules.put(new Integer(13),securityRoleRule);

//    	 rule for rowCRIClosedByEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(81); // Level=3 Bit=17
    	securityRoleRule.addSetAttributeIndexes(17); // Level=1 Bit=17
    	securityRoleRules.put(new Integer(81),securityRoleRule);

//    	 rule for rowCRIClosedByView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(17); // Level=1 Bit=17
    	securityRoleRule.addResetAttributeIndexes(81); // Level=3 Bit=17
    	securityRoleRules.put(new Integer(17),securityRoleRule);

//    	 rule for rowCRICreateDelTemp
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(67); // Level=3 Bit=3
    	securityRoleRules.put(new Integer(67),securityRoleRule);

//    	 rule for rowCRICreateFolder
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(203); // Level=7 Bit=11
    	securityRoleRules.put(new Integer(203),securityRoleRule);

//    	 rule for rowCRIDupNumberView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(14); // Level=1 Bit=14
    	securityRoleRules.put(new Integer(14),securityRoleRule);

//    	 rule for rowCRIDuplicatesAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(231); // Level=8 Bit=7
    	securityRoleRule.addSetAttributeIndexes(22); // Level=1 Bit=22
    	securityRoleRules.put(new Integer(231),securityRoleRule);

//    	 rule for rowCRIDuplicatesView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(22); // Level=1 Bit=22
    	securityRoleRule.addResetAttributeIndexes(231); // Level=8 Bit=7
    	securityRoleRule.addResetAttributeIndexes(231); // Level=8 Bit=7
    	securityRoleRules.put(new Integer(22),securityRoleRule);

//    	 rule for rowCRIESTDatesEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(163); // Level=6 Bit=3
    	securityRoleRule.addSetAttributeIndexes(131); // Level=5 Bit=3
    	securityRoleRules.put(new Integer(163),securityRoleRule);

//    	 rule for rowCRIESTDatesView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(131); // Level=5 Bit=3
    	securityRoleRule.addResetAttributeIndexes(163); // Level=6 Bit=3
    	securityRoleRules.put(new Integer(131),securityRoleRule);

//    	 rule for rowCRIElementSecurityEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(166); // Level=6 Bit=6
    	securityRoleRule.addSetAttributeIndexes(134); // Level=5 Bit=6
    	securityRoleRules.put(new Integer(166),securityRoleRule);

//    	 rule for rowCRIElementSecurityView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(134); // Level=5 Bit=6
    	securityRoleRule.addResetAttributeIndexes(166); // Level=6 Bit=6
    	securityRoleRules.put(new Integer(134),securityRoleRule);

//    	 rule for rowCRIExtRefNumberEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(76); // Level=3 Bit=12
    	securityRoleRule.addSetAttributeIndexes(12); // Level=1 Bit=12
    	securityRoleRules.put(new Integer(76),securityRoleRule);

//    	 rule for rowCRIExtRefNumberView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(12); // Level=1 Bit=12
    	securityRoleRule.addResetAttributeIndexes(76); // Level=3 Bit=12
    	securityRoleRules.put(new Integer(12),securityRoleRule);

//    	 rule for rowCRIOccurredDTEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(94); // Level=3 Bit=30
    	securityRoleRule.addSetAttributeIndexes(30); // Level=1 Bit=30
    	securityRoleRules.put(new Integer(94),securityRoleRule);

//    	 rule for rowCRIOccurredDTView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(30); // Level=1 Bit=30
    	securityRoleRule.addResetAttributeIndexes(94); // Level=3 Bit=30
    	securityRoleRules.put(new Integer(30),securityRoleRule);

//    	 rule for rowCRIPriorityEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(165); // Level=6 Bit=5
    	securityRoleRule.addSetAttributeIndexes(133); // Level=5 Bit=5
    	securityRoleRules.put(new Integer(165),securityRoleRule);

//    	 rule for rowCRIPriorityView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(133); // Level=5 Bit=5
    	securityRoleRule.addResetAttributeIndexes(165); // Level=6 Bit=5
    	securityRoleRules.put(new Integer(133),securityRoleRule);

//    	 rule for rowCRIProposedByEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(80); // Level=3 Bit=16
    	securityRoleRule.addSetAttributeIndexes(16); // Level=1 Bit=16
    	securityRoleRules.put(new Integer(80),securityRoleRule);

//    	 rule for rowCRIProposedByView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(16); // Level=1 Bit=16
    	securityRoleRule.addResetAttributeIndexes(80); // Level=3 Bit=16
    	securityRoleRules.put(new Integer(16),securityRoleRule);

//    	 rule for rowCRIQuantificationImpactEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(87); // Level=3 Bit=23
    	securityRoleRule.addSetAttributeIndexes(23); // Level=1 Bit=23
    	securityRoleRules.put(new Integer(87),securityRoleRule);

//    	 rule for rowCRIQuantificationImpactView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(23); // Level=1 Bit=23
    	securityRoleRule.addResetAttributeIndexes(87); // Level=3 Bit=23
    	securityRoleRules.put(new Integer(23),securityRoleRule);

//    	 rule for rowCRIRankEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(160); // Level=6 Bit=0
    	securityRoleRule.addSetAttributeIndexes(45); // Level=2 Bit=13
    	securityRoleRules.put(new Integer(160),securityRoleRule);

//    	 rule for rowCRIRankView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(45); // Level=2 Bit=13
    	securityRoleRule.addResetAttributeIndexes(160); // Level=6 Bit=0
    	securityRoleRules.put(new Integer(45),securityRoleRule);

//    	 rule for rowCRIRefNumberView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(129); // Level=5 Bit=1
    	securityRoleRules.put(new Integer(129),securityRoleRule);

//    	 rule for rowCRIRiskMitigationEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(84); // Level=3 Bit=20
    	securityRoleRule.addSetAttributeIndexes(20); // Level=1 Bit=20
    	securityRoleRules.put(new Integer(84),securityRoleRule);

//    	 rule for rowCRIRiskMitigationFactorsEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(89); // Level=3 Bit=25
    	securityRoleRule.addSetAttributeIndexes(25); // Level=1 Bit=25
    	securityRoleRules.put(new Integer(89),securityRoleRule);

//    	 rule for rowCRIRiskMitigationFactorsView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(25); // Level=1 Bit=25
    	securityRoleRule.addResetAttributeIndexes(89); // Level=3 Bit=25
    	securityRoleRules.put(new Integer(25),securityRoleRule);

//    	 rule for rowCRIRiskMitigationView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(20); // Level=1 Bit=20
    	securityRoleRule.addResetAttributeIndexes(84); // Level=3 Bit=20
    	securityRoleRules.put(new Integer(20),securityRoleRule);

//    	 rule for rowCRISchedInfo
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(40); // Level=2 Bit=8
    	securityRoleRules.put(new Integer(40),securityRoleRule);

//    	 rule for rowCRIScorecardAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(227); // Level=8 Bit=3
    	securityRoleRule.addSetAttributeIndexes(148); // Level=5 Bit=20
    	securityRoleRule.addSetAttributeIndexes(180); // Level=6 Bit=20
    	securityRoleRules.put(new Integer(227),securityRoleRule);

//    	 rule for rowCRIScorecardEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(180); // Level=6 Bit=20
    	securityRoleRule.addResetAttributeIndexes(227); // Level=8 Bit=3
    	securityRoleRule.addSetAttributeIndexes(148); // Level=5 Bit=20
    	securityRoleRules.put(new Integer(180),securityRoleRule);

//    	 rule for rowCRIScorecardView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(148); // Level=5 Bit=20
    	securityRoleRule.addResetAttributeIndexes(180); // Level=6 Bit=20
    	securityRoleRule.addResetAttributeIndexes(227); // Level=8 Bit=3
    	securityRoleRules.put(new Integer(148),securityRoleRule);

//    	 rule for rowCRISetCancelAsDef
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(3); // Level=1 Bit=3
    	securityRoleRules.put(new Integer(3),securityRoleRule);

//    	 rule for rowCRITargetDateEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(79); // Level=3 Bit=15
    	securityRoleRule.addSetAttributeIndexes(15); // Level=1 Bit=15
    	securityRoleRules.put(new Integer(79),securityRoleRule);

//    	 rule for rowCRITargetDateView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(15); // Level=1 Bit=15
    	securityRoleRule.addResetAttributeIndexes(79); // Level=3 Bit=15
    	securityRoleRules.put(new Integer(15),securityRoleRule);

//    	 rule for rowCRITimesReassignedEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(97); // Level=4 Bit=1
    	securityRoleRule.addSetAttributeIndexes(32); // Level=2 Bit=0
    	securityRoleRules.put(new Integer(97),securityRoleRule);

//    	 rule for rowCRITimesReassignedView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(32); // Level=2 Bit=0
    	securityRoleRule.addResetAttributeIndexes(97); // Level=4 Bit=1
    	securityRoleRules.put(new Integer(32),securityRoleRule);

//    	 rule for rowCRITransferAcrossPrj
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(112); // Level=4 Bit=16
    	securityRoleRules.put(new Integer(112),securityRoleRule);

//    	 rule for rowCRIViewHistory
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(155); // Level=5 Bit=27
    	securityRoleRules.put(new Integer(155),securityRoleRule);

//    	 rule for rowCRRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(489); // Level=16 Bit=9
    	securityRoleRule.addSetAttributeIndexes(329); // Level=11 Bit=9
    	securityRoleRules.put(new Integer(489),securityRoleRule);

//    	 rule for rowCRRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(329); // Level=11 Bit=9
    	securityRoleRule.addResetAttributeIndexes(489); // Level=16 Bit=9
    	securityRoleRules.put(new Integer(329),securityRoleRule);

//    	 rule for rowCRRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(480); // Level=16 Bit=0
    	securityRoleRule.addSetAttributeIndexes(320); // Level=11 Bit=0
    	securityRoleRules.put(new Integer(480),securityRoleRule);

//    	 rule for rowCRRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(320); // Level=11 Bit=0
    	securityRoleRule.addResetAttributeIndexes(480); // Level=16 Bit=0
    	securityRoleRules.put(new Integer(320),securityRoleRule);

//    	 rule for rowCRRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(481); // Level=16 Bit=1
    	securityRoleRule.addSetAttributeIndexes(321); // Level=11 Bit=1
    	securityRoleRules.put(new Integer(481),securityRoleRule);

//    	 rule for rowCRRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(321); // Level=11 Bit=1
    	securityRoleRule.addResetAttributeIndexes(481); // Level=16 Bit=1
    	securityRoleRules.put(new Integer(321),securityRoleRule);

//    	 rule for rowCRRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(482); // Level=16 Bit=2
    	securityRoleRule.addSetAttributeIndexes(322); // Level=11 Bit=2
    	securityRoleRules.put(new Integer(482),securityRoleRule);

//    	 rule for rowCRRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(322); // Level=11 Bit=2
    	securityRoleRule.addResetAttributeIndexes(482); // Level=16 Bit=2
    	securityRoleRules.put(new Integer(322),securityRoleRule);

//    	 rule for rowCRRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(483); // Level=16 Bit=3
    	securityRoleRule.addSetAttributeIndexes(323); // Level=11 Bit=3
    	securityRoleRules.put(new Integer(483),securityRoleRule);

//    	 rule for rowCRRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(323); // Level=11 Bit=3
    	securityRoleRule.addResetAttributeIndexes(483); // Level=16 Bit=3
    	securityRoleRules.put(new Integer(323),securityRoleRule);

//    	 rule for rowCRRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(484); // Level=16 Bit=4
    	securityRoleRule.addSetAttributeIndexes(324); // Level=11 Bit=4
    	securityRoleRules.put(new Integer(484),securityRoleRule);

//    	 rule for rowCRRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(324); // Level=11 Bit=4
    	securityRoleRule.addResetAttributeIndexes(484); // Level=16 Bit=4
    	securityRoleRules.put(new Integer(324),securityRoleRule);

//    	 rule for rowCRRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(485); // Level=16 Bit=5
    	securityRoleRule.addSetAttributeIndexes(325); // Level=11 Bit=5
    	securityRoleRules.put(new Integer(485),securityRoleRule);

//    	 rule for rowCRRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(325); // Level=11 Bit=5
    	securityRoleRule.addResetAttributeIndexes(485); // Level=16 Bit=5
    	securityRoleRules.put(new Integer(325),securityRoleRule);

//    	 rule for rowCRRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(486); // Level=16 Bit=6
    	securityRoleRule.addSetAttributeIndexes(326); // Level=11 Bit=6
    	securityRoleRules.put(new Integer(486),securityRoleRule);

//    	 rule for rowCRRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(326); // Level=11 Bit=6
    	securityRoleRule.addResetAttributeIndexes(486); // Level=16 Bit=6
    	securityRoleRules.put(new Integer(326),securityRoleRule);

//    	 rule for rowCRRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(487); // Level=16 Bit=7
    	securityRoleRule.addSetAttributeIndexes(327); // Level=11 Bit=7
    	securityRoleRules.put(new Integer(487),securityRoleRule);

//    	 rule for rowCRRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(327); // Level=11 Bit=7
    	securityRoleRule.addResetAttributeIndexes(487); // Level=16 Bit=7
    	securityRoleRules.put(new Integer(327),securityRoleRule);

//    	 rule for rowCRRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(488); // Level=16 Bit=8
    	securityRoleRule.addSetAttributeIndexes(328); // Level=11 Bit=8
    	securityRoleRules.put(new Integer(488),securityRoleRule);

//    	 rule for rowCRRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(328); // Level=11 Bit=8
    	securityRoleRule.addResetAttributeIndexes(488); // Level=16 Bit=8
    	securityRoleRules.put(new Integer(328),securityRoleRule);

//    	 rule for rowCalcLevel
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(125); // Level=4 Bit=29
    	securityRoleRules.put(new Integer(125),securityRoleRule);

//    	 rule for rowCalcLevelResults
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(42); // Level=2 Bit=10
    	securityRoleRules.put(new Integer(42),securityRoleRule);

//    	 rule for rowCanBreakdown
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(211); // Level=7 Bit=19
    	securityRoleRules.put(new Integer(211),securityRoleRule);

//    	 rule for rowCanChangeTo
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(210); // Level=7 Bit=18
    	securityRoleRules.put(new Integer(210),securityRoleRule);

//    	 rule for rowCanCheckIN
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(189); // Level=6 Bit=29
    	securityRoleRules.put(new Integer(189),securityRoleRule);

//    	 rule for rowCanClearBaseline
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(171); // Level=6 Bit=11
    	securityRoleRules.put(new Integer(171),securityRoleRule);

//    	 rule for rowCanCloseTask
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(190); // Level=6 Bit=30
    	securityRoleRules.put(new Integer(190),securityRoleRule);

//    	 rule for rowCanDeletePublicCri
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(55); // Level=2 Bit=23
    	securityRoleRules.put(new Integer(55),securityRoleRule);

//    	 rule for rowCanDeletePublicDoc
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(205); // Level=7 Bit=13
    	securityRoleRules.put(new Integer(205),securityRoleRule);

//    	 rule for rowCanEditDelState
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(75); // Level=3 Bit=11
    	securityRoleRules.put(new Integer(75),securityRoleRule);

//    	 rule for rowCanEditDocState
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(75); // Level=3 Bit=11
    	securityRoleRules.put(new Integer(75),securityRoleRule);

//    	 rule for rowCanEditExceptionState
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(75); // Level=3 Bit=11
    	securityRoleRules.put(new Integer(75),securityRoleRule);

//    	 rule for rowCanEditNoteMinState
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(75); // Level=3 Bit=11
    	securityRoleRules.put(new Integer(75),securityRoleRule);

//    	 rule for rowCanEditPrjState
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(75); // Level=3 Bit=11
    	securityRoleRules.put(new Integer(75),securityRoleRule);

//    	 rule for rowCanEditScorecState
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(75); // Level=3 Bit=11
    	securityRoleRules.put(new Integer(75),securityRoleRule);

//    	 rule for rowCanEditTaskState
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(75); // Level=3 Bit=11
    	securityRoleRules.put(new Integer(75),securityRoleRule);

//    	 rule for rowCanMarkElements
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(56); // Level=2 Bit=24
    	securityRoleRules.put(new Integer(56),securityRoleRule);

//    	 rule for rowCanModifySearchOptions
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(219); // Level=7 Bit=27
    	securityRoleRules.put(new Integer(219),securityRoleRule);

//    	 rule for rowCanPublishFolder
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(86); // Level=3 Bit=22
    	securityRoleRules.put(new Integer(86),securityRoleRule);

//    	 rule for rowCanViewAllDocuments
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(202); // Level=7 Bit=10
    	securityRoleRules.put(new Integer(202),securityRoleRule);

//    	 rule for rowCanViewAllExceptions
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(192); // Level=7 Bit=0
    	securityRoleRules.put(new Integer(192),securityRoleRule);

//    	 rule for rowCheckOutTo
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(114); // Level=4 Bit=18
    	securityRoleRules.put(new Integer(114),securityRoleRule);

//    	 rule for rowCommitAffectedResources
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(185); // Level=6 Bit=25
    	securityRoleRules.put(new Integer(185),securityRoleRule);

//    	 rule for rowCopyCalcRes
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(122); // Level=4 Bit=26
    	securityRoleRules.put(new Integer(122),securityRoleRule);

//    	 rule for rowCreatParticipant
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(181); // Level=6 Bit=21
    	securityRoleRules.put(new Integer(181),securityRoleRule);

//    	 rule for rowCreateAction
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(199); // Level=7 Bit=7
    	securityRoleRules.put(new Integer(199),securityRoleRule);

//    	 rule for rowCreateCR
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(194); // Level=7 Bit=2
    	securityRoleRules.put(new Integer(194),securityRoleRule);

//    	 rule for rowCreateDefect
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(197); // Level=7 Bit=5
    	securityRoleRules.put(new Integer(197),securityRoleRule);

//    	 rule for rowCreateDocumentItems
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(200); // Level=7 Bit=8
    	securityRoleRules.put(new Integer(200),securityRoleRule);

//    	 rule for rowCreateIssue
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(198); // Level=7 Bit=6
    	securityRoleRules.put(new Integer(198),securityRoleRule);

//    	 rule for rowCreateNoteMinItems
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(201); // Level=7 Bit=9
    	securityRoleRules.put(new Integer(201),securityRoleRule);

//    	 rule for rowCreateProAssignment
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(179); // Level=6 Bit=19
    	securityRoleRules.put(new Integer(179),securityRoleRule);

//    	 rule for rowCreateRates
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(168); // Level=6 Bit=8
    	securityRoleRule.addSetAttributeIndexes(136); // Level=5 Bit=8
    	securityRoleRules.put(new Integer(168),securityRoleRule);

//    	 rule for rowCreateRequirement
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(193); // Level=7 Bit=1
    	securityRoleRules.put(new Integer(193),securityRoleRule);

//    	 rule for rowCreateResAssignment
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(222); // Level=7 Bit=30
    	securityRoleRules.put(new Integer(222),securityRoleRule);

//    	 rule for rowCreateRisk
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(196); // Level=7 Bit=4
    	securityRoleRules.put(new Integer(196),securityRoleRule);

//    	 rule for rowCreateSR
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(195); // Level=7 Bit=3
    	securityRoleRules.put(new Integer(195),securityRoleRule);

//    	 rule for rowCriGodLikeSecurity
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(156); // Level=5 Bit=28
    	securityRoleRules.put(new Integer(156),securityRoleRule);

//    	 rule for rowDOCCreateDelTemp
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(105); // Level=4 Bit=9
    	securityRoleRules.put(new Integer(105),securityRoleRule);

//    	 rule for rowDatesBaselineEstCostBenef
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(119); // Level=4 Bit=23
    	securityRoleRules.put(new Integer(119),securityRoleRule);

//    	 rule for rowDatesBaselineSchedDatesCostBenefit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(120); // Level=4 Bit=24
    	securityRoleRules.put(new Integer(120),securityRoleRule);

//    	 rule for rowDefaultPrj
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(103); // Level=4 Bit=7
    	securityRoleRules.put(new Integer(103),securityRoleRule);

//    	 rule for rowDefectRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(521); // Level=17 Bit=9
    	securityRoleRule.addSetAttributeIndexes(361); // Level=12 Bit=9
    	securityRoleRules.put(new Integer(521),securityRoleRule);

//    	 rule for rowDefectRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(361); // Level=12 Bit=9
    	securityRoleRule.addResetAttributeIndexes(521); // Level=17 Bit=9
    	securityRoleRules.put(new Integer(361),securityRoleRule);

//    	 rule for rowDefectRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(512); // Level=17 Bit=0
    	securityRoleRule.addSetAttributeIndexes(352); // Level=12 Bit=0
    	securityRoleRules.put(new Integer(512),securityRoleRule);

//    	 rule for rowDefectRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(352); // Level=12 Bit=0
    	securityRoleRule.addResetAttributeIndexes(512); // Level=17 Bit=0
    	securityRoleRules.put(new Integer(352),securityRoleRule);

//    	 rule for rowDefectRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(513); // Level=17 Bit=1
    	securityRoleRule.addSetAttributeIndexes(353); // Level=12 Bit=1
    	securityRoleRules.put(new Integer(513),securityRoleRule);

//    	 rule for rowDefectRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(353); // Level=12 Bit=1
    	securityRoleRule.addResetAttributeIndexes(513); // Level=17 Bit=1
    	securityRoleRules.put(new Integer(353),securityRoleRule);

//    	 rule for rowDefectRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(514); // Level=17 Bit=2
    	securityRoleRule.addSetAttributeIndexes(354); // Level=12 Bit=2
    	securityRoleRules.put(new Integer(514),securityRoleRule);

//    	 rule for rowDefectRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(354); // Level=12 Bit=2
    	securityRoleRule.addResetAttributeIndexes(514); // Level=17 Bit=2
    	securityRoleRules.put(new Integer(354),securityRoleRule);

//    	 rule for rowDefectRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(515); // Level=17 Bit=3
    	securityRoleRule.addSetAttributeIndexes(355); // Level=12 Bit=3
    	securityRoleRules.put(new Integer(515),securityRoleRule);

//    	 rule for rowDefectRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(355); // Level=12 Bit=3
    	securityRoleRule.addResetAttributeIndexes(515); // Level=17 Bit=3
    	securityRoleRules.put(new Integer(355),securityRoleRule);

//    	 rule for rowDefectRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(516); // Level=17 Bit=4
    	securityRoleRule.addSetAttributeIndexes(356); // Level=12 Bit=4
    	securityRoleRules.put(new Integer(516),securityRoleRule);

//    	 rule for rowDefectRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(356); // Level=12 Bit=4
    	securityRoleRule.addResetAttributeIndexes(516); // Level=17 Bit=4
    	securityRoleRules.put(new Integer(356),securityRoleRule);

//    	 rule for rowDefectRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(517); // Level=17 Bit=5
    	securityRoleRule.addSetAttributeIndexes(357); // Level=12 Bit=5
    	securityRoleRules.put(new Integer(517),securityRoleRule);

//    	 rule for rowDefectRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(357); // Level=12 Bit=5
    	securityRoleRule.addResetAttributeIndexes(517); // Level=17 Bit=5
    	securityRoleRules.put(new Integer(357),securityRoleRule);

//    	 rule for rowDefectRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(518); // Level=17 Bit=6
    	securityRoleRule.addSetAttributeIndexes(358); // Level=12 Bit=6
    	securityRoleRules.put(new Integer(518),securityRoleRule);

//    	 rule for rowDefectRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(358); // Level=12 Bit=6
    	securityRoleRule.addResetAttributeIndexes(518); // Level=17 Bit=6
    	securityRoleRules.put(new Integer(358),securityRoleRule);

//    	 rule for rowDefectRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(519); // Level=17 Bit=7
    	securityRoleRule.addSetAttributeIndexes(359); // Level=12 Bit=7
    	securityRoleRules.put(new Integer(519),securityRoleRule);

//    	 rule for rowDefectRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(359); // Level=12 Bit=7
    	securityRoleRule.addResetAttributeIndexes(519); // Level=17 Bit=7
    	securityRoleRules.put(new Integer(359),securityRoleRule);

//    	 rule for rowDefectRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(520); // Level=17 Bit=8
    	securityRoleRule.addSetAttributeIndexes(360); // Level=12 Bit=8
    	securityRoleRules.put(new Integer(520),securityRoleRule);

//    	 rule for rowDefectRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(360); // Level=12 Bit=8
    	securityRoleRule.addResetAttributeIndexes(520); // Level=17 Bit=8
    	securityRoleRules.put(new Integer(360),securityRoleRule);

//    	 rule for rowDelAttrAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRule.addSetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRules.put(new Integer(224),securityRoleRule);

//    	 rule for rowDelAttrEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRules.put(new Integer(178),securityRoleRule);

//    	 rule for rowDelAttrView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(146); // Level=5 Bit=18
    	securityRoleRule.addResetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRules.put(new Integer(146),securityRoleRule);

//    	 rule for rowDelDefTCEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(118); // Level=4 Bit=22
    	securityRoleRule.addSetAttributeIndexes(130); // Level=5 Bit=2
    	securityRoleRules.put(new Integer(118),securityRoleRule);

//    	 rule for rowDelDefTCView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(130); // Level=5 Bit=2
    	securityRoleRule.addResetAttributeIndexes(118); // Level=4 Bit=22
    	securityRoleRules.put(new Integer(130),securityRoleRule);

//    	 rule for rowDelEstDatesEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(163); // Level=6 Bit=3
    	securityRoleRule.addSetAttributeIndexes(131); // Level=5 Bit=3
    	securityRoleRules.put(new Integer(163),securityRoleRule);

//    	 rule for rowDelEstDatesView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(131); // Level=5 Bit=3
    	securityRoleRule.addResetAttributeIndexes(163); // Level=6 Bit=3
    	securityRoleRules.put(new Integer(131),securityRoleRule);

//    	 rule for rowDelPriorityEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(160); // Level=6 Bit=0
    	securityRoleRule.addSetAttributeIndexes(45); // Level=2 Bit=13
    	securityRoleRules.put(new Integer(160),securityRoleRule);

//    	 rule for rowDelPriorityView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(45); // Level=2 Bit=13
    	securityRoleRule.addResetAttributeIndexes(160); // Level=6 Bit=0
    	securityRoleRules.put(new Integer(45),securityRoleRule);

//    	 rule for rowDelPublishedEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(162); // Level=6 Bit=2
    	securityRoleRules.put(new Integer(162),securityRoleRule);

//    	 rule for rowDelRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(445); // Level=14 Bit=29
    	securityRoleRule.addSetAttributeIndexes(285); // Level=9 Bit=29
    	securityRoleRules.put(new Integer(445),securityRoleRule);

//    	 rule for rowDelRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(285); // Level=9 Bit=29
    	securityRoleRule.addResetAttributeIndexes(445); // Level=14 Bit=29
    	securityRoleRules.put(new Integer(285),securityRoleRule);

//    	 rule for rowDelRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(436); // Level=14 Bit=20
    	securityRoleRule.addSetAttributeIndexes(276); // Level=9 Bit=20
    	securityRoleRules.put(new Integer(436),securityRoleRule);

//    	 rule for rowDelRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(276); // Level=9 Bit=20
    	securityRoleRule.addResetAttributeIndexes(436); // Level=14 Bit=20
    	securityRoleRules.put(new Integer(276),securityRoleRule);

//    	 rule for rowDelRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(437); // Level=14 Bit=21
    	securityRoleRule.addSetAttributeIndexes(277); // Level=9 Bit=21
    	securityRoleRules.put(new Integer(437),securityRoleRule);

//    	 rule for rowDelRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(277); // Level=9 Bit=21
    	securityRoleRule.addResetAttributeIndexes(437); // Level=14 Bit=21
    	securityRoleRules.put(new Integer(277),securityRoleRule);

//    	 rule for rowDelRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(438); // Level=14 Bit=22
    	securityRoleRule.addSetAttributeIndexes(278); // Level=9 Bit=22
    	securityRoleRules.put(new Integer(438),securityRoleRule);

//    	 rule for rowDelRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(278); // Level=9 Bit=22
    	securityRoleRule.addResetAttributeIndexes(438); // Level=14 Bit=22
    	securityRoleRules.put(new Integer(278),securityRoleRule);

//    	 rule for rowDelRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(439); // Level=14 Bit=23
    	securityRoleRule.addSetAttributeIndexes(279); // Level=9 Bit=23
    	securityRoleRules.put(new Integer(439),securityRoleRule);

//    	 rule for rowDelRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(279); // Level=9 Bit=23
    	securityRoleRule.addResetAttributeIndexes(439); // Level=14 Bit=23
    	securityRoleRules.put(new Integer(279),securityRoleRule);

//    	 rule for rowDelRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(440); // Level=14 Bit=24
    	securityRoleRule.addSetAttributeIndexes(280); // Level=9 Bit=24
    	securityRoleRules.put(new Integer(440),securityRoleRule);

//    	 rule for rowDelRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(280); // Level=9 Bit=24
    	securityRoleRule.addResetAttributeIndexes(440); // Level=14 Bit=24
    	securityRoleRules.put(new Integer(280),securityRoleRule);

//    	 rule for rowDelRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(441); // Level=14 Bit=25
    	securityRoleRule.addSetAttributeIndexes(281); // Level=9 Bit=25
    	securityRoleRules.put(new Integer(441),securityRoleRule);

//    	 rule for rowDelRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(281); // Level=9 Bit=25
    	securityRoleRule.addResetAttributeIndexes(441); // Level=14 Bit=25
    	securityRoleRules.put(new Integer(281),securityRoleRule);

//    	 rule for rowDelRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(442); // Level=14 Bit=26
    	securityRoleRule.addSetAttributeIndexes(282); // Level=9 Bit=26
    	securityRoleRules.put(new Integer(442),securityRoleRule);

//    	 rule for rowDelRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(282); // Level=9 Bit=26
    	securityRoleRule.addResetAttributeIndexes(442); // Level=14 Bit=26
    	securityRoleRules.put(new Integer(282),securityRoleRule);

//    	 rule for rowDelRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(443); // Level=14 Bit=27
    	securityRoleRule.addSetAttributeIndexes(283); // Level=9 Bit=27
    	securityRoleRules.put(new Integer(443),securityRoleRule);

//    	 rule for rowDelRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(283); // Level=9 Bit=27
    	securityRoleRule.addResetAttributeIndexes(443); // Level=14 Bit=27
    	securityRoleRules.put(new Integer(283),securityRoleRule);

//    	 rule for rowDelRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(444); // Level=14 Bit=28
    	securityRoleRule.addSetAttributeIndexes(284); // Level=9 Bit=28
    	securityRoleRules.put(new Integer(444),securityRoleRule);

//    	 rule for rowDelRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(284); // Level=9 Bit=28
    	securityRoleRule.addResetAttributeIndexes(444); // Level=14 Bit=28
    	securityRoleRules.put(new Integer(284),securityRoleRule);

//    	 rule for rowDeleteActuals
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(101); // Level=4 Bit=5
    	securityRoleRules.put(new Integer(101),securityRoleRule);

//    	 rule for rowDeleteCRIItems
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(208); // Level=7 Bit=16
    	securityRoleRules.put(new Integer(208),securityRoleRule);

//    	 rule for rowDeleteDocumentItems
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(208); // Level=7 Bit=16
    	securityRoleRules.put(new Integer(208),securityRoleRule);

//    	 rule for rowDeleteNotMinItems
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(208); // Level=7 Bit=16
    	securityRoleRules.put(new Integer(208),securityRoleRule);

//    	 rule for rowDeleteScorecardItems
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(208); // Level=7 Bit=16
    	securityRoleRules.put(new Integer(208),securityRoleRule);

//    	 rule for rowDeleteWBSItems
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(208); // Level=7 Bit=16
    	securityRoleRules.put(new Integer(208),securityRoleRule);

//    	 rule for rowDocAttrAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRule.addSetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRules.put(new Integer(224),securityRoleRule);

//    	 rule for rowDocAttrEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRules.put(new Integer(178),securityRoleRule);

//    	 rule for rowDocAttrView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(146); // Level=5 Bit=18
    	securityRoleRule.addResetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRules.put(new Integer(146),securityRoleRule);

//    	 rule for rowDocCreateFolder
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(204); // Level=7 Bit=12
    	securityRoleRules.put(new Integer(204),securityRoleRule);

//    	 rule for rowDocElementSecurityEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(166); // Level=6 Bit=6
    	securityRoleRule.addSetAttributeIndexes(134); // Level=5 Bit=6
    	securityRoleRules.put(new Integer(166),securityRoleRule);

//    	 rule for rowDocElementSecurityView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(134); // Level=5 Bit=6
    	securityRoleRule.addResetAttributeIndexes(166); // Level=6 Bit=6
    	securityRoleRules.put(new Integer(134),securityRoleRule);

//    	 rule for rowDocGodLikeSecurity
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(157); // Level=5 Bit=29
    	securityRoleRules.put(new Integer(157),securityRoleRule);

//    	 rule for rowDocKeywordEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(91); // Level=3 Bit=27
    	securityRoleRule.addSetAttributeIndexes(27); // Level=1 Bit=27
    	securityRoleRules.put(new Integer(91),securityRoleRule);

//    	 rule for rowDocKeywordView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(27); // Level=1 Bit=27
    	securityRoleRule.addResetAttributeIndexes(91); // Level=3 Bit=27
    	securityRoleRules.put(new Integer(27),securityRoleRule);

//    	 rule for rowDocMoveAcrossPrj
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(115); // Level=4 Bit=19
    	securityRoleRules.put(new Integer(115),securityRoleRule);

//    	 rule for rowDocNMAttrAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRule.addSetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRules.put(new Integer(224),securityRoleRule);

//    	 rule for rowDocNMAttrEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRules.put(new Integer(178),securityRoleRule);

//    	 rule for rowDocNMAttrView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(146); // Level=5 Bit=18
    	securityRoleRule.addResetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRules.put(new Integer(146),securityRoleRule);

//    	 rule for rowDocNMDescEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(93); // Level=3 Bit=29
    	securityRoleRule.addSetAttributeIndexes(29); // Level=1 Bit=29
    	securityRoleRules.put(new Integer(93),securityRoleRule);

//    	 rule for rowDocNMDescView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(29); // Level=1 Bit=29
    	securityRoleRule.addResetAttributeIndexes(93); // Level=3 Bit=29
    	securityRoleRules.put(new Integer(29),securityRoleRule);

//    	 rule for rowDocNMElementSecurityEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(166); // Level=6 Bit=6
    	securityRoleRule.addSetAttributeIndexes(134); // Level=5 Bit=6
    	securityRoleRules.put(new Integer(166),securityRoleRule);

//    	 rule for rowDocNMElementSecurityView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(134); // Level=5 Bit=6
    	securityRoleRule.addResetAttributeIndexes(166); // Level=6 Bit=6
    	securityRoleRules.put(new Integer(134),securityRoleRule);

//    	 rule for rowDocNMPriorityEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(165); // Level=6 Bit=5
    	securityRoleRule.addSetAttributeIndexes(133); // Level=5 Bit=5
    	securityRoleRules.put(new Integer(165),securityRoleRule);

//    	 rule for rowDocNMPriorityView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(133); // Level=5 Bit=5
    	securityRoleRule.addResetAttributeIndexes(165); // Level=6 Bit=5
    	securityRoleRules.put(new Integer(133),securityRoleRule);

//    	 rule for rowDocNMRankEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(160); // Level=6 Bit=0
    	securityRoleRule.addSetAttributeIndexes(45); // Level=2 Bit=13
    	securityRoleRules.put(new Integer(160),securityRoleRule);

//    	 rule for rowDocNMRankView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(45); // Level=2 Bit=13
    	securityRoleRule.addResetAttributeIndexes(160); // Level=6 Bit=0
    	securityRoleRules.put(new Integer(45),securityRoleRule);

//    	 rule for rowDocProperties
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(41); // Level=2 Bit=9
    	securityRoleRules.put(new Integer(41),securityRoleRule);

//    	 rule for rowDocRefNumberEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(161); // Level=6 Bit=1
    	securityRoleRule.addSetAttributeIndexes(129); // Level=5 Bit=1
    	securityRoleRules.put(new Integer(161),securityRoleRule);

//    	 rule for rowDocRefNumberView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(129); // Level=5 Bit=1
    	securityRoleRule.addResetAttributeIndexes(161); // Level=6 Bit=1
    	securityRoleRules.put(new Integer(129),securityRoleRule);

//    	 rule for rowDocSummEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(92); // Level=3 Bit=28
    	securityRoleRule.addSetAttributeIndexes(28); // Level=1 Bit=28
    	securityRoleRules.put(new Integer(92),securityRoleRule);

//    	 rule for rowDocSummView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(28); // Level=1 Bit=28
    	securityRoleRule.addResetAttributeIndexes(92); // Level=3 Bit=28
    	securityRoleRules.put(new Integer(28),securityRoleRule);

//    	 rule for rowDocViewHistory
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(155); // Level=5 Bit=27
    	securityRoleRules.put(new Integer(155),securityRoleRule);

//    	 rule for rowDocVisibleAtParentEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(90); // Level=3 Bit=26
    	securityRoleRule.addSetAttributeIndexes(26); // Level=1 Bit=26
    	securityRoleRules.put(new Integer(90),securityRoleRule);

//    	 rule for rowDocVisibleAtParentView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(26); // Level=1 Bit=26
    	securityRoleRule.addResetAttributeIndexes(90); // Level=3 Bit=26
    	securityRoleRules.put(new Integer(26),securityRoleRule);

//    	 rule for rowEarnedValue
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(151); // Level=5 Bit=23
    	securityRoleRules.put(new Integer(151),securityRoleRule);

//    	 rule for rowEditCost
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(167); // Level=6 Bit=7
    	securityRoleRule.addSetAttributeIndexes(135); // Level=5 Bit=7
    	securityRoleRules.put(new Integer(167),securityRoleRule);

//    	 rule for rowEditPrjDocSettings
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(232); // Level=8 Bit=8
    	securityRoleRules.put(new Integer(232),securityRoleRule);

//    	 rule for rowEditPublish
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(162); // Level=6 Bit=2
    	securityRoleRules.put(new Integer(162),securityRoleRule);

//    	 rule for rowEditSecurity
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(215); // Level=7 Bit=23
    	securityRoleRules.put(new Integer(215),securityRoleRule);

//    	 rule for rowEditTaskEffortDur
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(126); // Level=4 Bit=30
    	securityRoleRules.put(new Integer(126),securityRoleRule);

//    	 rule for rowExpCapAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(226); // Level=8 Bit=2
    	securityRoleRule.addSetAttributeIndexes(152); // Level=5 Bit=24
    	securityRoleRule.addSetAttributeIndexes(184); // Level=6 Bit=24
    	securityRoleRules.put(new Integer(226),securityRoleRule);

//    	 rule for rowExpCapEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(184); // Level=6 Bit=24
    	securityRoleRule.addResetAttributeIndexes(226); // Level=8 Bit=2
    	securityRoleRule.addSetAttributeIndexes(152); // Level=5 Bit=24
    	securityRoleRules.put(new Integer(184),securityRoleRule);

//    	 rule for rowExpCapView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(152); // Level=5 Bit=24
    	securityRoleRule.addResetAttributeIndexes(184); // Level=6 Bit=24
    	securityRoleRule.addResetAttributeIndexes(226); // Level=8 Bit=2
    	securityRoleRules.put(new Integer(152),securityRoleRule);

//    	 rule for rowFinancialSystemInfo
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(43); // Level=2 Bit=11
    	securityRoleRules.put(new Integer(43),securityRoleRule);

//    	 rule for rowFolderBreakdown
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(211); // Level=7 Bit=19
    	securityRoleRules.put(new Integer(211),securityRoleRule);

//    	 rule for rowFolderDelete
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(208); // Level=7 Bit=16
    	securityRoleRules.put(new Integer(208),securityRoleRule);

//    	 rule for rowFolderRename
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(209); // Level=7 Bit=17
    	securityRoleRules.put(new Integer(209),securityRoleRule);

//    	 rule for rowImport
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(107); // Level=4 Bit=11
    	securityRoleRules.put(new Integer(107),securityRoleRule);

//    	 rule for rowIssueRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(531); // Level=17 Bit=19
    	securityRoleRule.addSetAttributeIndexes(371); // Level=12 Bit=19
    	securityRoleRules.put(new Integer(531),securityRoleRule);

//    	 rule for rowIssueRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(371); // Level=12 Bit=19
    	securityRoleRule.addResetAttributeIndexes(531); // Level=17 Bit=19
    	securityRoleRules.put(new Integer(371),securityRoleRule);

//    	 rule for rowIssueRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(522); // Level=17 Bit=10
    	securityRoleRule.addSetAttributeIndexes(362); // Level=12 Bit=10
    	securityRoleRules.put(new Integer(522),securityRoleRule);

//    	 rule for rowIssueRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(362); // Level=12 Bit=10
    	securityRoleRule.addResetAttributeIndexes(522); // Level=17 Bit=10
    	securityRoleRules.put(new Integer(362),securityRoleRule);

//    	 rule for rowIssueRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(523); // Level=17 Bit=11
    	securityRoleRule.addSetAttributeIndexes(363); // Level=12 Bit=11
    	securityRoleRules.put(new Integer(523),securityRoleRule);

//    	 rule for rowIssueRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(363); // Level=12 Bit=11
    	securityRoleRule.addResetAttributeIndexes(523); // Level=17 Bit=11
    	securityRoleRules.put(new Integer(363),securityRoleRule);

//    	 rule for rowIssueRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(524); // Level=17 Bit=12
    	securityRoleRule.addSetAttributeIndexes(364); // Level=12 Bit=12
    	securityRoleRules.put(new Integer(524),securityRoleRule);

//    	 rule for rowIssueRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(364); // Level=12 Bit=12
    	securityRoleRule.addResetAttributeIndexes(524); // Level=17 Bit=12
    	securityRoleRules.put(new Integer(364),securityRoleRule);

//    	 rule for rowIssueRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(525); // Level=17 Bit=13
    	securityRoleRule.addSetAttributeIndexes(365); // Level=12 Bit=13
    	securityRoleRules.put(new Integer(525),securityRoleRule);

//    	 rule for rowIssueRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(365); // Level=12 Bit=13
    	securityRoleRule.addResetAttributeIndexes(525); // Level=17 Bit=13
    	securityRoleRules.put(new Integer(365),securityRoleRule);

//    	 rule for rowIssueRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(526); // Level=17 Bit=14
    	securityRoleRule.addSetAttributeIndexes(366); // Level=12 Bit=14
    	securityRoleRules.put(new Integer(526),securityRoleRule);

//    	 rule for rowIssueRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(366); // Level=12 Bit=14
    	securityRoleRule.addResetAttributeIndexes(526); // Level=17 Bit=14
    	securityRoleRules.put(new Integer(366),securityRoleRule);

//    	 rule for rowIssueRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(527); // Level=17 Bit=15
    	securityRoleRule.addSetAttributeIndexes(367); // Level=12 Bit=15
    	securityRoleRules.put(new Integer(527),securityRoleRule);

//    	 rule for rowIssueRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(367); // Level=12 Bit=15
    	securityRoleRule.addResetAttributeIndexes(527); // Level=17 Bit=15
    	securityRoleRules.put(new Integer(367),securityRoleRule);

//    	 rule for rowIssueRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(528); // Level=17 Bit=16
    	securityRoleRule.addSetAttributeIndexes(368); // Level=12 Bit=16
    	securityRoleRules.put(new Integer(528),securityRoleRule);

//    	 rule for rowIssueRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(368); // Level=12 Bit=16
    	securityRoleRule.addResetAttributeIndexes(528); // Level=17 Bit=16
    	securityRoleRules.put(new Integer(368),securityRoleRule);

//    	 rule for rowIssueRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(529); // Level=17 Bit=17
    	securityRoleRule.addSetAttributeIndexes(369); // Level=12 Bit=17
    	securityRoleRules.put(new Integer(529),securityRoleRule);

//    	 rule for rowIssueRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(369); // Level=12 Bit=17
    	securityRoleRule.addResetAttributeIndexes(529); // Level=17 Bit=17
    	securityRoleRules.put(new Integer(369),securityRoleRule);

//    	 rule for rowIssueRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(530); // Level=17 Bit=18
    	securityRoleRule.addSetAttributeIndexes(370); // Level=12 Bit=18
    	securityRoleRules.put(new Integer(530),securityRoleRule);

//    	 rule for rowIssueRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(370); // Level=12 Bit=18
    	securityRoleRule.addResetAttributeIndexes(530); // Level=17 Bit=18
    	securityRoleRules.put(new Integer(370),securityRoleRule);

//    	 rule for rowLockUnlock
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(206); // Level=7 Bit=14
    	securityRoleRules.put(new Integer(206),securityRoleRule);

//    	 rule for rowLockUnlockNM
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(51); // Level=2 Bit=19
    	securityRoleRules.put(new Integer(51),securityRoleRule);

//    	 rule for rowMergePrj
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(108); // Level=4 Bit=12
    	securityRoleRules.put(new Integer(108),securityRoleRule);

//    	 rule for rowMilestoneRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(477); // Level=15 Bit=29
    	securityRoleRule.addSetAttributeIndexes(317); // Level=10 Bit=29
    	securityRoleRules.put(new Integer(477),securityRoleRule);

//    	 rule for rowMilestoneRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(317); // Level=10 Bit=29
    	securityRoleRule.addResetAttributeIndexes(477); // Level=15 Bit=29
    	securityRoleRules.put(new Integer(317),securityRoleRule);

//    	 rule for rowMilestoneRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(468); // Level=15 Bit=20
    	securityRoleRule.addSetAttributeIndexes(308); // Level=10 Bit=20
    	securityRoleRules.put(new Integer(468),securityRoleRule);

//    	 rule for rowMilestoneRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(308); // Level=10 Bit=20
    	securityRoleRule.addResetAttributeIndexes(468); // Level=15 Bit=20
    	securityRoleRules.put(new Integer(308),securityRoleRule);

//    	 rule for rowMilestoneRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(469); // Level=15 Bit=21
    	securityRoleRule.addSetAttributeIndexes(309); // Level=10 Bit=21
    	securityRoleRules.put(new Integer(469),securityRoleRule);

//    	 rule for rowMilestoneRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(309); // Level=10 Bit=21
    	securityRoleRule.addResetAttributeIndexes(469); // Level=15 Bit=21
    	securityRoleRules.put(new Integer(309),securityRoleRule);

//    	 rule for rowMilestoneRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(470); // Level=15 Bit=22
    	securityRoleRule.addSetAttributeIndexes(310); // Level=10 Bit=22
    	securityRoleRules.put(new Integer(470),securityRoleRule);

//    	 rule for rowMilestoneRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(310); // Level=10 Bit=22
    	securityRoleRule.addResetAttributeIndexes(470); // Level=15 Bit=22
    	securityRoleRules.put(new Integer(310),securityRoleRule);

//    	 rule for rowMilestoneRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(471); // Level=15 Bit=23
    	securityRoleRule.addSetAttributeIndexes(311); // Level=10 Bit=23
    	securityRoleRules.put(new Integer(471),securityRoleRule);

//    	 rule for rowMilestoneRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(311); // Level=10 Bit=23
    	securityRoleRule.addResetAttributeIndexes(471); // Level=15 Bit=23
    	securityRoleRules.put(new Integer(311),securityRoleRule);

//    	 rule for rowMilestoneRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(472); // Level=15 Bit=24
    	securityRoleRule.addSetAttributeIndexes(312); // Level=10 Bit=24
    	securityRoleRules.put(new Integer(472),securityRoleRule);

//    	 rule for rowMilestoneRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(312); // Level=10 Bit=24
    	securityRoleRule.addResetAttributeIndexes(472); // Level=15 Bit=24
    	securityRoleRules.put(new Integer(312),securityRoleRule);

//    	 rule for rowMilestoneRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(473); // Level=15 Bit=25
    	securityRoleRule.addSetAttributeIndexes(313); // Level=10 Bit=25
    	securityRoleRules.put(new Integer(473),securityRoleRule);

//    	 rule for rowMilestoneRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(313); // Level=10 Bit=25
    	securityRoleRule.addResetAttributeIndexes(473); // Level=15 Bit=25
    	securityRoleRules.put(new Integer(313),securityRoleRule);

//    	 rule for rowMilestoneRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(474); // Level=15 Bit=26
    	securityRoleRule.addSetAttributeIndexes(314); // Level=10 Bit=26
    	securityRoleRules.put(new Integer(474),securityRoleRule);

//    	 rule for rowMilestoneRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(314); // Level=10 Bit=26
    	securityRoleRule.addResetAttributeIndexes(474); // Level=15 Bit=26
    	securityRoleRules.put(new Integer(314),securityRoleRule);

//    	 rule for rowMilestoneRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(475); // Level=15 Bit=27
    	securityRoleRule.addSetAttributeIndexes(315); // Level=10 Bit=27
    	securityRoleRules.put(new Integer(475),securityRoleRule);

//    	 rule for rowMilestoneRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(315); // Level=10 Bit=27
    	securityRoleRule.addResetAttributeIndexes(475); // Level=15 Bit=27
    	securityRoleRules.put(new Integer(315),securityRoleRule);

//    	 rule for rowMilestoneRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(476); // Level=15 Bit=28
    	securityRoleRule.addSetAttributeIndexes(316); // Level=10 Bit=28
    	securityRoleRules.put(new Integer(476),securityRoleRule);

//    	 rule for rowMilestoneRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(316); // Level=10 Bit=28
    	securityRoleRule.addResetAttributeIndexes(476); // Level=15 Bit=28
    	securityRoleRules.put(new Integer(316),securityRoleRule);

//    	 rule for rowMoveTemp
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(139); // Level=5 Bit=11
    	securityRoleRules.put(new Integer(139),securityRoleRule);

//    	 rule for rowNMLockUnlock
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(206); // Level=7 Bit=14
    	securityRoleRules.put(new Integer(206),securityRoleRule);

//    	 rule for rowNotMinViewVersion
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(155); // Level=5 Bit=27
    	securityRoleRules.put(new Integer(155),securityRoleRule);

//    	 rule for rowNoteMinVisibleAtParentEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(90); // Level=3 Bit=26
    	securityRoleRule.addSetAttributeIndexes(26); // Level=1 Bit=26
    	securityRoleRules.put(new Integer(90),securityRoleRule);

//    	 rule for rowNoteMinVisibleAtParentView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(26); // Level=1 Bit=26
    	securityRoleRule.addResetAttributeIndexes(90); // Level=3 Bit=26
    	securityRoleRules.put(new Integer(26),securityRoleRule);

//    	 rule for rowPermanentlyDeleteDoc
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(207); // Level=7 Bit=15
    	securityRoleRules.put(new Integer(207),securityRoleRule);

//    	 rule for rowPermanentlyDeleteDocManager
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(207); // Level=7 Bit=15
    	securityRoleRules.put(new Integer(207),securityRoleRule);

//    	 rule for rowPermanentlyDeleteDocOnException
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(207); // Level=7 Bit=15
    	securityRoleRules.put(new Integer(207),securityRoleRule);

//    	 rule for rowPermanentlyDeleteFolder
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(207); // Level=7 Bit=15
    	securityRoleRules.put(new Integer(207),securityRoleRule);

//    	 rule for rowPhaseActivityRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(467); // Level=15 Bit=19
    	securityRoleRule.addSetAttributeIndexes(307); // Level=10 Bit=19
    	securityRoleRules.put(new Integer(467),securityRoleRule);

//    	 rule for rowPhaseActivityRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(307); // Level=10 Bit=19
    	securityRoleRule.addResetAttributeIndexes(467); // Level=15 Bit=19
    	securityRoleRules.put(new Integer(307),securityRoleRule);

//    	 rule for rowPhaseActivityRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(458); // Level=15 Bit=10
    	securityRoleRule.addSetAttributeIndexes(298); // Level=10 Bit=10
    	securityRoleRules.put(new Integer(458),securityRoleRule);

//    	 rule for rowPhaseActivityRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(298); // Level=10 Bit=10
    	securityRoleRule.addResetAttributeIndexes(458); // Level=15 Bit=10
    	securityRoleRules.put(new Integer(298),securityRoleRule);

//    	 rule for rowPhaseActivityRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(459); // Level=15 Bit=11
    	securityRoleRule.addSetAttributeIndexes(299); // Level=10 Bit=11
    	securityRoleRules.put(new Integer(459),securityRoleRule);

//    	 rule for rowPhaseActivityRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(299); // Level=10 Bit=11
    	securityRoleRule.addResetAttributeIndexes(459); // Level=15 Bit=11
    	securityRoleRules.put(new Integer(299),securityRoleRule);

//    	 rule for rowPhaseActivityRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(460); // Level=15 Bit=12
    	securityRoleRule.addSetAttributeIndexes(300); // Level=10 Bit=12
    	securityRoleRules.put(new Integer(460),securityRoleRule);

//    	 rule for rowPhaseActivityRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(300); // Level=10 Bit=12
    	securityRoleRule.addResetAttributeIndexes(460); // Level=15 Bit=12
    	securityRoleRules.put(new Integer(300),securityRoleRule);

//    	 rule for rowPhaseActivityRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(461); // Level=15 Bit=13
    	securityRoleRule.addSetAttributeIndexes(301); // Level=10 Bit=13
    	securityRoleRules.put(new Integer(461),securityRoleRule);

//    	 rule for rowPhaseActivityRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(301); // Level=10 Bit=13
    	securityRoleRule.addResetAttributeIndexes(461); // Level=15 Bit=13
    	securityRoleRules.put(new Integer(301),securityRoleRule);

//    	 rule for rowPhaseActivityRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(462); // Level=15 Bit=14
    	securityRoleRule.addSetAttributeIndexes(302); // Level=10 Bit=14
    	securityRoleRules.put(new Integer(462),securityRoleRule);

//    	 rule for rowPhaseActivityRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(302); // Level=10 Bit=14
    	securityRoleRule.addResetAttributeIndexes(462); // Level=15 Bit=14
    	securityRoleRules.put(new Integer(302),securityRoleRule);

//    	 rule for rowPhaseActivityRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(463); // Level=15 Bit=15
    	securityRoleRule.addSetAttributeIndexes(303); // Level=10 Bit=15
    	securityRoleRules.put(new Integer(463),securityRoleRule);

//    	 rule for rowPhaseActivityRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(303); // Level=10 Bit=15
    	securityRoleRule.addResetAttributeIndexes(463); // Level=15 Bit=15
    	securityRoleRules.put(new Integer(303),securityRoleRule);

//    	 rule for rowPhaseActivityRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(464); // Level=15 Bit=16
    	securityRoleRule.addSetAttributeIndexes(304); // Level=10 Bit=16
    	securityRoleRules.put(new Integer(464),securityRoleRule);

//    	 rule for rowPhaseActivityRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(304); // Level=10 Bit=16
    	securityRoleRule.addResetAttributeIndexes(464); // Level=15 Bit=16
    	securityRoleRules.put(new Integer(304),securityRoleRule);

//    	 rule for rowPhaseActivityRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(465); // Level=15 Bit=17
    	securityRoleRule.addSetAttributeIndexes(305); // Level=10 Bit=17
    	securityRoleRules.put(new Integer(465),securityRoleRule);

//    	 rule for rowPhaseActivityRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(305); // Level=10 Bit=17
    	securityRoleRule.addResetAttributeIndexes(465); // Level=15 Bit=17
    	securityRoleRules.put(new Integer(305),securityRoleRule);

//    	 rule for rowPhaseActivityRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(466); // Level=15 Bit=18
    	securityRoleRule.addSetAttributeIndexes(306); // Level=10 Bit=18
    	securityRoleRules.put(new Integer(466),securityRoleRule);

//    	 rule for rowPhaseActivityRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(306); // Level=10 Bit=18
    	securityRoleRule.addResetAttributeIndexes(466); // Level=15 Bit=18
    	securityRoleRules.put(new Integer(306),securityRoleRule);

//    	 rule for rowPivotBudgets
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(582); // Level=19 Bit=6
    	securityRoleRules.put(new Integer(582),securityRoleRule);

//    	 rule for rowPivotCostCenters
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(586); // Level=19 Bit=10
    	securityRoleRules.put(new Integer(586),securityRoleRule);

//    	 rule for rowPivotCumulatedCashflow
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(584); // Level=19 Bit=8
    	securityRoleRules.put(new Integer(584),securityRoleRule);

//    	 rule for rowPivotDefectAttributes
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(601); // Level=19 Bit=25
    	securityRoleRules.put(new Integer(601),securityRoleRule);

//    	 rule for rowPivotDeliverable
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(603); // Level=19 Bit=27
    	securityRoleRules.put(new Integer(603),securityRoleRule);

//    	 rule for rowPivotDeliverableFinancials
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(602); // Level=19 Bit=26
    	securityRoleRules.put(new Integer(602),securityRoleRule);

//    	 rule for rowPivotEarnedValue
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(595); // Level=19 Bit=19
    	securityRoleRules.put(new Integer(595),securityRoleRule);

//    	 rule for rowPivotFinancialAssessment
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(580); // Level=19 Bit=4
    	securityRoleRules.put(new Integer(580),securityRoleRule);

//    	 rule for rowPivotGeneralHealth
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(576); // Level=19 Bit=0
    	securityRoleRules.put(new Integer(576),securityRoleRule);

//    	 rule for rowPivotGeneralHealthFinancials
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(577); // Level=19 Bit=1
    	securityRoleRules.put(new Integer(577),securityRoleRule);

//    	 rule for rowPivotMonthResourceUtilization
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(600); // Level=19 Bit=24
    	securityRoleRules.put(new Integer(600),securityRoleRule);

//    	 rule for rowPivotMonthTimesheets
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(599); // Level=19 Bit=23
    	securityRoleRules.put(new Integer(599),securityRoleRule);

//    	 rule for rowPivotNetCashflow
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(585); // Level=19 Bit=9
    	securityRoleRules.put(new Integer(585),securityRoleRule);

//    	 rule for rowPivotProjectCrossCharge
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(605); // Level=19 Bit=29
    	securityRoleRules.put(new Integer(605),securityRoleRule);

//    	 rule for rowPivotProjectDeliverableDetail
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(604); // Level=19 Bit=28
    	securityRoleRules.put(new Integer(604),securityRoleRule);

//    	 rule for rowPivotResourceSupplyandDemand
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(589); // Level=19 Bit=13
    	securityRoleRules.put(new Integer(589),securityRoleRule);

//    	 rule for rowPivotResourceUtilization
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(590); // Level=19 Bit=14
    	securityRoleRules.put(new Integer(590),securityRoleRule);

//    	 rule for rowPivotScope
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(578); // Level=19 Bit=2
    	securityRoleRules.put(new Integer(578),securityRoleRule);

//    	 rule for rowPivotScopeFinancials
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(579); // Level=19 Bit=3
    	securityRoleRules.put(new Integer(579),securityRoleRule);

//    	 rule for rowPivotTaskAnalyses
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(593); // Level=19 Bit=17
    	securityRoleRules.put(new Integer(593),securityRoleRule);

//    	 rule for rowPivotTimephasedBudgets
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(583); // Level=19 Bit=7
    	securityRoleRules.put(new Integer(583),securityRoleRule);

//    	 rule for rowPivotTimesheets
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(594); // Level=19 Bit=18
    	securityRoleRules.put(new Integer(594),securityRoleRule);

//    	 rule for rowPivotWBSElementsWithAttributes
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(591); // Level=19 Bit=15
    	securityRoleRules.put(new Integer(591),securityRoleRule);

//    	 rule for rowPivotWBSElementsWithAttributesFinancials
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(592); // Level=19 Bit=16
    	securityRoleRules.put(new Integer(592),securityRoleRule);

//    	 rule for rowPlan2Schd
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(183); // Level=6 Bit=23
    	securityRoleRules.put(new Integer(183),securityRoleRule);

//    	 rule for rowPoolAttrAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRule.addSetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRules.put(new Integer(224),securityRoleRule);

//    	 rule for rowPoolAttrEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRules.put(new Integer(178),securityRoleRule);

//    	 rule for rowPoolAttrView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(146); // Level=5 Bit=18
    	securityRoleRule.addResetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRules.put(new Integer(146),securityRoleRule);

//    	 rule for rowPrjAddRemTimeCodes
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(233); // Level=8 Bit=9
    	securityRoleRule.addSetAttributeIndexes(10); // Level=1 Bit=10
    	securityRoleRules.put(new Integer(233),securityRoleRule);

//    	 rule for rowPrjAssTypeEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(64); // Level=3 Bit=0
    	securityRoleRule.addSetAttributeIndexes(0); // Level=1 Bit=0
    	securityRoleRules.put(new Integer(64),securityRoleRule);

//    	 rule for rowPrjAssTypeView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(0); // Level=1 Bit=0
    	securityRoleRule.addResetAttributeIndexes(64); // Level=3 Bit=0
    	securityRoleRules.put(new Integer(0),securityRoleRule);

//    	 rule for rowPrjAssignEstEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(72); // Level=3 Bit=8
    	securityRoleRule.addSetAttributeIndexes(8); // Level=1 Bit=8
    	securityRoleRules.put(new Integer(72),securityRoleRule);

//    	 rule for rowPrjAssignEstView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(8); // Level=1 Bit=8
    	securityRoleRule.addResetAttributeIndexes(72); // Level=3 Bit=8
    	securityRoleRules.put(new Integer(8),securityRoleRule);

//    	 rule for rowPrjAttrAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(224); // Level=8 Bit=0
    	securityRoleRule.addResetAttributeIndexes(109); // Level=4 Bit=13
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRule.addSetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRules.put(new Integer(224),securityRoleRule);

//    	 rule for rowPrjAttrCreateLocal
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(109); // Level=4 Bit=13
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRule.addSetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRule.addSetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRules.put(new Integer(109),securityRoleRule);

//    	 rule for rowPrjAttrEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRule.addResetAttributeIndexes(109); // Level=4 Bit=13
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRules.put(new Integer(178),securityRoleRule);

//    	 rule for rowPrjAttrView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(146); // Level=5 Bit=18
    	securityRoleRule.addResetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRule.addResetAttributeIndexes(109); // Level=4 Bit=13
    	securityRoleRules.put(new Integer(146),securityRoleRule);

//    	 rule for rowPrjBallparkEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(164); // Level=6 Bit=4
    	securityRoleRule.addSetAttributeIndexes(132); // Level=5 Bit=4
    	securityRoleRules.put(new Integer(164),securityRoleRule);

//    	 rule for rowPrjBallparkView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(132); // Level=5 Bit=4
    	securityRoleRule.addResetAttributeIndexes(164); // Level=6 Bit=4
    	securityRoleRules.put(new Integer(132),securityRoleRule);

//    	 rule for rowPrjBudgetSettingEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(71); // Level=3 Bit=7
    	securityRoleRule.addSetAttributeIndexes(7); // Level=1 Bit=7
    	securityRoleRules.put(new Integer(71),securityRoleRule);

//    	 rule for rowPrjBudgetSettingView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(7); // Level=1 Bit=7
    	securityRoleRule.addResetAttributeIndexes(71); // Level=3 Bit=7
    	securityRoleRules.put(new Integer(7),securityRoleRule);

//    	 rule for rowPrjCalendarView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(1); // Level=1 Bit=1
    	securityRoleRules.put(new Integer(1),securityRoleRule);

//    	 rule for rowPrjCanCopyCalcResWithDateViolation
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(54); // Level=2 Bit=22
    	securityRoleRules.put(new Integer(54),securityRoleRule);

//    	 rule for rowPrjCanCreateCalendarExcp
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(21); // Level=1 Bit=21
    	securityRoleRules.put(new Integer(21),securityRoleRule);

//    	 rule for rowPrjCanMoveProjects
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(24); // Level=1 Bit=24
    	securityRoleRules.put(new Integer(24),securityRoleRule);

//    	 rule for rowPrjChargeBackFormulaEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(123); // Level=4 Bit=27
    	securityRoleRule.addSetAttributeIndexes(46); // Level=2 Bit=14
    	securityRoleRules.put(new Integer(123),securityRoleRule);

//    	 rule for rowPrjChargeBackFormulaView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(46); // Level=2 Bit=14
    	securityRoleRule.addResetAttributeIndexes(123); // Level=4 Bit=27
    	securityRoleRules.put(new Integer(46),securityRoleRule);

//    	 rule for rowPrjConfigEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(68); // Level=3 Bit=4
    	securityRoleRule.addSetAttributeIndexes(4); // Level=1 Bit=4
    	securityRoleRules.put(new Integer(68),securityRoleRule);

//    	 rule for rowPrjConfigView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(4); // Level=1 Bit=4
    	securityRoleRule.addResetAttributeIndexes(68); // Level=3 Bit=4
    	securityRoleRules.put(new Integer(4),securityRoleRule);

//    	 rule for rowPrjCurrencyView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(2); // Level=1 Bit=2
    	securityRoleRules.put(new Integer(2),securityRoleRule);

//    	 rule for rowPrjDecommission
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(66); // Level=3 Bit=2
    	securityRoleRules.put(new Integer(66),securityRoleRule);

//    	 rule for rowPrjDefScorecardAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(230); // Level=8 Bit=6
    	securityRoleRule.addSetAttributeIndexes(11); // Level=1 Bit=11
    	securityRoleRules.put(new Integer(230),securityRoleRule);

//    	 rule for rowPrjDefScorecardView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(11); // Level=1 Bit=11
    	securityRoleRule.addResetAttributeIndexes(230); // Level=8 Bit=6
    	securityRoleRule.addResetAttributeIndexes(230); // Level=8 Bit=6
    	securityRoleRules.put(new Integer(11),securityRoleRule);

//    	 rule for rowPrjDefTCEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(118); // Level=4 Bit=22
    	securityRoleRule.addSetAttributeIndexes(130); // Level=5 Bit=2
    	securityRoleRules.put(new Integer(118),securityRoleRule);

//    	 rule for rowPrjDefTCView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(130); // Level=5 Bit=2
    	securityRoleRule.addResetAttributeIndexes(118); // Level=4 Bit=22
    	securityRoleRules.put(new Integer(130),securityRoleRule);

//    	 rule for rowPrjDiscountAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(229); // Level=8 Bit=5
    	securityRoleRule.addSetAttributeIndexes(35); // Level=2 Bit=3
    	securityRoleRule.addSetAttributeIndexes(100); // Level=4 Bit=4
    	securityRoleRules.put(new Integer(229),securityRoleRule);

//    	 rule for rowPrjDiscountEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(100); // Level=4 Bit=4
    	securityRoleRule.addResetAttributeIndexes(229); // Level=8 Bit=5
    	securityRoleRule.addSetAttributeIndexes(35); // Level=2 Bit=3
    	securityRoleRules.put(new Integer(100),securityRoleRule);

//    	 rule for rowPrjDiscountView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(35); // Level=2 Bit=3
    	securityRoleRule.addResetAttributeIndexes(100); // Level=4 Bit=4
    	securityRoleRule.addResetAttributeIndexes(229); // Level=8 Bit=5
    	securityRoleRules.put(new Integer(35),securityRoleRule);

//    	 rule for rowPrjDoEVCalculationEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(124); // Level=4 Bit=28
    	securityRoleRule.addSetAttributeIndexes(47); // Level=2 Bit=15
    	securityRoleRules.put(new Integer(124),securityRoleRule);

//    	 rule for rowPrjDoEVCalculationView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(47); // Level=2 Bit=15
    	securityRoleRule.addResetAttributeIndexes(124); // Level=4 Bit=28
    	securityRoleRules.put(new Integer(47),securityRoleRule);

//    	 rule for rowPrjESTDatesEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(163); // Level=6 Bit=3
    	securityRoleRule.addSetAttributeIndexes(131); // Level=5 Bit=3
    	securityRoleRules.put(new Integer(163),securityRoleRule);

//    	 rule for rowPrjESTDatesView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(131); // Level=5 Bit=3
    	securityRoleRule.addResetAttributeIndexes(163); // Level=6 Bit=3
    	securityRoleRules.put(new Integer(131),securityRoleRule);

//    	 rule for rowPrjLevelWithPMO
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(121); // Level=4 Bit=25
    	securityRoleRules.put(new Integer(121),securityRoleRule);

//    	 rule for rowPrjModifyTaskType
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(106); // Level=4 Bit=10
    	securityRoleRules.put(new Integer(106),securityRoleRule);

//    	 rule for rowPrjPursuitEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(69); // Level=3 Bit=5
    	securityRoleRule.addSetAttributeIndexes(5); // Level=1 Bit=5
    	securityRoleRules.put(new Integer(69),securityRoleRule);

//    	 rule for rowPrjPursuitView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(5); // Level=1 Bit=5
    	securityRoleRule.addResetAttributeIndexes(69); // Level=3 Bit=5
    	securityRoleRules.put(new Integer(5),securityRoleRule);

//    	 rule for rowPrjRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(425); // Level=14 Bit=9
    	securityRoleRule.addSetAttributeIndexes(265); // Level=9 Bit=9
    	securityRoleRules.put(new Integer(425),securityRoleRule);

//    	 rule for rowPrjRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(265); // Level=9 Bit=9
    	securityRoleRule.addResetAttributeIndexes(425); // Level=14 Bit=9
    	securityRoleRules.put(new Integer(265),securityRoleRule);

//    	 rule for rowPrjRTF11Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(554); // Level=18 Bit=10
    	securityRoleRule.addSetAttributeIndexes(394); // Level=13 Bit=10
    	securityRoleRules.put(new Integer(554),securityRoleRule);

//    	 rule for rowPrjRTF11View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(394); // Level=13 Bit=10
    	securityRoleRule.addResetAttributeIndexes(554); // Level=18 Bit=10
    	securityRoleRules.put(new Integer(394),securityRoleRule);

//    	 rule for rowPrjRTF12Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(555); // Level=18 Bit=11
    	securityRoleRule.addSetAttributeIndexes(395); // Level=13 Bit=11
    	securityRoleRules.put(new Integer(555),securityRoleRule);

//    	 rule for rowPrjRTF12View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(395); // Level=13 Bit=11
    	securityRoleRule.addResetAttributeIndexes(555); // Level=18 Bit=11
    	securityRoleRules.put(new Integer(395),securityRoleRule);

//    	 rule for rowPrjRTF13Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(556); // Level=18 Bit=12
    	securityRoleRule.addSetAttributeIndexes(396); // Level=13 Bit=12
    	securityRoleRules.put(new Integer(556),securityRoleRule);

//    	 rule for rowPrjRTF13View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(396); // Level=13 Bit=12
    	securityRoleRule.addResetAttributeIndexes(556); // Level=18 Bit=12
    	securityRoleRules.put(new Integer(396),securityRoleRule);

//    	 rule for rowPrjRTF14Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(557); // Level=18 Bit=13
    	securityRoleRule.addSetAttributeIndexes(397); // Level=13 Bit=13
    	securityRoleRules.put(new Integer(557),securityRoleRule);

//    	 rule for rowPrjRTF14View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(397); // Level=13 Bit=13
    	securityRoleRule.addResetAttributeIndexes(557); // Level=18 Bit=13
    	securityRoleRules.put(new Integer(397),securityRoleRule);

//    	 rule for rowPrjRTF15Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(558); // Level=18 Bit=14
    	securityRoleRule.addSetAttributeIndexes(398); // Level=13 Bit=14
    	securityRoleRules.put(new Integer(558),securityRoleRule);

//    	 rule for rowPrjRTF15View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(398); // Level=13 Bit=14
    	securityRoleRule.addResetAttributeIndexes(558); // Level=18 Bit=14
    	securityRoleRules.put(new Integer(398),securityRoleRule);

//    	 rule for rowPrjRTF16Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(559); // Level=18 Bit=15
    	securityRoleRule.addSetAttributeIndexes(399); // Level=13 Bit=15
    	securityRoleRules.put(new Integer(559),securityRoleRule);

//    	 rule for rowPrjRTF16View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(399); // Level=13 Bit=15
    	securityRoleRule.addResetAttributeIndexes(559); // Level=18 Bit=15
    	securityRoleRules.put(new Integer(399),securityRoleRule);

//    	 rule for rowPrjRTF17Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(560); // Level=18 Bit=16
    	securityRoleRule.addSetAttributeIndexes(400); // Level=13 Bit=16
    	securityRoleRules.put(new Integer(560),securityRoleRule);

//    	 rule for rowPrjRTF17View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(400); // Level=13 Bit=16
    	securityRoleRule.addResetAttributeIndexes(560); // Level=18 Bit=16
    	securityRoleRules.put(new Integer(400),securityRoleRule);

//    	 rule for rowPrjRTF18Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(561); // Level=18 Bit=17
    	securityRoleRule.addSetAttributeIndexes(401); // Level=13 Bit=17
    	securityRoleRules.put(new Integer(561),securityRoleRule);

//    	 rule for rowPrjRTF18View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(401); // Level=13 Bit=17
    	securityRoleRule.addResetAttributeIndexes(561); // Level=18 Bit=17
    	securityRoleRules.put(new Integer(401),securityRoleRule);

//    	 rule for rowPrjRTF19Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(562); // Level=18 Bit=18
    	securityRoleRule.addSetAttributeIndexes(402); // Level=13 Bit=18
    	securityRoleRules.put(new Integer(562),securityRoleRule);

//    	 rule for rowPrjRTF19View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(402); // Level=13 Bit=18
    	securityRoleRule.addResetAttributeIndexes(562); // Level=18 Bit=18
    	securityRoleRules.put(new Integer(402),securityRoleRule);

//    	 rule for rowPrjRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(416); // Level=14 Bit=0
    	securityRoleRule.addSetAttributeIndexes(256); // Level=9 Bit=0
    	securityRoleRules.put(new Integer(416),securityRoleRule);

//    	 rule for rowPrjRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(256); // Level=9 Bit=0
    	securityRoleRule.addResetAttributeIndexes(416); // Level=14 Bit=0
    	securityRoleRules.put(new Integer(256),securityRoleRule);

//    	 rule for rowPrjRTF20Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(563); // Level=18 Bit=19
    	securityRoleRule.addSetAttributeIndexes(403); // Level=13 Bit=19
    	securityRoleRules.put(new Integer(563),securityRoleRule);

//    	 rule for rowPrjRTF20View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(403); // Level=13 Bit=19
    	securityRoleRule.addResetAttributeIndexes(563); // Level=18 Bit=19
    	securityRoleRules.put(new Integer(403),securityRoleRule);

//    	 rule for rowPrjRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(417); // Level=14 Bit=1
    	securityRoleRule.addSetAttributeIndexes(257); // Level=9 Bit=1
    	securityRoleRules.put(new Integer(417),securityRoleRule);

//    	 rule for rowPrjRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(257); // Level=9 Bit=1
    	securityRoleRule.addResetAttributeIndexes(417); // Level=14 Bit=1
    	securityRoleRules.put(new Integer(257),securityRoleRule);

//    	 rule for rowPrjRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(418); // Level=14 Bit=2
    	securityRoleRule.addSetAttributeIndexes(258); // Level=9 Bit=2
    	securityRoleRules.put(new Integer(418),securityRoleRule);

//    	 rule for rowPrjRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(258); // Level=9 Bit=2
    	securityRoleRule.addResetAttributeIndexes(418); // Level=14 Bit=2
    	securityRoleRules.put(new Integer(258),securityRoleRule);

//    	 rule for rowPrjRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(419); // Level=14 Bit=3
    	securityRoleRule.addSetAttributeIndexes(259); // Level=9 Bit=3
    	securityRoleRules.put(new Integer(419),securityRoleRule);

//    	 rule for rowPrjRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(259); // Level=9 Bit=3
    	securityRoleRule.addResetAttributeIndexes(419); // Level=14 Bit=3
    	securityRoleRules.put(new Integer(259),securityRoleRule);

//    	 rule for rowPrjRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(420); // Level=14 Bit=4
    	securityRoleRule.addSetAttributeIndexes(260); // Level=9 Bit=4
    	securityRoleRules.put(new Integer(420),securityRoleRule);

//    	 rule for rowPrjRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(260); // Level=9 Bit=4
    	securityRoleRule.addResetAttributeIndexes(420); // Level=14 Bit=4
    	securityRoleRules.put(new Integer(260),securityRoleRule);

//    	 rule for rowPrjRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(421); // Level=14 Bit=5
    	securityRoleRule.addSetAttributeIndexes(261); // Level=9 Bit=5
    	securityRoleRules.put(new Integer(421),securityRoleRule);

//    	 rule for rowPrjRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(261); // Level=9 Bit=5
    	securityRoleRule.addResetAttributeIndexes(421); // Level=14 Bit=5
    	securityRoleRules.put(new Integer(261),securityRoleRule);

//    	 rule for rowPrjRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(422); // Level=14 Bit=6
    	securityRoleRule.addSetAttributeIndexes(262); // Level=9 Bit=6
    	securityRoleRules.put(new Integer(422),securityRoleRule);

//    	 rule for rowPrjRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(262); // Level=9 Bit=6
    	securityRoleRule.addResetAttributeIndexes(422); // Level=14 Bit=6
    	securityRoleRules.put(new Integer(262),securityRoleRule);

//    	 rule for rowPrjRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(423); // Level=14 Bit=7
    	securityRoleRule.addSetAttributeIndexes(263); // Level=9 Bit=7
    	securityRoleRules.put(new Integer(423),securityRoleRule);

//    	 rule for rowPrjRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(263); // Level=9 Bit=7
    	securityRoleRule.addResetAttributeIndexes(423); // Level=14 Bit=7
    	securityRoleRules.put(new Integer(263),securityRoleRule);

//    	 rule for rowPrjRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(424); // Level=14 Bit=8
    	securityRoleRule.addSetAttributeIndexes(264); // Level=9 Bit=8
    	securityRoleRules.put(new Integer(424),securityRoleRule);

//    	 rule for rowPrjRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(264); // Level=9 Bit=8
    	securityRoleRule.addResetAttributeIndexes(424); // Level=14 Bit=8
    	securityRoleRules.put(new Integer(264),securityRoleRule);

//    	 rule for rowPrjRankEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(160); // Level=6 Bit=0
    	securityRoleRule.addSetAttributeIndexes(45); // Level=2 Bit=13
    	securityRoleRules.put(new Integer(160),securityRoleRule);

//    	 rule for rowPrjRankView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(45); // Level=2 Bit=13
    	securityRoleRule.addResetAttributeIndexes(160); // Level=6 Bit=0
    	securityRoleRules.put(new Integer(45),securityRoleRule);

//    	 rule for rowPrjRefEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(161); // Level=6 Bit=1
    	securityRoleRule.addSetAttributeIndexes(129); // Level=5 Bit=1
    	securityRoleRules.put(new Integer(161),securityRoleRule);

//    	 rule for rowPrjRefView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(129); // Level=5 Bit=1
    	securityRoleRule.addResetAttributeIndexes(161); // Level=6 Bit=1
    	securityRoleRules.put(new Integer(129),securityRoleRule);

//    	 rule for rowPrjRollupSettingsEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(65); // Level=3 Bit=1
    	securityRoleRule.addSetAttributeIndexes(49); // Level=2 Bit=17
    	securityRoleRules.put(new Integer(65),securityRoleRule);

//    	 rule for rowPrjRollupSettingsView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(49); // Level=2 Bit=17
    	securityRoleRule.addResetAttributeIndexes(65); // Level=3 Bit=1
    	securityRoleRules.put(new Integer(49),securityRoleRule);

//    	 rule for rowPrjScorecardEdir
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(180); // Level=6 Bit=20
    	securityRoleRule.addResetAttributeIndexes(227); // Level=8 Bit=3
    	securityRoleRule.addSetAttributeIndexes(148); // Level=5 Bit=20
    	securityRoleRules.put(new Integer(180),securityRoleRule);

//    	 rule for rowPrjScorecardView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(148); // Level=5 Bit=20
    	securityRoleRule.addResetAttributeIndexes(180); // Level=6 Bit=20
    	securityRoleRules.put(new Integer(148),securityRoleRule);

//    	 rule for rowPrjSettingUrlEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(70); // Level=3 Bit=6
    	securityRoleRule.addSetAttributeIndexes(6); // Level=1 Bit=6
    	securityRoleRules.put(new Integer(70),securityRoleRule);

//    	 rule for rowPrjSettingUrlView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(6); // Level=1 Bit=6
    	securityRoleRule.addResetAttributeIndexes(70); // Level=3 Bit=6
    	securityRoleRules.put(new Integer(6),securityRoleRule);

//    	 rule for rowPrjStateNotEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(73); // Level=3 Bit=9
    	securityRoleRule.addSetAttributeIndexes(9); // Level=1 Bit=9
    	securityRoleRules.put(new Integer(73),securityRoleRule);

//    	 rule for rowPrjStateNotView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(9); // Level=1 Bit=9
    	securityRoleRule.addResetAttributeIndexes(73); // Level=3 Bit=9
    	securityRoleRules.put(new Integer(9),securityRoleRule);

//    	 rule for rowPrjTimeCodeView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(10); // Level=1 Bit=10
    	securityRoleRule.addResetAttributeIndexes(233); // Level=8 Bit=9
    	securityRoleRules.put(new Integer(10),securityRoleRule);

//    	 rule for rowPrjTimePhasingEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(98); // Level=4 Bit=2
    	securityRoleRule.addSetAttributeIndexes(33); // Level=2 Bit=1
    	securityRoleRules.put(new Integer(98),securityRoleRule);

//    	 rule for rowPrjTimePhasingView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(33); // Level=2 Bit=1
    	securityRoleRule.addResetAttributeIndexes(98); // Level=4 Bit=2
    	securityRoleRules.put(new Integer(33),securityRoleRule);

//    	 rule for rowPrjTimesheetApprEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(85); // Level=3 Bit=21
    	securityRoleRule.addSetAttributeIndexes(50); // Level=2 Bit=18
    	securityRoleRules.put(new Integer(85),securityRoleRule);

//    	 rule for rowPrjTimesheetApprView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(50); // Level=2 Bit=18
    	securityRoleRule.addResetAttributeIndexes(85); // Level=3 Bit=21
    	securityRoleRules.put(new Integer(50),securityRoleRule);

//    	 rule for rowPrjTotalView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(147); // Level=5 Bit=19
    	securityRoleRules.put(new Integer(147),securityRoleRule);

//    	 rule for rowPrjUrlsView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(36); // Level=2 Bit=4
    	securityRoleRules.put(new Integer(36),securityRoleRule);

//    	 rule for rowPrjViewDesc
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(52); // Level=2 Bit=20
    	securityRoleRules.put(new Integer(52),securityRoleRule);

//    	 rule for rowPublishBubble
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(99); // Level=4 Bit=3
    	securityRoleRules.put(new Integer(99),securityRoleRule);

//    	 rule for rowRemoveProfile
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(218); // Level=7 Bit=26
    	securityRoleRules.put(new Integer(218),securityRoleRule);

//    	 rule for rowRemoveResource
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(217); // Level=7 Bit=25
    	securityRoleRules.put(new Integer(217),securityRoleRule);

//    	 rule for rowRenameCRI
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(209); // Level=7 Bit=17
    	securityRoleRules.put(new Integer(209),securityRoleRule);

//    	 rule for rowRenameDoc
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(209); // Level=7 Bit=17
    	securityRoleRules.put(new Integer(209),securityRoleRule);

//    	 rule for rowRenameNotMin
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(209); // Level=7 Bit=17
    	securityRoleRules.put(new Integer(209),securityRoleRule);

//    	 rule for rowRenameWBS
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(209); // Level=7 Bit=17
    	securityRoleRules.put(new Integer(209),securityRoleRule);

//    	 rule for rowReplaceProfile
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(216); // Level=7 Bit=24
    	securityRoleRules.put(new Integer(216),securityRoleRule);

//    	 rule for rowReqRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(509); // Level=16 Bit=29
    	securityRoleRule.addSetAttributeIndexes(349); // Level=11 Bit=29
    	securityRoleRules.put(new Integer(509),securityRoleRule);

//    	 rule for rowReqRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(349); // Level=11 Bit=29
    	securityRoleRule.addResetAttributeIndexes(509); // Level=16 Bit=29
    	securityRoleRules.put(new Integer(349),securityRoleRule);

//    	 rule for rowReqRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(500); // Level=16 Bit=20
    	securityRoleRule.addSetAttributeIndexes(340); // Level=11 Bit=20
    	securityRoleRules.put(new Integer(500),securityRoleRule);

//    	 rule for rowReqRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(340); // Level=11 Bit=20
    	securityRoleRule.addResetAttributeIndexes(500); // Level=16 Bit=20
    	securityRoleRules.put(new Integer(340),securityRoleRule);

//    	 rule for rowReqRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(501); // Level=16 Bit=21
    	securityRoleRule.addSetAttributeIndexes(341); // Level=11 Bit=21
    	securityRoleRules.put(new Integer(501),securityRoleRule);

//    	 rule for rowReqRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(341); // Level=11 Bit=21
    	securityRoleRule.addResetAttributeIndexes(501); // Level=16 Bit=21
    	securityRoleRules.put(new Integer(341),securityRoleRule);

//    	 rule for rowReqRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(502); // Level=16 Bit=22
    	securityRoleRule.addSetAttributeIndexes(342); // Level=11 Bit=22
    	securityRoleRules.put(new Integer(502),securityRoleRule);

//    	 rule for rowReqRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(342); // Level=11 Bit=22
    	securityRoleRule.addResetAttributeIndexes(502); // Level=16 Bit=22
    	securityRoleRules.put(new Integer(342),securityRoleRule);

//    	 rule for rowReqRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(503); // Level=16 Bit=23
    	securityRoleRule.addSetAttributeIndexes(343); // Level=11 Bit=23
    	securityRoleRules.put(new Integer(503),securityRoleRule);

//    	 rule for rowReqRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(343); // Level=11 Bit=23
    	securityRoleRule.addResetAttributeIndexes(503); // Level=16 Bit=23
    	securityRoleRules.put(new Integer(343),securityRoleRule);

//    	 rule for rowReqRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(504); // Level=16 Bit=24
    	securityRoleRule.addSetAttributeIndexes(344); // Level=11 Bit=24
    	securityRoleRules.put(new Integer(504),securityRoleRule);

//    	 rule for rowReqRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(344); // Level=11 Bit=24
    	securityRoleRule.addResetAttributeIndexes(504); // Level=16 Bit=24
    	securityRoleRules.put(new Integer(344),securityRoleRule);

//    	 rule for rowReqRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(505); // Level=16 Bit=25
    	securityRoleRule.addSetAttributeIndexes(345); // Level=11 Bit=25
    	securityRoleRules.put(new Integer(505),securityRoleRule);

//    	 rule for rowReqRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(345); // Level=11 Bit=25
    	securityRoleRule.addResetAttributeIndexes(505); // Level=16 Bit=25
    	securityRoleRules.put(new Integer(345),securityRoleRule);

//    	 rule for rowReqRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(506); // Level=16 Bit=26
    	securityRoleRule.addSetAttributeIndexes(346); // Level=11 Bit=26
    	securityRoleRules.put(new Integer(506),securityRoleRule);

//    	 rule for rowReqRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(346); // Level=11 Bit=26
    	securityRoleRule.addResetAttributeIndexes(506); // Level=16 Bit=26
    	securityRoleRules.put(new Integer(346),securityRoleRule);

//    	 rule for rowReqRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(507); // Level=16 Bit=27
    	securityRoleRule.addSetAttributeIndexes(347); // Level=11 Bit=27
    	securityRoleRules.put(new Integer(507),securityRoleRule);

//    	 rule for rowReqRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(347); // Level=11 Bit=27
    	securityRoleRule.addResetAttributeIndexes(507); // Level=16 Bit=27
    	securityRoleRules.put(new Integer(347),securityRoleRule);

//    	 rule for rowReqRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(508); // Level=16 Bit=28
    	securityRoleRule.addSetAttributeIndexes(348); // Level=11 Bit=28
    	securityRoleRules.put(new Integer(508),securityRoleRule);

//    	 rule for rowReqRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(348); // Level=11 Bit=28
    	securityRoleRule.addResetAttributeIndexes(508); // Level=16 Bit=28
    	securityRoleRules.put(new Integer(348),securityRoleRule);

//    	 rule for rowRiskRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(541); // Level=17 Bit=29
    	securityRoleRule.addSetAttributeIndexes(381); // Level=12 Bit=29
    	securityRoleRules.put(new Integer(541),securityRoleRule);

//    	 rule for rowRiskRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(381); // Level=12 Bit=29
    	securityRoleRule.addResetAttributeIndexes(541); // Level=17 Bit=29
    	securityRoleRules.put(new Integer(381),securityRoleRule);

//    	 rule for rowRiskRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(532); // Level=17 Bit=20
    	securityRoleRule.addSetAttributeIndexes(372); // Level=12 Bit=20
    	securityRoleRules.put(new Integer(532),securityRoleRule);

//    	 rule for rowRiskRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(372); // Level=12 Bit=20
    	securityRoleRule.addResetAttributeIndexes(532); // Level=17 Bit=20
    	securityRoleRules.put(new Integer(372),securityRoleRule);

//    	 rule for rowRiskRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(533); // Level=17 Bit=21
    	securityRoleRule.addSetAttributeIndexes(373); // Level=12 Bit=21
    	securityRoleRules.put(new Integer(533),securityRoleRule);

//    	 rule for rowRiskRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(373); // Level=12 Bit=21
    	securityRoleRule.addResetAttributeIndexes(533); // Level=17 Bit=21
    	securityRoleRules.put(new Integer(373),securityRoleRule);

//    	 rule for rowRiskRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(534); // Level=17 Bit=22
    	securityRoleRule.addSetAttributeIndexes(374); // Level=12 Bit=22
    	securityRoleRules.put(new Integer(534),securityRoleRule);

//    	 rule for rowRiskRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(374); // Level=12 Bit=22
    	securityRoleRule.addResetAttributeIndexes(534); // Level=17 Bit=22
    	securityRoleRules.put(new Integer(374),securityRoleRule);

//    	 rule for rowRiskRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(535); // Level=17 Bit=23
    	securityRoleRule.addSetAttributeIndexes(375); // Level=12 Bit=23
    	securityRoleRules.put(new Integer(535),securityRoleRule);

//    	 rule for rowRiskRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(375); // Level=12 Bit=23
    	securityRoleRule.addResetAttributeIndexes(535); // Level=17 Bit=23
    	securityRoleRules.put(new Integer(375),securityRoleRule);

//    	 rule for rowRiskRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(536); // Level=17 Bit=24
    	securityRoleRule.addSetAttributeIndexes(376); // Level=12 Bit=24
    	securityRoleRules.put(new Integer(536),securityRoleRule);

//    	 rule for rowRiskRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(376); // Level=12 Bit=24
    	securityRoleRule.addResetAttributeIndexes(536); // Level=17 Bit=24
    	securityRoleRules.put(new Integer(376),securityRoleRule);

//    	 rule for rowRiskRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(537); // Level=17 Bit=25
    	securityRoleRule.addSetAttributeIndexes(377); // Level=12 Bit=25
    	securityRoleRules.put(new Integer(537),securityRoleRule);

//    	 rule for rowRiskRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(377); // Level=12 Bit=25
    	securityRoleRule.addResetAttributeIndexes(537); // Level=17 Bit=25
    	securityRoleRules.put(new Integer(377),securityRoleRule);

//    	 rule for rowRiskRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(538); // Level=17 Bit=26
    	securityRoleRule.addSetAttributeIndexes(378); // Level=12 Bit=26
    	securityRoleRules.put(new Integer(538),securityRoleRule);

//    	 rule for rowRiskRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(378); // Level=12 Bit=26
    	securityRoleRule.addResetAttributeIndexes(538); // Level=17 Bit=26
    	securityRoleRules.put(new Integer(378),securityRoleRule);

//    	 rule for rowRiskRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(539); // Level=17 Bit=27
    	securityRoleRule.addSetAttributeIndexes(379); // Level=12 Bit=27
    	securityRoleRules.put(new Integer(539),securityRoleRule);

//    	 rule for rowRiskRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(379); // Level=12 Bit=27
    	securityRoleRule.addResetAttributeIndexes(539); // Level=17 Bit=27
    	securityRoleRules.put(new Integer(379),securityRoleRule);

//    	 rule for rowRiskRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(540); // Level=17 Bit=28
    	securityRoleRule.addSetAttributeIndexes(380); // Level=12 Bit=28
    	securityRoleRules.put(new Integer(540),securityRoleRule);

//    	 rule for rowRiskRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(380); // Level=12 Bit=28
    	securityRoleRule.addResetAttributeIndexes(540); // Level=17 Bit=28
    	securityRoleRules.put(new Integer(380),securityRoleRule);

//    	 rule for rowSRRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(499); // Level=16 Bit=19
    	securityRoleRule.addSetAttributeIndexes(339); // Level=11 Bit=19
    	securityRoleRules.put(new Integer(499),securityRoleRule);

//    	 rule for rowSRRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(339); // Level=11 Bit=19
    	securityRoleRule.addResetAttributeIndexes(499); // Level=16 Bit=19
    	securityRoleRules.put(new Integer(339),securityRoleRule);

//    	 rule for rowSRRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(490); // Level=16 Bit=10
    	securityRoleRule.addSetAttributeIndexes(330); // Level=11 Bit=10
    	securityRoleRules.put(new Integer(490),securityRoleRule);

//    	 rule for rowSRRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(330); // Level=11 Bit=10
    	securityRoleRule.addResetAttributeIndexes(490); // Level=16 Bit=10
    	securityRoleRules.put(new Integer(330),securityRoleRule);

//    	 rule for rowSRRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(491); // Level=16 Bit=11
    	securityRoleRule.addSetAttributeIndexes(331); // Level=11 Bit=11
    	securityRoleRules.put(new Integer(491),securityRoleRule);

//    	 rule for rowSRRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(331); // Level=11 Bit=11
    	securityRoleRule.addResetAttributeIndexes(491); // Level=16 Bit=11
    	securityRoleRules.put(new Integer(331),securityRoleRule);

//    	 rule for rowSRRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(492); // Level=16 Bit=12
    	securityRoleRule.addSetAttributeIndexes(332); // Level=11 Bit=12
    	securityRoleRules.put(new Integer(492),securityRoleRule);

//    	 rule for rowSRRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(332); // Level=11 Bit=12
    	securityRoleRule.addResetAttributeIndexes(492); // Level=16 Bit=12
    	securityRoleRules.put(new Integer(332),securityRoleRule);

//    	 rule for rowSRRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(493); // Level=16 Bit=13
    	securityRoleRule.addSetAttributeIndexes(333); // Level=11 Bit=13
    	securityRoleRules.put(new Integer(493),securityRoleRule);

//    	 rule for rowSRRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(333); // Level=11 Bit=13
    	securityRoleRule.addResetAttributeIndexes(493); // Level=16 Bit=13
    	securityRoleRules.put(new Integer(333),securityRoleRule);

//    	 rule for rowSRRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(494); // Level=16 Bit=14
    	securityRoleRule.addSetAttributeIndexes(334); // Level=11 Bit=14
    	securityRoleRules.put(new Integer(494),securityRoleRule);

//    	 rule for rowSRRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(334); // Level=11 Bit=14
    	securityRoleRule.addResetAttributeIndexes(494); // Level=16 Bit=14
    	securityRoleRules.put(new Integer(334),securityRoleRule);

//    	 rule for rowSRRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(495); // Level=16 Bit=15
    	securityRoleRule.addSetAttributeIndexes(335); // Level=11 Bit=15
    	securityRoleRules.put(new Integer(495),securityRoleRule);

//    	 rule for rowSRRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(335); // Level=11 Bit=15
    	securityRoleRule.addResetAttributeIndexes(495); // Level=16 Bit=15
    	securityRoleRules.put(new Integer(335),securityRoleRule);

//    	 rule for rowSRRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(496); // Level=16 Bit=16
    	securityRoleRule.addSetAttributeIndexes(336); // Level=11 Bit=16
    	securityRoleRules.put(new Integer(496),securityRoleRule);

//    	 rule for rowSRRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(336); // Level=11 Bit=16
    	securityRoleRule.addResetAttributeIndexes(496); // Level=16 Bit=16
    	securityRoleRules.put(new Integer(336),securityRoleRule);

//    	 rule for rowSRRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(497); // Level=16 Bit=17
    	securityRoleRule.addSetAttributeIndexes(337); // Level=11 Bit=17
    	securityRoleRules.put(new Integer(497),securityRoleRule);

//    	 rule for rowSRRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(337); // Level=11 Bit=17
    	securityRoleRule.addResetAttributeIndexes(497); // Level=16 Bit=17
    	securityRoleRules.put(new Integer(337),securityRoleRule);

//    	 rule for rowSRRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(498); // Level=16 Bit=18
    	securityRoleRule.addSetAttributeIndexes(338); // Level=11 Bit=18
    	securityRoleRules.put(new Integer(498),securityRoleRule);

//    	 rule for rowSRRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(338); // Level=11 Bit=18
    	securityRoleRule.addResetAttributeIndexes(498); // Level=16 Bit=18
    	securityRoleRules.put(new Integer(338),securityRoleRule);

//    	 rule for rowSaveAs
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(113); // Level=4 Bit=17
    	securityRoleRules.put(new Integer(113),securityRoleRule);

//    	 rule for rowScoreActDeact
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(117); // Level=4 Bit=21
    	securityRoleRules.put(new Integer(117),securityRoleRule);

//    	 rule for rowScoreHistory
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(155); // Level=5 Bit=27
    	securityRoleRules.put(new Integer(155),securityRoleRule);

//    	 rule for rowScorePublish
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(116); // Level=4 Bit=20
    	securityRoleRules.put(new Integer(116),securityRoleRule);

//    	 rule for rowScoreRename
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(209); // Level=7 Bit=17
    	securityRoleRules.put(new Integer(209),securityRoleRule);

//    	 rule for rowScoreScorecardAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(227); // Level=8 Bit=3
    	securityRoleRule.addSetAttributeIndexes(148); // Level=5 Bit=20
    	securityRoleRule.addSetAttributeIndexes(180); // Level=6 Bit=20
    	securityRoleRules.put(new Integer(227),securityRoleRule);

//    	 rule for rowScoreScorecardEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(180); // Level=6 Bit=20
    	securityRoleRule.addSetAttributeIndexes(148); // Level=5 Bit=20
    	securityRoleRules.put(new Integer(180),securityRoleRule);

//    	 rule for rowScoreScorecardView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(148); // Level=5 Bit=20
    	securityRoleRule.addResetAttributeIndexes(180); // Level=6 Bit=20
    	securityRoleRule.addResetAttributeIndexes(227); // Level=8 Bit=3
    	securityRoleRules.put(new Integer(148),securityRoleRule);

//    	 rule for rowScorecardCheckInAll
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(189); // Level=6 Bit=29
    	securityRoleRules.put(new Integer(189),securityRoleRule);

//    	 rule for rowScorecardElementSecurityEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(166); // Level=6 Bit=6
    	securityRoleRule.addResetAttributeIndexes(134); // Level=5 Bit=6
    	securityRoleRules.put(new Integer(166),securityRoleRule);

//    	 rule for rowScorecardElementSecurityView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(134); // Level=5 Bit=6
    	securityRoleRule.addResetAttributeIndexes(166); // Level=6 Bit=6
    	securityRoleRules.put(new Integer(134),securityRoleRule);

//    	 rule for rowSendToArchive
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(104); // Level=4 Bit=8
    	securityRoleRules.put(new Integer(104),securityRoleRule);

//    	 rule for rowSummaryRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(457); // Level=15 Bit=9
    	securityRoleRule.addSetAttributeIndexes(297); // Level=10 Bit=9
    	securityRoleRules.put(new Integer(457),securityRoleRule);

//    	 rule for rowSummaryRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(297); // Level=10 Bit=9
    	securityRoleRule.addResetAttributeIndexes(457); // Level=15 Bit=9
    	securityRoleRules.put(new Integer(297),securityRoleRule);

//    	 rule for rowSummaryRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(448); // Level=15 Bit=0
    	securityRoleRule.addSetAttributeIndexes(288); // Level=10 Bit=0
    	securityRoleRules.put(new Integer(448),securityRoleRule);

//    	 rule for rowSummaryRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(288); // Level=10 Bit=0
    	securityRoleRule.addResetAttributeIndexes(448); // Level=15 Bit=0
    	securityRoleRules.put(new Integer(288),securityRoleRule);

//    	 rule for rowSummaryRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(449); // Level=15 Bit=1
    	securityRoleRule.addSetAttributeIndexes(289); // Level=10 Bit=1
    	securityRoleRules.put(new Integer(449),securityRoleRule);

//    	 rule for rowSummaryRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(289); // Level=10 Bit=1
    	securityRoleRule.addResetAttributeIndexes(449); // Level=15 Bit=1
    	securityRoleRules.put(new Integer(289),securityRoleRule);

//    	 rule for rowSummaryRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(450); // Level=15 Bit=2
    	securityRoleRule.addSetAttributeIndexes(290); // Level=10 Bit=2
    	securityRoleRules.put(new Integer(450),securityRoleRule);

//    	 rule for rowSummaryRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(290); // Level=10 Bit=2
    	securityRoleRule.addResetAttributeIndexes(450); // Level=15 Bit=2
    	securityRoleRules.put(new Integer(290),securityRoleRule);

//    	 rule for rowSummaryRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(451); // Level=15 Bit=3
    	securityRoleRule.addSetAttributeIndexes(291); // Level=10 Bit=3
    	securityRoleRules.put(new Integer(451),securityRoleRule);

//    	 rule for rowSummaryRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(291); // Level=10 Bit=3
    	securityRoleRule.addResetAttributeIndexes(451); // Level=15 Bit=3
    	securityRoleRules.put(new Integer(291),securityRoleRule);

//    	 rule for rowSummaryRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(452); // Level=15 Bit=4
    	securityRoleRule.addSetAttributeIndexes(292); // Level=10 Bit=4
    	securityRoleRules.put(new Integer(452),securityRoleRule);

//    	 rule for rowSummaryRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(292); // Level=10 Bit=4
    	securityRoleRule.addResetAttributeIndexes(452); // Level=15 Bit=4
    	securityRoleRules.put(new Integer(292),securityRoleRule);

//    	 rule for rowSummaryRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(453); // Level=15 Bit=5
    	securityRoleRule.addSetAttributeIndexes(293); // Level=10 Bit=5
    	securityRoleRules.put(new Integer(453),securityRoleRule);

//    	 rule for rowSummaryRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(293); // Level=10 Bit=5
    	securityRoleRule.addResetAttributeIndexes(453); // Level=15 Bit=5
    	securityRoleRules.put(new Integer(293),securityRoleRule);

//    	 rule for rowSummaryRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(454); // Level=15 Bit=6
    	securityRoleRule.addSetAttributeIndexes(294); // Level=10 Bit=6
    	securityRoleRules.put(new Integer(454),securityRoleRule);

//    	 rule for rowSummaryRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(294); // Level=10 Bit=6
    	securityRoleRule.addResetAttributeIndexes(454); // Level=15 Bit=6
    	securityRoleRules.put(new Integer(294),securityRoleRule);

//    	 rule for rowSummaryRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(455); // Level=15 Bit=7
    	securityRoleRule.addSetAttributeIndexes(295); // Level=10 Bit=7
    	securityRoleRules.put(new Integer(455),securityRoleRule);

//    	 rule for rowSummaryRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(295); // Level=10 Bit=7
    	securityRoleRule.addResetAttributeIndexes(455); // Level=15 Bit=7
    	securityRoleRules.put(new Integer(295),securityRoleRule);

//    	 rule for rowSummaryRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(456); // Level=15 Bit=8
    	securityRoleRule.addSetAttributeIndexes(296); // Level=10 Bit=8
    	securityRoleRules.put(new Integer(456),securityRoleRule);

//    	 rule for rowSummaryRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(296); // Level=10 Bit=8
    	securityRoleRule.addResetAttributeIndexes(456); // Level=15 Bit=8
    	securityRoleRules.put(new Integer(296),securityRoleRule);

//    	 rule for rowTaskActualEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(174); // Level=6 Bit=14
    	securityRoleRules.put(new Integer(174),securityRoleRule);

//    	 rule for rowTaskAttrAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRule.addSetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRules.put(new Integer(224),securityRoleRule);

//    	 rule for rowTaskAttrEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRule.addSetAttributeIndexes(146); // Level=5 Bit=18
    	securityRoleRules.put(new Integer(178),securityRoleRule);

//    	 rule for rowTaskAttrView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(146); // Level=5 Bit=18
    	securityRoleRule.addResetAttributeIndexes(178); // Level=6 Bit=18
    	securityRoleRule.addResetAttributeIndexes(224); // Level=8 Bit=0
    	securityRoleRules.put(new Integer(146),securityRoleRule);

//    	 rule for rowTaskBaselineView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(144); // Level=5 Bit=16
    	securityRoleRules.put(new Integer(144),securityRoleRule);

//    	 rule for rowTaskCompleteEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(169); // Level=6 Bit=9
    	securityRoleRule.addSetAttributeIndexes(137); // Level=5 Bit=9
    	securityRoleRules.put(new Integer(169),securityRoleRule);

//    	 rule for rowTaskCompleteView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(137); // Level=5 Bit=9
    	securityRoleRule.addResetAttributeIndexes(169); // Level=6 Bit=9
    	securityRoleRules.put(new Integer(137),securityRoleRule);

//    	 rule for rowTaskConstEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(170); // Level=6 Bit=10
    	securityRoleRule.addSetAttributeIndexes(138); // Level=5 Bit=10
    	securityRoleRules.put(new Integer(170),securityRoleRule);

//    	 rule for rowTaskConstView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(138); // Level=5 Bit=10
    	securityRoleRule.addResetAttributeIndexes(170); // Level=6 Bit=10
    	securityRoleRules.put(new Integer(138),securityRoleRule);

//    	 rule for rowTaskDefTCEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(118); // Level=4 Bit=22
    	securityRoleRule.addSetAttributeIndexes(130); // Level=5 Bit=2
    	securityRoleRules.put(new Integer(118),securityRoleRule);

//    	 rule for rowTaskDefTCView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(130); // Level=5 Bit=2
    	securityRoleRule.addResetAttributeIndexes(118); // Level=4 Bit=22
    	securityRoleRules.put(new Integer(130),securityRoleRule);

//    	 rule for rowTaskModifyTaskType
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(106); // Level=4 Bit=10
    	securityRoleRules.put(new Integer(106),securityRoleRule);

//    	 rule for rowTaskPlanEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(172); // Level=6 Bit=12
    	securityRoleRules.put(new Integer(172),securityRoleRule);

//    	 rule for rowTaskPriorityEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(160); // Level=6 Bit=0
    	securityRoleRule.addSetAttributeIndexes(45); // Level=2 Bit=13
    	securityRoleRules.put(new Integer(160),securityRoleRule);

//    	 rule for rowTaskPriorityView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(45); // Level=2 Bit=13
    	securityRoleRule.addResetAttributeIndexes(160); // Level=6 Bit=0
    	securityRoleRules.put(new Integer(45),securityRoleRule);

//    	 rule for rowTaskPublishedEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(162); // Level=6 Bit=2
    	securityRoleRules.put(new Integer(162),securityRoleRule);

//    	 rule for rowTaskRTF10Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(435); // Level=14 Bit=19
    	securityRoleRule.addSetAttributeIndexes(275); // Level=9 Bit=19
    	securityRoleRules.put(new Integer(435),securityRoleRule);

//    	 rule for rowTaskRTF10View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(275); // Level=9 Bit=19
    	securityRoleRule.addResetAttributeIndexes(435); // Level=14 Bit=19
    	securityRoleRules.put(new Integer(275),securityRoleRule);

//    	 rule for rowTaskRTF1Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(426); // Level=14 Bit=10
    	securityRoleRule.addSetAttributeIndexes(266); // Level=9 Bit=10
    	securityRoleRules.put(new Integer(426),securityRoleRule);

//    	 rule for rowTaskRTF1View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(266); // Level=9 Bit=10
    	securityRoleRule.addResetAttributeIndexes(426); // Level=14 Bit=10
    	securityRoleRules.put(new Integer(266),securityRoleRule);

//    	 rule for rowTaskRTF2Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(427); // Level=14 Bit=11
    	securityRoleRule.addSetAttributeIndexes(267); // Level=9 Bit=11
    	securityRoleRules.put(new Integer(427),securityRoleRule);

//    	 rule for rowTaskRTF2View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(267); // Level=9 Bit=11
    	securityRoleRule.addResetAttributeIndexes(427); // Level=14 Bit=11
    	securityRoleRules.put(new Integer(267),securityRoleRule);

//    	 rule for rowTaskRTF3Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(428); // Level=14 Bit=12
    	securityRoleRule.addSetAttributeIndexes(268); // Level=9 Bit=12
    	securityRoleRules.put(new Integer(428),securityRoleRule);

//    	 rule for rowTaskRTF3View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(268); // Level=9 Bit=12
    	securityRoleRule.addResetAttributeIndexes(428); // Level=14 Bit=12
    	securityRoleRules.put(new Integer(268),securityRoleRule);

//    	 rule for rowTaskRTF4Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(429); // Level=14 Bit=13
    	securityRoleRule.addSetAttributeIndexes(269); // Level=9 Bit=13
    	securityRoleRules.put(new Integer(429),securityRoleRule);

//    	 rule for rowTaskRTF4View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(269); // Level=9 Bit=13
    	securityRoleRule.addResetAttributeIndexes(429); // Level=14 Bit=13
    	securityRoleRules.put(new Integer(269),securityRoleRule);

//    	 rule for rowTaskRTF5Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(430); // Level=14 Bit=14
    	securityRoleRule.addSetAttributeIndexes(270); // Level=9 Bit=14
    	securityRoleRules.put(new Integer(430),securityRoleRule);

//    	 rule for rowTaskRTF5View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(270); // Level=9 Bit=14
    	securityRoleRule.addResetAttributeIndexes(430); // Level=14 Bit=14
    	securityRoleRules.put(new Integer(270),securityRoleRule);

//    	 rule for rowTaskRTF6Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(431); // Level=14 Bit=15
    	securityRoleRule.addSetAttributeIndexes(271); // Level=9 Bit=15
    	securityRoleRules.put(new Integer(431),securityRoleRule);

//    	 rule for rowTaskRTF6View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(271); // Level=9 Bit=15
    	securityRoleRule.addResetAttributeIndexes(431); // Level=14 Bit=15
    	securityRoleRules.put(new Integer(271),securityRoleRule);

//    	 rule for rowTaskRTF7Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(432); // Level=14 Bit=16
    	securityRoleRule.addSetAttributeIndexes(272); // Level=9 Bit=16
    	securityRoleRules.put(new Integer(432),securityRoleRule);

//    	 rule for rowTaskRTF7View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(272); // Level=9 Bit=16
    	securityRoleRule.addResetAttributeIndexes(432); // Level=14 Bit=16
    	securityRoleRules.put(new Integer(272),securityRoleRule);

//    	 rule for rowTaskRTF8Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(433); // Level=14 Bit=17
    	securityRoleRule.addSetAttributeIndexes(273); // Level=9 Bit=17
    	securityRoleRules.put(new Integer(433),securityRoleRule);

//    	 rule for rowTaskRTF8View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(273); // Level=9 Bit=17
    	securityRoleRule.addResetAttributeIndexes(433); // Level=14 Bit=17
    	securityRoleRules.put(new Integer(273),securityRoleRule);

//    	 rule for rowTaskRTF9Edit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(434); // Level=14 Bit=18
    	securityRoleRule.addSetAttributeIndexes(274); // Level=9 Bit=18
    	securityRoleRules.put(new Integer(434),securityRoleRule);

//    	 rule for rowTaskRTF9View
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(274); // Level=9 Bit=18
    	securityRoleRule.addResetAttributeIndexes(434); // Level=14 Bit=18
    	securityRoleRules.put(new Integer(274),securityRoleRule);

//    	 rule for rowTaskSchedEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(173); // Level=6 Bit=13
    	securityRoleRules.put(new Integer(173),securityRoleRule);

//    	 rule for rowTransferWbsToCri
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(111); // Level=4 Bit=15
    	securityRoleRules.put(new Integer(111),securityRoleRule);

//    	 rule for rowUnlimittedBaselining
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(187); // Level=6 Bit=27
    	securityRoleRules.put(new Integer(187),securityRoleRule);

//    	 rule for rowUnlockANY
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(51); // Level=2 Bit=19
    	securityRoleRules.put(new Integer(51),securityRoleRule);

//    	 rule for rowViewAllDeletedDocs
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(53); // Level=2 Bit=21
    	securityRoleRules.put(new Integer(53),securityRoleRule);

//    	 rule for rowViewAssignment
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(153); // Level=5 Bit=25
    	securityRoleRules.put(new Integer(153),securityRoleRule);

//    	 rule for rowViewBubble
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(34); // Level=2 Bit=2
    	securityRoleRules.put(new Integer(34),securityRoleRule);

//    	 rule for rowViewCost
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(135); // Level=5 Bit=7
    	securityRoleRule.addResetAttributeIndexes(167); // Level=6 Bit=7
    	securityRoleRules.put(new Integer(135),securityRoleRule);

//    	 rule for rowViewProfit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(149); // Level=5 Bit=21
    	securityRoleRules.put(new Integer(149),securityRoleRule);

//    	 rule for rowViewRates
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(136); // Level=5 Bit=8
    	securityRoleRule.addResetAttributeIndexes(168); // Level=6 Bit=8
    	securityRoleRules.put(new Integer(136),securityRoleRule);

//    	 rule for rowViewReports
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(44); // Level=2 Bit=12
    	securityRoleRules.put(new Integer(44),securityRoleRule);

//    	 rule for rowViewScorecards
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(37); // Level=2 Bit=5
    	securityRoleRules.put(new Integer(37),securityRoleRule);

//    	 rule for rowViewVersion
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(155); // Level=5 Bit=27
    	securityRoleRules.put(new Integer(155),securityRoleRule);

//    	 rule for rowWBSCanSetTaskAsMandatory
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(74); // Level=3 Bit=10
    	securityRoleRules.put(new Integer(74),securityRoleRule);

//    	 rule for rowWBSDependencyAddRem
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(228); // Level=8 Bit=4
    	securityRoleRule.addSetAttributeIndexes(154); // Level=5 Bit=26
    	securityRoleRule.addSetAttributeIndexes(186); // Level=6 Bit=26
    	securityRoleRules.put(new Integer(228),securityRoleRule);

//    	 rule for rowWBSDependencyEdit
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(186); // Level=6 Bit=26
    	securityRoleRule.addResetAttributeIndexes(228); // Level=8 Bit=4
    	securityRoleRule.addSetAttributeIndexes(154); // Level=5 Bit=26
    	securityRoleRules.put(new Integer(186),securityRoleRule);

//    	 rule for rowWBSDependencyView
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(154); // Level=5 Bit=26
    	securityRoleRule.addResetAttributeIndexes(186); // Level=6 Bit=26
    	securityRoleRule.addResetAttributeIndexes(228); // Level=8 Bit=4
    	securityRoleRules.put(new Integer(154),securityRoleRule);

//    	 rule for rowWBSLockUnlock
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(206); // Level=7 Bit=14
    	securityRoleRules.put(new Integer(206),securityRoleRule);

//    	 rule for rowWbsSchedInfo
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(40); // Level=2 Bit=8
    	securityRoleRules.put(new Integer(40),securityRoleRule);

//    	 rule for rowWorkflowStart
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(235); // Level=8 Bit=11
    	securityRoleRule.addResetAttributeIndexes(236); // Level=8 Bit=12
    	securityRoleRules.put(new Integer(235),securityRoleRule);

//    	 rule for rowWorkflowStop
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(236); // Level=8 Bit=12
    	securityRoleRule.addSetAttributeIndexes(235); // Level=8 Bit=11
    	securityRoleRules.put(new Integer(236),securityRoleRule);

//    	 rule for rwoFS
    	securityRoleRule = new SecurityRule();
    	securityRoleRule.setAttributeIndex(102); // Level=4 Bit=6
    	securityRoleRules.put(new Integer(102),securityRoleRule);
    }

    public static SecurityRule getSecurityGroupRule(int attributeIndex){
    	return (SecurityRule) (securityGroupRules.containsKey(new Integer(attributeIndex)) ? securityGroupRules.get(new Integer(attributeIndex)) : new SecurityRule(attributeIndex));
    }
    
    public static SecurityRule getSecurityRoleRule(int attributeIndex){
    	return (SecurityRule) (securityRoleRules.containsKey(new Integer(attributeIndex)) ? securityRoleRules.get(new Integer(attributeIndex)) : new SecurityRule(attributeIndex));
    }
    
    public static Object[] applyBusinessRules(Object[] args){
    	int nbOfLevel = args.length-2;
    	int clearanceLevelType=-1;
    	if (nbOfLevel==7) {
    		clearanceLevelType=SECURITY_GROUP_CLEARANCE_LEVEL_TYPE;
    	} else if (nbOfLevel==26) {
    		clearanceLevelType=SECURITY_ROLE_CLEARANCE_LEVEL_TYPE;
    	} 

		for(int level=1;level<=nbOfLevel;level++){
			for(int bitNo=0;bitNo<32;bitNo++) {
				int attributeIndex = (level-1)*32 + bitNo;
				int mask=1<<bitNo;
				SecurityRule rule=null;
				if (clearanceLevelType==SECURITY_GROUP_CLEARANCE_LEVEL_TYPE) {
					rule=getSecurityGroupRule(attributeIndex);
				} else if (clearanceLevelType==SECURITY_ROLE_CLEARANCE_LEVEL_TYPE) {
					rule=getSecurityRoleRule(attributeIndex);
				} 
				if (rule==null) break;
				boolean clearanceTrue = (((Integer)args[level]).intValue() & (mask))==(mask);
				if (clearanceTrue) {
	        		for(Iterator iter=rule.getSetAttributeIndexes().iterator();iter.hasNext();) {
	        			int attributeIndexToModify = ((Integer)iter.next()).intValue();
	        			int levelToModify = 1+ (attributeIndexToModify / 32);
	        			int bitNoToModify = attributeIndexToModify % 32;
	        			int maskForBitNoToModify = 1<<bitNoToModify;
	        			int clearanceLevel = ((Integer)args[levelToModify]).intValue();
	        			//System.out.print("level="+levelToModify+"  bit="+bitNoToModify+"mask="+maskForBitNoToModify+"  before="+clearanceLevel+"   arg was"+args[levelToModify]);
	        			clearanceLevel |= maskForBitNoToModify;
	        			args[levelToModify] = new Integer(clearanceLevel);
	        			//System.out.println(" after="+clearanceLevel+"    arg is now="+args[levelToModify]);
	        		}
				}
				else {
	        		for(Iterator iter=rule.getResetAttributeIndexes().iterator();iter.hasNext();) {
	        			int attributeIndexToModify = ((Integer)iter.next()).intValue();
	        			int levelToModify = 1+ (attributeIndexToModify / 32);
	        			int bitNoToModify = attributeIndexToModify % 32;
	        			int maskForBitNoToModify = 1<<bitNoToModify;
	        			int clearanceLevel = ((Integer)args[levelToModify]).intValue();
	        			//System.out.print("level="+levelToModify+"  bit="+bitNoToModify+"mask="+maskForBitNoToModify+" before="+clearanceLevel+"   arg was"+args[levelToModify]);
	        			clearanceLevel &= ~maskForBitNoToModify;
	        			args[levelToModify] = new Integer(clearanceLevel);
	        			//System.out.println(" after="+clearanceLevel+"    arg is now="+args[levelToModify]);
					}
				}
			}
    	}	
		return args;
   	}	
}
